{**********************************************************************
                Copyright (c) PilotLogic Software House

 Package pl_OpenSSL
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)

 ***** BEGIN LICENSE BLOCK *****
 * Version: LGPL-2 with link exception (Modified LGPL)
 *
 * The contents of this file are subject to the
 * GNU LIBRARY GENERAL PUBLIC LICENSE Version 2 (the "License");
 * with the following modification:
 *
 * As a special exception, the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your choice,
 * provided that you also meet, for each linked independent module, the terms
 * and conditions of the license of that module. An independent module is a
 * module which is not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library, but
 * you are not obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * ***** END LICENSE BLOCK *****

***********************************************************************}

unit ssl1_loader;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  sysloader,
  libOpenSSL_1;

Type

  TLoaderSSL1 = Class(TbaseLoader)
  private
  public             
    constructor Create(AOwner: TComponent); override;

    Procedure Libraries_Load; override;
    Procedure Libraries_Free; override;
    Function  GetlibSSL1_Loaded:Boolean;
    Function  GetlibCrypto1_Loaded:Boolean;
  published
    Property IslibSSL1_Loaded:Boolean read GetlibSSL1_Loaded stored False;
    Property IslibCrypto1_Loaded:Boolean read GetlibCrypto1_Loaded stored False;
  end;

implementation

constructor TLoaderSSL1.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCTSubDir:='openssl';
end;

Procedure TLoaderSSL1.Libraries_Load;
begin
  inherited Libraries_Load;
  //.............................

  libSSL1_Load;  
  libCrypto1_Load;

  FActive:=True;
end;

Procedure TLoaderSSL1.Libraries_Free;
begin
  libSSL1_Free;
  libCrypto1_Free;   

  FActive:=False;
end;

Function  TLoaderSSL1.GetlibSSL1_Loaded:Boolean;
begin
  Result:= libSSL1_IsLoaded;
end;

Function  TLoaderSSL1.GetlibCrypto1_Loaded:Boolean;
begin
  Result:= libCrypto1_IsLoaded;
end;


end.


