{**********************************************************************
                Copyright (c) PilotLogic Software House

 Package pl_OpenSSL
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)

 ***** BEGIN LICENSE BLOCK *****
 * Version: LGPL-2 with link exception (Modified LGPL)
 *
 * The contents of this file are subject to the
 * GNU LIBRARY GENERAL PUBLIC LICENSE Version 2 (the "License");
 * with the following modification:
 *
 * As a special exception, the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your choice,
 * provided that you also meet, for each linked independent module, the terms
 * and conditions of the license of that module. An independent module is a
 * module which is not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library, but
 * you are not obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * ***** END LICENSE BLOCK *****

***********************************************************************}

Unit libOpenSSL_3;

{$MODE objfpc}{$H+}

{$PACKENUM 4}
{$PACKRECORDS C}

Interface
Uses
   dynlibs, classes,
   ctypes;

Const
{$IF defined(MSWINDOWS)}

  {$IFDEF CPU32}
    SSL3LibName    = 'libssl-1_1.dll';
    Crypto3LibName = 'libcrypto-1_1.dll';
  {$ELSE}
    SSL3LibName    = 'libssl-3-x64.dll';
    Crypto3LibName = 'libcrypto-3-x64.dll';
  {$ENDIF}

{$ELSEIF defined(LINUX)}
    SSL3LibName    = 'libssl.so.3';
    Crypto3LibName = 'libcrypto.so.3';
{$ELSEIF defined(DARWIN)}
    SSL3LibName    = 'libssl.3.dylib';
    Crypto3LibName = 'libcrypto.3.dylib';
{$ELSE}
    SSL3LibName    = 'libssl.so.3';
    Crypto3LibName = 'libcrypto.so.3';
{$ENDIF}

Const
   ERR_NUM_ERRORS = 16;
   CONF_MFLAGS_IGNORE_ERRORS = $1;
   CONF_MFLAGS_IGNORE_RETURN_CODES = $2;
   CONF_MFLAGS_SILENT = $4;
   CONF_MFLAGS_NO_DSO = $8;
   CONF_MFLAGS_IGNORE_MISSING_FILE = $10;
   CONF_MFLAGS_DEFAULT_SECTION = $20;
   CONF_F_CONF_DUMP_FP = 104;
   CONF_F_CONF_LOAD = 100;
   CONF_F_CONF_LOAD_BIO = 102;
   CONF_F_CONF_LOAD_FP = 103;
   CONF_F_CONF_MODULES_LOAD = 116;
   CONF_F_DEF_LOAD = 120;
   CONF_F_DEF_LOAD_BIO = 121;
   CONF_F_MODULE_INIT = 115;
   CONF_F_MODULE_LOAD_DSO = 117;
   CONF_F_CONF_PARSE_LIST = 119;
   CONF_F_MODULE_RUN = 118;
   CONF_F_NCONF_DUMP_BIO = 105;
   CONF_F_NCONF_DUMP_FP = 106;
   CONF_F_NCONF_GET_NUMBER = 107;
   CONF_F_NCONF_GET_NUMBER_E = 112;
   CONF_F_NCONF_GET_SECTION = 108;
   CONF_F_NCONF_GET_STRING = 109;
   CONF_F_NCONF_LOAD = 113;
   CONF_F_NCONF_LOAD_BIO = 110;
   CONF_F_NCONF_LOAD_FP = 114;
   CONF_F_NCONF_NEW = 111;
   CONF_F_STR_COPY = 101;
   CONF_R_ERROR_LOADING_DSO = 110;
   CONF_R_LIST_CANNOT_BE_NULL = 115;
   CONF_R_MISSING_CLOSE_SQUARE_BRACKET = 100;
   CONF_R_MISSING_EQUAL_SIGN = 101;
   CONF_R_MISSING_FINISH_FUNCTION = 111;
   CONF_R_MISSING_INIT_FUNCTION = 112;
   CONF_R_MODULE_INITIALIZATION_ERROR = 109;
   CONF_R_NO_CLOSE_BRACE = 102;
   CONF_R_NO_CONF = 105;
   CONF_R_NO_CONF_OR_ENVIRONMENT_VARIABLE = 106;
   CONF_R_NO_SECTION = 107;
   CONF_R_NO_SUCH_FILE = 114;
   CONF_R_NO_VALUE = 108;
   CONF_R_UNABLE_TO_CREATE_NEW_SECTION = 103;
   CONF_R_UNKNOWN_MODULE_NAME = 113;
   CONF_R_VARIABLE_HAS_NO_VALUE = 104;
   ASN1_F_A2D_ASN1_OBJECT = 100;
   ASN1_F_A2I_ASN1_ENUMERATED = 236;
   ASN1_F_A2I_ASN1_INTEGER = 101;
   ASN1_F_A2I_ASN1_STRING = 102;
   ASN1_F_ASN1_COLLATE_PRIMITIVE = 103;
   ASN1_F_ASN1_D2I_BIO = 104;
   ASN1_F_ASN1_D2I_FP = 105;
   ASN1_F_ASN1_DUP = 106;
   ASN1_F_ASN1_ENUMERATED_SET = 232;
   ASN1_F_ASN1_ENUMERATED_TO_BN = 233;
   ASN1_F_ASN1_GENERALIZEDTIME_NEW = 222;
   ASN1_F_ASN1_GET_OBJECT = 107;
   ASN1_F_ASN1_HEADER_NEW = 108;
   ASN1_F_ASN1_I2D_BIO = 109;
   ASN1_F_ASN1_I2D_FP = 110;
   ASN1_F_ASN1_INTEGER_SET = 111;
   ASN1_F_ASN1_INTEGER_TO_BN = 112;
   ASN1_F_ASN1_OBJECT_NEW = 113;
   ASN1_F_ASN1_OUTPUT_DATA = 207;
   ASN1_F_ASN1_PACK_STRING = 245;
   ASN1_F_ASN1_PBE_SET = 253;
   ASN1_F_ASN1_SEQ_PACK = 246;
   ASN1_F_ASN1_SEQ_UNPACK = 247;
   ASN1_F_ASN1_SIGN = 114;
   ASN1_F_ASN1_STRING_NEW = 115;
   ASN1_F_ASN1_STRING_TYPE_NEW = 116;
   ASN1_F_ASN1_TYPE_GET_INT_OCTETSTRING = 117;
   ASN1_F_ASN1_TYPE_GET_OCTETSTRING = 118;
   ASN1_F_ASN1_TYPE_NEW = 119;
   ASN1_F_ASN1_UNPACK_STRING = 248;
   ASN1_F_ASN1_UTCTIME_NEW = 120;
   ASN1_F_ASN1_VERIFY = 121;
   ASN1_F_B64_READ_ASN1 = 208;
   ASN1_F_B64_WRITE_ASN1 = 209;
   ASN1_F_BIO_NEW_NDEF = 212;
   ASN1_F_BITSTR_CB = 180;
   ASN1_F_SMIME_READ_ASN1 = 210;
   ASN1_F_SMIME_TEXT = 211;
   ASN1_F_AUTHORITY_KEYID_NEW = 237;
   ASN1_F_BASIC_CONSTRAINTS_NEW = 226;
   ASN1_F_BN_TO_ASN1_ENUMERATED = 234;
   ASN1_F_BN_TO_ASN1_INTEGER = 122;
   ASN1_F_D2I_ASN1_BIT_STRING = 123;
   ASN1_F_D2I_ASN1_BMPSTRING = 124;
   ASN1_F_D2I_ASN1_BOOLEAN = 125;
   ASN1_F_D2I_ASN1_BYTES = 126;
   ASN1_F_D2I_ASN1_ENUMERATED = 235;
   ASN1_F_D2I_ASN1_GENERALIZEDTIME = 223;
   ASN1_F_D2I_ASN1_HEADER = 127;
   ASN1_F_D2I_ASN1_INTEGER = 128;
   ASN1_F_D2I_ASN1_OBJECT = 129;
   ASN1_F_D2I_ASN1_OCTET_STRING = 130;
   ASN1_F_D2I_ASN1_PRINT_TYPE = 131;
   ASN1_F_D2I_ASN1_SET = 132;
   ASN1_F_D2I_ASN1_TIME = 224;
   ASN1_F_D2I_ASN1_TYPE = 133;
   ASN1_F_D2I_ASN1_TYPE_BYTES = 134;
   ASN1_F_D2I_ASN1_UINTEGER = 280;
   ASN1_F_D2I_ASN1_UTCTIME = 135;
   ASN1_F_D2I_ASN1_UTF8STRING = 266;
   ASN1_F_D2I_ASN1_VISIBLESTRING = 267;
   ASN1_F_D2I_AUTHORITY_KEYID = 238;
   ASN1_F_D2I_BASIC_CONSTRAINTS = 227;
   ASN1_F_D2I_DHPARAMS = 136;
   ASN1_F_D2I_DIST_POINT = 276;
   ASN1_F_D2I_DIST_POINT_NAME = 277;
   ASN1_F_D2I_DSAPARAMS = 137;
   ASN1_F_D2I_DSAPRIVATEKEY = 138;
   ASN1_F_D2I_DSAPUBLICKEY = 139;
   ASN1_F_D2I_GENERAL_NAME = 230;
   ASN1_F_D2I_NETSCAPE_CERT_SEQUENCE = 228;
   ASN1_F_D2I_NETSCAPE_PKEY = 140;
   ASN1_F_D2I_NETSCAPE_RSA = 141;
   ASN1_F_D2I_NETSCAPE_RSA_2 = 142;
   ASN1_F_D2I_NETSCAPE_SPKAC = 143;
   ASN1_F_D2I_NETSCAPE_SPKI = 144;
   ASN1_F_D2I_NOTICEREF = 268;
   ASN1_F_D2I_PBE2PARAM = 262;
   ASN1_F_D2I_PBEPARAM = 249;
   ASN1_F_D2I_PBKDF2PARAM = 263;
   ASN1_F_D2I_PKCS12 = 254;
   ASN1_F_D2I_PKCS12_BAGS = 255;
   ASN1_F_D2I_PKCS12_MAC_DATA = 256;
   ASN1_F_D2I_PKCS12_SAFEBAG = 257;
   ASN1_F_D2I_PKCS7 = 145;
   ASN1_F_D2I_PKCS7_DIGEST = 146;
   ASN1_F_D2I_PKCS7_ENCRYPT = 147;
   ASN1_F_D2I_PKCS7_ENC_CONTENT = 148;
   ASN1_F_D2I_PKCS7_ENVELOPE = 149;
   ASN1_F_D2I_PKCS7_ISSUER_AND_SERIAL = 150;
   ASN1_F_D2I_PKCS7_RECIP_INFO = 151;
   ASN1_F_D2I_PKCS7_SIGNED = 152;
   ASN1_F_D2I_PKCS7_SIGNER_INFO = 153;
   ASN1_F_D2I_PKCS7_SIGN_ENVELOPE = 154;
   ASN1_F_D2I_PKCS8_PRIV_KEY_INFO = 250;
   ASN1_F_D2I_PKEY_USAGE_PERIOD = 239;
   ASN1_F_D2I_POLICYINFO = 269;
   ASN1_F_D2I_POLICYQUALINFO = 270;
   ASN1_F_D2I_PRIVATEKEY = 155;
   ASN1_F_D2I_PUBLICKEY = 156;
   ASN1_F_D2I_RSAPRIVATEKEY = 157;
   ASN1_F_D2I_RSAPUBLICKEY = 158;
   ASN1_F_D2I_SXNET = 241;
   ASN1_F_D2I_SXNETID = 243;
   ASN1_F_D2I_USERNOTICE = 271;
   ASN1_F_D2I_X509 = 159;
   ASN1_F_D2I_X509_ALGOR = 160;
   ASN1_F_D2I_X509_ATTRIBUTE = 161;
   ASN1_F_D2I_X509_CINF = 162;
   ASN1_F_D2I_X509_CRL = 163;
   ASN1_F_D2I_X509_CRL_INFO = 164;
   ASN1_F_D2I_X509_EXTENSION = 165;
   ASN1_F_D2I_X509_KEY = 166;
   ASN1_F_D2I_X509_NAME = 167;
   ASN1_F_D2I_X509_NAME_ENTRY = 168;
   ASN1_F_D2I_X509_PKEY = 169;
   ASN1_F_D2I_X509_PUBKEY = 170;
   ASN1_F_D2I_X509_REQ = 171;
   ASN1_F_D2I_X509_REQ_INFO = 172;
   ASN1_F_D2I_X509_REVOKED = 173;
   ASN1_F_D2I_X509_SIG = 174;
   ASN1_F_D2I_X509_VAL = 175;
   ASN1_F_DIST_POINT_NAME_NEW = 278;
   ASN1_F_DIST_POINT_NEW = 279;
   ASN1_F_GENERAL_NAME_NEW = 231;
   ASN1_F_I2D_ASN1_HEADER = 176;
   ASN1_F_I2D_ASN1_TIME = 225;
   ASN1_F_I2D_DHPARAMS = 177;
   ASN1_F_I2D_DSAPARAMS = 178;
   ASN1_F_I2D_DSAPRIVATEKEY = 179;
   ASN1_F_I2D_DSAPUBLICKEY = 180;
   ASN1_F_I2D_NETSCAPE_RSA = 181;
   ASN1_F_I2D_PKCS7 = 182;
   ASN1_F_I2D_PRIVATEKEY = 183;
   ASN1_F_I2D_PUBLICKEY = 184;
   ASN1_F_I2D_RSAPRIVATEKEY = 185;
   ASN1_F_I2D_RSAPUBLICKEY = 186;
   ASN1_F_I2D_X509_ATTRIBUTE = 187;
   ASN1_F_I2T_ASN1_OBJECT = 188;
   ASN1_F_NETSCAPE_CERT_SEQUENCE_NEW = 229;
   ASN1_F_NETSCAPE_PKEY_NEW = 189;
   ASN1_F_NETSCAPE_SPKAC_NEW = 190;
   ASN1_F_NETSCAPE_SPKI_NEW = 191;
   ASN1_F_NOTICEREF_NEW = 272;
   ASN1_F_PBE2PARAM_NEW = 264;
   ASN1_F_PBEPARAM_NEW = 251;
   ASN1_F_PBKDF2PARAM_NEW = 265;
   ASN1_F_PKCS12_BAGS_NEW = 258;
   ASN1_F_PKCS12_MAC_DATA_NEW = 259;
   ASN1_F_PKCS12_NEW = 260;
   ASN1_F_PKCS12_SAFEBAG_NEW = 261;
   ASN1_F_PKCS5_PBE2_SET = 281;
   ASN1_F_PKCS7_DIGEST_NEW = 192;
   ASN1_F_PKCS7_ENCRYPT_NEW = 193;
   ASN1_F_PKCS7_ENC_CONTENT_NEW = 194;
   ASN1_F_PKCS7_ENVELOPE_NEW = 195;
   ASN1_F_PKCS7_ISSUER_AND_SERIAL_NEW = 196;
   ASN1_F_PKCS7_NEW = 197;
   ASN1_F_PKCS7_RECIP_INFO_NEW = 198;
   ASN1_F_PKCS7_SIGNED_NEW = 199;
   ASN1_F_PKCS7_SIGNER_INFO_NEW = 200;
   ASN1_F_PKCS7_SIGN_ENVELOPE_NEW = 201;
   ASN1_F_PKCS8_PRIV_KEY_INFO_NEW = 252;
   ASN1_F_PKEY_USAGE_PERIOD_NEW = 240;
   ASN1_F_POLICYINFO_NEW = 273;
   ASN1_F_POLICYQUALINFO_NEW = 274;
   ASN1_F_SXNETID_NEW = 244;
   ASN1_F_SXNET_NEW = 242;
   ASN1_F_USERNOTICE_NEW = 275;
   ASN1_F_X509_ALGOR_NEW = 202;
   ASN1_F_X509_ATTRIBUTE_NEW = 203;
   ASN1_F_X509_CINF_NEW = 204;
   ASN1_F_X509_CRL_INFO_NEW = 205;
   ASN1_F_X509_CRL_NEW = 206;
   ASN1_F_X509_DHPARAMS_NEW = 207;
   ASN1_F_X509_EXTENSION_NEW = 208;
   ASN1_F_X509_INFO_NEW = 209;
   ASN1_F_X509_KEY_NEW = 210;
   ASN1_F_X509_NAME_ENTRY_NEW = 211;
   ASN1_F_X509_NAME_NEW = 212;
   ASN1_F_X509_NEW = 213;
   ASN1_F_X509_PKEY_NEW = 214;
   ASN1_F_X509_PUBKEY_NEW = 215;
   ASN1_F_X509_REQ_INFO_NEW = 216;
   ASN1_F_X509_REQ_NEW = 217;
   ASN1_F_X509_REVOKED_NEW = 218;
   ASN1_F_X509_SIG_NEW = 219;
   ASN1_F_X509_VAL_FREE = 220;
   ASN1_F_X509_VAL_NEW = 221;
   ASN1_OBJECT_FLAG_CRITICAL = $02;
   ASN1_OBJECT_FLAG_DYNAMIC = $01;
   ASN1_OBJECT_FLAG_DYNAMIC_DATA = $08;
   ASN1_OBJECT_FLAG_DYNAMIC_STRINGS = $04;
   ASN1_R_ADDING_OBJECT = 171;
   ASN1_R_ASN1_PARSE_ERROR = 198;
   ASN1_R_ASN1_SIG_PARSE_ERROR = 199;
   ASN1_R_AUX_ERROR = 100;
   ASN1_R_BAD_CLASS = 101;
   ASN1_R_BAD_OBJECT_HEADER = 102;
   ASN1_R_BAD_PASSWORD_READ = 103;
   ASN1_R_BAD_TAG = 104;
   ASN1_R_BMPSTRING_IS_WRONG_LENGTH = 210;
   ASN1_R_BN_LIB = 105;
   ASN1_R_BOOLEAN_IS_WRONG_LENGTH = 106;
   ASN1_R_BUFFER_TOO_SMALL = 107;
   ASN1_R_CIPHER_HAS_NO_OBJECT_IDENTIFIER = 108;
   ASN1_R_DATA_IS_WRONG = 109;
   ASN1_R_DECODE_ERROR = 110;
   ASN1_R_DECODING_ERROR = 111;
   ASN1_R_DEPTH_EXCEEDED = 174;
   ASN1_R_ENCODE_ERROR = 112;
   ASN1_R_ERROR_GETTING_TIME = 173;
   ASN1_R_ERROR_LOADING_SECTION = 172;
   ASN1_R_ERROR_PARSING_SET_ELEMENT = 113;
   ASN1_R_ERROR_SETTING_CIPHER_PARAMS = 114;
   ASN1_R_EXPECTING_AN_INTEGER = 115;
   ASN1_R_EXPECTING_AN_OBJECT = 116;
   ASN1_R_EXPECTING_A_BOOLEAN = 117;
   ASN1_R_EXPECTING_A_TIME = 118;
   ASN1_R_EXPLICIT_LENGTH_MISMATCH = 119;
   ASN1_R_EXPLICIT_TAG_NOT_CONSTRUCTED = 120;
   ASN1_R_FIELD_MISSING = 121;
   ASN1_R_FIRST_NUM_TOO_LARGE = 122;
   ASN1_R_HEADER_TOO_LONG = 123;
   ASN1_R_ILLEGAL_BITSTRING_FORMAT = 175;
   ASN1_R_ILLEGAL_BOOLEAN = 176;
   ASN1_R_ILLEGAL_CHARACTERS = 124;
   ASN1_R_ILLEGAL_FORMAT = 177;
   ASN1_R_ILLEGAL_HEX = 178;
   ASN1_R_ILLEGAL_IMPLICIT_TAG = 179;
   ASN1_R_ILLEGAL_INTEGER = 180;
   ASN1_R_ILLEGAL_NESTED_TAGGING = 181;
   ASN1_R_ILLEGAL_NULL = 125;
   ASN1_R_ILLEGAL_NULL_VALUE = 182;
   ASN1_R_ILLEGAL_OBJECT = 183;
   ASN1_R_ILLEGAL_OPTIONAL_ANY = 126;
   ASN1_R_ILLEGAL_OPTIONS_ON_ITEM_TEMPLATE = 170;
   ASN1_R_ILLEGAL_TAGGED_ANY = 127;
   ASN1_R_ILLEGAL_TIME_VALUE = 184;
   ASN1_R_INTEGER_NOT_ASCII_FORMAT = 185;
   ASN1_R_INTEGER_TOO_LARGE_FOR_LONG = 128;
   ASN1_R_INVALID_BMPSTRING_LENGTH = 129;
   ASN1_R_INVALID_DIGIT = 130;
   ASN1_R_INVALID_MIME_TYPE = 200;
   ASN1_R_INVALID_MODIFIER = 186;
   ASN1_R_INVALID_NUMBER = 187;
   ASN1_R_INVALID_OBJECT_ENCODING = 212;
   ASN1_R_INVALID_SEPARATOR = 131;
   ASN1_R_INVALID_TIME_FORMAT = 132;
   ASN1_R_INVALID_UNIVERSALSTRING_LENGTH = 133;
   ASN1_R_INVALID_UTF8STRING = 134;
   ASN1_R_IV_TOO_LARGE = 135;
   ASN1_R_LENGTH_ERROR = 136;
   ASN1_R_LIST_ERROR = 188;
   ASN1_R_MIME_NO_CONTENT_TYPE = 201;
   ASN1_R_MIME_PARSE_ERROR = 202;
   ASN1_R_MIME_SIG_PARSE_ERROR = 203;
   ASN1_R_MISSING_EOC = 137;
   ASN1_R_MISSING_SECOND_NUMBER = 138;
   ASN1_R_MISSING_VALUE = 189;
   ASN1_R_MSTRING_NOT_UNIVERSAL = 139;
   ASN1_R_MSTRING_WRONG_TAG = 140;
   ASN1_R_NESTED_ASN1_STRING = 197;
   ASN1_R_NON_HEX_CHARACTERS = 141;
   ASN1_R_NOT_ASCII_FORMAT = 190;
   ASN1_R_NOT_ENOUGH_DATA = 142;
   ASN1_R_NO_CONTENT_TYPE = 204;
   ASN1_R_NO_MATCHING_CHOICE_TYPE = 143;
   ASN1_R_NO_MULTIPART_BODY_FAILURE = 205;
   ASN1_R_NO_MULTIPART_BOUNDARY = 206;
   ASN1_R_NO_SIG_CONTENT_TYPE = 207;
   ASN1_R_NULL_IS_WRONG_LENGTH = 144;
   ASN1_R_OBJECT_NOT_ASCII_FORMAT = 191;
   ASN1_R_ODD_NUMBER_OF_CHARS = 145;
   ASN1_R_PRIVATE_KEY_HEADER_MISSING = 146;
   ASN1_R_SECOND_NUMBER_TOO_LARGE = 147;
   ASN1_R_SEQUENCE_LENGTH_MISMATCH = 148;
   ASN1_R_SEQUENCE_NOT_CONSTRUCTED = 149;
   ASN1_R_SEQUENCE_OR_SET_NEEDS_CONFIG = 192;
   ASN1_R_SHORT_LINE = 150;
   ASN1_R_SIG_INVALID_MIME_TYPE = 208;
   ASN1_R_STREAMING_NOT_SUPPORTED = 209;
   ASN1_R_STRING_TOO_LONG = 151;
   ASN1_R_STRING_TOO_SHORT = 152;
   ASN1_R_TAG_VALUE_TOO_HIGH = 153;
   ASN1_R_THE_ASN1_OBJECT_IDENTIFIER_IS_NOT_KNOWN_FOR_THIS_MD = 154;
   ASN1_R_TIME_NOT_ASCII_FORMAT = 193;
   ASN1_R_TOO_LONG = 155;
   ASN1_R_TYPE_NOT_CONSTRUCTED = 156;
   ASN1_R_UNABLE_TO_DECODE_RSA_KEY = 157;
   ASN1_R_UNABLE_TO_DECODE_RSA_PRIVATE_KEY = 158;
   ASN1_R_UNEXPECTED_EOC = 159;
   ASN1_R_UNIVERSALSTRING_IS_WRONG_LENGTH = 211;
   ASN1_R_UNKNOWN_FORMAT = 160;
   ASN1_R_UNKNOWN_MESSAGE_DIGEST_ALGORITHM = 161;
   ASN1_R_UNKNOWN_OBJECT_TYPE = 162;
   ASN1_R_UNKNOWN_PUBLIC_KEY_TYPE = 163;
   ASN1_R_UNKNOWN_TAG = 194;
   ASN1_R_UNKOWN_FORMAT = 195;
   ASN1_R_UNSUPPORTED_ANY_DEFINED_BY_TYPE = 164;
   ASN1_R_UNSUPPORTED_CIPHER = 165;
   ASN1_R_UNSUPPORTED_ENCRYPTION_ALGORITHM = 166;
   ASN1_R_UNSUPPORTED_PUBLIC_KEY_TYPE = 167;
   ASN1_R_UNSUPPORTED_TYPE = 196;
   ASN1_R_WRONG_TAG = 168;
   ASN1_R_WRONG_TYPE = 169;
   ASN1_STRING_FLAG_BITS_LEFT = $08;
   ASN1_STRING_FLAG_NDEF = $010;
   ASN1_STRING_FLAG_CONT = $020;
   ASN1_LONG_UNDEF = $7FFFFFFF;
   UB_NAME = 32768;
   UB_COMMON_NAME = 64;
   UB_LOCALITY_NAME = 128;
   UB_STATE_NAME = 128;
   UB_ORGANIZATION_NAME = 64;
   UB_ORGANIZATION_UNIT_NAME = 64;
   UB_TITLE = 64;
   UB_EMAIL_ADDRESS = 128;
   ASN1_STRFLGS_ESC_2253 = 1;
   ASN1_STRFLGS_ESC_CTRL = 2;
   ASN1_STRFLGS_ESC_MSB = 4;
   ASN1_STRFLGS_ESC_QUOTE = 8;
   ASN1_STRFLGS_UTF8_CONVERT = $10;
   ASN1_STRFLGS_IGNORE_TYPE = $20;
   ASN1_STRFLGS_SHOW_TYPE = $40;
   ASN1_STRFLGS_DUMP_ALL = $80;
   ASN1_STRFLGS_DUMP_UNKNOWN = $100;
   ASN1_STRFLGS_DUMP_DER = $200;
   ASN1_STRFLGS_RFC2253 = ASN1_STRFLGS_ESC_2253 Or ASN1_STRFLGS_ESC_CTRL Or ASN1_STRFLGS_ESC_MSB Or ASN1_STRFLGS_UTF8_CONVERT Or
      ASN1_STRFLGS_DUMP_UNKNOWN Or ASN1_STRFLGS_DUMP_DER;
   BIO_BIND_NORMAL = 0;
   BIO_BIND_REUSEADDR = 2;
   BIO_BIND_REUSEADDR_IF_UNUSED = 1;
   BIO_CB_CTRL = $06;
   BIO_CB_FREE = $01;
   BIO_CB_GETS = $05;
   BIO_CB_PUTS = $04;
   BIO_CB_READ = $02;
   BIO_CB_RETURN = $80;
   BIO_CB_WRITE = $03;
   BIO_CLOSE = $01;
   BIO_CONN_S_BEFORE = 1;
   BIO_CONN_S_BLOCKED_CONNECT = 7;
   BIO_CONN_S_CONNECT = 5;
   BIO_CONN_S_CREATE_SOCKET = 4;
   BIO_CONN_S_GET_IP = 2;
   BIO_CONN_S_GET_PORT = 3;
   BIO_CONN_S_NBIO = 8;
   BIO_CONN_S_OK = 6;
   BIO_CTRL_DUP = 12;
   BIO_CTRL_EOF = 2;
   BIO_CTRL_FLUSH = 11;
   BIO_CTRL_GET = 5;
   BIO_CTRL_GET_CALLBACK = 15;
   BIO_CTRL_GET_CLOSE = 8;
   BIO_CTRL_INFO = 3;
   BIO_CTRL_PENDING = 10;
   BIO_CTRL_POP = 7;
   BIO_CTRL_PUSH = 6;
   BIO_CTRL_RESET = 1;
   BIO_CTRL_SET = 4;
   BIO_CTRL_SET_CALLBACK = 14;
   BIO_CTRL_SET_CLOSE = 9;
   BIO_CTRL_SET_FILENAME = 30;
   BIO_CTRL_DGRAM_CONNECT = 31;
   BIO_CTRL_DGRAM_SET_CONNECTED = 32;
   BIO_CTRL_DGRAM_SET_RECV_TIMEOUT = 33;
   BIO_CTRL_DGRAM_GET_RECV_TIMEOUT = 34;
   BIO_CTRL_DGRAM_SET_SEND_TIMEOUT = 35;
   BIO_CTRL_DGRAM_GET_SEND_TIMEOUT = 36;
   BIO_CTRL_DGRAM_GET_RECV_TIMER_EXP = 37;
   BIO_CTRL_DGRAM_GET_SEND_TIMER_EXP = 38;
   BIO_CTRL_DGRAM_MTU_DISCOVER = 39;
   BIO_CTRL_DGRAM_QUERY_MTU = 40;
   BIO_CTRL_DGRAM_GET_MTU = 41;
   BIO_CTRL_DGRAM_SET_MTU = 42;
   BIO_CTRL_DGRAM_MTU_EXCEEDED = 43;
   BIO_CTRL_DGRAM_GET_PEER = 46;
   BIO_CTRL_DGRAM_SET_PEER = 44;
   BIO_CTRL_DGRAM_SET_NEXT_TIMEOUT = 45;
   BIO_CTRL_WPENDING = 13;
   BIO_C_DESTROY_BIO_PAIR = 139;
   BIO_C_DO_STATE_MACHINE = 101;
   BIO_C_FILE_SEEK = 128;
   BIO_C_FILE_TELL = 133;
   BIO_C_GET_ACCEPT = 124;
   BIO_C_GET_BIND_MODE = 132;
   BIO_C_GET_BUFF_NUM_LINES = 116;
   BIO_C_GET_BUF_MEM_PTR = 115;
   BIO_C_GET_CIPHER_CTX = 129;
   BIO_C_GET_CIPHER_STATUS = 113;
   BIO_C_GET_CONNECT = 123;
   BIO_C_GET_FD = 105;
   BIO_C_GET_FILE_PTR = 107;
   BIO_C_GET_MD = 112;
   BIO_C_GET_MD_CTX = 120;
   BIO_C_GET_PROXY_PARAM = 121;
   BIO_C_GET_READ_REQUEST = 141;
   BIO_C_GET_SOCKS = 134;
   BIO_C_GET_SSL = 110;
   BIO_C_GET_SSL_NUM_RENEGOTIATES = 126;
   BIO_C_GET_WRITE_BUF_SIZE = 137;
   BIO_C_GET_WRITE_GUARANTEE = 140;
   BIO_C_MAKE_BIO_PAIR = 138;
   BIO_C_SET_ACCEPT = 118;
   BIO_C_SET_BIND_MODE = 131;
   BIO_C_SET_BUFF_READ_DATA = 122;
   BIO_C_SET_BUFF_SIZE = 117;
   BIO_C_SET_BUF_MEM = 114;
   BIO_C_SET_BUF_MEM_EOF_RETURN = 130;
   BIO_C_SET_CONNECT = 100;
   BIO_C_SET_FD = 104;
   BIO_C_SET_FILENAME = 108;
   BIO_C_SET_FILE_PTR = 106;
   BIO_C_SET_MD = 111;
   BIO_C_SET_NBIO = 102;
   BIO_C_SET_PROXY_PARAM = 103;
   BIO_C_SET_SOCKS = 135;
   BIO_C_SET_SSL = 109;
   BIO_C_SET_SSL_RENEGOTIATE_BYTES = 125;
   BIO_C_SET_SSL_RENEGOTIATE_TIMEOUT = 127;
   BIO_C_SET_WRITE_BUF_SIZE = 136;
   BIO_C_SHUTDOWN_WR = 142;
   BIO_C_NREAD0 = 143;
   BIO_C_NREAD = 144;
   BIO_C_NWRITE0 = 145;
   BIO_C_NWRITE = 146;
   BIO_C_RESET_READ_REQUEST = 147;
   BIO_C_SET_MD_CTX = 148;
   BIO_C_SSL_MODE = 119;
   BIO_FLAGS_BASE64_NO_NL = $100;
   BIO_FLAGS_IO_SPECIAL = $04;
   BIO_FLAGS_READ = $01;
   BIO_FLAGS_WRITE = $02;
   BIO_FLAGS_RWS = BIO_FLAGS_READ Or BIO_FLAGS_WRITE Or BIO_FLAGS_IO_SPECIAL;
   BIO_FLAGS_SHOULD_RETRY = $08;
   BIO_FP_APPEND = $08;
   BIO_FP_READ = $02;
   BIO_FP_TEXT = $10;
   BIO_FP_WRITE = $04;
   BIO_F_ACPT_STATE = 100;
   BIO_F_BIO_ACCEPT = 101;
   BIO_F_BIO_BER_GET_HEADER = 102;
   BIO_F_BIO_CTRL = 103;
   BIO_F_BIO_GETHOSTBYNAME = 120;
   BIO_F_BIO_GETS = 104;
   BIO_F_BIO_GET_ACCEPT_SOCKET = 105;
   BIO_F_BIO_GET_HOST_IP = 106;
   BIO_F_BIO_GET_PORT = 107;
   BIO_F_BIO_MAKE_PAIR = 121;
   BIO_F_BIO_NEW = 108;
   BIO_F_BIO_NEW_FILE = 109;
   BIO_F_BIO_PUTS = 110;
   BIO_F_BIO_READ = 111;
   BIO_F_BIO_SOCK_INIT = 112;
   BIO_F_BIO_WRITE = 113;
   BIO_F_BUFFER_CTRL = 114;
   BIO_F_CONN_STATE = 115;
   BIO_F_FILE_CTRL = 116;
   BIO_F_MEM_WRITE = 117;
   BIO_F_SSL_NEW = 118;
   BIO_F_WSASTARTUP = 119;
   BIO_GHBN_CTRL_CACHE_SIZE = 3;
   BIO_GHBN_CTRL_FLUSH = 5;
   BIO_GHBN_CTRL_GET_ENTRY = 4;
   BIO_GHBN_CTRL_HITS = 1;
   BIO_GHBN_CTRL_MISSES = 2;
   BIO_NOCLOSE = $00;
   BIO_RR_CONNECT = $02;
   BIO_RR_SSL_X509_LOOKUP = $01;
   BIO_R_ACCEPT_ERROR = 100;
   BIO_R_BAD_FOPEN_MODE = 101;
   BIO_R_BAD_HOSTNAME_LOOKUP = 102;
   BIO_R_BROKEN_PIPE = 124;
   BIO_R_CONNECT_ERROR = 103;
   BIO_R_ERROR_SETTING_NBIO = 104;
   BIO_R_ERROR_SETTING_NBIO_ON_ACCEPTED_SOCKET = 105;
   BIO_R_ERROR_SETTING_NBIO_ON_ACCEPT_SOCKET = 106;
   BIO_R_GETHOSTBYNAME_ADDR_IS_NOT_AF_INET = 107;
   BIO_R_INVALID_ARGUMENT = 125;
   BIO_R_INVALID_IP_ADDRESS = 108;
   BIO_R_IN_USE = 123;
   BIO_R_KEEPALIVE = 109;
   BIO_R_NBIO_CONNECT_ERROR = 110;
   BIO_R_NO_ACCEPT_PORT_SPECIFIED = 111;
   BIO_R_NO_HOSTNAME_SPECIFIED = 112;
   BIO_R_NO_PORT_DEFINED = 113;
   BIO_R_NO_PORT_SPECIFIED = 114;
   BIO_R_NULL_PARAMETER = 115;
   BIO_R_TAG_MISMATCH = 116;
   BIO_R_UNABLE_TO_BIND_SOCKET = 117;
   BIO_R_UNABLE_TO_CREATE_SOCKET = 118;
   BIO_R_UNABLE_TO_LISTEN_SOCKET = 119;
   BIO_R_UNINITIALIZED = 120;
   BIO_R_UNSUPPORTED_METHOD = 121;
   BIO_R_WSASTARTUP = 122;
   BIO_TYPE_ACCEPT = 13 Or $0400 Or $0100;
   BIO_TYPE_BASE64 = 11 Or $0200;
   BIO_TYPE_BER = 18 Or $0200;
   BIO_TYPE_BIO = 19 Or $0400;
   BIO_TYPE_BUFFER = 9 Or $0200;
   BIO_TYPE_CIPHER = 10 Or $0200;
   BIO_TYPE_CONNECT = 12 Or $0400 Or $0100;
   BIO_TYPE_DESCRIPTOR = $0100;
   BIO_TYPE_FD = 4 Or $0400 Or $0100;
   BIO_TYPE_FILE = 2 Or $0400;
   BIO_TYPE_FILTER = $0200;
   BIO_TYPE_MD = 8 Or $0200;
   BIO_TYPE_MEM = 1 Or $0400;
   BIO_TYPE_NBIO_TEST = 16 Or $0200;
   BIO_TYPE_NONE = 0;
   BIO_TYPE_NULL = 6 Or $0400;
   BIO_TYPE_NULL_FILTER = 17 Or $0200;
   BIO_TYPE_PROXY_CLIENT = 14 Or $0200;
   BIO_TYPE_PROXY_SERVER = 15 Or $0200;
   BIO_TYPE_SOCKET = 5 Or $0400 Or $0100;
   BIO_TYPE_SOURCE_SINK = $0400;
   BIO_TYPE_SSL = 7 Or $0200;
   BIO_TYPE_LINEBUFFER = 20 Or $0200;
   BIO_TYPE_DGRAM = 21 Or $0400 Or $0100;
   BIO_TYPE_COMP = 23 Or $0200;
   BN_CTX_NUM = 12;
   BN_DEFAULT_BITS = 1280;
   BN_FLG_FREE = $8000;
   BN_FLG_MALLOCED = $01;
   BN_FLG_STATIC_DATA = $02;
   BN_FLG_CONSTTIME = $04;
   BN_FLG_EXP_CONSTTIME = BN_FLG_CONSTTIME;
   BN_F_BN_BLINDING_CONVERT = 100;
   BN_F_BN_BLINDING_INVERT = 101;
   BN_F_BN_BLINDING_NEW = 102;
   BN_F_BN_BLINDING_UPDATE = 103;
   BN_F_BN_BN2DEC = 104;
   BN_F_BN_BN2HEX = 105;
   BN_F_BN_CTX_NEW = 106;
   BN_F_BN_DIV = 107;
   BN_F_BN_DIV_NO_BRANCH = 138;
   BN_F_BN_EXPAND2 = 108;
   BN_F_BN_MOD_EXP_MONT = 109;
   BN_F_BN_MOD_INVERSE = 110;
   BN_F_BN_MOD_INVERSE_NO_BRANCH = 139;
   BN_F_BN_MOD_MUL_RECIPROCAL = 111;
   BN_F_BN_MPI2BN = 112;
   BN_F_BN_NEW = 113;
   BN_F_BN_RAND = 114;
   BN_F_BN_USUB = 115;
   BN_MASK2 = $FFFFFFFF;
   BN_MASK2h = $FFFF0000;
   BN_MASK2h1 = $FFFF8000;
   BN_MASK2l = $FFFF;
   BN_R_ARG2_LT_ARG3 = 100;
   BN_R_BAD_RECIPROCAL = 101;
   BN_R_CALLED_WITH_EVEN_MODULUS = 102;
   BN_R_DIV_BY_ZERO = 103;
   BN_R_ENCODING_ERROR = 104;
   BN_R_EXPAND_ON_STATIC_BIGNUM_DATA = 105;
   BN_R_INVALID_LENGTH = 106;
   BN_R_NOT_INITIALIZED = 107;
   BN_R_NO_INVERSE = 108;
   BN_TBIT = $80000000;
   BUFSIZ = 1024;
   BUF_F_BUF_MEM_GROW = 100;
   BUF_F_BUF_MEM_NEW = 101;
   BUF_F_BUF_STRDUP = 102;
   RAND_F_ENG_RAND_GET_RAND_METHOD = 108;
   RAND_F_FIPS_RAND = 103;
   RAND_F_FIPS_RAND_BYTES = 102;
   RAND_F_FIPS_RAND_GET_RAND_METHOD = 109;
   RAND_F_FIPS_RAND_SET_DT = 106;
   RAND_F_FIPS_SET_DT = 104;
   RAND_F_FIPS_SET_PRNG_SEED = 107;
   RAND_F_FIPS_SET_TEST_MODE = 105;
   RAND_F_RAND_GET_RAND_METHOD = 101;
   RAND_F_SSLEAY_RAND_BYTES = 100;
   RAND_R_NON_FIPS_METHOD = 105;
   RAND_R_NOT_IN_TEST_MODE = 106;
   RAND_R_NO_KEY_SET = 107;
   RAND_R_PRNG_ASKING_FOR_TOO_MUCH = 101;
   RAND_R_PRNG_ERROR = 108;
   RAND_R_PRNG_KEYED = 109;
   RAND_R_PRNG_NOT_REKEYED = 102;
   RAND_R_PRNG_NOT_RESEEDED = 103;
   RAND_R_PRNG_NOT_SEEDED = 100;
   RAND_R_PRNG_SEED_MUST_NOT_MATCH_KEY = 110;
   RAND_R_PRNG_STUCK = 104;
   B_ASN1_BIT_STRING = $0400;
   B_ASN1_BMPSTRING = $0800;
   B_ASN1_GENERALSTRING = $0080;
   B_ASN1_GRAPHICSTRING = $0020;
   B_ASN1_IA5STRING = $0010;
   B_ASN1_ISO64STRING = $0040;
   B_ASN1_NUMERICSTRING = $0001;
   B_ASN1_OCTET_STRING = $0200;
   B_ASN1_PRINTABLESTRING = $0002;
   B_ASN1_T61STRING = $0004;
   B_ASN1_TELETEXSTRING = $0008;
   B_ASN1_UNIVERSALSTRING = $0100;
   B_ASN1_UNKNOWN = $1000;
   B_ASN1_UTF8STRING = $2000;
   B_ASN1_VIDEOTEXSTRING = $0008;
   B_ASN1_VISIBLESTRING = $0040;
   B_ASN1_UTCTIME = $4000;
   B_ASN1_GENERALIZEDTIME = $8000;
   B_ASN1_SEQUENCE = $10000;
   B_ASN1_TIME = B_ASN1_UTCTIME Or B_ASN1_GENERALIZEDTIME;
   B_ASN1_PRINTABLE = B_ASN1_NUMERICSTRING Or B_ASN1_PRINTABLESTRING Or B_ASN1_T61STRING Or B_ASN1_IA5STRING Or B_ASN1_BIT_STRING Or B_ASN1_UNIVERSALSTRING Or
      B_ASN1_BMPSTRING Or B_ASN1_UTF8STRING Or B_ASN1_SEQUENCE Or B_ASN1_UNKNOWN;
   B_ASN1_DIRECTORYSTRING = B_ASN1_PRINTABLESTRING Or B_ASN1_TELETEXSTRING Or B_ASN1_BMPSTRING Or B_ASN1_UNIVERSALSTRING Or B_ASN1_UTF8STRING;
   B_ASN1_DISPLAYTEXT = B_ASN1_IA5STRING Or B_ASN1_VISIBLESTRING Or B_ASN1_BMPSTRING Or B_ASN1_UTF8STRING;
   MBSTRING_FLAG = $1000;
   MBSTRING_UTF8 = MBSTRING_FLAG;
   MBSTRING_ASC = MBSTRING_FLAG Or 1;
   MBSTRING_BMP = MBSTRING_FLAG Or 2;
   MBSTRING_UNIV = MBSTRING_FLAG Or 4;
   SMIME_OLDMIME = $400;
   SMIME_CRLFEOL = $800;
   SMIME_STREAM = $1000;
   _CLOCKS_PER_SEC_ = 1000;
   CLOCKS_PER_SEC = _CLOCKS_PER_SEC_;
   CLK_TCK = CLOCKS_PER_SEC;
   COMP_F_BIO_ZLIB_FLUSH = 99;
   COMP_F_BIO_ZLIB_NEW = 100;
   COMP_F_BIO_ZLIB_READ = 101;
   COMP_F_BIO_ZLIB_WRITE = 102;
   COMP_R_ZLIB_DEFLATE_ERROR = 99;
   COMP_R_ZLIB_INFLATE_ERROR = 100;
   COMP_R_ZLIB_NOT_SUPPORTED = 101;
   CRYPTO_EX_INDEX_BIO = 0;
   CRYPTO_EX_INDEX_SSL = 1;
   CRYPTO_EX_INDEX_SSL_CTX = 2;
   CRYPTO_EX_INDEX_SSL_SESSION = 3;
   CRYPTO_EX_INDEX_X509_STORE = 4;
   CRYPTO_EX_INDEX_X509_STORE_CTX = 5;
   CRYPTO_EX_INDEX_RSA = 6;
   CRYPTO_EX_INDEX_DSA = 7;
   CRYPTO_EX_INDEX_DH = 8;
   CRYPTO_EX_INDEX_ENGINE = 9;
   CRYPTO_EX_INDEX_X509 = 10;
   CRYPTO_EX_INDEX_UI = 11;
   CRYPTO_EX_INDEX_ECDSA = 12;
   CRYPTO_EX_INDEX_ECDH = 13;
   CRYPTO_EX_INDEX_COMP = 14;
   CRYPTO_EX_INDEX_STORE = 15;
   CRYPTO_EX_INDEX_USER = 100;
   CRYPTO_F_CRYPTO_GET_EX_NEW_INDEX = 100;
   CRYPTO_F_CRYPTO_GET_NEW_DYNLOCKID = 103;
   CRYPTO_F_CRYPTO_GET_NEW_LOCKID = 101;
   CRYPTO_F_CRYPTO_SET_EX_DATA = 102;
   CRYPTO_F_DEF_ADD_INDEX = 104;
   CRYPTO_F_DEF_GET_CLASS = 105;
   CRYPTO_F_INT_DUP_EX_DATA = 106;
   CRYPTO_F_INT_FREE_EX_DATA = 107;
   CRYPTO_F_INT_NEW_EX_DATA = 108;
   CRYPTO_R_NO_DYNLOCK_CREATE_CALLBACK = 100;
   CRYPTO_LOCK = 1;
   CRYPTO_LOCK_ERR = 1;
   CRYPTO_LOCK_ERR_HASH = 2;
   CRYPTO_LOCK_X509 = 3;
   CRYPTO_LOCK_X509_INFO = 4;
   CRYPTO_LOCK_X509_PKEY = 5;
   CRYPTO_LOCK_X509_CRL = 6;
   CRYPTO_LOCK_X509_REQ = 7;
   CRYPTO_LOCK_DSA = 8;
   CRYPTO_LOCK_RSA = 9;
   CRYPTO_LOCK_EVP_PKEY = 10;
   CRYPTO_LOCK_X509_STORE = 11;
   CRYPTO_LOCK_SSL_CTX = 12;
   CRYPTO_LOCK_SSL_CERT = 13;
   CRYPTO_LOCK_SSL_SESSION = 14;
   CRYPTO_LOCK_SSL_SESS_CERT = 15;
   CRYPTO_LOCK_SSL = 16;
   CRYPTO_LOCK_SSL_METHOD = 17;
   CRYPTO_LOCK_RAND = 18;
   CRYPTO_LOCK_RAND2 = 19;
   CRYPTO_LOCK_MALLOC = 20;
   CRYPTO_LOCK_BIO = 21;
   CRYPTO_LOCK_GETHOSTBYNAME = 22;
   CRYPTO_LOCK_GETSERVBYNAME = 23;
   CRYPTO_LOCK_READDIR = 24;
   CRYPTO_LOCK_RSA_BLINDING = 25;
   CRYPTO_LOCK_DH = 26;
   CRYPTO_LOCK_MALLOC2 = 27;
   CRYPTO_LOCK_DSO = 28;
   CRYPTO_LOCK_DYNLOCK = 29;
   CRYPTO_LOCK_ENGINE = 30;
   CRYPTO_LOCK_UI = 31;
   CRYPTO_LOCK_ECDSA = 32;
   CRYPTO_LOCK_EC = 33;
   CRYPTO_LOCK_ECDH = 34;
   CRYPTO_LOCK_BN = 35;
   CRYPTO_LOCK_EC_PRE_COMP = 36;
   CRYPTO_LOCK_STORE = 37;
   CRYPTO_LOCK_COMP = 38;
   CRYPTO_LOCK_FIPS = 39;
   CRYPTO_LOCK_FIPS2 = 40;
   CRYPTO_NUM_LOCKS = 41;
   CRYPTO_MEM_CHECK_DISABLE = $3;
   CRYPTO_MEM_CHECK_ENABLE = $2;
   CRYPTO_MEM_CHECK_OFF = $0;
   CRYPTO_MEM_CHECK_ON = $1;
   CRYPTO_READ = 4;
   CRYPTO_UNLOCK = 2;
   CRYPTO_WRITE = 8;
   V_CRYPTO_MDEBUG_TIME = $1;
   V_CRYPTO_MDEBUG_THREAD = $2;
   AES_ENCRYPT = 1;
   AES_DECRYPT = 0;
   AES_MAXNR = 14;
   AES_BLOCK_SIZE = 16;
   DSO_CTRL_GET_FLAGS = 1;
   DSO_CTRL_SET_FLAGS = 2;
   DSO_CTRL_OR_FLAGS = 3;
   DSO_FLAG_NO_NAME_TRANSLATION = $01;
   DSO_FLAG_NAME_TRANSLATION_EXT_ONLY = $02;
   DSO_FLAG_UPCASE_SYMBOL = $10;
   DSO_FLAG_GLOBAL_SYMBOLS = $20;
   SEED_BLOCK_SIZE = 16;
   SEED_KEY_LENGTH = 16;
   CAST_BLOCK = 8;
   CAST_DECRYPT = 0;
   CAST_ENCRYPT = 1;
   CAST_KEY_LENGTH = 16;
   DES_CBC_MODE = 0;
   DES_DECRYPT = 0;
   DES_ENCRYPT = 1;
   DES_PCBC_MODE = 1;
   DH_MAX_MODULUS_BITS = 10000;
   DH_FIPS_MIN_MODULUS_BITS = 1024;
   DH_FLAG_CACHE_MONT_P = $01;
   DH_FLAG_NO_EXP_CONSTTIME = $02;
   DH_GENERATOR_2 = 2;
   DH_GENERATOR_5 = 5;
   DH_CHECK_P_NOT_PRIME = $01;
   DH_CHECK_P_NOT_STRONG_PRIME = $02;
   DH_UNABLE_TO_CHECK_GENERATOR = $04;
   DH_NOT_SUITABLE_GENERATOR = $08;
   DH_CHECK_PUBKEY_TOO_SMALL = $01;
   DH_CHECK_PUBKEY_TOO_LARGE = $02;
   DH_CHECK_P_NOT_SAFE_PRIME = DH_CHECK_P_NOT_STRONG_PRIME;
   DH_F_DHPARAMS_PRINT = 100;
   DH_F_DHPARAMS_PRINT_FP = 101;
   DH_F_COMPUTE_KEY = 102;
   DH_F_GENERATE_KEY = 103;
   DH_F_GENERATE_PARAMETERS = 104;
   DH_F_DH_NEW_METHOD = 105;
   DH_F_DH_NEW = 105;
   DH_F_DH_BUILTIN_GENPARAMS = 106;
   DH_F_DH_COMPUTE_KEY = 107;
   DH_F_DH_GENERATE_KEY = 108;
   DH_F_DH_GENERATE_PARAMETERS = 109;
   DH_R_NO_PRIVATE_VALUE = 100;
   DH_R_BAD_GENERATOR = 101;
   DH_R_INVALID_PUBKEY = 102;
   DH_R_MODULUS_TOO_LARGE = 103;
   DH_R_KEY_SIZE_TOO_SMALL = 104;
   DSA_MAX_MODULUS_BITS = 10000;
   DSA_FIPS_MIN_MODULUS_BITS = 1024;
   DSA_FLAG_CACHE_MONT_P = $01;
   DSA_FLAG_NO_EXP_CONSTTIME = $02;
   DSA_FLAG_FIPS_METHOD = $0400;
   DSA_FLAG_NON_FIPS_ALLOW = $0400;
   DSA_F_D2I_DSA_SIG = 110;
   DSA_F_DSAPARAMS_PRINT = 100;
   DSA_F_DSAPARAMS_PRINT_FP = 101;
   DSA_F_DSA_BUILTIN_KEYGEN = 119;
   DSA_F_DSA_BUILTIN_PARAMGEN = 118;
   DSA_F_DSA_DO_SIGN = 112;
   DSA_F_DSA_DO_VERIFY = 113;
   DSA_F_DSA_IS_PRIME = 102;
   DSA_F_DSA_NEW = 103;
   DSA_F_DSA_PRINT = 104;
   DSA_F_DSA_PRINT_FP = 105;
   DSA_F_DSA_SIGN = 106;
   DSA_F_DSA_SIGN_SETUP = 107;
   DSA_F_DSA_SIG_NEW = 109;
   DSA_F_DSA_VERIFY = 108;
   DSA_F_DSA_GENERATE_PARAMETERS = 117;
   DSA_F_I2D_DSA_SIG = 111;
   DSA_F_SIG_CB = 114;
   DSA_R_DATA_TOO_LARGE_FOR_KEY_SIZE = 100;
   DSA_R_MISSING_PARAMETERS = 101;
   DSA_R_BAD_Q_VALUE = 102;
   DSA_R_MODULUS_TOO_LARGE = 103;
   DSA_R_NON_FIPS_METHOD = 104;
   DSA_R_OPERATION_NOT_ALLOWED_IN_FIPS_MODE = 105;
   DSA_R_KEY_SIZE_TOO_SMALL = 106;
   ECC_MAX_FIELD_BITS = 661;
   EC_NAMED_CURVE = $001;
   POINT_CONVERSION_COMPRESSED = 2;
   POINT_CONVERSION_UNCOMPRESSED = 4;
   POINT_CONVERSION_HYBRID = 6;
   EC_PKEY_NO_PARAMETERS = $001;
   EC_PKEY_NO_PUBKEY = $002;
   EC_F_COMPUTE_WNAF = 143;
   EC_F_D2I_ECPARAMETERS = 144;
   EC_F_D2I_ECPKPARAMETERS = 145;
   EC_F_D2I_ECPRIVATEKEY = 146;
   EC_F_ECPARAMETERS_PRINT = 147;
   EC_F_ECPARAMETERS_PRINT_FP = 148;
   EC_F_ECPKPARAMETERS_PRINT = 149;
   EC_F_ECPKPARAMETERS_PRINT_FP = 150;
   EC_F_ECP_NIST_MOD_192 = 203;
   EC_F_ECP_NIST_MOD_224 = 204;
   EC_F_ECP_NIST_MOD_256 = 205;
   EC_F_ECP_NIST_MOD_521 = 206;
   EC_F_EC_ASN1_GROUP2CURVE = 153;
   EC_F_EC_ASN1_GROUP2FIELDID = 154;
   EC_F_EC_ASN1_GROUP2PARAMETERS = 155;
   EC_F_EC_ASN1_GROUP2PKPARAMETERS = 156;
   EC_F_EC_ASN1_PARAMETERS2GROUP = 157;
   EC_F_EC_ASN1_PKPARAMETERS2GROUP = 158;
   EC_F_EC_EX_DATA_SET_DATA = 211;
   EC_F_EC_GF2M_MONTGOMERY_POINT_MULTIPLY = 208;
   EC_F_EC_GF2M_SIMPLE_GROUP_CHECK_DISCRIMINANT = 159;
   EC_F_EC_GF2M_SIMPLE_GROUP_SET_CURVE = 195;
   EC_F_EC_GF2M_SIMPLE_OCT2POINT = 160;
   EC_F_EC_GF2M_SIMPLE_POINT2OCT = 161;
   EC_F_EC_GF2M_SIMPLE_POINT_GET_AFFINE_COORDINATES = 162;
   EC_F_EC_GF2M_SIMPLE_POINT_SET_AFFINE_COORDINATES = 163;
   EC_F_EC_GF2M_SIMPLE_SET_COMPRESSED_COORDINATES = 164;
   EC_F_EC_GFP_MONT_FIELD_DECODE = 133;
   EC_F_EC_GFP_MONT_FIELD_ENCODE = 134;
   EC_F_EC_GFP_MONT_FIELD_MUL = 131;
   EC_F_EC_GFP_MONT_FIELD_SET_TO_ONE = 209;
   EC_F_EC_GFP_MONT_FIELD_SQR = 132;
   EC_F_EC_GFP_MONT_GROUP_SET_CURVE = 189;
   EC_F_EC_GFP_MONT_GROUP_SET_CURVE_GFP = 135;
   EC_F_EC_GFP_NIST_FIELD_MUL = 200;
   EC_F_EC_GFP_NIST_FIELD_SQR = 201;
   EC_F_EC_GFP_NIST_GROUP_SET_CURVE = 202;
   EC_F_EC_GFP_SIMPLE_GROUP_CHECK_DISCRIMINANT = 165;
   EC_F_EC_GFP_SIMPLE_GROUP_SET_CURVE = 166;
   EC_F_EC_GFP_SIMPLE_GROUP_SET_CURVE_GFP = 100;
   EC_F_EC_GFP_SIMPLE_GROUP_SET_GENERATOR = 101;
   EC_F_EC_GFP_SIMPLE_MAKE_AFFINE = 102;
   EC_F_EC_GFP_SIMPLE_OCT2POINT = 103;
   EC_F_EC_GFP_SIMPLE_POINT2OCT = 104;
   EC_F_EC_GFP_SIMPLE_POINTS_MAKE_AFFINE = 137;
   EC_F_EC_GFP_SIMPLE_POINT_GET_AFFINE_COORDINATES = 167;
   EC_F_EC_GFP_SIMPLE_POINT_GET_AFFINE_COORDINATES_GFP = 105;
   EC_F_EC_GFP_SIMPLE_POINT_SET_AFFINE_COORDINATES = 168;
   EC_F_EC_GFP_SIMPLE_POINT_SET_AFFINE_COORDINATES_GFP = 128;
   EC_F_EC_GFP_SIMPLE_SET_COMPRESSED_COORDINATES = 169;
   EC_F_EC_GFP_SIMPLE_SET_COMPRESSED_COORDINATES_GFP = 129;
   EC_F_EC_GROUP_CHECK = 170;
   EC_F_EC_GROUP_CHECK_DISCRIMINANT = 171;
   EC_F_EC_GROUP_COPY = 106;
   EC_F_EC_GROUP_GET0_GENERATOR = 139;
   EC_F_EC_GROUP_GET_COFACTOR = 140;
   EC_F_EC_GROUP_GET_CURVE_GF2M = 172;
   EC_F_EC_GROUP_GET_CURVE_GFP = 130;
   EC_F_EC_GROUP_GET_DEGREE = 173;
   EC_F_EC_GROUP_GET_ORDER = 141;
   EC_F_EC_GROUP_GET_PENTANOMIAL_BASIS = 193;
   EC_F_EC_GROUP_GET_TRINOMIAL_BASIS = 194;
   EC_F_EC_GROUP_NEW = 108;
   EC_F_EC_GROUP_NEW_BY_CURVE_NAME = 174;
   EC_F_EC_GROUP_NEW_FROM_DATA = 175;
   EC_F_EC_GROUP_PRECOMPUTE_MULT = 142;
   EC_F_EC_GROUP_SET_CURVE_GF2M = 176;
   EC_F_EC_GROUP_SET_CURVE_GFP = 109;
   EC_F_EC_GROUP_SET_EXTRA_DATA = 110;
   EC_F_EC_GROUP_SET_GENERATOR = 111;
   EC_F_EC_KEY_CHECK_KEY = 177;
   EC_F_EC_KEY_COPY = 178;
   EC_F_EC_KEY_GENERATE_KEY = 179;
   EC_F_EC_KEY_NEW = 182;
   EC_F_EC_KEY_PRINT = 180;
   EC_F_EC_KEY_PRINT_FP = 181;
   EC_F_EC_POINTS_MAKE_AFFINE = 136;
   EC_F_EC_POINTS_MUL = 138;
   EC_F_EC_POINT_ADD = 112;
   EC_F_EC_POINT_CMP = 113;
   EC_F_EC_POINT_COPY = 114;
   EC_F_EC_POINT_DBL = 115;
   EC_F_EC_POINT_GET_AFFINE_COORDINATES_GF2M = 183;
   EC_F_EC_POINT_GET_AFFINE_COORDINATES_GFP = 116;
   EC_F_EC_POINT_GET_JPROJECTIVE_COORDINATES_GFP = 117;
   EC_F_EC_POINT_INVERT = 210;
   EC_F_EC_POINT_IS_AT_INFINITY = 118;
   EC_F_EC_POINT_IS_ON_CURVE = 119;
   EC_F_EC_POINT_MAKE_AFFINE = 120;
   EC_F_EC_POINT_MUL = 184;
   EC_F_EC_POINT_NEW = 121;
   EC_F_EC_POINT_OCT2POINT = 122;
   EC_F_EC_POINT_POINT2OCT = 123;
   EC_F_EC_POINT_SET_AFFINE_COORDINATES_GF2M = 185;
   EC_F_EC_POINT_SET_AFFINE_COORDINATES_GFP = 124;
   EC_F_EC_POINT_SET_COMPRESSED_COORDINATES_GF2M = 186;
   EC_F_EC_POINT_SET_COMPRESSED_COORDINATES_GFP = 125;
   EC_F_EC_POINT_SET_JPROJECTIVE_COORDINATES_GFP = 126;
   EC_F_EC_POINT_SET_TO_INFINITY = 127;
   EC_F_EC_PRE_COMP_DUP = 207;
   EC_F_EC_PRE_COMP_NEW = 196;
   EC_F_EC_WNAF_MUL = 187;
   EC_F_EC_WNAF_PRECOMPUTE_MULT = 188;
   EC_F_I2D_ECPARAMETERS = 190;
   EC_F_I2D_ECPKPARAMETERS = 191;
   EC_F_I2D_ECPRIVATEKEY = 192;
   EC_F_I2O_ECPUBLICKEY = 151;
   EC_F_O2I_ECPUBLICKEY = 152;
   EC_R_ASN1_ERROR = 115;
   EC_R_ASN1_UNKNOWN_FIELD = 116;
   EC_R_BUFFER_TOO_SMALL = 100;
   EC_R_D2I_ECPKPARAMETERS_FAILURE = 117;
   EC_R_DISCRIMINANT_IS_ZERO = 118;
   EC_R_EC_GROUP_NEW_BY_NAME_FAILURE = 119;
   EC_R_FIELD_TOO_LARGE = 138;
   EC_R_GROUP2PKPARAMETERS_FAILURE = 120;
   EC_R_I2D_ECPKPARAMETERS_FAILURE = 121;
   EC_R_INCOMPATIBLE_OBJECTS = 101;
   EC_R_INVALID_ARGUMENT = 112;
   EC_R_INVALID_COMPRESSED_POINT = 110;
   EC_R_INVALID_COMPRESSION_BIT = 109;
   EC_R_INVALID_ENCODING = 102;
   EC_R_INVALID_FIELD = 103;
   EC_R_INVALID_FORM = 104;
   EC_R_INVALID_GROUP_ORDER = 122;
   EC_R_INVALID_PENTANOMIAL_BASIS = 132;
   EC_R_INVALID_PRIVATE_KEY = 123;
   EC_R_INVALID_TRINOMIAL_BASIS = 137;
   EC_R_MISSING_PARAMETERS = 124;
   EC_R_MISSING_PRIVATE_KEY = 125;
   EC_R_NOT_A_NIST_PRIME = 135;
   EC_R_NOT_A_SUPPORTED_NIST_PRIME = 136;
   EC_R_NOT_IMPLEMENTED = 126;
   EC_R_NOT_INITIALIZED = 111;
   EC_R_NO_FIELD_MOD = 133;
   EC_R_PASSED_NULL_PARAMETER = 134;
   EC_R_PKPARAMETERS2GROUP_FAILURE = 127;
   EC_R_POINT_AT_INFINITY = 106;
   EC_R_POINT_IS_NOT_ON_CURVE = 107;
   EC_R_SLOT_FULL = 108;
   EC_R_UNDEFINED_GENERATOR = 113;
   EC_R_UNDEFINED_ORDER = 128;
   EC_R_UNKNOWN_GROUP = 129;
   EC_R_UNKNOWN_ORDER = 114;
   EC_R_UNSUPPORTED_FIELD = 131;
   EC_R_WRONG_ORDER = 130;
   ECDSA_F_ECDSA_DATA_NEW_METHOD = 100;
   ECDSA_F_ECDSA_DO_SIGN = 101;
   ECDSA_F_ECDSA_DO_VERIFY = 102;
   ECDSA_F_ECDSA_SIGN_SETUP = 103;
   ECDSA_R_BAD_SIGNATURE = 100;
   ECDSA_R_DATA_TOO_LARGE_FOR_KEY_SIZE = 101;
   ECDSA_R_ERR_EC_LIB = 102;
   ECDSA_R_MISSING_PARAMETERS = 103;
   ECDSA_R_RANDOM_NUMBER_GENERATION_FAILED = 104;
   ECDSA_R_SIGNATURE_MALLOC_FAILED = 105;
   ECDH_F_ECDH_COMPUTE_KEY = 100;
   ECDH_F_ECDH_DATA_NEW_METHOD = 101;
   ECDH_R_KDF_FAILED = 102;
   ECDH_R_NO_PRIVATE_VALUE = 100;
   ECDH_R_POINT_ARITHMETIC_FAILURE = 101;
   BF_BLOCK = 8;
   BF_DECRYPT = 0;
   BF_ENCRYPT = 1;
   BF_ROUNDS = 16;
   EVP_MAX_MD_SIZE = 64;
   EVP_MAX_KEY_LENGTH = 32;
   EVP_MAX_IV_LENGTH = 16;
   EVP_MAX_BLOCK_LENGTH = 32;
   NID_dhKeyAgreement = 28;
   NID_dsa = 116;
   NID_dsa_2 = 67;
   NID_dsaWithSHA = 66;
   NID_dsaWithSHA1 = 113;
   NID_dsaWithSHA1_2 = 70;
   EVP_PKEY_MO_SIGN = $0001;
   EVP_PKEY_MO_VERIFY = $0002;
   EVP_PKEY_MO_ENCRYPT = $0004;
   EVP_PKEY_MO_DECRYPT = $0008;
   EVP_MD_FLAG_FIPS = $0400;
   EVP_MD_FLAG_PKEY_DIGEST = $0002;
   EVP_MD_FLAG_PKEY_METHOD_SIGNATURE = $0004;
   EVP_MD_FLAG_DIGALGID_MASK = $0018;
   EVP_MD_FLAG_DIGALGID_NULL = $0000;
   EVP_MD_FLAG_DIGALGID_ABSENT = $0008;
   EVP_MD_FLAG_DIGALGID_CUSTOM = $0018;
   EVP_MD_FLAG_SVCTX = $0800;
   EVP_MD_CTRL_DIGALGID = $1;
   EVP_MD_CTRL_MICALG = $2;
   EVP_MD_CTRL_ALG_CTRL = $1000;
   NID_undef = 0;
   NID_rsaEncryption = 6;
   NID_rsa = 19;
   NID_X9_62_id_ecPublicKey = 408;
   EVP_PKEY_NONE = NID_undef;
   EVP_PKEY_RSA = NID_rsaEncryption;
   EVP_PKEY_RSA2 = NID_rsa;
   EVP_PKEY_DSA = NID_dsa;
   EVP_PKEY_DSA1 = NID_dsa_2;
   EVP_PKEY_DSA2 = NID_dsaWithSHA;
   EVP_PKEY_DSA3 = NID_dsaWithSHA1;
   EVP_PKEY_DSA4 = NID_dsaWithSHA1_2;
   EVP_PKEY_DH = NID_dhKeyAgreement;
   EVP_PKEY_EC = NID_X9_62_id_ecPublicKey;
   EVP_PKT_SIGN = $0010;
   EVP_PKT_ENC = $0020;
   EVP_PKT_EXCH = $0040;
   EVP_PKT_EXP = $1000;
   EVP_PKS_RSA = $0100;
   EVP_PKS_DSA = $0200;
   EVP_PKS_EC = $0400;
   EVP_PK_RSA = $0001;
   EVP_PK_DSA = $0002;
   EVP_PK_DH = $0004;
   EVP_PK_EC = $0008;
   EVP_BLOWFISH_KEY_SIZE = 16;
   EVP_CAST5_KEY_SIZE = 16;
   EVP_RC2_KEY_SIZE = 16;
   EVP_RC4_KEY_SIZE = 16;
   EVP_RC5_32_12_16_KEY_SIZE = 16;
   EVP_MD_CTX_FLAG_ONESHOT = $0001;
   EVP_MD_CTX_FLAG_CLEANED = $0002;
   EVP_MD_CTX_FLAG_REUSE = $0004;
   EVP_MD_CTX_FLAG_NON_FIPS_ALLOW = $0008;
   EVP_MD_CTX_FLAG_PAD_MASK = $F0;
   EVP_MD_CTX_FLAG_PAD_PKCS1 = $00;
   EVP_MD_CTX_FLAG_PAD_X931 = $10;
   EVP_MD_CTX_FLAG_PAD_PSS = $20;
   EVP_MD_CTX_FLAG_PSS_MDLEN = $FFFF;
   EVP_MD_CTX_FLAG_PSS_MREC = $FFFE;
   EVP_MD_CTX_FLAG_NO_INIT = $0100;
   EVP_CIPH_STREAM_CIPHER = $0;
   EVP_CIPH_ECB_MODE = $1;
   EVP_CIPH_CBC_MODE = $2;
   EVP_CIPH_CFB_MODE = $3;
   EVP_CIPH_OFB_MODE = $4;
   EVP_CIPH_CTR_MODE = $5;
   EVP_CIPH_GCM_MODE = $6;
   EVP_CIPH_CCM_MODE = $7;
   EVP_CIPH_XTS_MODE = $10001;
   EVP_CIPH_MODE = $F0007;
   EVP_CIPH_VARIABLE_LENGTH = $8;
   EVP_CIPH_CUSTOM_IV = $10;
   EVP_CIPH_ALWAYS_CALL_INIT = $20;
   EVP_CIPH_CTRL_INIT = $40;
   EVP_CIPH_CUSTOM_KEY_LENGTH = $80;
   EVP_CIPH_NO_PADDING = $100;
   EVP_CIPH_RAND_KEY = $200;
   EVP_CIPH_CUSTOM_COPY = $400;
   EVP_CIPH_FLAG_DEFAULT_ASN1 = $1000;
   EVP_CIPH_FLAG_LENGTH_BITS = $2000;
   EVP_CIPH_FLAG_FIPS = $4000;
   EVP_CIPH_FLAG_NON_FIPS_ALLOW = $8000;
   EVP_CIPH_FLAG_CUSTOM_CIPHER = $100000;
   EVP_CIPH_FLAG_AEAD_CIPHER = $200000;
   EVP_CTRL_INIT = $0;
   EVP_CTRL_SET_KEY_LENGTH = $1;
   EVP_CTRL_GET_RC2_KEY_BITS = $2;
   EVP_CTRL_SET_RC2_KEY_BITS = $3;
   EVP_CTRL_GET_RC5_ROUNDS = $4;
   EVP_CTRL_SET_RC5_ROUNDS = $5;
   EVP_CTRL_RAND_KEY = $6;
   EVP_CTRL_PBE_PRF_NID = $7;
   EVP_CTRL_COPY = $8;
   EVP_CTRL_GCM_SET_IVLEN = $9;
   EVP_CTRL_GCM_GET_TAG = $10;
   EVP_CTRL_GCM_SET_TAG = $11;
   EVP_CTRL_GCM_SET_IV_FIXED = $12;
   EVP_CTRL_GCM_IV_GEN = $13;
   EVP_CTRL_CCM_SET_IVLEN = EVP_CTRL_GCM_SET_IVLEN;
   EVP_CTRL_CCM_GET_TAG = EVP_CTRL_GCM_GET_TAG;
   EVP_CTRL_CCM_SET_TAG = EVP_CTRL_GCM_SET_TAG;
   EVP_CTRL_CCM_SET_L = $14;
   EVP_CTRL_CCM_SET_MSGLEN = $15;
   EVP_CTRL_AEAD_TLS1_AAD = $16;
   EVP_CTRL_AEAD_SET_MAC_KEY = $17;
   EVP_CTRL_GCM_SET_IV_INV = $18;
   EVP_GCM_TLS_FIXED_IV_LEN = 4;
   EVP_GCM_TLS_EXPLICIT_IV_LEN = 8;
   EVP_GCM_TLS_TAG_LEN = 16;
   EVP_PBE_TYPE_OUTER = $0;
   EVP_PBE_TYPE_PRF = $1;
   ASN1_PKEY_ALIAS = $1;
   ASN1_PKEY_DYNAMIC = $2;
   ASN1_PKEY_SIGPARAM_NULL = $4;
   ASN1_PKEY_CTRL_PKCS7_SIGN = $1;
   ASN1_PKEY_CTRL_PKCS7_ENCRYPT = $2;
   ASN1_PKEY_CTRL_DEFAULT_MD_NID = $3;
   ASN1_PKEY_CTRL_CMS_SIGN = $5;
   ASN1_PKEY_CTRL_CMS_ENVELOPE = $7;
   EVP_PKEY_OP_UNDEFINED = 0;
   EVP_PKEY_OP_PARAMGEN = (1 Shl 1);
   EVP_PKEY_OP_KEYGEN = (1 Shl 2);
   EVP_PKEY_OP_SIGN = (1 Shl 3);
   EVP_PKEY_OP_VERIFY = (1 Shl 4);
   EVP_PKEY_OP_VERIFYRECOVER = (1 Shl 5);
   EVP_PKEY_OP_SIGNCTX = (1 Shl 6);
   EVP_PKEY_OP_VERIFYCTX = (1 Shl 7);
   EVP_PKEY_OP_ENCRYPT = (1 Shl 8);
   EVP_PKEY_OP_DECRYPT = (1 Shl 9);
   EVP_PKEY_OP_DERIVE = (1 Shl 10);
   EVP_PKEY_OP_TYPE_SIG =
      (EVP_PKEY_OP_SIGN Or EVP_PKEY_OP_VERIFY Or EVP_PKEY_OP_VERIFYRECOVER Or EVP_PKEY_OP_SIGNCTX Or EVP_PKEY_OP_VERIFYCTX);
   EVP_PKEY_OP_TYPE_CRYPT = (EVP_PKEY_OP_ENCRYPT Or EVP_PKEY_OP_DECRYPT);
   EVP_PKEY_OP_TYPE_NOGEN =
      (EVP_PKEY_OP_TYPE_SIG Or EVP_PKEY_OP_TYPE_CRYPT Or EVP_PKEY_OP_DERIVE);
   EVP_PKEY_OP_TYPE_GEN =
      (EVP_PKEY_OP_PARAMGEN Or EVP_PKEY_OP_KEYGEN);
   EVP_PKEY_CTRL_MD = 1;
   EVP_PKEY_CTRL_PEER_KEY = 2;
   EVP_PKEY_CTRL_PKCS7_ENCRYPT = 3;
   EVP_PKEY_CTRL_PKCS7_DECRYPT = 4;
   EVP_PKEY_CTRL_PKCS7_SIGN = 5;
   EVP_PKEY_CTRL_SET_MAC_KEY = 6;
   EVP_PKEY_CTRL_DIGESTINIT = 7;
   EVP_PKEY_CTRL_SET_IV = 8;
   EVP_PKEY_CTRL_CMS_ENCRYPT = 9;
   EVP_PKEY_CTRL_CMS_DECRYPT = 10;
   EVP_PKEY_CTRL_CMS_SIGN = 11;
   EVP_PKEY_CTRL_CIPHER = 12;
   EVP_PKEY_ALG_CTRL = $1000;
   EVP_PKEY_FLAG_AUTOARGLEN = 2;
   EVP_PKEY_FLAG_SIGCTX_CUSTOM = 4;
   EVP_F_AESNI_INIT_KEY = 165;
   EVP_F_AESNI_XTS_CIPHER = 176;
   EVP_F_AES_INIT_KEY = 133;
   EVP_F_ALG_MODULE_INIT = 138;
   EVP_F_AES_XTS = 172;
   EVP_F_AES_XTS_CIPHER = 175;
   EVP_F_CAMELLIA_INIT_KEY = 159;
   EVP_F_CMAC_INIT = 173;
   EVP_F_D2I_PKEY = 100;
   EVP_F_DO_SIGVER_INIT = 161;
   EVP_F_DO_EVP_ENC_ENGINE = 140;
   EVP_F_DSAPKEY2PKCS8 = 134;
   EVP_F_DSA_PKEY2PKCS8 = 135;
   EVP_F_ECDSA_PKEY2PKCS8 = 129;
   EVP_F_ECKEY_PKEY2PKCS8 = 132;
   EVP_F_EVP_CIPHERINIT_EX = 123;
   EVP_F_EVP_CIPHER_CTX_COPY = 163;
   EVP_F_EVP_CIPHER_CTX_CTRL = 124;
   EVP_F_EVP_CIPHER_CTX_SET_KEY_LENGTH = 122;
   EVP_F_EVP_DECRYPTFINAL_EX = 101;
   EVP_F_EVP_DIGESTINIT_EX = 128;
   EVP_F_EVP_ENCRYPTFINAL_EX = 127;
   EVP_F_EVP_MD_CTX_COPY_EX = 110;
   EVP_F_EVP_MD_SIZE = 162;
   EVP_F_EVP_OPENINIT = 102;
   EVP_F_EVP_PBE_ALG_ADD = 115;
   EVP_F_EVP_PBE_ALG_ADD_TYPE = 160;
   EVP_F_EVP_PBE_CIPHERINIT = 116;
   EVP_F_EVP_PKCS82PKEY = 111;
   EVP_F_EVP_PKEY2PKCS8_BROKEN = 113;
   EVP_F_EVP_PKCS82PKEY_BROKEN = 136;
   EVP_F_EVP_PKEY_COPY_PARAMETERS = 103;
   EVP_F_EVP_PKEY_CTX_CTRL = 137;
   EVP_F_EVP_PKEY_CTX_CTRL_STR = 150;
   EVP_F_EVP_PKEY_CTX_DUP = 156;
   EVP_F_EVP_PKEY_DECRYPT = 104;
   EVP_F_EVP_PKEY_DECRYPT_INIT = 138;
   EVP_F_EVP_PKEY_DECRYPT_OLD = 151;
   EVP_F_EVP_PKEY_DERIVE = 153;
   EVP_F_EVP_PKEY_DERIVE_INIT = 154;
   EVP_F_EVP_PKEY_DERIVE_SET_PEER = 155;
   EVP_F_EVP_PKEY_ENCRYPT = 105;
   EVP_F_EVP_PKEY_ENCRYPT_INIT = 139;
   EVP_F_EVP_PKEY_ENCRYPT_OLD = 152;
   EVP_F_EVP_PKEY_GET1_DH = 119;
   EVP_F_EVP_PKEY_GET1_DSA = 120;
   EVP_F_EVP_PKEY_GET1_ECDSA = 130;
   EVP_F_EVP_PKEY_GET1_EC_KEY = 131;
   EVP_F_EVP_PKEY_GET1_RSA = 121;
   EVP_F_EVP_PKEY_KEYGEN = 146;
   EVP_F_EVP_PKEY_KEYGEN_INIT = 147;
   EVP_F_EVP_PKEY_NEW = 106;
   EVP_F_EVP_PKEY_PARAMGEN = 148;
   EVP_F_EVP_PKEY_PARAMGEN_INIT = 149;
   EVP_F_EVP_PKEY_SIGN = 140;
   EVP_F_EVP_PKEY_SIGN_INIT = 141;
   EVP_F_EVP_PKEY_VERIFY = 142;
   EVP_F_EVP_PKEY_VERIFY_INIT = 143;
   EVP_F_EVP_PKEY_VERIFY_RECOVER = 144;
   EVP_F_EVP_PKEY_VERIFY_RECOVER_INIT = 145;
   EVP_F_EVP_RIJNDAEL = 126;
   EVP_F_EVP_SIGNFINAL = 107;
   EVP_F_EVP_VERIFYFINAL = 108;
   EVP_F_FIPS_CIPHERINIT = 166;
   EVP_F_FIPS_CIPHER_CTX_COPY = 170;
   EVP_F_FIPS_CIPHER_CTX_CTRL = 167;
   EVP_F_FIPS_CIPHER_CTX_SET_KEY_LENGTH = 171;
   EVP_F_FIPS_DIGESTINIT = 168;
   EVP_F_FIPS_MD_CTX_COPY = 169;
   EVP_F_HMAC_INIT_EX = 174;
   EVP_F_INT_CTX_NEW = 157;
   EVP_F_PKCS5_PBE_KEYIVGEN = 117;
   EVP_F_PKCS5_V2_PBKDF2_KEYIVGEN = 164;
   EVP_F_PKCS5_V2_PBE_KEYIVGEN = 118;
   EVP_F_PKCS8_SET_BROKEN = 112;
   EVP_F_PKEY_SET_TYPE = 158;
   EVP_F_RC2_MAGIC_TO_METH = 109;
   EVP_F_RC5_CTRL = 125;
   EVP_R_AES_IV_SETUP_FAILED = 162;
   EVP_R_AES_KEY_SETUP_FAILED = 143;
   EVP_R_ASN1_LIB = 140;
   EVP_R_BAD_BLOCK_LENGTH = 136;
   EVP_R_BAD_DECRYPT = 100;
   EVP_R_BN_DECODE_ERROR = 112;
   EVP_R_BN_PUBKEY_ERROR = 113;
   EVP_R_BUFFER_TOO_SMALL = 155;
   EVP_R_CIPHER_PARAMETER_ERROR = 122;
   EVP_R_COMMAND_NOT_SUPPORTED = 147;
   EVP_R_DECODE_ERROR = 114;
   EVP_R_DIFFERENT_KEY_TYPES = 101;
   EVP_R_DIFFERENT_PARAMETERS = 153;
   EVP_R_DISABLED_FOR_FIPS = 163;
   EVP_R_ENCODE_ERROR = 115;
   EVP_R_ERROR_LOADING_SECTION = 165;
   EVP_R_ERROR_SETTING_FIPS_MODE = 166;
   EVP_R_EVP_PBE_CIPHERINIT_ERROR = 119;
   EVP_R_EXPECTING_AN_RSA_KEY = 127;
   EVP_R_EXPECTING_A_DH_KEY = 128;
   EVP_R_EXPECTING_A_DSA_KEY = 129;
   EVP_R_EXPECTING_A_ECDSA_KEY = 141;
   EVP_R_EXPECTING_A_EC_KEY = 142;
   EVP_R_FIPS_MODE_NOT_SUPPORTED = 167;
   EVP_R_INITIALIZATION_ERROR = 134;
   EVP_R_INPUT_NOT_INITIALIZED = 111;
   EVP_R_INVALID_DIGEST = 152;
   EVP_R_INVALID_KEY_LENGTH = 130;
   EVP_R_INVALID_OPERATION = 148;
   EVP_R_INVALID_FIPS_MODE = 168;
   EVP_R_IV_TOO_LARGE = 102;
   EVP_R_KEYGEN_FAILURE = 120;
   EVP_R_MESSAGE_DIGEST_IS_NULL = 159;
   EVP_R_METHOD_NOT_SUPPORTED = 144;
   EVP_R_MISSING_PARMATERS = 103;
   EVP_R_NO_CIPHER_SET = 131;
   EVP_R_NO_DEFAULT_DIGEST = 158;
   EVP_R_NO_DIGEST_SET = 139;
   EVP_R_NO_DSA_PARAMETERS = 116;
   EVP_R_NO_KEY_SET = 154;
   EVP_R_NO_OPERATION_SET = 149;
   EVP_R_NO_SIGN_FUNCTION_CONFIGURED = 104;
   EVP_R_NO_VERIFY_FUNCTION_CONFIGURED = 105;
   EVP_R_OPERATION_NOT_SUPPORTED_FOR_THIS_KEYTYPE = 150;
   EVP_R_OPERATON_NOT_INITIALIZED = 151;
   EVP_R_PKCS8_UNKNOWN_BROKEN_TYPE = 117;
   EVP_R_PRIVATE_KEY_DECODE_ERROR = 145;
   EVP_R_PRIVATE_KEY_ENCODE_ERROR = 146;
   EVP_R_PUBLIC_KEY_NOT_RSA = 106;
   EVP_R_TOO_LARGE = 164;
   EVP_R_UNKNOWN_CIPHER = 160;
   EVP_R_UNKNOWN_DIGEST = 161;
   EVP_R_UNKNOWN_OPTION = 169;
   EVP_R_UNKNOWN_PBE_ALGORITHM = 121;
   EVP_R_UNSUPPORTED_CIPHER = 107;
   EVP_R_UNSUPORTED_NUMBER_OF_ROUNDS = 135;
   EVP_R_UNSUPPORTED_KEYLENGTH = 123;
   EVP_R_UNSUPPORTED_KEY_DERIVATION_FUNCTION = 124;
   EVP_R_UNSUPPORTED_KEY_SIZE = 108;
   EVP_R_UNSUPPORTED_PRF = 125;
   EVP_R_UNSUPPORTED_PRIVATE_KEY_ALGORITHM = 118;
   EVP_R_UNSUPPORTED_SALT_TYPE = 126;
   EVP_R_WRONG_FINAL_BLOCK_LENGTH = 109;
   EVP_R_WRONG_PUBLIC_KEY_TYPE = 110;
   EVP_R_SEED_KEY_SETUP_FAILED = 162;
   FIPS_F_DH_BUILTIN_GENPARAMS = 100;
   FIPS_F_DSA_BUILTIN_PARAMGEN = 101;
   FIPS_F_DSA_DO_SIGN = 102;
   FIPS_F_DSA_DO_VERIFY = 103;
   FIPS_F_EVP_CIPHERINIT_EX = 124;
   FIPS_F_EVP_DIGESTINIT_EX = 125;
   FIPS_F_FIPS_CHECK_DSA = 104;
   FIPS_F_FIPS_CHECK_INCORE_FINGERPRINT = 105;
   FIPS_F_FIPS_CHECK_RSA = 106;
   FIPS_F_FIPS_DSA_CHECK = 107;
   FIPS_F_FIPS_MODE_SET = 108;
   FIPS_F_FIPS_PKEY_SIGNATURE_TEST = 109;
   FIPS_F_FIPS_SELFTEST_AES = 110;
   FIPS_F_FIPS_SELFTEST_DES = 111;
   FIPS_F_FIPS_SELFTEST_DSA = 112;
   FIPS_F_FIPS_SELFTEST_HMAC = 113;
   FIPS_F_FIPS_SELFTEST_RNG = 114;
   FIPS_F_FIPS_SELFTEST_SHA1 = 115;
   FIPS_F_HASH_FINAL = 123;
   FIPS_F_RSA_BUILTIN_KEYGEN = 116;
   FIPS_F_RSA_EAY_PRIVATE_DECRYPT = 117;
   FIPS_F_RSA_EAY_PRIVATE_ENCRYPT = 118;
   FIPS_F_RSA_EAY_PUBLIC_DECRYPT = 119;
   FIPS_F_RSA_EAY_PUBLIC_ENCRYPT = 120;
   FIPS_F_RSA_X931_GENERATE_KEY_EX = 121;
   FIPS_F_SSLEAY_RAND_BYTES = 122;
   FIPS_R_CANNOT_READ_EXE = 103;
   FIPS_R_CANNOT_READ_EXE_DIGEST = 104;
   FIPS_R_CONTRADICTING_EVIDENCE = 114;
   FIPS_R_EXE_DIGEST_DOES_NOT_MATCH = 105;
   FIPS_R_FINGERPRINT_DOES_NOT_MATCH = 110;
   FIPS_R_FINGERPRINT_DOES_NOT_MATCH_NONPIC_RELOCATED = 111;
   FIPS_R_FINGERPRINT_DOES_NOT_MATCH_SEGMENT_ALIASING = 112;
   FIPS_R_FIPS_MODE_ALREADY_SET = 102;
   FIPS_R_FIPS_SELFTEST_FAILED = 106;
   FIPS_R_INVALID_KEY_LENGTH = 109;
   FIPS_R_KEY_TOO_SHORT = 108;
   FIPS_R_NON_FIPS_METHOD = 100;
   FIPS_R_PAIRWISE_TEST_FAILED = 107;
   FIPS_R_RSA_DECRYPT_ERROR = 115;
   FIPS_R_RSA_ENCRYPT_ERROR = 116;
   FIPS_R_SELFTEST_FAILED = 101;
   FIPS_R_TEST_FAILURE = 117;
   FIPS_R_UNSUPPORTED_PLATFORM = 113;
   ENGINE_METHOD_RSA: cUInt = $0001;
   ENGINE_METHOD_DSA: cUInt = $0002;
   ENGINE_METHOD_DH: cUInt = $0004;
   ENGINE_METHOD_RAND: cUInt = $0008;
   ENGINE_METHOD_ECDH: cUInt = $0010;
   ENGINE_METHOD_ECDSA: cUInt = $0020;
   ENGINE_METHOD_CIPHERS: cUInt = $0040;
   ENGINE_METHOD_DIGESTS: cUInt = $0080;
   ENGINE_METHOD_STORE: cUInt = $0100;
   ENGINE_METHOD_PKEY_METHS: cUInt = $0200;
   ENGINE_METHOD_PKEY_ASN1_METHS: cUInt = $0400;
   ENGINE_METHOD_ALL: cUInt = $FFFF;
   ENGINE_METHOD_NONE: cUInt = $0000;
   ENGINE_TABLE_FLAG_NOINIT: cUInt = $0001;
   ENGINE_FLAGS_MANUAL_CMD_CTRL: cInt = $0002;
   ENGINE_FLAGS_BY_ID_COPY: cInt = $0004;
   ENGINE_CMD_FLAG_NUMERIC: cUInt = $0001;
   ENGINE_CMD_FLAG_STRING: cUInt = $0002;
   ENGINE_CMD_FLAG_NO_INPUT: cUInt = $0004;
   ENGINE_CMD_FLAG_INTERNAL: cUInt = $0008;
   ENGINE_CTRL_SET_LOGSTREAM = 1;
   ENGINE_CTRL_SET_PASSWORD_CALLBACK = 2;
   ENGINE_CTRL_HUP = 3;
   ENGINE_CTRL_SET_USER_INTERFACE = 4;
   _CALLBACK_DATA = 5;
   D_CONFIGURATION = 6;
   D_SECTION = 7;
   ENGINE_CTRL_HAS_CTRL_FUNCTION = 10;
   ENGINE_CTRL_GET_FIRST_CMD_TYPE = 11;
   ENGINE_CTRL_GET_NEXT_CMD_TYPE = 12;
   ENGINE_CTRL_GET_CMD_FROM_NAME = 13;
   ENGINE_CTRL_GET_NAME_LEN_FROM_CMD = 14;
   ENGINE_CTRL_GET_NAME_FROM_CMD = 15;
   ENGINE_CTRL_GET_DESC_LEN_FROM_CMD = 16;
   ENGINE_CTRL_GET_DESC_FROM_CMD = 17;
   ENGINE_CTRL_GET_CMD_FLAGS = 18;
   ENGINE_CMD_BASE = 200;
   ENGINE_CTRL_CHIL_SET_FORKCHECK = 100;
   ENGINE_CTRL_CHIL_NO_LOCKING = 101;
   OSSL_DYNAMIC_VERSION: cUInt = $00020000;
   OSSL_DYNAMIC_OLDEST: cUInt = $00020000;
   ENGINE_F_DYNAMIC_CTRL = 180;
   ENGINE_F_DYNAMIC_GET_DATA_CTX = 181;
   ENGINE_F_DYNAMIC_LOAD = 182;
   ENGINE_F_DYNAMIC_SET_DATA_CTX = 183;
   ENGINE_F_ENGINE_ADD = 105;
   ENGINE_F_ENGINE_BY_ID = 106;
   ENGINE_F_ENGINE_CMD_IS_EXECUTABLE = 170;
   ENGINE_F_ENGINE_CTRL = 142;
   ENGINE_F_ENGINE_CTRL_CMD = 178;
   ENGINE_F_ENGINE_CTRL_CMD_STRING = 171;
   ENGINE_F_ENGINE_FINISH = 107;
   ENGINE_F_ENGINE_FREE_UTIL = 108;
   ENGINE_F_ENGINE_GET_CIPHER = 185;
   ENGINE_F_ENGINE_GET_DEFAULT_TYPE = 177;
   ENGINE_F_ENGINE_GET_DIGEST = 186;
   ENGINE_F_ENGINE_GET_NEXT = 115;
   ENGINE_F_ENGINE_GET_PKEY_ASN1_METH = 193;
   ENGINE_F_ENGINE_GET_PKEY_METH = 192;
   ENGINE_F_ENGINE_GET_PREV = 116;
   ENGINE_F_ENGINE_INIT = 119;
   ENGINE_F_ENGINE_LIST_ADD = 120;
   ENGINE_F_ENGINE_LIST_REMOVE = 121;
   ENGINE_F_ENGINE_LOAD_PRIVATE_KEY = 150;
   ENGINE_F_ENGINE_LOAD_PUBLIC_KEY = 151;
   ENGINE_F_ENGINE_LOAD_SSL_CLIENT_CERT = 194;
   ENGINE_F_ENGINE_NEW = 122;
   ENGINE_F_ENGINE_REMOVE = 123;
   ENGINE_F_ENGINE_SET_DEFAULT_STRING = 189;
   ENGINE_F_ENGINE_SET_DEFAULT_TYPE = 126;
   ENGINE_F_ENGINE_SET_ID = 129;
   ENGINE_F_ENGINE_SET_NAME = 130;
   ENGINE_F_ENGINE_TABLE_REGISTER = 184;
   ENGINE_F_ENGINE_UNLOAD_KEY = 152;
   ENGINE_F_ENGINE_UNLOCKED_FINISH = 191;
   ENGINE_F_ENGINE_UP_REF = 190;
   ENGINE_F_INT_CTRL_HELPER = 172;
   ENGINE_F_INT_ENGINE_CONFIGURE = 188;
   ENGINE_F_INT_ENGINE_MODULE_INIT = 187;
   ENGINE_F_LOG_MESSAGE = 141;
   ENGINE_R_ALREADY_LOADED = 100;
   ENGINE_R_ARGUMENT_IS_NOT_A_NUMBER = 133;
   ENGINE_R_CMD_NOT_EXECUTABLE = 134;
   ENGINE_R_COMMAND_TAKES_INPUT = 135;
   ENGINE_R_COMMAND_TAKES_NO_INPUT = 136;
   ENGINE_R_CONFLICTING_ENGINE_ID = 103;
   ENGINE_R_CTRL_COMMAND_NOT_IMPLEMENTED = 119;
   ENGINE_R_DH_NOT_IMPLEMENTED = 139;
   ENGINE_R_DSA_NOT_IMPLEMENTED = 140;
   ENGINE_R_DSO_FAILURE = 104;
   ENGINE_R_DSO_NOT_FOUND = 132;
   ENGINE_R_ENGINES_SECTION_ERROR = 148;
   ENGINE_R_ENGINE_CONFIGURATION_ERROR = 102;
   ENGINE_R_ENGINE_IS_NOT_IN_LIST = 105;
   ENGINE_R_ENGINE_SECTION_ERROR = 149;
   ENGINE_R_FAILED_LOADING_PRIVATE_KEY = 128;
   ENGINE_R_FAILED_LOADING_PUBLIC_KEY = 129;
   ENGINE_R_FINISH_FAILED = 106;
   ENGINE_R_GET_HANDLE_FAILED = 107;
   ENGINE_R_ID_OR_NAME_MISSING = 108;
   ENGINE_R_INIT_FAILED = 109;
   ENGINE_R_INTERNAL_LIST_ERROR = 110;
   ENGINE_R_INVALID_ARGUMENT = 143;
   ENGINE_R_INVALID_CMD_NAME = 137;
   ENGINE_R_INVALID_CMD_NUMBER = 138;
   ENGINE_R_INVALID_INIT_VALUE = 151;
   ENGINE_R_INVALID_STRING = 150;
   ENGINE_R_NOT_INITIALISED = 117;
   ENGINE_R_NOT_LOADED = 112;
   ENGINE_R_NO_CONTROL_FUNCTION = 120;
   ENGINE_R_NO_INDEX = 144;
   ENGINE_R_NO_LOAD_FUNCTION = 125;
   ENGINE_R_NO_REFERENCE = 130;
   ENGINE_R_NO_SUCH_ENGINE = 116;
   ENGINE_R_NO_UNLOAD_FUNCTION = 126;
   ENGINE_R_PROVIDE_PARAMETERS = 113;
   ENGINE_R_RSA_NOT_IMPLEMENTED = 141;
   ENGINE_R_UNIMPLEMENTED_CIPHER = 146;
   ENGINE_R_UNIMPLEMENTED_DIGEST = 147;
   ENGINE_R_UNIMPLEMENTED_PUBLIC_KEY_METHOD = 101;
   ENGINE_R_VERSION_INCOMPATIBILITY = 145;
   MSS_EXIT_FAILURE = 1;
   MSS_EXIT_SUCCESS = 0;
   FILENAME_MAX = 1024;
   FOPEN_MAX = 20;
   IDEA_BLOCK = 8;
   IDEA_DECRYPT = 0;
   IDEA_ENCRYPT = 1;
   IDEA_KEY_LENGTH = 16;
   IS_SEQUENCE = 0;
   IS_SET = 1;
   KRBDES_DECRYPT = DES_DECRYPT;
   KRBDES_ENCRYPT = DES_ENCRYPT;
   LH_LOAD_MULT = 256;
   L_ctermid = 16;
   L_cuserid = 9;
   L_tmpnam = 1024;
   CAMELLIA_ENCRYPT = 1;
   CAMELLIA_DECRYPT = 0;
   CAMELLIA_BLOCK_SIZE = 16;
   CAMELLIA_TABLE_BYTE_LEN = 272;
   CAMELLIA_TABLE_WORD_LEN = (CAMELLIA_TABLE_BYTE_LEN / 4);
   WHIRLPOOL_DIGEST_LENGTH = (512 Div 8);
   WHIRLPOOL_BBLOCK = 512;
   WHIRLPOOL_COUNTER = (256 Div 8);
   MD2_BLOCK = 16;
   MD2_DIGEST_LENGTH = 16;
   MD4_CBLOCK = 64;
   MD4_LBLOCK = (MD4_CBLOCK Div 4);
   MD4_DIGEST_LENGTH = 16;
   MD5_CBLOCK = 64;
   MD5_LBLOCK = 16;
   MD5_DIGEST_LENGTH = 16;
   OPENSSL_MDC2_BLOCK = 8;
   OPENSSL_MDC2_DIGEST_LENGTH = 16;
   SHA_LBLOCK = 16;
   SHA_CBLOCK = 64;
   SHA_DIGEST_LENGTH = 20;
   SHA_LAST_BLOCK = (SHA_CBLOCK - 8);
   SHA256_CBLOCK = (SHA_LBLOCK * 4);
   SHA224_DIGEST_LENGTH = 28;
   SHA256_DIGEST_LENGTH = 32;
   SHA384_DIGEST_LENGTH = 48;
   SHA512_DIGEST_LENGTH = 64;
   SHA512_CBLOCK = (SHA_LBLOCK * 8);
   LN_SMIMECapabilities = 'S/MIME Capabilities';
   LN_X500 = 'X500';
   LN_X509 = 'X509';
   LN_algorithm = 'algorithm';
   LN_authority_key_identifier = 'X509v3 Authority Key Identifier';
   LN_basic_constraints = 'X509v3 Basic Constraints';
   LN_bf_cbc = 'bf-cbc';
   LN_bf_cfb64 = 'bf-cfb';
   LN_bf_ecb = 'bf-ecb';
   LN_bf_ofb64 = 'bf-ofb';
   LN_cast5_cbc = 'cast5-cbc';
   LN_cast5_cfb64 = 'cast5-cfb';
   LN_cast5_ecb = 'cast5-ecb';
   LN_cast5_ofb64 = 'cast5-ofb';
   LN_certBag = 'certBag';
   LN_certificate_policies = 'X509v3 Certificate Policies';
   LN_client_auth = 'TLS Web Client Authentication';
   LN_code_sign = 'Code Signing';
   LN_commonName = 'commonName';
   LN_countryName = 'countryName';
   LN_crlBag = 'crlBag';
   LN_crl_distribution_points = 'X509v3 CRL Distribution Points';
   LN_crl_number = 'X509v3 CRL Number';
   LN_crl_reason = 'CRL Reason Code';
   LN_delta_crl = 'X509v3 Delta CRL Indicator';
   LN_des_cbc = 'des-cbc';
   LN_des_cfb64 = 'des-cfb';
   LN_des_ecb = 'des-ecb';
   LN_des_ede = 'des-ede';
   LN_des_ede3 = 'des-ede3';
   LN_des_ede3_cbc = 'des-ede3-cbc';
   LN_des_ede3_cfb64 = 'des-ede3-cfb';
   LN_des_ede3_ofb64 = 'des-ede3-ofb';
   LN_des_ede_cbc = 'des-ede-cbc';
   LN_des_ede_cfb64 = 'des-ede-cfb';
   LN_des_ede_ofb64 = 'des-ede-ofb';
   LN_des_ofb64 = 'des-ofb';
   LN_description = 'description';
   LN_desx_cbc = 'desx-cbc';
   LN_dhKeyAgreement = 'dhKeyAgreement';
   LN_dsa = 'dsaEncryption';
   LN_dsaWithSHA = 'dsaWithSHA';
   LN_dsaWithSHA1 = 'dsaWithSHA1';
   LN_dsaWithSHA1_2 = 'dsaWithSHA1-old';
   LN_dsa_2 = 'dsaEncryption-old';
   LN_email_protect = 'E-mail Protection';
   LN_ext_key_usage = 'X509v3 Extended Key Usage';
   LN_friendlyName = 'friendlyName';
   LN_givenName = 'givenName';
   LN_hmacWithSHA1 = 'hmacWithSHA1';
   LN_id_pbkdf2 = 'PBKDF2';
   LN_id_qt_cps = 'Policy Qualifier CPS';
   LN_id_qt_unotice = 'Policy Qualifier User Notice';
   LN_idea_cbc = 'idea-cbc';
   LN_idea_cfb64 = 'idea-cfb';
   LN_idea_ecb = 'idea-ecb';
   LN_idea_ofb64 = 'idea-ofb';
   LN_initials = 'initials';
   LN_invalidity_date = 'Invalidity Date';
   LN_issuer_alt_name = 'X509v3 Issuer Alternative Name';
   LN_keyBag = 'keyBag';
   LN_key_usage = 'X509v3 Key Usage';
   LN_localKeyID = 'localKeyID';
   LN_localityName = 'localityName';
   LN_md2 = 'md2';
   LN_md2WithRSAEncryption = 'md2WithRSAEncryption';
   LN_md4 = 'md4';
   LN_md5 = 'md5';
   LN_md5WithRSA = 'md5WithRSA';
   LN_md5WithRSAEncryption = 'md5WithRSAEncryption';
   LN_md5_sha1 = 'md5-sha1';
   LN_mdc2 = 'mdc2';
   LN_mdc2WithRSA = 'mdc2withRSA';
   LN_ms_code_com = 'Microsoft Commercial Code Signing';
   LN_ms_code_ind = 'Microsoft Individual Code Signing';
   LN_ms_ctl_sign = 'Microsoft Trust List Signing';
   LN_ms_efs = 'Microsoft Encrypted File System';
   LN_ms_sgc = 'Microsoft Server Gated Crypto';
   LN_netscape = 'Netscape Communications Corp.';
   LN_netscape_base_url = 'Netscape Base Url';
   LN_netscape_ca_policy_url = 'Netscape CA Policy Url';
   LN_netscape_ca_revocation_url = 'Netscape CA Revocation Url';
   LN_netscape_cert_extension = 'Netscape Certificate Extension';
   LN_netscape_cert_sequence = 'Netscape Certificate Sequence';
   LN_netscape_cert_type = 'Netscape Cert Type';
   LN_netscape_comment = 'Netscape Comment';
   LN_netscape_data_type = 'Netscape Data Type';
   LN_netscape_renewal_url = 'Netscape Renewal Url';
   LN_netscape_revocation_url = 'Netscape Revocation Url';
   LN_netscape_ssl_server_name = 'Netscape SSL Server Name';
   LN_ns_sgc = 'Netscape Server Gated Crypto';
   LN_organizationName = 'organizationName';
   LN_organizationalUnitName = 'organizationalUnitName';
   LN_pbeWithMD2AndDES_CBC = 'pbeWithMD2AndDES-CBC';
   LN_pbeWithMD2AndRC2_CBC = 'pbeWithMD2AndRC2-CBC';
   LN_pbeWithMD5AndCast5_CBC = 'pbeWithMD5AndCast5CBC';
   LN_pbeWithMD5AndDES_CBC = 'pbeWithMD5AndDES-CBC';
   LN_pbeWithMD5AndRC2_CBC = 'pbeWithMD5AndRC2-CBC';
   LN_pbeWithSHA1AndDES_CBC = 'pbeWithSHA1AndDES-CBC';
   LN_pbeWithSHA1AndRC2_CBC = 'pbeWithSHA1AndRC2-CBC';
   LN_pbe_WithSHA1And128BitRC2_CBC = 'pbeWithSHA1And128BitRC2-CBC';
   LN_pbe_WithSHA1And128BitRC4 = 'pbeWithSHA1And128BitRC4';
   LN_pbe_WithSHA1And2_Key_TripleDES_CBC = 'pbeWithSHA1And2-KeyTripleDES-CBC';
   LN_pbe_WithSHA1And3_Key_TripleDES_CBC = 'pbeWithSHA1And3-KeyTripleDES-CBC';
   LN_pbe_WithSHA1And40BitRC2_CBC = 'pbeWithSHA1And40BitRC2-CBC';
   LN_pbe_WithSHA1And40BitRC4 = 'pbeWithSHA1And40BitRC4';
   LN_pbes2 = 'PBES2';
   LN_pbmac1 = 'PBMAC1';
   LN_pkcs = 'pkcs';
   LN_pkcs3 = 'pkcs3';
   LN_pkcs7 = 'pkcs7';
   LN_pkcs7_data = 'pkcs7-data';
   LN_pkcs7_digest = 'pkcs7-digestData';
   LN_pkcs7_encrypted = 'pkcs7-encryptedData';
   LN_pkcs7_enveloped = 'pkcs7-envelopedData';
   LN_pkcs7_signed = 'pkcs7-signedData';
   LN_pkcs7_signedAndEnveloped = 'pkcs7-signedAndEnvelopedData';
   LN_pkcs8ShroudedKeyBag = 'pkcs8ShroudedKeyBag';
   LN_pkcs9 = 'pkcs9';
   LN_pkcs9_challengePassword = 'challengePassword';
   LN_pkcs9_contentType = 'contentType';
   LN_pkcs9_countersignature = 'countersignature';
   LN_pkcs9_emailAddress = 'emailAddress';
   LN_pkcs9_extCertAttributes = 'extendedCertificateAttributes';
   LN_pkcs9_messageDigest = 'messageDigest';
   LN_pkcs9_signingTime = 'signingTime';
   LN_pkcs9_unstructuredAddress = 'unstructuredAddress';
   LN_pkcs9_unstructuredName = 'unstructuredName';
   LN_private_key_usage_period = 'X509v3 Private Key Usage Period';
   LN_rc2_40_cbc = 'rc2-40-cbc';
   LN_rc2_64_cbc = 'rc2-64-cbc';
   LN_rc2_cbc = 'rc2-cbc';
   LN_rc2_cfb64 = 'rc2-cfb';
   LN_rc2_ecb = 'rc2-ecb';
   LN_rc2_ofb64 = 'rc2-ofb';
   LN_rc4 = 'rc4';
   LN_rc4_40 = 'rc4-40';
   LN_rc5_cbc = 'rc5-cbc';
   LN_rc5_cfb64 = 'rc5-cfb';
   LN_rc5_ecb = 'rc5-ecb';
   LN_rc5_ofb64 = 'rc5-ofb';
   LN_ripemd160 = 'ripemd160';
   LN_ripemd160WithRSA = 'ripemd160WithRSA';
   LN_rle_compression = 'run length compression';
   LN_rsa = 'rsa';
   LN_rsaEncryption = 'rsaEncryption';
   LN_rsadsi = 'rsadsi';
   LN_safeContentsBag = 'safeContentsBag';
   LN_sdsiCertificate = 'sdsiCertificate';
   LN_secretBag = 'secretBag';
   LN_serialNumber = 'serialNumber';
   LN_server_auth = 'TLS Web Server Authentication';
   LN_sha = 'sha';
   LN_sha1 = 'sha1';
   LN_sha1WithRSA = 'sha1WithRSA';
   LN_sha1WithRSAEncryption = 'sha1WithRSAEncryption';
   LN_shaWithRSAEncryption = 'shaWithRSAEncryption';
   LN_sha256WithRSAEncryption = 'sha256WithRSAEncryption';
   LN_sha384WithRSAEncryption = 'sha384WithRSAEncryption';
   LN_sha512WithRSAEncryption = 'sha512WithRSAEncryption';
   LN_sha224WithRSAEncryption = 'sha224WithRSAEncryption';
   LN_stateOrProvinceName = 'stateOrProvinceName';
   LN_subject_alt_name = 'X509v3 Subject Alternative Name';
   LN_subject_key_identifier = 'X509v3 Subject Key Identifier';
   LN_surname = 'surname';
   LN_sxnet = 'Strong Extranet ID';
   LN_time_stamp = 'Time Stamping';
   LN_title = 'title';
   LN_undef = 'undefined';
   LN_uniqueIdentifier = 'uniqueIdentifier';
   LN_x509Certificate = 'x509Certificate';
   LN_x509Crl = 'x509Crl';
   LN_zlib_compression = 'zlib compression';
   NID_SMIMECapabilities = 167;
   NID_X500 = 11;
   NID_X509 = 12;
   NID_algorithm = 38;
   NID_authority_key_identifier = 90;
   NID_basic_constraints = 87;
   NID_bf_cbc = 91;
   NID_bf_cfb64 = 93;
   NID_bf_ecb = 92;
   NID_bf_ofb64 = 94;
   NID_cast5_cbc = 108;
   NID_cast5_cfb64 = 110;
   NID_cast5_ecb = 109;
   NID_cast5_ofb64 = 111;
   NID_certBag = 152;
   NID_certificate_policies = 89;
   NID_client_auth = 130;
   NID_code_sign = 131;
   NID_commonName = 13;
   NID_countryName = 14;
   NID_crlBag = 153;
   NID_crl_distribution_points = 103;
   NID_crl_number = 88;
   NID_crl_reason = 141;
   NID_delta_crl = 140;
   NID_des_cbc = 31;
   NID_des_cfb64 = 30;
   NID_des_ecb = 29;
   NID_des_ede = 32;
   NID_des_ede3 = 33;
   NID_des_ede3_cbc = 44;
   NID_des_ede3_cfb64 = 61;
   NID_des_ede3_ofb64 = 63;
   NID_des_ede_cbc = 43;
   NID_des_ede_cfb64 = 60;
   NID_des_ede_ofb64 = 62;
   NID_des_ofb64 = 45;
   NID_description = 107;
   NID_desx_cbc = 80;
   NID_email_protect = 132;
   NID_ext_key_usage = 126;
   NID_friendlyName = 156;
   NID_givenName = 99;
   NID_hmacWithSHA1 = 163;
   NID_id_kp = 128;
   NID_id_pbkdf2 = 69;
   NID_id_pkix = 127;
   NID_id_qt_cps = 164;
   NID_id_qt_unotice = 165;
   NID_idea_cbc = 34;
   NID_idea_cfb64 = 35;
   NID_idea_ecb = 36;
   NID_idea_ofb64 = 46;
   NID_initials = 101;
   NID_invalidity_date = 142;
   NID_issuer_alt_name = 86;
   NID_keyBag = 150;
   NID_key_usage = 83;
   NID_ld_ce = 81;
   NID_localKeyID = 157;
   NID_localityName = 15;
   NID_md2 = 3;
   NID_md2WithRSAEncryption = 7;
   NID_md4 = 257;
   NID_md4WithRSAEncryption = 396;
   NID_md5 = 4;
   NID_md5WithRSA = 104;
   NID_md5WithRSAEncryption = 8;
   NID_md5_sha1 = 114;
   NID_mdc2 = 95;
   NID_mdc2WithRSA = 96;
   NID_ms_code_com = 135;
   NID_ms_code_ind = 134;
   NID_ms_ctl_sign = 136;
   NID_ms_efs = 138;
   NID_ms_sgc = 137;
   NID_netscape = 57;
   NID_netscape_base_url = 72;
   NID_netscape_ca_policy_url = 76;
   NID_netscape_ca_revocation_url = 74;
   NID_netscape_cert_extension = 58;
   NID_netscape_cert_sequence = 79;
   NID_netscape_cert_type = 71;
   NID_netscape_comment = 78;
   NID_netscape_data_type = 59;
   NID_netscape_renewal_url = 75;
   NID_netscape_revocation_url = 73;
   NID_netscape_ssl_server_name = 77;
   NID_ns_sgc = 139;
   NID_organizationName = 17;
   NID_organizationalUnitName = 18;
   NID_pbeWithMD2AndDES_CBC = 9;
   NID_pbeWithMD2AndRC2_CBC = 168;
   NID_pbeWithMD5AndCast5_CBC = 112;
   NID_pbeWithMD5AndDES_CBC = 10;
   NID_pbeWithMD5AndRC2_CBC = 169;
   NID_pbeWithSHA1AndDES_CBC = 170;
   NID_pbeWithSHA1AndRC2_CBC = 68;
   NID_pbe_WithSHA1And128BitRC2_CBC = 148;
   NID_pbe_WithSHA1And128BitRC4 = 144;
   NID_pbe_WithSHA1And2_Key_TripleDES_CBC = 147;
   NID_pbe_WithSHA1And3_Key_TripleDES_CBC = 146;
   NID_pbe_WithSHA1And40BitRC2_CBC = 149;
   NID_pbe_WithSHA1And40BitRC4 = 145;
   NID_pbes2 = 161;
   NID_pbmac1 = 162;
   NID_pkcs = 2;
   NID_pkcs3 = 27;
   NID_pkcs7 = 20;
   NID_pkcs7_data = 21;
   NID_pkcs7_digest = 25;
   NID_pkcs7_encrypted = 26;
   NID_pkcs7_enveloped = 23;
   NID_pkcs7_signed = 22;
   NID_pkcs7_signedAndEnveloped = 24;
   NID_pkcs8ShroudedKeyBag = 151;
   NID_pkcs9 = 47;
   NID_pkcs9_challengePassword = 54;
   NID_pkcs9_contentType = 50;
   NID_pkcs9_countersignature = 53;
   NID_pkcs9_emailAddress = 48;
   NID_pkcs9_extCertAttributes = 56;
   NID_pkcs9_messageDigest = 51;
   NID_pkcs9_signingTime = 52;
   NID_pkcs9_unstructuredAddress = 55;
   NID_pkcs9_unstructuredName = 49;
   NID_private_key_usage_period = 84;
   NID_rc2_40_cbc = 98;
   NID_rc2_64_cbc = 166;
   NID_rc2_cbc = 37;
   NID_rc2_cfb64 = 39;
   NID_rc2_ecb = 38;
   NID_rc2_ofb64 = 40;
   NID_rc4 = 5;
   NID_rc4_40 = 97;
   NID_rc5_cbc = 120;
   NID_rc5_cfb64 = 122;
   NID_rc5_ecb = 121;
   NID_rc5_ofb64 = 123;
   NID_ripemd160 = 117;
   NID_ripemd160WithRSA = 119;
   NID_rle_compression = 124;
   NID_rsadsi = 1;
   NID_safeContentsBag = 155;
   NID_sdsiCertificate = 159;
   NID_secretBag = 154;
   NID_serialNumber = 105;
   NID_server_auth = 129;
   NID_sha = 41;
   NID_sha1 = 64;
   NID_sha1WithRSA = 115;
   NID_sha1WithRSAEncryption = 65;
   NID_sha256WithRSAEncryption = 668;
   NID_sha384WithRSAEncryption = 669;
   NID_sha512WithRSAEncryption = 670;
   NID_sha224WithRSAEncryption = 671;
   NID_shaWithRSAEncryption = 42;
   NID_stateOrProvinceName = 16;
   NID_subject_alt_name = 85;
   NID_subject_key_identifier = 82;
   NID_surname = 100;
   NID_sxnet = 143;
   NID_time_stamp = 133;
   NID_title = 106;
   NID_uniqueIdentifier = 102;
   NID_x509Certificate = 158;
   NID_x509Crl = 160;
   NID_zlib_compression = 125;
   OBJ_F_OBJ_CREATE = 100;
   OBJ_F_OBJ_DUP = 101;
   OBJ_F_OBJ_NID2LN = 102;
   OBJ_F_OBJ_NID2OBJ = 103;
   OBJ_F_OBJ_NID2SN = 104;
   OBJ_NAME_ALIAS = $8000;
   OBJ_NAME_TYPE_CIPHER_METH = $02;
   OBJ_NAME_TYPE_COMP_METH = $04;
   OBJ_NAME_TYPE_MD_METH = $01;
   OBJ_NAME_TYPE_NUM = $05;
   OBJ_NAME_TYPE_PKEY_METH = $03;
   OBJ_NAME_TYPE_UNDEF = $00;
   OBJ_R_MALLOC_FAILURE = 100;
   OBJ_R_UNKNOWN_NID = 101;
   OPENSSL_VERSION_NUMBER = $1000105F;
   PEM_BUFSIZE = 1024;
   PEM_DEK_DES_CBC = 40;
   PEM_DEK_DES_ECB = 60;
   PEM_DEK_DES_EDE = 50;
   PEM_DEK_IDEA_CBC = 45;
   PEM_DEK_RSA = 70;
   PEM_DEK_RSA_MD2 = 80;
   PEM_DEK_RSA_MD5 = 90;
   PEM_ERROR = 30;
   PEM_F_DEF_CALLBACK = 100;
   PEM_F_LOAD_IV = 101;
   PEM_F_PEM_ASN1_READ = 102;
   PEM_F_PEM_ASN1_READ_BIO = 103;
   PEM_F_PEM_ASN1_WRITE = 104;
   PEM_F_PEM_ASN1_WRITE_BIO = 105;
   PEM_F_PEM_DO_HEADER = 106;
   PEM_F_PEM_F_PEM_WRITE_PKCS8PRIVATEKEY = 118;
   PEM_F_PEM_GET_EVP_CIPHER_INFO = 107;
   PEM_F_PEM_READ = 108;
   PEM_F_PEM_READ_BIO = 109;
   PEM_F_PEM_SEALFINAL = 110;
   PEM_F_PEM_SEALINIT = 111;
   PEM_F_PEM_SIGNFINAL = 112;
   PEM_F_PEM_WRITE = 113;
   PEM_F_PEM_WRITE_BIO = 114;
   PEM_F_PEM_WRITE_BIO_PKCS8PRIVATEKEY = 119;
   PEM_F_PEM_X509_INFO_READ = 115;
   PEM_F_PEM_X509_INFO_READ_BIO = 116;
   PEM_F_PEM_X509_INFO_WRITE_BIO = 117;
   PEM_MD_MD2 = NID_md2;
   PEM_MD_MD2_RSA = NID_md2WithRSAEncryption;
   PEM_MD_MD5 = NID_md5;
   PEM_MD_MD5_RSA = NID_md5WithRSAEncryption;
   PEM_MD_SHA = NID_sha;
   PEM_MD_SHA_RSA = NID_sha1WithRSAEncryption;
   PEM_OBJ_UNDEF = 0;
   PEM_OBJ_X509 = 1;
   PEM_OBJ_X509_REQ = 2;
   PEM_OBJ_CRL = 3;
   PEM_OBJ_SSL_SESSION = 4;
   PEM_OBJ_PRIV_KEY = 10;
   PEM_OBJ_PRIV_RSA = 11;
   PEM_OBJ_PRIV_DSA = 12;
   PEM_OBJ_PRIV_DH = 13;
   PEM_OBJ_PUB_RSA = 14;
   PEM_OBJ_PUB_DSA = 15;
   PEM_OBJ_PUB_DH = 16;
   PEM_OBJ_DHPARAMS = 17;
   PEM_OBJ_DSAPARAMS = 18;
   PEM_OBJ_PRIV_RSA_PUBLIC = 19;
   PEM_OBJ_PRIV_ECDSA = 20;
   PEM_OBJ_PUB_ECDSA = 21;
   PEM_OBJ_ECPARAMETERS = 22;
   PEM_R_BAD_BASE64_DECODE = 100;
   PEM_R_BAD_DECRYPT = 101;
   PEM_R_BAD_END_LINE = 102;
   PEM_R_BAD_IV_CHARS = 103;
   PEM_R_BAD_PASSWORD_READ = 104;
   PEM_R_ERROR_CONVERTING_PRIVATE_KEY = 115;
   PEM_R_NOT_DEK_INFO = 105;
   PEM_R_NOT_ENCRYPTED = 106;
   PEM_R_NOT_PROC_TYPE = 107;
   PEM_R_NO_START_LINE = 108;
   PEM_R_PROBLEMS_GETTING_PASSWORD = 109;
   PEM_R_PUBLIC_KEY_NO_RSA = 110;
   PEM_R_READ_KEY = 111;
   PEM_R_SHORT_HEADER = 112;
   PEM_R_UNSUPPORTED_CIPHER = 113;
   PEM_R_UNSUPPORTED_ENCRYPTION = 114;
   PEM_STRING_EVP_PKEY = 'ANY PRIVATE KEY';
   PEM_STRING_X509_OLD = 'X509 CERTIFICATE';
   PEM_STRING_X509 = 'CERTIFICATE';
   PEM_STRING_X509_PAIR = 'CERTIFICATE PAIR';
   PEM_STRING_X509_TRUSTED = 'TRUSTED CERTIFICATE';
   PEM_STRING_X509_REQ_OLD = 'NEW CERTIFICATE REQUEST';
   PEM_STRING_X509_REQ = 'CERTIFICATE REQUEST';
   PEM_STRING_X509_CRL = 'X509 CRL';
   PEM_STRING_PUBLIC = 'PUBLIC KEY';
   PEM_STRING_RSA = 'RSA PRIVATE KEY';
   PEM_STRING_RSA_PUBLIC = 'RSA PUBLIC KEY';
   PEM_STRING_DSA = 'DSA PRIVATE KEY';
   PEM_STRING_DSA_PUBLIC = 'DSA PUBLIC KEY';
   PEM_STRING_PKCS7 = 'PKCS7';
   PEM_STRING_PKCS7_SIGNED = 'PKCS #7 SIGNED DATA';
   PEM_STRING_PKCS8 = 'ENCRYPTED PRIVATE KEY';
   PEM_STRING_PKCS8INF = 'PRIVATE KEY';
   PEM_STRING_DHPARAMS = 'DH PARAMETERS';
   PEM_STRING_SSL_SESSION = 'SSL SESSION PARAMETERS';
   PEM_STRING_DSAPARAMS = 'DSA PARAMETERS';
   PEM_STRING_ECDSA_PUBLIC = 'ECDSA PUBLIC KEY';
   PEM_STRING_ECPARAMETERS = 'EC PARAMETERS';
   PEM_STRING_ECPRIVATEKEY = 'EC PRIVATE KEY';
   PEM_STRING_CMS = 'CMS';
   PEM_TYPE_CLEAR = 40;
   PEM_TYPE_ENCRYPTED = 10;
   PEM_TYPE_MIC_CLEAR = 30;
   PEM_TYPE_MIC_ONLY = 20;
   PKCS5_DEFAULT_ITER = 2048;
   PKCS5_SALT_LEN = 8;
   PKCS7_F_PKCS7_ADD_CERTIFICATE = 100;
   PKCS7_F_PKCS7_ADD_CRL = 101;
   PKCS7_F_PKCS7_ADD_RECIPIENT_INFO = 102;
   PKCS7_F_PKCS7_ADD_SIGNER = 103;
   PKCS7_F_PKCS7_CTRL = 104;
   PKCS7_F_PKCS7_DATADECODE = 112;
   PKCS7_F_PKCS7_DATAINIT = 105;
   PKCS7_F_PKCS7_DATASIGN = 106;
   PKCS7_F_PKCS7_DATAVERIFY = 107;
   PKCS7_F_PKCS7_SET_CIPHER = 108;
   PKCS7_F_PKCS7_SET_CONTENT = 109;
   PKCS7_F_PKCS7_SET_TYPE = 110;
   PKCS7_F_PKCS7_SIGNATUREVERIFY = 113;
   PKCS7_OP_GET_DETACHED_SIGNATURE = 2;
   PKCS7_OP_SET_DETACHED_SIGNATURE = 1;
   PKCS7_R_CIPHER_NOT_INITIALIZED = 116;
   PKCS7_R_DECRYPTED_KEY_IS_WRONG_LENGTH = 100;
   PKCS7_R_DIGEST_FAILURE = 101;
   PKCS7_R_INTERNAL_ERROR = 102;
   PKCS7_R_MISSING_CERIPEND_INFO = 103;
   PKCS7_R_NO_RECIPIENT_MATCHES_CERTIFICATE = 115;
   PKCS7_R_OPERATION_NOT_SUPPORTED_ON_THIS_TYPE = 104;
   PKCS7_R_SIGNATURE_FAILURE = 105;
   PKCS7_R_UNABLE_TO_FIND_CERTIFICATE = 106;
   PKCS7_R_UNABLE_TO_FIND_MEM_BIO = 107;
   PKCS7_R_UNABLE_TO_FIND_MESSAGE_DIGEST = 108;
   PKCS7_R_UNKNOWN_DIGEST_TYPE = 109;
   PKCS7_R_UNKNOWN_OPERATION = 110;
   PKCS7_R_UNSUPPORTED_CIPHER_TYPE = 111;
   PKCS7_R_UNSUPPORTED_CONTENT_TYPE = 112;
   PKCS7_R_WRONG_CONTENT_TYPE = 113;
   PKCS7_R_WRONG_PKCS7_TYPE = 114;
   PKCS7_S_BODY = 1;
   PKCS7_S_HEADER = 0;
   PKCS7_S_TAIL = 2;
   PKCS8_NEG_PRIVKEY = 4;
   PKCS8_NS_DB = 3;
   PKCS8_EMBEDDED_PARAM = 2;
   PKCS8_NO_OCTET = 1;
   PKCS8_OK = 0;
   P_tmpdir = '/tmp';
   MSS_RAND_MAX = $7FFFFFFF;
   RC2_BLOCK = 8;
   RC2_DECRYPT = 0;
   RC2_ENCRYPT = 1;
   RC2_KEY_LENGTH = 16;
   RC5_12_ROUNDS = 12;
   RC5_16_ROUNDS = 16;
   RC5_32_BLOCK = 8;
   RC5_32_KEY_LENGTH = 16;
   RC5_8_ROUNDS = 8;
   RC5_DECRYPT = 0;
   RC5_ENCRYPT = 1;
   HMAC_MAX_MD_CBLOCK = 128;
   RIPEMD160_BLOCK = 16;
   RIPEMD160_CBLOCK = 64;
   RIPEMD160_DIGEST_LENGTH = 20;
   RIPEMD160_LAST_BLOCK = 56;
   RIPEMD160_LBLOCK = 16;
   RIPEMD160_LENGTH_BLOCK = 8;
   RSA_FLAG_FIPS_METHOD = $0400;
   RSA_FLAG_NON_FIPS_ALLOW = $0400;
   RSA_3 = $3;
   RSA_F4 = $10001;
   RSA_FLAG_BLINDING = $08;
   RSA_FLAG_CACHE_PRIVATE = $04;
   RSA_FLAG_CACHE_PUBLIC = $02;
   RSA_FLAG_EXT_PKEY = $20;
   RSA_FLAG_SIGN_VER = $0040;
   RSA_FLAG_NO_BLINDING = $0080;
   RSA_FLAG_NO_CONSTTIME = $0100;
   RSA_FLAG_NO_EXP_CONSTTIME = RSA_FLAG_NO_CONSTTIME;
   RSA_MAX_MODULUS_BITS = 16384;
   RSA_FIPS_MIN_MODULUS_BITS = 1024;
   RSA_SMALL_MODULUS_BITS = 3072;
   RSA_MAX_PUBEXP_BITS = 64;
   RSA_FLAG_THREAD_SAFE = $10;
   RSA_F_FIPS_RSA_SIGN = 140;
   RSA_F_FIPS_RSA_VERIFY = 141;
   RSA_F_MEMORY_LOCK = 100;
   RSA_F_RSA_CHECK_KEY = 123;
   RSA_F_RSA_EAY_PRIVATE_DECRYPT = 101;
   RSA_F_RSA_EAY_PRIVATE_ENCRYPT = 102;
   RSA_F_RSA_EAY_PUBLIC_DECRYPT = 103;
   RSA_F_RSA_EAY_PUBLIC_ENCRYPT = 104;
   RSA_F_RSA_GENERATE_KEY = 105;
   RSA_F_RSA_NEW_METHOD = 106;
   RSA_F_RSA_PADDING_ADD_NONE = 107;
   RSA_F_RSA_PADDING_ADD_PKCS1_OAEP = 121;
   RSA_F_RSA_PADDING_ADD_PKCS1_TYPE_1 = 108;
   RSA_F_RSA_PADDING_ADD_PKCS1_TYPE_2 = 109;
   RSA_F_RSA_PADDING_ADD_SSLV23 = 110;
   RSA_F_RSA_PADDING_CHECK_NONE = 111;
   RSA_F_RSA_PADDING_CHECK_PKCS1_OAEP = 122;
   RSA_F_RSA_PADDING_CHECK_PKCS1_TYPE_1 = 112;
   RSA_F_RSA_PADDING_CHECK_PKCS1_TYPE_2 = 113;
   RSA_F_RSA_PADDING_CHECK_SSLV23 = 114;
   RSA_F_RSA_PRINT = 115;
   RSA_F_RSA_PRINT_FP = 116;
   RSA_F_RSA_PRIVATE_ENCRYPT = 137;
   RSA_F_RSA_PUBLIC_DECRYPT = 138;
   RSA_F_RSA_SETUP_BLINDING = 136;
   RSA_F_RSA_SET_DEFAULT_METHOD = 139;
   RSA_F_RSA_SET_METHOD = 142;
   RSA_F_RSA_SIGN = 117;
   RSA_F_RSA_SIGN_ASN1_OCTET_STRING = 118;
   RSA_F_RSA_VERIFY = 119;
   RSA_F_RSA_VERIFY_ASN1_OCTET_STRING = 120;
   RSA_F_RSA_VERIFY_PKCS1_PSS = 126;
   RSA_METHOD_FLAG_NO_CHECK = $01;
   RSA_NO_PADDING = 3;
   RSA_PKCS1_OAEP_PADDING = 4;
   RSA_PKCS1_PADDING = 1;
   RSA_R_ALGORITHM_MISMATCH = 100;
   RSA_R_BAD_E_VALUE = 101;
   RSA_R_BAD_FIXED_HEADER_DECRYPT = 102;
   RSA_R_BAD_PAD_BYTE_COUNT = 103;
   RSA_R_BAD_SIGNATURE = 104;
   RSA_R_BLOCK_TYPE_IS_NOT_01 = 106;
   RSA_R_BLOCK_TYPE_IS_NOT_02 = 107;
   RSA_R_DATA_GREATER_THAN_MOD_LEN = 108;
   RSA_R_DATA_TOO_LARGE = 109;
   RSA_R_DATA_TOO_LARGE_FOR_KEY_SIZE = 110;
   RSA_R_DATA_TOO_SMALL = 111;
   RSA_R_DATA_TOO_SMALL_FOR_KEY_SIZE = 122;
   RSA_R_DIGEST_TOO_BIG_FOR_RSA_KEY = 112;
   RSA_R_DMP1_NOT_CONGRUENT_TO_D = 124;
   RSA_R_DMQ1_NOT_CONGRUENT_TO_D = 125;
   RSA_R_D_E_NOT_CONGRUENT_TO_1 = 123;
   RSA_R_IQMP_NOT_INVERSE_OF_Q = 126;
   RSA_R_KEY_SIZE_TOO_SMALL = 120;
   RSA_R_LAST_OCTET_INVALID = 134;
   RSA_R_MODULUS_TOO_LARGE = 105;
   RSA_R_NON_FIPS_METHOD = 141;
   RSA_R_NO_PUBLIC_EXPONENT = 140;
   RSA_R_NULL_BEFORE_BLOCK_MISSING = 113;
   RSA_R_N_DOES_NOT_EQUAL_P_Q = 127;
   RSA_R_OAEP_DECODING_ERROR = 121;
   RSA_R_OPERATION_NOT_ALLOWED_IN_FIPS_MODE = 142;
   RSA_R_PADDING_CHECK_FAILED = 114;
   RSA_R_P_NOT_PRIME = 128;
   RSA_R_Q_NOT_PRIME = 129;
   RSA_R_SLEN_CHECK_FAILED = 136;
   RSA_R_SLEN_RECOVERY_FAILED = 135;
   RSA_R_SSLV3_ROLLBACK_ATTACK = 115;
   RSA_R_THE_ASN1_OBJECT_IDENTIFIER_IS_NOT_KNOWN_FOR_THIS_MD = 116;
   RSA_R_UNKNOWN_ALGORITHM_TYPE = 117;
   RSA_R_UNKNOWN_PADDING_TYPE = 118;
   RSA_R_WRONG_SIGNATURE_LENGTH = 119;
   RSA_SSLV23_PADDING = 2;
   SEEK_CUR = 1;
   SEEK_END = 2;
   SEEK_SET = 0;
   SN_Algorithm = 'Algorithm';
   SN_SMIMECapabilities = 'SMIME-CAPS';
   SN_authority_key_identifier = 'authorityKeyIdentifier';
   SN_basic_constraints = 'basicConstraints';
   SN_bf_cbc = 'BF-CBC';
   SN_bf_cfb64 = 'BF-CFB';
   SN_bf_ecb = 'BF-ECB';
   SN_bf_ofb64 = 'BF-OFB';
   SN_cast5_cbc = 'CAST5-CBC';
   SN_cast5_cfb64 = 'CAST5-CFB';
   SN_cast5_ecb = 'CAST5-ECB';
   SN_cast5_ofb64 = 'CAST5-OFB';
   SN_certificate_policies = 'certificatePolicies';
   SN_client_auth = 'clientAuth';
   SN_code_sign = 'codeSigning';
   SN_commonName = 'CN';
   SN_countryName = 'C';
   SN_crl_distribution_points = 'crlDistributionPoints';
   SN_crl_number = 'crlNumber';
   SN_crl_reason = 'CRLReason';
   SN_delta_crl = 'deltaCRL';
   SN_des_cbc = 'DES-CBC';
   SN_des_cfb64 = 'DES-CFB';
   SN_des_ecb = 'DES-ECB';
   SN_des_ede = 'DES-EDE';
   SN_des_ede3 = 'DES-EDE3';
   SN_des_ede3_cbc = 'DES-EDE3-CBC';
   SN_des_ede3_cfb64 = 'DES-EDE3-CFB';
   SN_des_ede3_ofb64 = 'DES-EDE3-OFB';
   SN_des_ede_cbc = 'DES-EDE-CBC';
   SN_des_ede_cfb64 = 'DES-EDE-CFB';
   SN_des_ede_ofb64 = 'DES-EDE-OFB';
   SN_des_ofb64 = 'DES-OFB';
   SN_description = 'D';
   SN_desx_cbc = 'DESX-CBC';
   SN_dsa = 'DSA';
   SN_dsaWithSHA = 'DSA-SHA';
   SN_dsaWithSHA1 = 'DSA-SHA1';
   SN_dsaWithSHA1_2 = 'DSA-SHA1-old';
   SN_dsa_2 = 'DSA-old';
   SN_X9_62_id_ecPublicKey = 'id-ecPublicKey';
   SN_email_protect = 'emailProtection';
   SN_ext_key_usage = 'extendedKeyUsage';
   SN_givenName = 'G';
   SN_id_kp = 'id-kp';
   SN_id_pkix = 'PKIX';
   SN_id_qt_cps = 'id-qt-cps';
   SN_id_qt_unotice = 'id-qt-unotice';
   SN_idea_cbc = 'IDEA-CBC';
   SN_idea_cfb64 = 'IDEA-CFB';
   SN_idea_ecb = 'IDEA-ECB';
   SN_idea_ofb64 = 'IDEA-OFB';
   SN_identified_organization = 'identified-organization';
   SN_initials = 'I';
   SN_invalidity_date = 'invalidityDate';
   SN_iso = 'ISO';
   SN_issuer_alt_name = 'issuerAltName';
   SN_itu_t = 'ITU-T';
   SN_joint_iso_itu_t = 'JOINT-ISO-ITU-T';
   SN_key_usage = 'keyUsage';
   SN_ld_ce = 'ld-ce';
   SN_localityName = 'L';
   SN_md2 = 'MD2';
   SN_md2WithRSAEncryption = 'RSA-MD2';
   SN_md5 = 'MD5';
   SN_md5WithRSA = 'RSA-NP-MD5';
   SN_md5WithRSAEncryption = 'RSA-MD5';
   SN_md5_sha1 = 'MD5-SHA1';
   SN_mdc2 = 'MDC2';
   SN_mdc2WithRSA = 'RSA-MDC2';
   SN_member_body = 'member-body';
   SN_ms_code_com = 'msCodeCom';
   SN_ms_code_ind = 'msCodeInd';
   SN_ms_ctl_sign = 'msCTLSign';
   SN_ms_efs = 'msEFS';
   SN_ms_sgc = 'msSGC';
   SN_netscape = 'Netscape';
   SN_netscape_base_url = 'nsBaseUrl';
   SN_netscape_ca_policy_url = 'nsCaPolicyUrl';
   SN_netscape_ca_revocation_url = 'nsCaRevocationUrl';
   SN_netscape_cert_extension = 'nsCertExt';
   SN_netscape_cert_sequence = 'nsCertSequence';
   SN_netscape_cert_type = 'nsCertType';
   SN_netscape_comment = 'nsComment';
   SN_netscape_data_type = 'nsDataType';
   SN_netscape_renewal_url = 'nsRenewalUrl';
   SN_netscape_revocation_url = 'nsRevocationUrl';
   SN_netscape_ssl_server_name = 'nsSslServerName';
   SN_ns_sgc = 'nsSGC';
   SN_organizationName = 'O';
   SN_organizationalUnitName = 'OU';
   SN_pkcs9_emailAddress = 'Email';
   SN_private_key_usage_period = 'privateKeyUsagePeriod';
   SN_rc2_40_cbc = 'RC2-40-CBC';
   SN_rc2_64_cbc = 'RC2-64-CBC';
   SN_rc2_cbc = 'RC2-CBC';
   SN_rc2_cfb64 = 'RC2-CFB';
   SN_rc2_ecb = 'RC2-ECB';
   SN_rc2_ofb64 = 'RC2-OFB';
   SN_rc4 = 'RC4';
   SN_rc4_40 = 'RC4-40';
   SN_rc5_cbc = 'RC5-CBC';
   SN_rc5_cfb64 = 'RC5-CFB';
   SN_rc5_ecb = 'RC5-ECB';
   SN_rc5_ofb64 = 'RC5-OFB';
   SN_ripemd160 = 'RIPEMD160';
   SN_ripemd160WithRSA = 'RSA-RIPEMD160';
   SN_rle_compression = 'RLE';
   SN_rsa = 'RSA';
   SN_serialNumber = 'SN';
   SN_server_auth = 'serverAuth';
   SN_sha = 'SHA';
   SN_sha1 = 'SHA1';
   SN_sha1WithRSA = 'RSA-SHA1-2';
   SN_sha1WithRSAEncryption = 'RSA-SHA1';
   SN_shaWithRSAEncryption = 'RSA-SHA';
   SN_stateOrProvinceName = 'ST';
   SN_subject_alt_name = 'subjectAltName';
   SN_subject_key_identifier = 'subjectKeyIdentifier';
   SN_surname = 'S';
   SN_sxnet = 'SXNetID';
   SN_time_stamp = 'timeStamping';
   SN_title = 'T';
   SN_undef = 'UNDEF';
   SN_uniqueIdentifier = 'UID';
   SN_zlib_compression = 'ZLIB';
   OCSP_DEFAULT_NONCE_LENGTH = 16;
   OCSP_NOCERTS = $1;
   OCSP_NOINTERN = $2;
   OCSP_NOSIGS = $4;
   OCSP_NOCHAIN = $8;
   OCSP_NOVERIFY = $10;
   OCSP_NOEXPLICIT = $20;
   OCSP_NOCASIGN = $40;
   OCSP_NODELEGATED = $80;
   OCSP_NOCHECKS = $100;
   OCSP_TRUSTOTHER = $200;
   OCSP_RESPID_KEY = $400;
   OCSP_NOTIME = $800;
   OCSP_RESPONSE_STATUS_SUCCESSFUL = 0;
   OCSP_RESPONSE_STATUS_MALFORMEDREQUEST = 1;
   OCSP_RESPONSE_STATUS_INTERNALERROR = 2;
   OCSP_RESPONSE_STATUS_TRYLATER = 3;
   OCSP_RESPONSE_STATUS_SIGREQUIRED = 5;
   OCSP_RESPONSE_STATUS_UNAUTHORIZED = 6;
   OCSP_REVOKED_STATUS_NOSTATUS = -1;
   OCSP_REVOKED_STATUS_UNSPECIFIED = 0;
   OCSP_REVOKED_STATUS_KEYCOMPROMISE = 1;
   OCSP_REVOKED_STATUS_CACOMPROMISE = 2;
   OCSP_REVOKED_STATUS_AFFILIATIONCHANGED = 3;
   OCSP_REVOKED_STATUS_SUPERSEDED = 4;
   OCSP_REVOKED_STATUS_CESSATIONOFOPERATION = 5;
   OCSP_REVOKED_STATUS_CERTIFICATEHOLD = 6;
   OCSP_REVOKED_STATUS_REMOVEFROMCRL = 8;
   V_OCSP_CERTSTATUS_GOOD = 0;
   V_OCSP_CERTSTATUS_REVOKED = 1;
   V_OCSP_CERTSTATUS_UNKNOWN = 2;
   OCSP_F_ASN1_STRING_ENCODE = 100;
   OCSP_F_D2I_OCSP_NONCE = 102;
   OCSP_F_OCSP_BASIC_ADD1_STATUS = 103;
   OCSP_F_OCSP_BASIC_SIGN = 104;
   OCSP_F_OCSP_BASIC_VERIFY = 105;
   OCSP_F_OCSP_CERT_ID_NEW = 101;
   OCSP_F_OCSP_CHECK_DELEGATED = 106;
   OCSP_F_OCSP_CHECK_IDS = 107;
   OCSP_F_OCSP_CHECK_ISSUER = 108;
   OCSP_F_OCSP_CHECK_VALIDITY = 115;
   OCSP_F_OCSP_MATCH_ISSUERID = 109;
   OCSP_F_OCSP_PARSE_URL = 114;
   OCSP_F_OCSP_REQUEST_SIGN = 110;
   OCSP_F_OCSP_REQUEST_VERIFY = 116;
   OCSP_F_OCSP_RESPONSE_GET1_BASIC = 111;
   OCSP_F_OCSP_SENDREQ_BIO = 112;
   OCSP_F_PARSE_HTTP_LINE1 = 117;
   OCSP_F_REQUEST_VERIFY = 113;
   OCSP_R_BAD_DATA = 100;
   OCSP_R_CERTIFICATE_VERIFY_ERROR = 101;
   OCSP_R_DIGEST_ERR = 102;
   OCSP_R_ERROR_IN_NEXTUPDATE_FIELD = 122;
   OCSP_R_ERROR_IN_THISUPDATE_FIELD = 123;
   OCSP_R_ERROR_PARSING_URL = 121;
   OCSP_R_MISSING_OCSPSIGNING_USAGE = 103;
   OCSP_R_NEXTUPDATE_BEFORE_THISUPDATE = 124;
   OCSP_R_NOT_BASIC_RESPONSE = 104;
   OCSP_R_NO_CERTIFICATES_IN_CHAIN = 105;
   OCSP_R_NO_CONTENT = 106;
   OCSP_R_NO_PUBLIC_KEY = 107;
   OCSP_R_NO_RESPONSE_DATA = 108;
   OCSP_R_NO_REVOKED_TIME = 109;
   OCSP_R_PRIVATE_KEY_DOES_NOT_MATCH_CERTIFICATE = 110;
   OCSP_R_REQUEST_NOT_SIGNED = 128;
   OCSP_R_RESPONSE_CONTAINS_NO_REVOCATION_DATA = 111;
   OCSP_R_ROOT_CA_NOT_TRUSTED = 112;
   OCSP_R_SERVER_READ_ERROR = 113;
   OCSP_R_SERVER_RESPONSE_ERROR = 114;
   OCSP_R_SERVER_RESPONSE_PARSE_ERROR = 115;
   OCSP_R_SERVER_WRITE_ERROR = 116;
   OCSP_R_SIGNATURE_FAILURE = 117;
   OCSP_R_SIGNER_CERTIFICATE_NOT_FOUND = 118;
   OCSP_R_STATUS_EXPIRED = 125;
   OCSP_R_STATUS_NOT_YET_VALID = 126;
   OCSP_R_STATUS_TOO_OLD = 127;
   OCSP_R_UNKNOWN_MESSAGE_DIGEST = 119;
   OCSP_R_UNKNOWN_NID = 120;
   OCSP_R_UNSUPPORTED_REQUESTORNAME_TYPE = 129;
   SSL_ST_CONNECT = $1000;
   SSL_ST_ACCEPT = $2000;
   SSL_ST_MASK = $0FFF;
   SSL_ST_INIT = SSL_ST_CONNECT Or SSL_ST_ACCEPT;
   SSL_ST_BEFORE = $4000;
   SSL_ST_OK = $03;
   SSL_ST_RENEGOTIATE = $04 Or SSL_ST_INIT;
   SSL_CB_LOOP = $01;
   SSL_CB_EXIT = $02;
   SSL_CB_READ = $04;
   SSL_CB_WRITE = $08;
   SSL_CB_ALERT = $4000;
   SSL_CB_READ_ALERT = SSL_CB_ALERT Or SSL_CB_READ;
   SSL_CB_WRITE_ALERT = SSL_CB_ALERT Or SSL_CB_WRITE;
   SSL_CB_ACCEPT_LOOP = SSL_ST_ACCEPT Or SSL_CB_LOOP;
   SSL_CB_ACCEPT_EXIT = SSL_ST_ACCEPT Or SSL_CB_EXIT;
   SSL_CB_CONNECT_LOOP = SSL_ST_CONNECT Or SSL_CB_LOOP;
   SSL_CB_CONNECT_EXIT = SSL_ST_CONNECT Or SSL_CB_EXIT;
   SSL_CB_HANDSHAKE_START = $10;
   SSL_CB_HANDSHAKE_DONE = $20;
   SSL_ST_READ_BODY = $F1;
   SSL_ST_READ_DONE = $F2;
   SSL_ST_READ_HEADER = $F0;
   SSL23_ST_CR_SRVR_HELLO_A = $220 Or SSL_ST_CONNECT;
   SSL23_ST_CR_SRVR_HELLO_B = $221 Or SSL_ST_CONNECT;
   SSL23_ST_CW_CLNT_HELLO_A = $210 Or SSL_ST_CONNECT;
   SSL23_ST_CW_CLNT_HELLO_B = $211 Or SSL_ST_CONNECT;
   SSL23_ST_SR_CLNT_HELLO_A = $210 Or SSL_ST_ACCEPT;
   SSL23_ST_SR_CLNT_HELLO_B = $211 Or SSL_ST_ACCEPT;
   SSL2_AT_MD5_WITH_RSA_ENCRYPTION = $01;
   SSL2_CF_5_BYTE_ENC = $01;
   SSL2_CF_8_BYTE_ENC = $02;
   SSL2_CHALLENGE_LENGTH = 16;
   SSL2_CK_DES_192_EDE3_CBC_WITH_MD5 = $020700C0;
   SSL2_CK_DES_192_EDE3_CBC_WITH_SHA = $020701C0;
   SSL2_CK_DES_64_CBC_WITH_MD5 = $02060040;
   SSL2_CK_DES_64_CBC_WITH_SHA = $02060140;
   SSL2_CK_DES_64_CFB64_WITH_MD5_1 = $02FF0800;
   SSL2_CK_IDEA_128_CBC_WITH_MD5 = $02050080;
   SSL2_CK_NULL = $02FF0810;
   SSL2_CK_NULL_WITH_MD5 = $02000000;
   SSL2_CK_RC2_128_CBC_EXPORT40_WITH_MD5 = $02040080;
   SSL2_CK_RC2_128_CBC_WITH_MD5 = $02030080;
   SSL2_CK_RC4_128_EXPORT40_WITH_MD5 = $02020080;
   SSL2_CK_RC4_128_WITH_MD5 = $02010080;
   SSL2_CK_RC4_64_WITH_MD5 = $02080080;
   SSL2_CONNECTION_ID_LENGTH = 16;
   SSL2_CT_X509_CERTIFICATE = $01;
   SSL2_MAX_CERT_CHALLENGE_LENGTH = 32;
   SSL2_MAX_CHALLENGE_LENGTH = 32;
   SSL2_MAX_CONNECTION_ID_LENGTH = 16;
   SSL2_MAX_KEY_MATERIAL_LENGTH = 24;
   SSL2_MAX_MASTER_KEY_LENGTH_IN_BITS = 256;
   SSL2_MAX_RECORD_LENGTH_3_BYTE_HEADER = 16383;
   SSL2_MAX_SSL_SESSION_ID_LENGTH = 32;
   SSL2_MIN_CERT_CHALLENGE_LENGTH = 16;
   SSL2_MIN_CHALLENGE_LENGTH = 16;
   SSL2_MT_CLIENT_CERTIFICATE = 8;
   SSL2_MT_CLIENT_FINISHED = 3;
   SSL2_MT_CLIENT_HELLO = 1;
   SSL2_MT_CLIENT_MASTER_KEY = 2;
   SSL2_MT_ERROR = 0;
   SSL2_MT_REQUEST_CERTIFICATE = 7;
   SSL2_MT_SERVER_FINISHED = 6;
   SSL2_MT_SERVER_HELLO = 4;
   SSL2_MT_SERVER_VERIFY = 5;
   SSL2_PE_BAD_CERTIFICATE = $0004;
   SSL2_PE_NO_CERTIFICATE = $0002;
   SSL2_PE_NO_CIPHER = $0001;
   SSL2_PE_UNDEFINED_ERROR = $0000;
   SSL2_PE_UNSUPPORTED_CERTIFICATE_TYPE = $0006;
   SSL2_SSL_SESSION_ID_LENGTH = 16;
   SSL2_ST_CLIENT_START_ENCRYPTION = $80 Or SSL_ST_CONNECT;
   SSL2_ST_GET_CLIENT_FINISHED_A = $50 Or SSL_ST_ACCEPT;
   SSL2_ST_GET_CLIENT_FINISHED_B = $51 Or SSL_ST_ACCEPT;
   SSL2_ST_GET_CLIENT_HELLO_A = $10 Or SSL_ST_ACCEPT;
   SSL2_ST_GET_CLIENT_HELLO_B = $11 Or SSL_ST_ACCEPT;
   SSL2_ST_GET_CLIENT_HELLO_C = $12 Or SSL_ST_ACCEPT;
   SSL2_ST_GET_CLIENT_MASTER_KEY_A = $30 Or SSL_ST_ACCEPT;
   SSL2_ST_GET_CLIENT_MASTER_KEY_B = $31 Or SSL_ST_ACCEPT;
   SSL2_ST_GET_SERVER_FINISHED_A = $70 Or SSL_ST_CONNECT;
   SSL2_ST_GET_SERVER_FINISHED_B = $71 Or SSL_ST_CONNECT;
   SSL2_ST_GET_SERVER_HELLO_A = $20 Or SSL_ST_CONNECT;
   SSL2_ST_GET_SERVER_HELLO_B = $21 Or SSL_ST_CONNECT;
   SSL2_ST_GET_SERVER_VERIFY_A = $60 Or SSL_ST_CONNECT;
   SSL2_ST_GET_SERVER_VERIFY_B = $61 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_CERTIFICATE_A = $50 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_CERTIFICATE_B = $51 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_CERTIFICATE_C = $52 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_CERTIFICATE_D = $53 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_FINISHED_A = $40 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_FINISHED_B = $41 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_HELLO_A = $10 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_HELLO_B = $11 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_MASTER_KEY_A = $30 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_CLIENT_MASTER_KEY_B = $31 Or SSL_ST_CONNECT;
   SSL2_ST_SEND_REQUEST_CERTIFICATE_A = $70 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_REQUEST_CERTIFICATE_B = $71 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_REQUEST_CERTIFICATE_C = $72 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_REQUEST_CERTIFICATE_D = $73 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_SERVER_FINISHED_A = $60 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_SERVER_FINISHED_B = $61 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_SERVER_HELLO_A = $20 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_SERVER_HELLO_B = $21 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_SERVER_VERIFY_A = $40 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_SERVER_VERIFY_B = $41 Or SSL_ST_ACCEPT;
   SSL2_ST_SEND_SERVER_VERIFY_C = $42 Or SSL_ST_ACCEPT;
   SSL2_ST_SERVER_START_ENCRYPTION = $80 Or SSL_ST_ACCEPT;
   SSL2_ST_X509_GET_CLIENT_CERTIFICATE = $90 Or SSL_ST_CONNECT;
   SSL2_ST_X509_GET_SERVER_CERTIFICATE = $90 Or SSL_ST_ACCEPT;
   SSL2_TXT_DES_192_EDE3_CBC_WITH_MD5 = 'DES-CBC3-MD5';
   SSL2_TXT_DES_192_EDE3_CBC_WITH_SHA = 'DES-CBC3-SHA';
   SSL2_TXT_DES_64_CBC_WITH_MD5 = 'DES-CBC-MD5';
   SSL2_TXT_DES_64_CBC_WITH_SHA = 'DES-CBC-SHA';
   SSL2_TXT_DES_64_CFB64_WITH_MD5_1 = 'DES-CFB-M1';
   SSL2_TXT_IDEA_128_CBC_WITH_MD5 = 'IDEA-CBC-MD5';
   SSL2_TXT_NULL = 'NULL';
   SSL2_TXT_NULL_WITH_MD5 = 'NULL-MD5';
   SSL2_TXT_RC2_128_CBC_EXPORT40_WITH_MD5 = 'EXP-RC2-CBC-MD5';
   SSL2_TXT_RC2_128_CBC_WITH_MD5 = 'RC2-CBC-MD5';
   SSL2_TXT_RC4_128_EXPORT40_WITH_MD5 = 'EXP-RC4-MD5';
   SSL2_TXT_RC4_128_WITH_MD5 = 'RC4-MD5';
   SSL2_TXT_RC4_64_WITH_MD5 = 'RC4-64-MD5';
   SSL2_VERSION = $0002;
   SSL2_VERSION_MAJOR = $00;
   SSL2_VERSION_MINOR = $02;
   SSL3_AD_BAD_CERTIFICATE = 42;
   SSL3_AD_BAD_RECORD_MAC = 20;
   SSL3_AD_CERTIFICATE_EXPIRED = 45;
   SSL3_AD_CERTIFICATE_REVOKED = 44;
   SSL3_AD_CERTIFICATE_UNKNOWN = 46;
   SSL3_AD_CLOSE_NOTIFY = 0;
   SSL3_AD_DECOMPRESSION_FAILURE = 30;
   SSL3_AD_HANDSHAKE_FAILURE = 40;
   SSL3_AD_ILLEGAL_PARAMETER = 47;
   TLS1_HB_REQUEST = 1;
   TLS1_HB_RESPONSE = 2;
   SSL3_AD_NO_CERTIFICATE = 41;
   SSL3_AD_UNEXPECTED_MESSAGE = 10;
   SSL3_AD_UNSUPPORTED_CERTIFICATE = 43;
   SSL3_AL_FATAL = 2;
   SSL3_AL_WARNING = 1;
   SSL3_CC_CLIENT = $10;
   SSL3_CC_READ = $01;
   SSL3_CC_SERVER = $20;
   SSL3_CC_WRITE = $02;
   SSL3_CHANGE_CIPHER_CLIENT_READ = SSL3_CC_CLIENT Or SSL3_CC_READ;
   SSL3_CHANGE_CIPHER_CLIENT_WRITE = SSL3_CC_CLIENT Or SSL3_CC_WRITE;
   SSL3_CHANGE_CIPHER_SERVER_READ = SSL3_CC_SERVER Or SSL3_CC_READ;
   SSL3_CHANGE_CIPHER_SERVER_WRITE = SSL3_CC_SERVER Or SSL3_CC_WRITE;
   SSL3_CK_ADH_DES_192_CBC_SHA = $0300001B;
   SSL3_CK_ADH_DES_40_CBC_SHA = $03000019;
   SSL3_CK_ADH_DES_64_CBC_SHA = $0300001A;
   SSL3_CK_ADH_RC4_128_MD5 = $03000018;
   SSL3_CK_ADH_RC4_40_MD5 = $03000017;
   SSL3_CK_DH_DSS_DES_192_CBC3_SHA = $0300000D;
   SSL3_CK_DH_DSS_DES_40_CBC_SHA = $0300000B;
   SSL3_CK_DH_DSS_DES_64_CBC_SHA = $0300000C;
   SSL3_CK_DH_RSA_DES_192_CBC3_SHA = $03000010;
   SSL3_CK_DH_RSA_DES_40_CBC_SHA = $0300000E;
   SSL3_CK_DH_RSA_DES_64_CBC_SHA = $0300000F;
   SSL3_CK_EDH_DSS_DES_192_CBC3_SHA = $03000013;
   SSL3_CK_EDH_DSS_DES_40_CBC_SHA = $03000011;
   SSL3_CK_EDH_DSS_DES_64_CBC_SHA = $03000012;
   SSL3_CK_EDH_RSA_DES_192_CBC3_SHA = $03000016;
   SSL3_CK_EDH_RSA_DES_40_CBC_SHA = $03000014;
   SSL3_CK_EDH_RSA_DES_64_CBC_SHA = $03000015;
   SSL3_CK_FZA_DMS_FZA_SHA = $0300001D;
   SSL3_CK_FZA_DMS_NULL_SHA = $0300001C;
   SSL3_CK_FZA_DMS_RC4_SHA = $0300001E;
   SSL3_CK_RSA_DES_192_CBC3_SHA = $0300000A;
   SSL3_CK_RSA_DES_40_CBC_SHA = $03000008;
   SSL3_CK_RSA_DES_64_CBC_SHA = $03000009;
   SSL3_CK_RSA_IDEA_128_SHA = $03000007;
   SSL3_CK_SCSV = $030000FF;
   SSL3_CK_RSA_NULL_MD5 = $03000001;
   SSL3_CK_RSA_NULL_SHA = $03000002;
   SSL3_CK_RSA_RC2_40_MD5 = $03000006;
   SSL3_CK_RSA_RC4_128_MD5 = $03000004;
   SSL3_CK_RSA_RC4_128_SHA = $03000005;
   SSL3_CK_RSA_RC4_40_MD5 = $03000003;
   SSL3_CT_RSA_SIGN = 1;
   SSL3_CT_DSS_SIGN = 2;
   SSL3_CT_RSA_FIXED_DH = 3;
   SSL3_CT_DSS_FIXED_DH = 4;
   SSL3_CT_RSA_EPHEMERAL_DH = 5;
   SSL3_CT_DSS_EPHEMERAL_DH = 6;
   SSL3_CT_FORTEZZA_DMS = 20;
   SSL3_CT_NUMBER = 9;
   SSL3_FLAGS_DELAY_CLIENT_FINISHED = $0002;
   SSL3_FLAGS_NO_RENEGOTIATE_CIPHERS = $0001;
   SSL3_FLAGS_POP_BUFFER = $0004;
   TLS1_FLAGS_TLS_PADDING_BUG = $0008;
   TLS1_FLAGS_SKIP_CERT_VERIFY = $0010;
   TLS1_FLAGS_KEEP_HANDSHAKE = $0020;
   SSL3_FLAGS_SGC_RESTART_DONE = $0040;
   SSL3_MASTER_SECRET_SIZE = 48;
   SSL3_MAX_SSL_SESSION_ID_LENGTH = 32;
   SSL3_MT_HELLO_REQUEST = 0;
   SSL3_MT_CLIENT_REQUEST = 0;
   SSL3_MT_CLIENT_HELLO = 1;
   SSL3_MT_SERVER_HELLO = 2;
   SSL3_MT_NEWSESSION_TICKET = 4;
   SSL3_MT_CERTIFICATE = 11;
   SSL3_MT_SERVER_KEY_EXCHANGE = 12;
   SSL3_MT_CERTIFICATE_REQUEST = 13;
   SSL3_MT_SERVER_DONE = 14;
   SSL3_MT_CERTIFICATE_VERIFY = 15;
   SSL3_MT_CLIENT_KEY_EXCHANGE = 16;
   SSL3_MT_FINISHED = 20;
   SSL3_MT_CERTIFICATE_STATUS = 22;
   SSL3_MT_NEXT_PROTO = 67;
   DTLS1_MT_HELLO_VERIFY_REQUEST = 3;
   SSL3_MT_CCS = 1;
   SSL3_RANDOM_SIZE = 32;
   SSL3_RS_BLANK = 1;
   SSL3_RS_ENCODED = 2;
   SSL3_RS_PART_READ = 4;
   SSL3_RS_PART_WRITE = 5;
   SSL3_RS_PLAIN = 3;
   SSL3_RS_READ_MORE = 3;
   SSL3_RT_ALERT = 21;
   SSL3_RT_APPLICATION_DATA = 23;
   TLS1_RT_HEARTBEAT = 24;
   SSL3_RT_CHANGE_CIPHER_SPEC = 20;
   SSL3_RT_HANDSHAKE = 22;
   SSL3_RT_HEADER_LENGTH = 5;
   SSL3_RT_MAX_MD_SIZE = 64;
   SSL_RT_MAX_CIPHER_BLOCK_SIZE = 16;
   SSL3_RT_MAX_EXTRA = (16384);
   SSL3_RT_MAX_PLAIN_LENGTH = 16384;
   SSL3_RT_MAX_COMPRESSED_OVERHEAD = 1024;
   SSL3_RT_MAX_ENCRYPTED_OVERHEAD = (256 + SSL3_RT_MAX_MD_SIZE);
   SSL3_RT_SEND_MAX_ENCRYPTED_OVERHEAD = (SSL_RT_MAX_CIPHER_BLOCK_SIZE + SSL3_RT_MAX_MD_SIZE);
   SSL3_RT_MAX_COMPRESSED_LENGTH =
      (SSL3_RT_MAX_PLAIN_LENGTH + SSL3_RT_MAX_COMPRESSED_OVERHEAD);
   SSL3_RT_MAX_ENCRYPTED_LENGTH =
      (SSL3_RT_MAX_ENCRYPTED_OVERHEAD + SSL3_RT_MAX_COMPRESSED_LENGTH);
   SSL3_RT_MAX_PACKET_SIZE =
      (SSL3_RT_MAX_ENCRYPTED_LENGTH + SSL3_RT_HEADER_LENGTH);
   SSL3_RT_MAX_DATA_SIZE = 1024 * 1024;
   SSL3_SESSION_ID_SIZE = 32;
   SSL3_SSL_SESSION_ID_LENGTH = 32;
   SSL3_ST_CR_CERT_A = $130 Or SSL_ST_CONNECT;
   SSL3_ST_CR_CERT_B = $131 Or SSL_ST_CONNECT;
   SSL3_ST_CR_CERT_REQ_A = $150 Or SSL_ST_CONNECT;
   SSL3_ST_CR_CERT_REQ_B = $151 Or SSL_ST_CONNECT;
   SSL3_ST_CR_CHANGE_A = $1C0 Or SSL_ST_CONNECT;
   SSL3_ST_CR_CHANGE_B = $1C1 Or SSL_ST_CONNECT;
   SSL3_ST_CR_FINISHED_A = $1D0 Or SSL_ST_CONNECT;
   SSL3_ST_CR_FINISHED_B = $1D1 Or SSL_ST_CONNECT;
   SSL3_ST_CR_SESSION_TICKET_A = ($1E0 Or SSL_ST_CONNECT);
   SSL3_ST_CR_SESSION_TICKET_B = ($1E1 Or SSL_ST_CONNECT);
   SSL3_ST_CR_CERT_STATUS_A = ($1F0 Or SSL_ST_CONNECT);
   SSL3_ST_CR_CERT_STATUS_B = ($1F1 Or SSL_ST_CONNECT);
   SSL3_ST_CR_KEY_EXCH_A = $140 Or SSL_ST_CONNECT;
   SSL3_ST_CR_KEY_EXCH_B = $141 Or SSL_ST_CONNECT;
   SSL3_ST_CR_SRVR_DONE_A = $160 Or SSL_ST_CONNECT;
   SSL3_ST_CR_SRVR_DONE_B = $161 Or SSL_ST_CONNECT;
   SSL3_ST_CR_SRVR_HELLO_A = $120 Or SSL_ST_CONNECT;
   SSL3_ST_CR_SRVR_HELLO_B = $121 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CERT_A = $170 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CERT_B = $171 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CERT_C = $172 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CERT_D = $173 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CERT_VRFY_A = $190 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CERT_VRFY_B = $191 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CHANGE_A = $1A0 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CHANGE_B = $1A1 Or SSL_ST_CONNECT;
   SSL3_ST_CW_NEXT_PROTO_A = ($200 Or SSL_ST_CONNECT);
   SSL3_ST_CW_NEXT_PROTO_B = ($201 Or SSL_ST_CONNECT);
   DTLS1_SCTP_ST_CW_WRITE_SOCK = $310 Or SSL_ST_CONNECT;
   DTLS1_SCTP_ST_CR_READ_SOCK = $320 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CLNT_HELLO_A = $110 Or SSL_ST_CONNECT;
   SSL3_ST_CW_CLNT_HELLO_B = $111 Or SSL_ST_CONNECT;
   SSL3_ST_CW_FINISHED_A = $1B0 Or SSL_ST_CONNECT;
   SSL3_ST_CW_FINISHED_B = $1B1 Or SSL_ST_CONNECT;
   SSL3_ST_CW_FLUSH = $100 Or SSL_ST_CONNECT;
   SSL3_ST_CW_KEY_EXCH_A = $180 Or SSL_ST_CONNECT;
   SSL3_ST_CW_KEY_EXCH_B = $181 Or SSL_ST_CONNECT;
   SSL3_ST_SR_CERT_A = $180 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_CERT_B = $181 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_CERT_VRFY_A = $1A0 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_CERT_VRFY_B = $1A1 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_CHANGE_A = $1B0 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_CHANGE_B = $1B1 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_NEXT_PROTO_A = ($210 Or SSL_ST_ACCEPT);
   SSL3_ST_SR_NEXT_PROTO_B = ($211 Or SSL_ST_ACCEPT);
   SSL3_ST_SR_CLNT_HELLO_A = $110 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_CLNT_HELLO_B = $111 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_CLNT_HELLO_C = $112 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_FINISHED_A = $1C0 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_FINISHED_B = $1C1 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_KEY_EXCH_A = $190 Or SSL_ST_ACCEPT;
   SSL3_ST_SR_KEY_EXCH_B = $191 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_CERT_A = $140 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_CERT_B = $141 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_CERT_REQ_A = $160 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_CERT_REQ_B = $161 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_CHANGE_A = $1D0 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_CHANGE_B = $1D1 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_FINISHED_A = $1E0 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_FINISHED_B = $1E1 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_SESSION_TICKET_A = ($1F0 Or SSL_ST_ACCEPT);
   SSL3_ST_SW_SESSION_TICKET_B = ($1F1 Or SSL_ST_ACCEPT);
   SSL3_ST_SW_CERT_STATUS_A = ($200 Or SSL_ST_ACCEPT);
   SSL3_ST_SW_CERT_STATUS_B = ($201 Or SSL_ST_ACCEPT);
   SSL3_ST_SW_FLUSH = $100 Or SSL_ST_ACCEPT;
   DTLS1_SCTP_ST_SW_WRITE_SOCK = ($310 Or SSL_ST_ACCEPT);
   DTLS1_SCTP_ST_SR_READ_SOCK = ($320 Or SSL_ST_ACCEPT);
   SSL3_ST_SW_HELLO_REQ_A = $120 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_HELLO_REQ_B = $121 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_HELLO_REQ_C = $122 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_KEY_EXCH_A = $150 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_KEY_EXCH_B = $151 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_SRVR_DONE_A = $170 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_SRVR_DONE_B = $171 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_SRVR_HELLO_A = $130 Or SSL_ST_ACCEPT;
   SSL3_ST_SW_SRVR_HELLO_B = $131 Or SSL_ST_ACCEPT;
   SSL3_TXT_ADH_DES_192_CBC_SHA = 'ADH-DES-CBC3-SHA';
   SSL3_TXT_ADH_DES_40_CBC_SHA = 'EXP-ADH-DES-CBC-SHA';
   SSL3_TXT_ADH_DES_64_CBC_SHA = 'ADH-DES-CBC-SHA';
   SSL3_TXT_ADH_RC4_128_MD5 = 'ADH-RC4-MD5';
   SSL3_TXT_ADH_RC4_40_MD5 = 'EXP-ADH-RC4-MD5';
   SSL3_TXT_DH_DSS_DES_192_CBC3_SHA = 'DH-DSS-DES-CBC3-SHA';
   SSL3_TXT_DH_DSS_DES_40_CBC_SHA = 'EXP-DH-DSS-DES-CBC-SHA';
   SSL3_TXT_DH_DSS_DES_64_CBC_SHA = 'DH-DSS-DES-CBC-SHA';
   SSL3_TXT_DH_RSA_DES_192_CBC3_SHA = 'DH-RSA-DES-CBC3-SHA';
   SSL3_TXT_DH_RSA_DES_40_CBC_SHA = 'EXP-DH-RSA-DES-CBC-SHA';
   SSL3_TXT_DH_RSA_DES_64_CBC_SHA = 'DH-RSA-DES-CBC-SHA';
   SSL3_TXT_EDH_DSS_DES_192_CBC3_SHA = 'EDH-DSS-DES-CBC3-SHA';
   SSL3_TXT_EDH_DSS_DES_40_CBC_SHA = 'EXP-EDH-DSS-DES-CBC-SHA';
   SSL3_TXT_EDH_DSS_DES_64_CBC_SHA = 'EDH-DSS-DES-CBC-SHA';
   SSL3_TXT_EDH_RSA_DES_192_CBC3_SHA = 'EDH-RSA-DES-CBC3-SHA';
   SSL3_TXT_EDH_RSA_DES_40_CBC_SHA = 'EXP-EDH-RSA-DES-CBC-SHA';
   SSL3_TXT_EDH_RSA_DES_64_CBC_SHA = 'EDH-RSA-DES-CBC-SHA';
   SSL3_TXT_FZA_DMS_FZA_SHA = 'FZA-FZA-CBC-SHA';
   SSL3_TXT_FZA_DMS_NULL_SHA = 'FZA-NULL-SHA';
   SSL3_TXT_FZA_DMS_RC4_SHA = 'FZA-RC4-SHA';
   SSL3_TXT_RSA_DES_192_CBC3_SHA = 'DES-CBC3-SHA';
   SSL3_TXT_RSA_DES_40_CBC_SHA = 'EXP-DES-CBC-SHA';
   SSL3_TXT_RSA_DES_64_CBC_SHA = 'DES-CBC-SHA';
   SSL3_TXT_RSA_IDEA_128_SHA = 'IDEA-CBC-SHA';
   SSL3_TXT_RSA_NULL_MD5 = 'NULL-MD5';
   SSL3_TXT_RSA_NULL_SHA = 'NULL-SHA';
   SSL3_TXT_RSA_RC2_40_MD5 = 'EXP-RC2-CBC-MD5';
   SSL3_TXT_RSA_RC4_128_MD5 = 'RC4-MD5';
   SSL3_TXT_RSA_RC4_128_SHA = 'RC4-SHA';
   SSL3_TXT_RSA_RC4_40_MD5 = 'EXP-RC4-MD5';
   SSL3_VERSION = $0300;
   SSL3_VERSION_MAJOR = $03;
   SSL3_VERSION_MINOR = $00;
   SSLEAY_VERSION = 0;
   SSLEAY_CFLAGS = 2;
   SSLEAY_BUILT_ON = 3;
   SSLEAY_PLATFORM = 4;
   SSLEAY_DIR = 5;
   TLS1_AD_DECRYPTION_FAILED = 21;
   TLS1_AD_RECORD_OVERFLOW = 22;
   TLS1_AD_UNKNOWN_CA = 48;
   TLS1_AD_ACCESS_DENIED = 49;
   TLS1_AD_DECODE_ERROR = 50;
   TLS1_AD_DECRYPT_ERROR = 51;
   TLS1_AD_EXPORT_RESTRICTION = 60;
   TLS1_AD_PROTOCOL_VERSION = 70;
   TLS1_AD_INSUFFICIENT_SECURITY = 71;
   TLS1_AD_INTERNAL_ERROR = 80;
   TLS1_AD_USER_CANCELLED = 90;
   TLS1_AD_NO_RENEGOTIATION = 100;
   TLS1_AD_UNSUPPORTED_EXTENSION = 110;
   TLS1_AD_CERTIFICATE_UNOBTAINABLE = 111;
   TLS1_AD_UNRECOGNIZED_NAME = 112;
   TLS1_AD_BAD_CERTIFICATE_STATUS_RESPONSE = 113;
   TLS1_AD_BAD_CERTIFICATE_HASH_VALUE = 114;
   TLS1_AD_UNKNOWN_PSK_IDENTITY = 115;
   TLSEXT_TYPE_server_name = 0;
   TLSEXT_TYPE_max_fragment_length = 1;
   TLSEXT_TYPE_client_certificate_url = 2;
   TLSEXT_TYPE_trusted_ca_keys = 3;
   TLSEXT_TYPE_truncated_hmac = 4;
   TLSEXT_TYPE_status_request = 5;
   TLSEXT_TYPE_user_mapping = 6;
   TLSEXT_TYPE_client_authz = 7;
   TLSEXT_TYPE_server_authz = 8;
   TLSEXT_TYPE_cert_type = 9;
   TLSEXT_TYPE_elliptic_curves = 10;
   TLSEXT_TYPE_ec_point_formats = 11;
   TLSEXT_TYPE_srp = 12;
   TLSEXT_TYPE_signature_algorithms = 13;
   TLSEXT_TYPE_use_srtp = 14;
   TLSEXT_TYPE_heartbeat = 15;
   TLSEXT_TYPE_session_ticket = 35;
   TLSEXT_TYPE_next_proto_neg = 13172;
   TLSEXT_TYPE_renegotiate = $FF01;
   TLSEXT_NAMETYPE_host_name = 0;
   TLSEXT_STATUSTYPE_ocsp = 1;
   TLSEXT_ECPOINTFORMAT_first = 0;
   TLSEXT_ECPOINTFORMAT_uncompressed = 0;
   TLSEXT_ECPOINTFORMAT_ansiX962_compressed_prime = 1;
   TLSEXT_ECPOINTFORMAT_ansiX962_compressed_char2 = 2;
   TLSEXT_ECPOINTFORMAT_last = 2;
   TLSEXT_signature_anonymous = 0;
   TLSEXT_signature_rsa = 1;
   TLSEXT_signature_dsa = 2;
   TLSEXT_signature_ecdsa = 3;
   TLSEXT_hash_none = 0;
   TLSEXT_hash_md5 = 1;
   TLSEXT_hash_sha1 = 2;
   TLSEXT_hash_sha224 = 3;
   TLSEXT_hash_sha256 = 4;
   TLSEXT_hash_sha384 = 5;
   TLSEXT_hash_sha512 = 6;
   TLSEXT_MAXLEN_host_name = 255;
   SSL_TLSEXT_ERR_OK = 0;
   SSL_TLSEXT_ERR_ALERT_WARNING = 1;
   SSL_TLSEXT_ERR_ALERT_FATAL = 2;
   SSL_TLSEXT_ERR_NOACK = 3;
   SSLEAY_VERSION_NUMBER = OPENSSL_VERSION_NUMBER;
   SSL_AD_REASON_OFFSET = 1000;
   SSL_AD_CLOSE_NOTIFY = SSL3_AD_CLOSE_NOTIFY;
   SSL_AD_UNEXPECTED_MESSAGE = SSL3_AD_UNEXPECTED_MESSAGE;
   SSL_AD_BAD_RECORD_MAC = SSL3_AD_BAD_RECORD_MAC;
   SSL_AD_DECRYPTION_FAILED = TLS1_AD_DECRYPTION_FAILED;
   SSL_AD_RECORD_OVERFLOW = TLS1_AD_RECORD_OVERFLOW;
   SSL_AD_DECOMPRESSION_FAILURE = SSL3_AD_DECOMPRESSION_FAILURE;
   SSL_AD_HANDSHAKE_FAILURE = SSL3_AD_HANDSHAKE_FAILURE;
   SSL_AD_NO_CERTIFICATE = SSL3_AD_NO_CERTIFICATE;
   SSL_AD_BAD_CERTIFICATE = SSL3_AD_BAD_CERTIFICATE;
   SSL_AD_UNSUPPORTED_CERTIFICATE = SSL3_AD_UNSUPPORTED_CERTIFICATE;
   SSL_AD_CERTIFICATE_REVOKED = SSL3_AD_CERTIFICATE_REVOKED;
   SSL_AD_CERTIFICATE_EXPIRED = SSL3_AD_CERTIFICATE_EXPIRED;
   SSL_AD_CERTIFICATE_UNKNOWN = SSL3_AD_CERTIFICATE_UNKNOWN;
   SSL_AD_ILLEGAL_PARAMETER = SSL3_AD_ILLEGAL_PARAMETER;
   SSL_AD_UNKNOWN_CA = TLS1_AD_UNKNOWN_CA;
   SSL_AD_ACCESS_DENIED = TLS1_AD_ACCESS_DENIED;
   SSL_AD_DECODE_ERROR = TLS1_AD_DECODE_ERROR;
   SSL_AD_DECRYPT_ERROR = TLS1_AD_DECRYPT_ERROR;
   SSL_AD_EXPORT_RESTRICTION = TLS1_AD_EXPORT_RESTRICTION;
   SSL_AD_PROTOCOL_VERSION = TLS1_AD_PROTOCOL_VERSION;
   SSL_AD_INSUFFICIENT_SECURITY = TLS1_AD_INSUFFICIENT_SECURITY;
   SSL_AD_INTERNAL_ERROR = TLS1_AD_INTERNAL_ERROR;
   SSL_AD_USER_CANCELLED = TLS1_AD_USER_CANCELLED;
   SSL_AD_NO_RENEGOTIATION = TLS1_AD_NO_RENEGOTIATION;
   SSL_AD_UNSUPPORTED_EXTENSION = TLS1_AD_UNSUPPORTED_EXTENSION;
   SSL_AD_CERTIFICATE_UNOBTAINABLE = TLS1_AD_CERTIFICATE_UNOBTAINABLE;
   SSL_AD_UNRECOGNIZED_NAME = TLS1_AD_UNRECOGNIZED_NAME;
   SSL_AD_BAD_CERTIFICATE_STATUS_RESPONSE = TLS1_AD_BAD_CERTIFICATE_STATUS_RESPONSE;
   SSL_AD_BAD_CERTIFICATE_HASH_VALUE = TLS1_AD_BAD_CERTIFICATE_HASH_VALUE;
   SSL_AD_UNKNOWN_PSK_IDENTITY = TLS1_AD_UNKNOWN_PSK_IDENTITY;
   SSL_CTRL_NEED_TMP_RSA = 1;
   SSL_CTRL_SET_TMP_RSA = 2;
   SSL_CTRL_SET_TMP_DH = 3;
   SSL_CTRL_SET_TMP_ECDH = 4;
   SSL_CTRL_SET_TMP_RSA_CB = 5;
   SSL_CTRL_SET_TMP_DH_CB = 6;
   SSL_CTRL_SET_TMP_ECDH_CB = 7;
   SSL_CTRL_SET_TLSEXT_SERVERNAME_CB = 53;
   SSL_CTRL_SET_TLSEXT_SERVERNAME_ARG = 54;
   SSL_CTRL_SET_TLSEXT_HOSTNAME = 55;
   SSL_CTRL_SET_TLSEXT_DEBUG_CB = 56;
   SSL_CTRL_SET_TLSEXT_DEBUG_ARG = 57;
   SSL_CTRL_GET_TLSEXT_TICKET_KEYS = 58;
   SSL_CTRL_SET_TLSEXT_TICKET_KEYS = 59;
   SSL_CTRL_SET_TLSEXT_OPAQUE_PRF_INPUT = 60;
   SSL_CTRL_SET_TLSEXT_OPAQUE_PRF_INPUT_CB = 61;
   SSL_CTRL_SET_TLSEXT_OPAQUE_PRF_INPUT_CB_ARG = 62;
   SSL_CTRL_SET_TLSEXT_STATUS_REQ_CB = 63;
   SSL_CTRL_SET_TLSEXT_STATUS_REQ_CB_ARG = 64;
   SSL_CTRL_SET_TLSEXT_STATUS_REQ_TYPE = 65;
   SSL_CTRL_GET_TLSEXT_STATUS_REQ_EXTS = 66;
   SSL_CTRL_SET_TLSEXT_STATUS_REQ_EXTS = 67;
   SSL_CTRL_GET_TLSEXT_STATUS_REQ_IDS = 68;
   SSL_CTRL_SET_TLSEXT_STATUS_REQ_IDS = 69;
   SSL_CTRL_GET_TLSEXT_STATUS_REQ_OCSP_RESP = 70;
   SSL_CTRL_SET_TLSEXT_STATUS_REQ_OCSP_RESP = 71;
   SSL_CTRL_SET_TLSEXT_TICKET_KEY_CB = 72;
   SSL_CTRL_SET_TLS_EXT_SRP_USERNAME_CB = 75;
   SSL_CTRL_SET_SRP_VERIFY_PARAM_CB = 76;
   SSL_CTRL_SET_SRP_GIVE_CLIENT_PWD_CB = 77;
   SSL_CTRL_SET_SRP_ARG = 78;
   SSL_CTRL_SET_TLS_EXT_SRP_USERNAME = 79;
   SSL_CTRL_SET_TLS_EXT_SRP_STRENGTH = 80;
   SSL_CTRL_SET_TLS_EXT_SRP_PASSWORD = 81;
   SSL_CTRL_TLS_EXT_SEND_HEARTBEAT = 85;
   SSL_CTRL_GET_TLS_EXT_HEARTBEAT_PENDING = 86;
   SSL_CTRL_SET_TLS_EXT_HEARTBEAT_NO_REQUESTS = 87;
   SSL_CTRL_SET_ECDH_AUTO = 94;
   DTLS_CTRL_GET_TIMEOUT = 73;
   DTLS_CTRL_HANDLE_TIMEOUT = 74;
   DTLS_CTRL_LISTEN = 75;
   SSL_CTRL_GET_RI_SUPPORT = 76;
   SSL_CTRL_CLEAR_OPTIONS = 77;
   SSL_CTRL_CLEAR_MODE = 78;
   SSL_CTRL_GET_EXTRA_CHAIN_CERTS = 82;
   SSL_CTRL_CLEAR_EXTRA_CHAIN_CERTS = 83;
   SSL_CTRL_CHAIN = 88;
   SSL_CTRL_CHAIN_CERT = 89;
   SSL_CTRL_GET_CHAIN_CERTS = 115;
   SSL_CTRL_GET_SESSION_REUSED = 8;
   SSL_CTRL_GET_CLIENT_CERT_REQUEST = 9;
   SSL_CTRL_GET_NUM_RENEGOTIATIONS = 10;
   SSL_CTRL_CLEAR_NUM_RENEGOTIATIONS = 11;
   SSL_CTRL_GET_TOTAL_RENEGOTIATIONS = 12;
   SSL_CTRL_GET_FLAGS = 13;
   SSL_CTRL_EXTRA_CHAIN_CERT = 14;
   SSL_CTRL_SET_MSG_CALLBACK = 15;
   SSL_CTRL_SET_MSG_CALLBACK_ARG = 16;
   SSL_CTRL_SET_MTU = 17;
   SSL_CTRL_SESS_NUMBER = 20;
   SSL_CTRL_SESS_CONNECT = 21;
   SSL_CTRL_SESS_CONNECT_GOOD = 22;
   SSL_CTRL_SESS_CONNECT_RENEGOTIATE = 23;
   SSL_CTRL_SESS_ACCEPT = 24;
   SSL_CTRL_SESS_ACCEPT_GOOD = 25;
   SSL_CTRL_SESS_ACCEPT_RENEGOTIATE = 26;
   SSL_CTRL_SESS_HIT = 27;
   SSL_CTRL_SESS_CB_HIT = 28;
   SSL_CTRL_SESS_MISSES = 29;
   SSL_CTRL_SESS_TIMEOUTS = 30;
   SSL_CTRL_SESS_CACHE_FULL = 31;
   SSL_CTRL_OPTIONS = 32;
   SSL_CTRL_MODE = 33;
   SSL_CTRL_GET_READ_AHEAD = 40;
   SSL_CTRL_SET_READ_AHEAD = 41;
   SSL_CTRL_SET_SESS_CACHE_SIZE = 42;
   SSL_CTRL_GET_SESS_CACHE_SIZE = 43;
   SSL_CTRL_SET_SESS_CACHE_MODE = 44;
   SSL_CTRL_GET_SESS_CACHE_MODE = 45;
   SSL_CTRL_GET_MAX_CERT_LIST = 50;
   SSL_CTRL_SET_MAX_CERT_LIST = 51;
   SSL_CTRL_SET_MAX_SEND_FRAGMENT = 52;
   SSL_DEFAULT_CIPHER_LIST = 'AES:ALL:!aNULL:!eNULL:+RC4:@STRENGTH';
   SSL_ERROR_NONE = 0;
   SSL_ERROR_SSL = 1;
   SSL_ERROR_WANT_READ = 2;
   SSL_ERROR_WANT_WRITE = 3;
   SSL_ERROR_WANT_X509_LOOKUP = 4;
   SSL_ERROR_SYSCALL = 5;
   SSL_ERROR_ZERO_RETURN = 6;
   SSL_ERROR_WANT_CONNECT = 7;
   SSL_ERROR_WANT_ACCEPT = 8;
   X509_FILETYPE_ASN1 = 2;
   SSL_FILETYPE_ASN1 = X509_FILETYPE_ASN1;
   X509_FILETYPE_PEM = 1;
   SSL_FILETYPE_PEM = X509_FILETYPE_PEM;
   SSL_F_CLIENT_CERTIFICATE = 100;
   SSL_F_CLIENT_HELLO = 101;
   SSL_F_CLIENT_MASTER_KEY = 102;
   SSL_F_D2I_SSL_SESSION = 103;
   SSL_F_DO_SSL3_WRITE = 104;
   SSL_F_DTLS1_ACCEPT = 246;
   SSL_F_DTLS1_ADD_CERT_TO_BUF = 295;
   SSL_F_DTLS1_BUFFER_RECORD = 247;
   SSL_F_DTLS1_CHECK_TIMEOUT_NUM = 316;
   SSL_F_DTLS1_CLIENT_HELLO = 248;
   SSL_F_DTLS1_CONNECT = 249;
   SSL_F_DTLS1_ENC = 250;
   SSL_F_DTLS1_GET_HELLO_VERIFY = 251;
   SSL_F_DTLS1_GET_MESSAGE = 252;
   SSL_F_DTLS1_GET_MESSAGE_FRAGMENT = 253;
   SSL_F_DTLS1_GET_RECORD = 254;
   SSL_F_DTLS1_HANDLE_TIMEOUT = 297;
   SSL_F_DTLS1_HEARTBEAT = 305;
   SSL_F_DTLS1_OUTPUT_CERT_CHAIN = 255;
   SSL_F_DTLS1_PREPROCESS_FRAGMENT = 288;
   SSL_F_DTLS1_PROCESS_OUT_OF_SEQ_MESSAGE = 256;
   SSL_F_DTLS1_PROCESS_RECORD = 257;
   SSL_F_DTLS1_READ_BYTES = 258;
   SSL_F_DTLS1_READ_FAILED = 259;
   SSL_F_DTLS1_SEND_CERTIFICATE_REQUEST = 260;
   SSL_F_DTLS1_SEND_CLIENT_CERTIFICATE = 261;
   SSL_F_DTLS1_SEND_CLIENT_KEY_EXCHANGE = 262;
   SSL_F_DTLS1_SEND_CLIENT_VERIFY = 263;
   SSL_F_DTLS1_SEND_HELLO_VERIFY_REQUEST = 264;
   SSL_F_DTLS1_SEND_SERVER_CERTIFICATE = 265;
   SSL_F_DTLS1_SEND_SERVER_HELLO = 266;
   SSL_F_DTLS1_SEND_SERVER_KEY_EXCHANGE = 267;
   SSL_F_DTLS1_WRITE_APP_DATA_BYTES = 268;
   SSL_F_GET_CLIENT_FINISHED = 105;
   SSL_F_GET_CLIENT_HELLO = 106;
   SSL_F_GET_CLIENT_MASTER_KEY = 107;
   SSL_F_GET_SERVER_FINISHED = 108;
   SSL_F_GET_SERVER_HELLO = 109;
   SSL_F_GET_SERVER_VERIFY = 110;
   SSL_F_I2D_SSL_SESSION = 111;
   SSL_F_READ_N = 112;
   SSL_F_REQUEST_CERTIFICATE = 113;
   SSL_F_SERVER_HELLO = 114;
   SSL_F_SSL23_ACCEPT = 115;
   SSL_F_SSL3_ADD_CERT_TO_BUF = 296;
   SSL_F_SSL23_CLIENT_HELLO = 116;
   SSL_F_SSL23_CONNECT = 117;
   SSL_F_SSL23_GET_CLIENT_HELLO = 118;
   SSL_F_SSL23_GET_SERVER_HELLO = 119;
   SSL_F_SSL23_READ = 120;
   SSL_F_SSL23_WRITE = 121;
   SSL_F_SSL2_ACCEPT = 122;
   SSL_F_SSL2_CONNECT = 123;
   SSL_F_SSL2_ENC_INIT = 124;
   SSL_F_SSL2_READ = 125;
   SSL_F_SSL2_SET_CERTIFICATE = 126;
   SSL_F_SSL2_WRITE = 127;
   SSL_F_SSL3_ACCEPT = 128;
   SSL_F_SSL3_CHANGE_CIPHER_STATE = 129;
   SSL_F_SSL3_CHECK_CERT_AND_ALGORITHM = 130;
   SSL_F_SSL3_CHECK_CLIENT_HELLO = 304;
   SSL_F_SSL3_CLIENT_HELLO = 131;
   SSL_F_SSL3_CONNECT = 132;
   SSL_F_SSL3_CTRL = 213;
   SSL_F_SSL3_CTX_CTRL = 133;
   SSL_F_SSL3_DIGEST_CACHED_RECORDS = 293;
   SSL_F_SSL3_DO_CHANGE_CIPHER_SPEC = 292;
   SSL_F_SSL3_ENC = 134;
   SSL_F_SSL3_GET_CERTIFICATE_REQUEST = 135;
   SSL_F_SSL3_GET_CERT_STATUS = 289;
   SSL_F_SSL3_GET_CERT_VERIFY = 136;
   SSL_F_SSL3_GET_CLIENT_CERTIFICATE = 137;
   SSL_F_SSL3_GET_CLIENT_HELLO = 138;
   SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE = 139;
   SSL_F_SSL3_GET_FINISHED = 140;
   SSL_F_SSL3_GET_KEY_EXCHANGE = 141;
   SSL_F_SSL3_GET_MESSAGE = 142;
   SSL_F_SSL3_GET_NEW_SESSION_TICKET = 283;
   SSL_F_SSL3_GET_NEXT_PROTO = 306;
   SSL_F_SSL3_GET_RECORD = 143;
   SSL_F_SSL3_GET_SERVER_CERTIFICATE = 144;
   SSL_F_SSL3_GET_SERVER_DONE = 145;
   SSL_F_SSL3_GET_SERVER_HELLO = 146;
   SSL_F_SSL3_HANDSHAKE_MAC = 285;
   SSL_F_SSL3_NEW_SESSION_TICKET = 287;
   SSL_F_SSL3_OUTPUT_CERT_CHAIN = 147;
   SSL_F_SSL3_READ_BYTES = 148;
   SSL_F_SSL3_READ_N = 149;
   SSL_F_SSL3_SEND_CERTIFICATE_REQUEST = 150;
   SSL_F_SSL3_SEND_CLIENT_CERTIFICATE = 151;
   SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE = 152;
   SSL_F_SSL3_SEND_CLIENT_VERIFY = 153;
   SSL_F_SSL3_SEND_SERVER_CERTIFICATE = 154;
   SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE = 155;
   SSL_F_SSL3_SETUP_KEY_BLOCK = 157;
   SSL_F_SSL3_SETUP_READ_BUFFER = 156;
   SSL_F_SSL3_SETUP_WRITE_BUFFER = 291;
   SSL_F_SSL3_WRITE_BYTES = 158;
   SSL_F_SSL3_WRITE_PENDING = 159;
   SSL_F_SSL_ADD_CLIENTHELLO_RENEGOTIATE_EXT = 298;
   SSL_F_SSL_ADD_CLIENTHELLO_TLSEXT = 277;
   SSL_F_SSL_ADD_CLIENTHELLO_USE_SRTP_EXT = 307;
   SSL_F_SSL_ADD_DIR_CERT_SUBJECTS_TO_STACK = 215;
   SSL_F_SSL_ADD_FILE_CERT_SUBJECTS_TO_STACK = 216;
   SSL_F_SSL_ADD_SERVERHELLO_RENEGOTIATE_EXT = 299;
   SSL_F_SSL_ADD_SERVERHELLO_TLSEXT = 278;
   SSL_F_SSL_ADD_SERVERHELLO_USE_SRTP_EXT = 308;
   SSL_F_SSL_BAD_METHOD = 160;
   SSL_F_SSL_BYTES_TO_CIPHER_LIST = 161;
   SSL_F_SSL_CERT_DUP = 221;
   SSL_F_SSL_CERT_INST = 222;
   SSL_F_SSL_CERT_INSTANTIATE = 214;
   SSL_F_SSL_CERT_NEW = 162;
   SSL_F_SSL_CHECK_PRIVATE_KEY = 163;
   SSL_F_SSL_CHECK_SERVERHELLO_TLSEXT = 280;
   SSL_F_SSL_CHECK_SRVR_ECC_CERT_AND_ALG = 279;
   SSL_F_SSL_CIPHER_PROCESS_RULESTR = 230;
   SSL_F_SSL_CIPHER_STRENGTH_SORT = 231;
   SSL_F_SSL_CLEAR = 164;
   SSL_F_SSL_COMP_ADD_COMPRESSION_METHOD = 165;
   SSL_F_SSL_CREATE_CIPHER_LIST = 166;
   SSL_F_SSL_CTRL = 232;
   SSL_F_SSL_CTX_CHECK_PRIVATE_KEY = 168;
   SSL_F_SSL_CTX_MAKE_PROFILES = 309;
   SSL_F_SSL_CTX_NEW = 169;
   SSL_F_SSL_CTX_SET_CIPHER_LIST = 269;
   SSL_F_SSL_CTX_SET_CLIENT_CERT_ENGINE = 290;
   SSL_F_SSL_CTX_SET_PURPOSE = 226;
   SSL_F_SSL_CTX_SET_SESSION_ID_CONTEXT = 219;
   SSL_F_SSL_CTX_SET_SSL_VERSION = 170;
   SSL_F_SSL_CTX_SET_TRUST = 229;
   SSL_F_SSL_CTX_USE_CERTIFICATE = 171;
   SSL_F_SSL_CTX_USE_CERTIFICATE_ASN1 = 172;
   SSL_F_SSL_CTX_USE_CERTIFICATE_CHAIN_FILE = 220;
   SSL_F_SSL_CTX_USE_CERTIFICATE_FILE = 173;
   SSL_F_SSL_CTX_USE_PRIVATEKEY = 174;
   SSL_F_SSL_CTX_USE_PRIVATEKEY_ASN1 = 175;
   SSL_F_SSL_CTX_USE_PRIVATEKEY_FILE = 176;
   SSL_F_SSL_CTX_USE_PSK_IDENTITY_HINT = 272;
   SSL_F_SSL_CTX_USE_RSAPRIVATEKEY = 177;
   SSL_F_SSL_CTX_USE_RSAPRIVATEKEY_ASN1 = 178;
   SSL_F_SSL_CTX_USE_RSAPRIVATEKEY_FILE = 179;
   SSL_F_SSL_DO_HANDSHAKE = 180;
   SSL_F_SSL_GET_NEW_SESSION = 181;
   SSL_F_SSL_GET_PREV_SESSION = 217;
   SSL_F_SSL_GET_SERVER_SEND_CERT = 182;
   SSL_F_SSL_GET_SERVER_SEND_PKEY = 317;
   SSL_F_SSL_GET_SIGN_PKEY = 183;
   SSL_F_SSL_INIT_WBIO_BUFFER = 184;
   SSL_F_SSL_LOAD_CLIENT_CA_FILE = 185;
   SSL_F_SSL_NEW = 186;
   SSL_F_SSL_PARSE_CLIENTHELLO_RENEGOTIATE_EXT = 300;
   SSL_F_SSL_PARSE_CLIENTHELLO_TLSEXT = 302;
   SSL_F_SSL_PARSE_CLIENTHELLO_USE_SRTP_EXT = 310;
   SSL_F_SSL_PARSE_SERVERHELLO_RENEGOTIATE_EXT = 301;
   SSL_F_SSL_PARSE_SERVERHELLO_TLSEXT = 303;
   SSL_F_SSL_PARSE_SERVERHELLO_USE_SRTP_EXT = 311;
   SSL_F_SSL_PEEK = 270;
   SSL_F_SSL_PREPARE_CLIENTHELLO_TLSEXT = 281;
   SSL_F_SSL_PREPARE_SERVERHELLO_TLSEXT = 282;
   SSL_F_SSL_READ = 223;
   SSL_F_SSL_RSA_PRIVATE_DECRYPT = 187;
   SSL_F_SSL_RSA_PUBLIC_ENCRYPT = 188;
   SSL_F_SSL_SESSION_NEW = 189;
   SSL_F_SSL_SESSION_PRINT_FP = 190;
   SSL_F_SSL_SESSION_SET1_ID_CONTEXT = 312;
   SSL_F_SSL_SESS_CERT_NEW = 225;
   SSL_F_SSL_SET_CERT = 191;
   SSL_F_SSL_SET_FD = 192;
   SSL_F_SSL_SET_PKEY = 193;
   SSL_F_SSL_SET_RFD = 194;
   SSL_F_SSL_SET_SESSION = 195;
   SSL_F_SSL_SET_SESSION_ID_CONTEXT = 218;
   SSL_F_SSL_SET_SESSION_TICKET_EXT = 294;
   SSL_F_SSL_SET_WFD = 196;
   SSL_F_SSL_SHUTDOWN = 224;
   SSL_F_SSL_SRP_CTX_INIT = 313;
   SSL_F_SSL_UNDEFINED_FUNCTION = 197;
   SSL_F_SSL_USE_CERTIFICATE = 198;
   SSL_F_SSL_USE_CERTIFICATE_ASN1 = 199;
   SSL_F_SSL_USE_CERTIFICATE_FILE = 200;
   SSL_F_SSL_USE_PRIVATEKEY = 201;
   SSL_F_SSL_USE_PRIVATEKEY_ASN1 = 202;
   SSL_F_SSL_USE_PRIVATEKEY_FILE = 203;
   SSL_F_SSL_USE_PSK_IDENTITY_HINT = 273;
   SSL_F_SSL_USE_RSAPRIVATEKEY = 204;
   SSL_F_SSL_USE_RSAPRIVATEKEY_ASN1 = 205;
   SSL_F_SSL_USE_RSAPRIVATEKEY_FILE = 206;
   SSL_F_SSL_VERIFY_CERT_CHAIN = 207;
   SSL_F_SSL_WRITE = 208;
   SSL_F_TLS1_CERT_VERIFY_MAC = 286;
   SSL_F_TLS1_CHANGE_CIPHER_STATE = 209;
   SSL_F_TLS1_CHECK_SERVERHELLO_TLSEXT = 274;
   SSL_F_TLS1_ENC = 210;
   SSL_F_TLS1_EXPORT_KEYING_MATERIAL = 314;
   SSL_F_TLS1_HEARTBEAT = 315;
   SSL_F_TLS1_PREPARE_CLIENTHELLO_TLSEXT = 275;
   SSL_F_TLS1_PREPARE_SERVERHELLO_TLSEXT = 276;
   SSL_F_TLS1_PRF = 284;
   SSL_F_TLS1_SETUP_KEY_BLOCK = 211;
   SSL_F_WRITE_PENDING = 212;
   SSL_MAX_KEY_ARG_LENGTH = 8;
   SSL_MAX_MASTER_KEY_LENGTH = 48;
   SSL_MAX_SID_CTX_LENGTH = 32;
   SSL_MAX_KRB5_PRINCIPAL_LENGTH = 256;
   SSL_MAX_SSL_SESSION_ID_LENGTH = 32;
   SSL_MODE_ENABLE_PARTIAL_WRITE = $00000001;
   SSL_MODE_ACCEPT_MOVING_WRITE_BUFFER = $00000002;
   SSL_MODE_AUTO_RETRY = $00000004;
   SSL_MODE_NO_AUTO_CHAIN = $00000008;
   SSL_MODE_RELEASE_BUFFERS = $00000010;
   SSL_NOTHING = 1;
   SSL_WRITING = 2;
   SSL_READING = 3;
   SSL_X509_LOOKUP = 4;
   SSL_OP_MICROSOFT_SESS_ID_BUG = $00000001;
   SSL_OP_NETSCAPE_CHALLENGE_BUG = $00000002;
   SSL_OP_LEGACY_SERVER_CONNECT = $00000004;
   SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG = $00000008;
   SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG = $00000010;
   SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER = $00000020;
   SSL_OP_MSIE_SSLV2_RSA_PADDING = $00000040;
   SSL_OP_SSLEAY_080_CLIENT_DH_BUG = $00000080;
   SSL_OP_TLS_D5_BUG = $00000100;
   SSL_OP_TLS_BLOCK_PADDING_BUG = $00000200;
   SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS = $00000800;
   SSL_OP_ALL = $00000FFF;
   SSL_OP_NO_QUERY_MTU = $00001000;
   SSL_OP_COOKIE_EXCHANGE = $00002000;
   SSL_OP_NO_TICKET = $00004000;
   SSL_OP_CISCO_ANYCONNECT = $00008000;
   SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION = $00010000;
   SSL_OP_NO_COMPRESSION = $00020000;
   SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION = $00040000;
   SSL_OP_SINGLE_ECDH_USE = $00080000;
   SSL_OP_SINGLE_DH_USE = $00100000;
   SSL_OP_EPHEMERAL_RSA = $00200000;
   SSL_OP_CIPHER_SERVER_PREFERENCE = $00400000;
   SSL_OP_TLS_ROLLBACK_BUG = $00800000;
   SSL_OP_NO_SSLv2 = $01000000;
   SSL_OP_NO_SSLv3 = $02000000;
   SSL_OP_NO_TLSv1 = $04000000;
   SSL_OP_NO_TLSv1_2 = $08000000;
   SSL_OP_NO_TLSv1_1 = $10000000;
   SSL_OP_PKCS1_CHECK_1 = $00;
   SSL_OP_PKCS1_CHECK_2 = $00;
   SSL_OP_NETSCAPE_CA_DN_BUG = $20000000;
   SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG = $40000000;
   SSL_OP_CRYPTOPRO_TLSEXT_BUG = $80000000;
   SSL_RECEIVED_SHUTDOWN = 2;
   SSL_R_APP_DATA_IN_HANDSHAKE = 100;
   SSL_R_ATTEMPT_TO_REUSE_SESSION_IN_DIFFERENT_CONTEXT = 272;
   SSL_R_BAD_ALERT_RECORD = 101;
   SSL_R_BAD_AUTHENTICATION_TYPE = 102;
   SSL_R_BAD_CHANGE_CIPHER_SPEC = 103;
   SSL_R_BAD_CHECKSUM = 104;
   SSL_R_BAD_CLIENT_REQUEST = 105;
   SSL_R_BAD_DATA_RETURNED_BY_CALLBACK = 106;
   SSL_R_BAD_DECOMPRESSION = 107;
   SSL_R_BAD_DH_G_LENGTH = 108;
   SSL_R_BAD_DH_PUB_KEY_LENGTH = 109;
   SSL_R_BAD_DH_P_LENGTH = 110;
   SSL_R_BAD_DIGEST_LENGTH = 111;
   SSL_R_BAD_DSA_SIGNATURE = 112;
   SSL_R_BAD_ECC_CERT = 304;
   SSL_R_BAD_ECDSA_SIGNATURE = 305;
   SSL_R_BAD_ECPOINT = 306;
   SSL_R_BAD_HANDSHAKE_LENGTH = 332;
   SSL_R_BAD_HELLO_REQUEST = 105;
   SSL_R_BAD_LENGTH = 271;
   SSL_R_BAD_MAC_DECODE = 113;
   SSL_R_BAD_MAC_LENGTH = 333;
   SSL_R_BAD_MESSAGE_TYPE = 114;
   SSL_R_BAD_PACKET_LENGTH = 115;
   SSL_R_BAD_PROTOCOL_VERSION_NUMBER = 116;
   SSL_R_BAD_PSK_IDENTITY_HINT_LENGTH = 316;
   SSL_R_BAD_RESPONSE_ARGUMENT = 117;
   SSL_R_BAD_RSA_DECRYPT = 118;
   SSL_R_BAD_RSA_ENCRYPT = 119;
   SSL_R_BAD_RSA_E_LENGTH = 120;
   SSL_R_BAD_RSA_MODULUS_LENGTH = 121;
   SSL_R_BAD_RSA_SIGNATURE = 122;
   SSL_R_BAD_SIGNATURE = 123;
   SSL_R_BAD_SRP_A_LENGTH = 347;
   SSL_R_BAD_SRP_B_LENGTH = 348;
   SSL_R_BAD_SRP_G_LENGTH = 349;
   SSL_R_BAD_SRP_N_LENGTH = 350;
   SSL_R_BAD_SRP_S_LENGTH = 351;
   SSL_R_BAD_SRTP_MKI_VALUE = 352;
   SSL_R_BAD_SRTP_PROTECTION_PROFILE_LIST = 353;
   SSL_R_BAD_SSL_FILETYPE = 124;
   SSL_R_BAD_SSL_SESSION_ID_LENGTH = 125;
   SSL_R_BAD_STATE = 126;
   SSL_R_BAD_WRITE_RETRY = 127;
   SSL_R_BIO_NOT_SET = 128;
   SSL_R_BLOCK_CIPHER_PAD_IS_WRONG = 129;
   SSL_R_BN_LIB = 130;
   SSL_R_CA_DN_LENGTH_MISMATCH = 131;
   SSL_R_CA_DN_TOO_LONG = 132;
   SSL_R_CCS_RECEIVED_EARLY = 133;
   SSL_R_CERTIFICATE_VERIFY_FAILED = 134;
   SSL_R_CERT_LENGTH_MISMATCH = 135;
   SSL_R_CHALLENGE_IS_DIFFERENT = 136;
   SSL_R_CIPHER_CODE_WRONG_LENGTH = 137;
   SSL_R_CIPHER_OR_HASH_UNAVAILABLE = 138;
   SSL_R_CIPHER_TABLE_SRC_ERROR = 139;
   SSL_R_CLIENTHELLO_TLSEXT = 226;
   SSL_R_COMPRESSED_LENGTH_TOO_LONG = 140;
   SSL_R_COMPRESSION_DISABLED = 343;
   SSL_R_COMPRESSION_FAILURE = 141;
   SSL_R_COMPRESSION_LIBRARY_ERROR = 142;
   SSL_R_CONNECTION_ID_IS_DIFFERENT = 143;
   SSL_R_CONNECTION_TYPE_NOT_SET = 144;
   SSL_R_DATA_BETWEEN_CCS_AND_FINISHED = 145;
   SSL_R_DATA_LENGTH_TOO_LONG = 146;
   SSL_R_DECRYPTION_FAILED = 147;
   SSL_R_DH_PUBLIC_VALUE_LENGTH_IS_WRONG = 148;
   SSL_R_DIGEST_CHECK_FAILED = 149;
   SSL_R_DTLS_MESSAGE_TOO_BIG = 334;
   SSL_R_ECC_CERT_NOT_FOR_KEY_AGREEMENT = 317;
   SSL_R_ECC_CERT_NOT_FOR_SIGNING = 318;
   SSL_R_ECC_CERT_SHOULD_HAVE_RSA_SIGNATURE = 322;
   SSL_R_ECC_CERT_SHOULD_HAVE_SHA1_SIGNATURE = 323;
   SSL_R_ECGROUP_TOO_LARGE_FOR_CIPHER = 310;
   SSL_R_EMPTY_SRTP_PROTECTION_PROFILE_LIST = 354;
   SSL_R_ENCRYPTED_LENGTH_TOO_LONG = 150;
   SSL_R_ERROR_IN_RECEIVED_CIPHER_LIST = 151;
   SSL_R_EXCESSIVE_MESSAGE_SIZE = 152;
   SSL_R_EXTRA_DATA_IN_MESSAGE = 153;
   SSL_R_GOT_A_FIN_BEFORE_A_CCS = 154;
   SSL_R_GOT_NEXT_PROTO_BEFORE_A_CCS = 355;
   SSL_R_GOT_NEXT_PROTO_WITHOUT_EXTENSION = 356;
   SSL_R_HTTPS_PROXY_REQUEST = 155;
   SSL_R_HTTP_REQUEST = 156;
   SSL_R_ILLEGAL_PADDING = 283;
   SSL_R_INCONSISTENT_COMPRESSION = 340;
   SSL_R_INTERNAL_ERROR = 157;
   SSL_R_INVALID_CHALLENGE_LENGTH = 158;
   SSL_R_INVALID_COMMAND = 280;
   SSL_R_INVALID_PURPOSE = 278;
   SSL_R_INVALID_STATUS_RESPONSE = 316;
   SSL_R_INVALID_TICKET_KEYS_LENGTH = 275;
   SSL_R_INVALID_TRUST = 279;
   SSL_R_LENGTH_MISMATCH = 159;
   SSL_R_LENGTH_TOO_SHORT = 160;
   SSL_R_LIBRARY_BUG = 274;
   SSL_R_LIBRARY_HAS_NO_CIPHERS = 161;
   SSL_R_MISSING_DH_DSA_CERT = 162;
   SSL_R_MISSING_DH_KEY = 163;
   SSL_R_MISSING_DH_RSA_CERT = 164;
   SSL_R_MISSING_DSA_SIGNING_CERT = 165;
   SSL_R_MISSING_EXPORT_TMP_DH_KEY = 166;
   SSL_R_MISSING_EXPORT_TMP_RSA_KEY = 167;
   SSL_R_MISSING_RSA_CERTIFICATE = 168;
   SSL_R_MISSING_RSA_ENCRYPTING_CERT = 169;
   SSL_R_MISSING_RSA_SIGNING_CERT = 170;
   SSL_R_MISSING_TMP_DH_KEY = 171;
   SSL_R_MISSING_TMP_RSA_KEY = 172;
   SSL_R_MISSING_TMP_RSA_PKEY = 173;
   SSL_R_MISSING_VERIFY_MESSAGE = 174;
   SSL_R_MULTIPLE_SGC_RESTARTS = 346;
   SSL_R_NON_SSLV2_INITIAL_PACKET = 175;
   SSL_R_NO_CERTIFICATES_RETURNED = 176;
   SSL_R_NO_CERTIFICATE_ASSIGNED = 177;
   SSL_R_NO_CERTIFICATE_RETURNED = 178;
   SSL_R_NO_CERTIFICATE_SET = 179;
   SSL_R_NO_CERTIFICATE_SPECIFIED = 180;
   SSL_R_NO_CIPHERS_AVAILABLE = 181;
   SSL_R_NO_CIPHERS_PASSED = 182;
   SSL_R_NO_CIPHERS_SPECIFIED = 183;
   SSL_R_NO_CIPHER_LIST = 184;
   SSL_R_NO_CIPHER_MATCH = 185;
   SSL_R_NO_CLIENT_CERT_METHOD = 317;
   SSL_R_NO_CLIENT_CERT_RECEIVED = 186;
   SSL_R_NO_COMPRESSION_SPECIFIED = 187;
   SSL_R_NO_METHOD_SPECIFIED = 188;
   SSL_R_NO_PRIVATEKEY = 189;
   SSL_R_NO_PRIVATE_KEY_ASSIGNED = 190;
   SSL_R_NO_PROTOCOLS_AVAILABLE = 191;
   SSL_R_NO_PUBLICKEY = 192;
   SSL_R_NO_RENEGOTIATION = 319;
   SSL_R_NO_SHARED_CIPHER = 193;
   SSL_R_NO_VERIFY_CALLBACK = 194;
   SSL_R_NULL_SSL_CTX = 195;
   SSL_R_NULL_SSL_METHOD_PASSED = 196;
   SSL_R_OLD_SESSION_CIPHER_NOT_RETURNED = 197;
   SSL_R_ONLY_TLS_ALLOWED_IN_FIPS_MODE = 297;
   SSL_R_PACKET_LENGTH_TOO_LONG = 198;
   SSL_R_PARSE_TLSEXT = 223;
   SSL_R_PATH_TOO_LONG = 270;
   SSL_R_PEER_DID_NOT_RETURN_A_CERTIFICATE = 199;
   SSL_R_PEER_ERROR = 200;
   SSL_R_PEER_ERROR_CERTIFICATE = 201;
   SSL_R_PEER_ERROR_NO_CERTIFICATE = 202;
   SSL_R_PEER_ERROR_NO_CIPHER = 203;
   SSL_R_PEER_ERROR_UNSUPPORTED_CERTIFICATE_TYPE = 204;
   SSL_R_PRE_MAC_LENGTH_TOO_LONG = 205;
   SSL_R_PROBLEMS_MAPPING_CIPHER_FUNCTIONS = 206;
   SSL_R_PROTOCOL_IS_SHUTDOWN = 207;
   SSL_R_PUBLIC_KEY_ENCRYPT_ERROR = 208;
   SSL_R_PUBLIC_KEY_IS_NOT_RSA = 209;
   SSL_R_PUBLIC_KEY_NOT_RSA = 210;
   SSL_R_READ_BIO_NOT_SET = 211;
   SSL_R_READ_WRONG_PACKET_TYPE = 212;
   SSL_R_RECORD_LENGTH_MISMATCH = 213;
   SSL_R_RECORD_TOO_LARGE = 214;
   SSL_R_RECORD_TOO_SMALL = 298;
   SSL_R_RENEGOTIATE_EXT_TOO_LONG = 320;
   SSL_R_RENEGOTIATION_ENCODING_ERR = 321;
   SSL_R_RENEGOTIATION_MISMATCH = 322;
   SSL_R_REQUIRED_CIPHER_MISSING = 215;
   SSL_R_REUSE_CERT_LENGTH_NOT_ZERO = 216;
   SSL_R_REUSE_CERT_TYPE_NOT_ZERO = 217;
   SSL_R_REUSE_CIPHER_LIST_NOT_ZERO = 218;
   SSL_R_SCSV_RECEIVED_WHEN_RENEGOTIATING = 324;
   SSL_R_SERVERHELLO_TLSEXT = 224;
   SSL_R_SESSION_ID_CONTEXT_UNINITIALIZED = 277;
   SSL_R_SHORT_READ = 219;
   SSL_R_SIGNATURE_FOR_NON_SIGNING_CERTIFICATE = 220;
   SSL_R_SSL23_DOING_SESSION_ID_REUSE = 221;
   SSL_R_SSL2_CONNECTION_ID_TOO_LONG = 299;
   SSL_R_SSL3_EXT_INVALID_SERVERNAME = 225;
   SSL_R_SSL3_EXT_INVALID_SERVERNAME_TYPE = 226;
   SSL_R_SSL3_SESSION_ID_TOO_LONG = 300;
   SSL_R_SSL3_SESSION_ID_TOO_SHORT = 222;
   SSL_R_SSLV3_ALERT_BAD_CERTIFICATE = 1042;
   SSL_R_SSLV3_ALERT_BAD_RECORD_MAC = 1020;
   SSL_R_SSLV3_ALERT_CERTIFICATE_EXPIRED = 1045;
   SSL_R_SSLV3_ALERT_CERTIFICATE_REVOKED = 1044;
   SSL_R_SSLV3_ALERT_CERTIFICATE_UNKNOWN = 1046;
   SSL_R_SSLV3_ALERT_DECOMPRESSION_FAILURE = 1030;
   SSL_R_SSLV3_ALERT_HANDSHAKE_FAILURE = 1040;
   SSL_R_SSLV3_ALERT_ILLEGAL_PARAMETER = 1047;
   SSL_R_SSLV3_ALERT_NO_CERTIFICATE = 1041;
   SSL_R_SSLV3_ALERT_PEER_ERROR_CERTIFICATE = 223;
   SSL_R_SSLV3_ALERT_PEER_ERROR_NO_CERTIFICATE = 224;
   SSL_R_SSLV3_ALERT_PEER_ERROR_NO_CIPHER = 225;
   SSL_R_SSLV3_ALERT_PEER_ERROR_UNSUPPORTED_CERTIFICATE_TYPE = 226;
   SSL_R_SSLV3_ALERT_UNEXPECTED_MESSAGE = 1010;
   SSL_R_SSLV3_ALERT_UNKNOWN_REMOTE_ERROR_TYPE = 227;
   SSL_R_SSLV3_ALERT_UNSUPPORTED_CERTIFICATE = 1043;
   SSL_R_SSL_CTX_HAS_NO_DEFAULT_SSL_VERSION = 228;
   SSL_R_SSL_HANDSHAKE_FAILURE = 229;
   SSL_R_SSL_LIBRARY_HAS_NO_CIPHERS = 230;
   SSL_R_SSL_SESSION_ID_CONTEXT_TOO_LONG = 273;
   SSL_R_SSL_SESSION_ID_IS_DIFFERENT = 231;
   SSL_R_TLSV1_ALERT_ACCESS_DENIED = 1049;
   SSL_R_TLSV1_ALERT_DECODE_ERROR = 1050;
   SSL_R_TLSV1_ALERT_DECRYPTION_FAILED = 1021;
   SSL_R_TLSV1_ALERT_DECRYPT_ERROR = 1051;
   SSL_R_TLSV1_ALERT_EXPORT_RESTRICION = 1060;
   SSL_R_TLSV1_ALERT_INSUFFICIENT_SECURITY = 1071;
   SSL_R_TLSV1_ALERT_INTERNAL_ERROR = 1080;
   SSL_R_TLSV1_ALERT_NO_RENEGOTIATION = 1100;
   SSL_R_TLSV1_ALERT_PROTOCOL_VERSION = 1070;
   SSL_R_TLSV1_ALERT_RECORD_OVERFLOW = 1022;
   SSL_R_TLSV1_ALERT_UNKNOWN_CA = 1048;
   SSL_R_TLSV1_ALERT_USER_CANCLED = 1090;
   SSL_R_TLS_CLIENT_CERT_REQ_WITH_ANON_CIPHER = 232;
   SSL_R_TLS_INVALID_ECPOINTFORMAT_LIST = 227;
   SSL_R_TLS_PEER_DID_NOT_RESPOND_WITH_CERTIFICATE_LIST = 233;
   SSL_R_TLS_RSA_ENCRYPTED_VALUE_LENGTH_IS_WRONG = 234;
   SSL_R_TRIED_TO_USE_UNSUPPORTED_CIPHER = 235;
   SSL_R_UNABLE_TO_DECODE_DH_CERTS = 236;
   SSL_R_UNABLE_TO_EXTRACT_PUBLIC_KEY = 237;
   SSL_R_UNABLE_TO_FIND_DH_PARAMETERS = 238;
   SSL_R_UNABLE_TO_FIND_PUBLIC_KEY_PARAMETERS = 239;
   SSL_R_UNABLE_TO_FIND_SSL_METHOD = 240;
   SSL_R_UNABLE_TO_LOAD_SSL2_MD5_ROUTINES = 241;
   SSL_R_UNABLE_TO_LOAD_SSL3_MD5_ROUTINES = 242;
   SSL_R_UNABLE_TO_LOAD_SSL3_SHA1_ROUTINES = 243;
   SSL_R_UNEXPECTED_MESSAGE = 244;
   SSL_R_UNEXPECTED_RECORD = 245;
   SSL_R_UNINITIALIZED = 276;
   SSL_R_UNKNOWN_ALERT_TYPE = 246;
   SSL_R_UNKNOWN_CERTIFICATE_TYPE = 247;
   SSL_R_UNKNOWN_CIPHER_RETURNED = 248;
   SSL_R_UNKNOWN_CIPHER_TYPE = 249;
   SSL_R_UNKNOWN_KEY_EXCHANGE_TYPE = 250;
   SSL_R_UNKNOWN_PKEY_TYPE = 251;
   SSL_R_UNKNOWN_PROTOCOL = 252;
   SSL_R_UNKNOWN_REMOTE_ERROR_TYPE = 253;
   SSL_R_UNKNOWN_SSL_VERSION = 254;
   SSL_R_UNSUPPORTED_STATUS_TYPE = 329;
   SSL_R_UNKNOWN_STATE = 255;
   SSL_R_UNSAFE_LEGACY_RENEGOTIATION_DISABLED = 323;
   SSL_R_UNSUPPORTED_CIPHER = 256;
   SSL_R_UNSUPPORTED_COMPRESSION_ALGORITHM = 257;
   SSL_R_UNSUPPORTED_DIGEST_TYPE = 326;
   SSL_R_UNSUPPORTED_PROTOCOL = 258;
   SSL_R_UNSUPPORTED_SSL_VERSION = 259;
   SSL_R_USE_SRTP_NOT_NEGOTIATED = 369;
   SSL_R_WRITE_BIO_NOT_SET = 260;
   SSL_R_WRONG_CIPHER_RETURNED = 261;
   SSL_R_WRONG_MESSAGE_TYPE = 262;
   SSL_R_WRONG_NUMBER_OF_KEY_BITS = 263;
   SSL_R_WRONG_SIGNATURE_LENGTH = 264;
   SSL_R_WRONG_SIGNATURE_SIZE = 265;
   SSL_R_WRONG_SIGNATURE_TYPE = 370;
   SSL_R_WRONG_SSL_VERSION = 266;
   SSL_R_WRONG_VERSION_NUMBER = 267;
   SSL_R_X509_LIB = 268;
   SSL_R_X509_VERIFICATION_SETUP_PROBLEMS = 269;
   SSL_SENT_SHUTDOWN = 1;
   SSL_SESSION_ASN1_VERSION = $0001;
   SSL_SESSION_CACHE_MAX_SIZE_DEFAULT = 1024 * 20;
   SSL_SESS_CACHE_CLIENT = $0001;
   SSL_SESS_CACHE_SERVER = $0002;
   SSL_SESS_CACHE_BOTH = SSL_SESS_CACHE_CLIENT Or SSL_SESS_CACHE_SERVER;
   SSL_SESS_CACHE_NO_AUTO_CLEAR = $0080;
   SSL_SESS_CACHE_NO_INTERNAL_LOOKUP = $0100;
   SSL_SESS_CACHE_OFF = $0000;
   OPENSSL_NPN_UNSUPPORTED = 0;
   OPENSSL_NPN_NEGOTIATED = 1;
   OPENSSL_NPN_NO_OVERLAP = 2;
   PSK_MAX_IDENTITY_LEN = 128;
   PSK_MAX_PSK_LEN = 256;
   SSL_TXT_LOW = 'LOW';
   SSL_TXT_MEDIUM = 'MEDIUM';
   SSL_TXT_HIGH = 'HIGH';
   SSL_TXT_FIPS = 'FIPS';
   SSL_TXT_kFZA = 'kFZA';
   SSL_TXT_aFZA = 'aFZA';
   SSL_TXT_eFZA = 'eFZA';
   SSL_TXT_FZA = 'FZA';
   SSL_TXT_aNULL = 'aNULL';
   SSL_TXT_eNULL = 'eNULL';
   SSL_TXT_NULL = 'NULL';
   SSL_TXT_kKRB5 = 'kKRB5';
   SSL_TXT_aKRB5 = 'aKRB5';
   SSL_TXT_KRB5 = 'KRB5';
   SSL_TXT_kRSA = 'kRSA';
   SSL_TXT_kDHr = 'kDHr';
   SSL_TXT_kDHd = 'kDHd';
   SSL_TXT_kEDH = 'kEDH';
   SSL_TXT_aRSA = 'aRSA';
   SSL_TXT_aDSS = 'aDSS';
   SSL_TXT_aDH = 'aDH';
   SSL_TXT_RSA = 'RSA';
   SSL_TXT_DH = 'DH';
   SSL_TXT_EDH = 'EDH';
   SSL_TXT_ADH_C = 'ADH';
   SSL_TXT_aDH_S = 'aDH';
   SSL_TXT_DSS = 'DSS';
   SSL_TXT_DES = 'DES';
   SSL_TXT_3DES = '3DES';
   SSL_TXT_RC4 = 'RC4';
   SSL_TXT_RC2 = 'RC2';
   SSL_TXT_IDEA = 'IDEA';
   SSL_TXT_SEED = 'SEED';
   SSL_TXT_AES = 'AES';
   SSL_TXT_CAMELLIA = 'CAMELLIA';
   SSL_TXT_MD5 = 'MD5';
   SSL_TXT_SHA1 = 'SHA1';
   SSL_TXT_SHA = 'SHA';
   SSL_TXT_EXP = 'EXP';
   SSL_TXT_EXPORT = 'EXPORT';
   SSL_TXT_EXP40 = 'EXPORT40';
   SSL_TXT_EXP56 = 'EXPORT56';
   SSL_TXT_SSLV2 = 'SSLv2';
   SSL_TXT_SSLV3 = 'SSLv3';
   SSL_TXT_TLSV1 = 'TLSv1';
   SSL_TXT_ALL = 'ALL';
   SSL_TXT_ECC = 'ECCdraft';
   SSL_TXT_DES_192_EDE3_CBC_WITH_MD5 = SSL2_TXT_DES_192_EDE3_CBC_WITH_MD5;
   SSL_TXT_DES_192_EDE3_CBC_WITH_SHA = SSL2_TXT_DES_192_EDE3_CBC_WITH_SHA;
   SSL_TXT_DES_64_CBC_WITH_MD5 = SSL2_TXT_DES_64_CBC_WITH_MD5;
   SSL_TXT_DES_64_CBC_WITH_SHA = SSL2_TXT_DES_64_CBC_WITH_SHA;
   SSL_TXT_IDEA_128_CBC_WITH_MD5 = SSL2_TXT_IDEA_128_CBC_WITH_MD5;
   SSL_TXT_NULL_WITH_MD5 = SSL2_TXT_NULL_WITH_MD5;
   SSL_TXT_RC2_128_CBC_EXPORT40_WITH_MD5 = SSL2_TXT_RC2_128_CBC_EXPORT40_WITH_MD5;
   SSL_TXT_RC2_128_CBC_WITH_MD5 = SSL2_TXT_RC2_128_CBC_WITH_MD5;
   SSL_TXT_RC4_128_EXPORT40_WITH_MD5 = SSL2_TXT_RC4_128_EXPORT40_WITH_MD5;
   SSL_TXT_RC4_128_WITH_MD5 = SSL2_TXT_RC4_128_WITH_MD5;
   SSL_VERIFY_CLIENT_ONCE = $04;
   SSL_VERIFY_FAIL_IF_NO_PEER_CERT = $02;
   SSL_VERIFY_NONE = $00;
   SSL_VERIFY_PEER = $01;
   SSL_MAC_FLAG_READ_MAC_STREAM = 1;
   SSL_MAC_FLAG_WRITE_MAC_STREAM = 2;
   TLS1_ALLOW_EXPERIMENTAL_CIPHERSUITES = 0;
   TLS1_2_VERSION = $0303;
   TLS1_2_VERSION_MAJOR = $03;
   TLS1_2_VERSION_MINOR = $03;
   TLS1_1_VERSION = $0302;
   TLS1_1_VERSION_MAJOR = $03;
   TLS1_1_VERSION_MINOR = $02;
   TLS1_VERSION = $0301;
   TLS1_VERSION_MAJOR = $03;
   TLS1_VERSION_MINOR = $01;
   SSL_TLSEXT_HB_ENABLED = $01;
   SSL_TLSEXT_HB_DONT_SEND_REQUESTS = $02;
   SSL_TLSEXT_HB_DONT_RECV_REQUESTS = $04;
   TLS1_CK_PSK_WITH_RC4_128_SHA = $0300008A;
   TLS1_CK_PSK_WITH_3DES_EDE_CBC_SHA = $0300008B;
   TLS1_CK_PSK_WITH_AES_128_CBC_SHA = $0300008C;
   TLS1_CK_PSK_WITH_AES_256_CBC_SHA = $0300008D;
   TLS1_CK_RSA_EXPORT1024_WITH_RC4_56_MD5 = $03000060;
   TLS1_CK_RSA_EXPORT1024_WITH_RC2_CBC_56_MD5 = $03000061;
   TLS1_CK_RSA_EXPORT1024_WITH_DES_CBC_SHA = $03000062;
   TLS1_CK_DHE_DSS_EXPORT1024_WITH_DES_CBC_SHA = $03000063;
   TLS1_CK_RSA_EXPORT1024_WITH_RC4_56_SHA = $03000064;
   TLS1_CK_DHE_DSS_EXPORT1024_WITH_RC4_56_SHA = $03000065;
   TLS1_CK_DHE_DSS_WITH_RC4_128_SHA = $03000066;
   TLS1_CK_RSA_WITH_AES_128_SHA = $0300002F;
   TLS1_CK_DH_DSS_WITH_AES_128_SHA = $03000030;
   TLS1_CK_DH_RSA_WITH_AES_128_SHA = $03000031;
   TLS1_CK_DHE_DSS_WITH_AES_128_SHA = $03000032;
   TLS1_CK_DHE_RSA_WITH_AES_128_SHA = $03000033;
   TLS1_CK_ADH_WITH_AES_128_SHA = $03000034;
   TLS1_CK_RSA_WITH_AES_256_SHA = $03000035;
   TLS1_CK_DH_DSS_WITH_AES_256_SHA = $03000036;
   TLS1_CK_DH_RSA_WITH_AES_256_SHA = $03000037;
   TLS1_CK_DHE_DSS_WITH_AES_256_SHA = $03000038;
   TLS1_CK_DHE_RSA_WITH_AES_256_SHA = $03000039;
   TLS1_CK_ADH_WITH_AES_256_SHA = $0300003A;
   TLS1_CK_RSA_WITH_NULL_SHA256 = $0300003B;
   TLS1_CK_RSA_WITH_AES_128_SHA256 = $0300003C;
   TLS1_CK_RSA_WITH_AES_256_SHA256 = $0300003D;
   TLS1_CK_DH_DSS_WITH_AES_128_SHA256 = $0300003E;
   TLS1_CK_DH_RSA_WITH_AES_128_SHA256 = $0300003F;
   TLS1_CK_DHE_DSS_WITH_AES_128_SHA256 = $03000040;
   TLS1_CK_RSA_WITH_CAMELLIA_128_CBC_SHA = $03000041;
   TLS1_CK_DH_DSS_WITH_CAMELLIA_128_CBC_SHA = $03000042;
   TLS1_CK_DH_RSA_WITH_CAMELLIA_128_CBC_SHA = $03000043;
   TLS1_CK_DHE_DSS_WITH_CAMELLIA_128_CBC_SHA = $03000044;
   TLS1_CK_DHE_RSA_WITH_CAMELLIA_128_CBC_SHA = $03000045;
   TLS1_CK_ADH_WITH_CAMELLIA_128_CBC_SHA = $03000046;
   TLS1_CK_RSA_WITH_CAMELLIA_256_CBC_SHA = $03000084;
   TLS1_CK_DH_DSS_WITH_CAMELLIA_256_CBC_SHA = $03000085;
   TLS1_CK_DH_RSA_WITH_CAMELLIA_256_CBC_SHA = $03000086;
   TLS1_CK_DHE_DSS_WITH_CAMELLIA_256_CBC_SHA = $03000087;
   TLS1_CK_DHE_RSA_WITH_CAMELLIA_256_CBC_SHA = $03000088;
   TLS1_CK_ADH_WITH_CAMELLIA_256_CBC_SHA = $03000089;
   TLS1_CK_DHE_RSA_WITH_AES_128_SHA256 = $03000067;
   TLS1_CK_DH_DSS_WITH_AES_256_SHA256 = $03000068;
   TLS1_CK_DH_RSA_WITH_AES_256_SHA256 = $03000069;
   TLS1_CK_DHE_DSS_WITH_AES_256_SHA256 = $0300006A;
   TLS1_CK_DHE_RSA_WITH_AES_256_SHA256 = $0300006B;
   TLS1_CK_ADH_WITH_AES_128_SHA256 = $0300006C;
   TLS1_CK_ADH_WITH_AES_256_SHA256 = $0300006D;
   TLS1_CK_RSA_WITH_SEED_SHA = $03000096;
   TLS1_CK_DH_DSS_WITH_SEED_SHA = $03000097;
   TLS1_CK_DH_RSA_WITH_SEED_SHA = $03000098;
   TLS1_CK_DHE_DSS_WITH_SEED_SHA = $03000099;
   TLS1_CK_DHE_RSA_WITH_SEED_SHA = $0300009A;
   TLS1_CK_ADH_WITH_SEED_SHA = $0300009B;
   TLS1_CK_RSA_WITH_AES_128_GCM_SHA256 = $0300009C;
   TLS1_CK_RSA_WITH_AES_256_GCM_SHA384 = $0300009D;
   TLS1_CK_DHE_RSA_WITH_AES_128_GCM_SHA256 = $0300009E;
   TLS1_CK_DHE_RSA_WITH_AES_256_GCM_SHA384 = $0300009F;
   TLS1_CK_DH_RSA_WITH_AES_128_GCM_SHA256 = $030000A0;
   TLS1_CK_DH_RSA_WITH_AES_256_GCM_SHA384 = $030000A1;
   TLS1_CK_DHE_DSS_WITH_AES_128_GCM_SHA256 = $030000A2;
   TLS1_CK_DHE_DSS_WITH_AES_256_GCM_SHA384 = $030000A3;
   TLS1_CK_DH_DSS_WITH_AES_128_GCM_SHA256 = $030000A4;
   TLS1_CK_DH_DSS_WITH_AES_256_GCM_SHA384 = $030000A5;
   TLS1_CK_ADH_WITH_AES_128_GCM_SHA256 = $030000A6;
   TLS1_CK_ADH_WITH_AES_256_GCM_SHA384 = $030000A7;
   TLS1_CK_ECDH_ECDSA_WITH_NULL_SHA = $0300C001;
   TLS1_CK_ECDH_ECDSA_WITH_RC4_128_SHA = $0300C002;
   TLS1_CK_ECDH_ECDSA_WITH_DES_192_CBC3_SHA = $0300C003;
   TLS1_CK_ECDH_ECDSA_WITH_AES_128_CBC_SHA = $0300C004;
   TLS1_CK_ECDH_ECDSA_WITH_AES_256_CBC_SHA = $0300C005;
   TLS1_CK_ECDHE_ECDSA_WITH_NULL_SHA = $0300C006;
   TLS1_CK_ECDHE_ECDSA_WITH_RC4_128_SHA = $0300C007;
   TLS1_CK_ECDHE_ECDSA_WITH_DES_192_CBC3_SHA = $0300C008;
   TLS1_CK_ECDHE_ECDSA_WITH_AES_128_CBC_SHA = $0300C009;
   TLS1_CK_ECDHE_ECDSA_WITH_AES_256_CBC_SHA = $0300C00A;
   TLS1_CK_ECDH_RSA_WITH_NULL_SHA = $0300C00B;
   TLS1_CK_ECDH_RSA_WITH_RC4_128_SHA = $0300C00C;
   TLS1_CK_ECDH_RSA_WITH_DES_192_CBC3_SHA = $0300C00D;
   TLS1_CK_ECDH_RSA_WITH_AES_128_CBC_SHA = $0300C00E;
   TLS1_CK_ECDH_RSA_WITH_AES_256_CBC_SHA = $0300C00F;
   TLS1_CK_ECDHE_RSA_WITH_NULL_SHA = $0300C010;
   TLS1_CK_ECDHE_RSA_WITH_RC4_128_SHA = $0300C011;
   TLS1_CK_ECDHE_RSA_WITH_DES_192_CBC3_SHA = $0300C012;
   TLS1_CK_ECDHE_RSA_WITH_AES_128_CBC_SHA = $0300C013;
   TLS1_CK_ECDHE_RSA_WITH_AES_256_CBC_SHA = $0300C014;
   TLS1_CK_ECDH_anon_WITH_NULL_SHA = $0300C015;
   TLS1_CK_ECDH_anon_WITH_RC4_128_SHA = $0300C016;
   TLS1_CK_ECDH_anon_WITH_DES_192_CBC3_SHA = $0300C017;
   TLS1_CK_ECDH_anon_WITH_AES_128_CBC_SHA = $0300C018;
   TLS1_CK_ECDH_anon_WITH_AES_256_CBC_SHA = $0300C019;
   TLS1_CK_SRP_SHA_WITH_3DES_EDE_CBC_SHA = $0300C01A;
   TLS1_CK_SRP_SHA_RSA_WITH_3DES_EDE_CBC_SHA = $0300C01B;
   TLS1_CK_SRP_SHA_DSS_WITH_3DES_EDE_CBC_SHA = $0300C01C;
   TLS1_CK_SRP_SHA_WITH_AES_128_CBC_SHA = $0300C01D;
   TLS1_CK_SRP_SHA_RSA_WITH_AES_128_CBC_SHA = $0300C01E;
   TLS1_CK_SRP_SHA_DSS_WITH_AES_128_CBC_SHA = $0300C01F;
   TLS1_CK_SRP_SHA_WITH_AES_256_CBC_SHA = $0300C020;
   TLS1_CK_SRP_SHA_RSA_WITH_AES_256_CBC_SHA = $0300C021;
   TLS1_CK_SRP_SHA_DSS_WITH_AES_256_CBC_SHA = $0300C022;
   TLS1_CK_ECDHE_ECDSA_WITH_AES_128_SHA256 = $0300C023;
   TLS1_CK_ECDHE_ECDSA_WITH_AES_256_SHA384 = $0300C024;
   TLS1_CK_ECDH_ECDSA_WITH_AES_128_SHA256 = $0300C025;
   TLS1_CK_ECDH_ECDSA_WITH_AES_256_SHA384 = $0300C026;
   TLS1_CK_ECDHE_RSA_WITH_AES_128_SHA256 = $0300C027;
   TLS1_CK_ECDHE_RSA_WITH_AES_256_SHA384 = $0300C028;
   TLS1_CK_ECDH_RSA_WITH_AES_128_SHA256 = $0300C029;
   TLS1_CK_ECDH_RSA_WITH_AES_256_SHA384 = $0300C02A;
   TLS1_CK_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256 = $0300C02B;
   TLS1_CK_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384 = $0300C02C;
   TLS1_CK_ECDH_ECDSA_WITH_AES_128_GCM_SHA256 = $0300C02D;
   TLS1_CK_ECDH_ECDSA_WITH_AES_256_GCM_SHA384 = $0300C02E;
   TLS1_CK_ECDHE_RSA_WITH_AES_128_GCM_SHA256 = $0300C02F;
   TLS1_CK_ECDHE_RSA_WITH_AES_256_GCM_SHA384 = $0300C030;
   TLS1_CK_ECDH_RSA_WITH_AES_128_GCM_SHA256 = $0300C031;
   TLS1_CK_ECDH_RSA_WITH_AES_256_GCM_SHA384 = $0300C032;
   TLS1_FINISH_MAC_LENGTH = 12;
   TLS1_TXT_RSA_EXPORT1024_WITH_RC4_56_MD5 = 'EXP1024-RC4-MD5';
   TLS1_TXT_RSA_EXPORT1024_WITH_RC2_CBC_56_MD5 = 'EXP1024-RC2-CBC-MD5';
   TLS1_TXT_RSA_EXPORT1024_WITH_DES_CBC_SHA = 'EXP1024-DES-CBC-SHA';
   TLS1_TXT_DHE_DSS_EXPORT1024_WITH_DES_CBC_SHA = 'EXP1024-DHE-DSS-DES-CBC-SHA';
   TLS1_TXT_RSA_EXPORT1024_WITH_RC4_56_SHA = 'EXP1024-RC4-SHA';
   TLS1_TXT_DHE_DSS_EXPORT1024_WITH_RC4_56_SHA = 'EXP1024-DHE-DSS-RC4-SHA';
   TLS1_TXT_DHE_DSS_WITH_RC4_128_SHA = 'DHE-DSS-RC4-SHA';
   TLS1_TXT_RSA_WITH_AES_128_SHA = 'AES128-SHA';
   TLS1_TXT_DH_DSS_WITH_AES_128_SHA = 'DH-DSS-AES128-SHA';
   TLS1_TXT_DH_RSA_WITH_AES_128_SHA = 'DH-RSA-AES128-SHA';
   TLS1_TXT_DHE_DSS_WITH_AES_128_SHA = 'DHE-DSS-AES128-SHA';
   TLS1_TXT_DHE_RSA_WITH_AES_128_SHA = 'DHE-RSA-AES128-SHA';
   TLS1_TXT_ADH_WITH_AES_128_SHA = 'ADH-AES128-SHA';
   TLS1_TXT_RSA_WITH_AES_256_SHA = 'AES256-SHA';
   TLS1_TXT_DH_DSS_WITH_AES_256_SHA = 'DH-DSS-AES256-SHA';
   TLS1_TXT_DH_RSA_WITH_AES_256_SHA = 'DH-RSA-AES256-SHA';
   TLS1_TXT_DHE_DSS_WITH_AES_256_SHA = 'DHE-DSS-AES256-SHA';
   TLS1_TXT_DHE_RSA_WITH_AES_256_SHA = 'DHE-RSA-AES256-SHA';
   TLS1_TXT_ADH_WITH_AES_256_SHA = 'ADH-AES256-SHA';
   TLS1_TXT_ECDH_ECDSA_WITH_NULL_SHA = 'ECDH-ECDSA-NULL-SHA';
   TLS1_TXT_ECDH_ECDSA_WITH_RC4_128_SHA = 'ECDH-ECDSA-RC4-SHA';
   TLS1_TXT_ECDH_ECDSA_WITH_DES_192_CBC3_SHA = 'ECDH-ECDSA-DES-CBC3-SHA';
   TLS1_TXT_ECDH_ECDSA_WITH_AES_128_CBC_SHA = 'ECDH-ECDSA-AES128-SHA';
   TLS1_TXT_ECDH_ECDSA_WITH_AES_256_CBC_SHA = 'ECDH-ECDSA-AES256-SHA';
   TLS1_TXT_ECDHE_ECDSA_WITH_NULL_SHA = 'ECDHE-ECDSA-NULL-SHA';
   TLS1_TXT_ECDHE_ECDSA_WITH_RC4_128_SHA = 'ECDHE-ECDSA-RC4-SHA';
   TLS1_TXT_ECDHE_ECDSA_WITH_DES_192_CBC3_SHA = 'ECDHE-ECDSA-DES-CBC3-SHA';
   TLS1_TXT_ECDHE_ECDSA_WITH_AES_128_CBC_SHA = 'ECDHE-ECDSA-AES128-SHA';
   TLS1_TXT_ECDHE_ECDSA_WITH_AES_256_CBC_SHA = 'ECDHE-ECDSA-AES256-SHA';
   TLS1_TXT_ECDH_RSA_WITH_NULL_SHA = 'ECDH-RSA-NULL-SHA';
   TLS1_TXT_ECDH_RSA_WITH_RC4_128_SHA = 'ECDH-RSA-RC4-SHA';
   TLS1_TXT_ECDH_RSA_WITH_DES_192_CBC3_SHA = 'ECDH-RSA-DES-CBC3-SHA';
   TLS1_TXT_ECDH_RSA_WITH_AES_128_CBC_SHA = 'ECDH-RSA-AES128-SHA';
   TLS1_TXT_ECDH_RSA_WITH_AES_256_CBC_SHA = 'ECDH-RSA-AES256-SHA';
   TLS1_TXT_ECDHE_RSA_WITH_NULL_SHA = 'ECDHE-RSA-NULL-SHA';
   TLS1_TXT_ECDHE_RSA_WITH_RC4_128_SHA = 'ECDHE-RSA-RC4-SHA';
   TLS1_TXT_ECDHE_RSA_WITH_DES_192_CBC3_SHA = 'ECDHE-RSA-DES-CBC3-SHA';
   TLS1_TXT_ECDHE_RSA_WITH_AES_128_CBC_SHA = 'ECDHE-RSA-AES128-SHA';
   TLS1_TXT_ECDHE_RSA_WITH_AES_256_CBC_SHA = 'ECDHE-RSA-AES256-SHA';
   TLS1_TXT_ECDH_anon_WITH_NULL_SHA = 'AECDH-NULL-SHA';
   TLS1_TXT_ECDH_anon_WITH_RC4_128_SHA = 'AECDH-RC4-SHA';
   TLS1_TXT_ECDH_anon_WITH_DES_192_CBC3_SHA = 'AECDH-DES-CBC3-SHA';
   TLS1_TXT_ECDH_anon_WITH_AES_128_CBC_SHA = 'AECDH-AES128-SHA';
   TLS1_TXT_ECDH_anon_WITH_AES_256_CBC_SHA = 'AECDH-AES256-SHA';
   TLS1_TXT_RSA_WITH_CAMELLIA_128_CBC_SHA = 'CAMELLIA128-SHA';
   TLS1_TXT_DH_DSS_WITH_CAMELLIA_128_CBC_SHA = 'DH-DSS-CAMELLIA128-SHA';
   TLS1_TXT_DH_RSA_WITH_CAMELLIA_128_CBC_SHA = 'DH-RSA-CAMELLIA128-SHA';
   TLS1_TXT_DHE_DSS_WITH_CAMELLIA_128_CBC_SHA = 'DHE-DSS-CAMELLIA128-SHA';
   TLS1_TXT_DHE_RSA_WITH_CAMELLIA_128_CBC_SHA = 'DHE-RSA-CAMELLIA128-SHA';
   TLS1_TXT_ADH_WITH_CAMELLIA_128_CBC_SHA = 'ADH-CAMELLIA128-SHA';
   TLS1_TXT_RSA_WITH_CAMELLIA_256_CBC_SHA = 'CAMELLIA256-SHA';
   TLS1_TXT_DH_DSS_WITH_CAMELLIA_256_CBC_SHA = 'DH-DSS-CAMELLIA256-SHA';
   TLS1_TXT_DH_RSA_WITH_CAMELLIA_256_CBC_SHA = 'DH-RSA-CAMELLIA256-SHA';
   TLS1_TXT_DHE_DSS_WITH_CAMELLIA_256_CBC_SHA = 'DHE-DSS-CAMELLIA256-SHA';
   TLS1_TXT_DHE_RSA_WITH_CAMELLIA_256_CBC_SHA = 'DHE-RSA-CAMELLIA256-SHA';
   TLS1_TXT_ADH_WITH_CAMELLIA_256_CBC_SHA = 'ADH-CAMELLIA256-SHA';
   TLS1_TXT_RSA_WITH_SEED_SHA = 'SEED-SHA';
   TLS1_TXT_DH_DSS_WITH_SEED_SHA = 'DH-DSS-SEED-SHA';
   TLS1_TXT_DH_RSA_WITH_SEED_SHA = 'DH-RSA-SEED-SHA';
   TLS1_TXT_DHE_DSS_WITH_SEED_SHA = 'DHE-DSS-SEED-SHA';
   TLS1_TXT_DHE_RSA_WITH_SEED_SHA = 'DHE-RSA-SEED-SHA';
   TLS1_TXT_ADH_WITH_SEED_SHA = 'ADH-SEED-SHA';
   TLS1_TXT_RSA_WITH_NULL_SHA256 = 'NULL-SHA256';
   TLS1_TXT_RSA_WITH_AES_128_SHA256 = 'AES128-SHA256';
   TLS1_TXT_RSA_WITH_AES_256_SHA256 = 'AES256-SHA256';
   TLS1_TXT_DH_DSS_WITH_AES_128_SHA256 = 'DH-DSS-AES128-SHA256';
   TLS1_TXT_DH_RSA_WITH_AES_128_SHA256 = 'DH-RSA-AES128-SHA256';
   TLS1_TXT_DHE_DSS_WITH_AES_128_SHA256 = 'DHE-DSS-AES128-SHA256';
   TLS1_TXT_DHE_RSA_WITH_AES_128_SHA256 = 'DHE-RSA-AES128-SHA256';
   TLS1_TXT_DH_DSS_WITH_AES_256_SHA256 = 'DH-DSS-AES256-SHA256';
   TLS1_TXT_DH_RSA_WITH_AES_256_SHA256 = 'DH-RSA-AES256-SHA256';
   TLS1_TXT_DHE_DSS_WITH_AES_256_SHA256 = 'DHE-DSS-AES256-SHA256';
   TLS1_TXT_DHE_RSA_WITH_AES_256_SHA256 = 'DHE-RSA-AES256-SHA256';
   TLS1_TXT_ADH_WITH_AES_128_SHA256 = 'ADH-AES128-SHA256';
   TLS1_TXT_ADH_WITH_AES_256_SHA256 = 'ADH-AES256-SHA256';
   TLS1_TXT_RSA_WITH_AES_128_GCM_SHA256 = 'AES128-GCM-SHA256';
   TLS1_TXT_RSA_WITH_AES_256_GCM_SHA384 = 'AES256-GCM-SHA384';
   TLS1_TXT_DHE_RSA_WITH_AES_128_GCM_SHA256 = 'DHE-RSA-AES128-GCM-SHA256';
   TLS1_TXT_DHE_RSA_WITH_AES_256_GCM_SHA384 = 'DHE-RSA-AES256-GCM-SHA384';
   TLS1_TXT_DH_RSA_WITH_AES_128_GCM_SHA256 = 'DH-RSA-AES128-GCM-SHA256';
   TLS1_TXT_DH_RSA_WITH_AES_256_GCM_SHA384 = 'DH-RSA-AES256-GCM-SHA384';
   TLS1_TXT_DHE_DSS_WITH_AES_128_GCM_SHA256 = 'DHE-DSS-AES128-GCM-SHA256';
   TLS1_TXT_DHE_DSS_WITH_AES_256_GCM_SHA384 = 'DHE-DSS-AES256-GCM-SHA384';
   TLS1_TXT_DH_DSS_WITH_AES_128_GCM_SHA256 = 'DH-DSS-AES128-GCM-SHA256';
   TLS1_TXT_DH_DSS_WITH_AES_256_GCM_SHA384 = 'DH-DSS-AES256-GCM-SHA384';
   TLS1_TXT_ADH_WITH_AES_128_GCM_SHA256 = 'ADH-AES128-GCM-SHA256';
   TLS1_TXT_ADH_WITH_AES_256_GCM_SHA384 = 'ADH-AES256-GCM-SHA384';
   TLS1_TXT_ECDHE_ECDSA_WITH_AES_128_SHA256 = 'ECDHE-ECDSA-AES128-SHA256';
   TLS1_TXT_ECDHE_ECDSA_WITH_AES_256_SHA384 = 'ECDHE-ECDSA-AES256-SHA384';
   TLS1_TXT_ECDH_ECDSA_WITH_AES_128_SHA256 = 'ECDH-ECDSA-AES128-SHA256';
   TLS1_TXT_ECDH_ECDSA_WITH_AES_256_SHA384 = 'ECDH-ECDSA-AES256-SHA384';
   TLS1_TXT_ECDHE_RSA_WITH_AES_128_SHA256 = 'ECDHE-RSA-AES128-SHA256';
   TLS1_TXT_ECDHE_RSA_WITH_AES_256_SHA384 = 'ECDHE-RSA-AES256-SHA384';
   TLS1_TXT_ECDH_RSA_WITH_AES_128_SHA256 = 'ECDH-RSA-AES128-SHA256';
   TLS1_TXT_ECDH_RSA_WITH_AES_256_SHA384 = 'ECDH-RSA-AES256-SHA384';
   TLS1_TXT_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256 = 'ECDHE-ECDSA-AES128-GCM-SHA256';
   TLS1_TXT_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384 = 'ECDHE-ECDSA-AES256-GCM-SHA384';
   TLS1_TXT_ECDH_ECDSA_WITH_AES_128_GCM_SHA256 = 'ECDH-ECDSA-AES128-GCM-SHA256';
   TLS1_TXT_ECDH_ECDSA_WITH_AES_256_GCM_SHA384 = 'ECDH-ECDSA-AES256-GCM-SHA384';
   TLS1_TXT_ECDHE_RSA_WITH_AES_128_GCM_SHA256 = 'ECDHE-RSA-AES128-GCM-SHA256';
   TLS1_TXT_ECDHE_RSA_WITH_AES_256_GCM_SHA384 = 'ECDHE-RSA-AES256-GCM-SHA384';
   TLS1_TXT_ECDH_RSA_WITH_AES_128_GCM_SHA256 = 'ECDH-RSA-AES128-GCM-SHA256';
   TLS1_TXT_ECDH_RSA_WITH_AES_256_GCM_SHA384 = 'ECDH-RSA-AES256-GCM-SHA384';
   TLS_CT_RSA_SIGN = 1;
   TLS_CT_DSS_SIGN = 2;
   TLS_CT_RSA_FIXED_DH = 3;
   TLS_CT_DSS_FIXED_DH = 4;
   TLS_CT_ECDSA_SIGN = 64;
   TLS_CT_RSA_FIXED_ECDH = 65;
   TLS_CT_ECDSA_FIXED_ECDH = 66;
   TLS_CT_GOST94_SIGN = 21;
   TLS_CT_GOST01_SIGN = 22;
   TLS_CT_NUMBER = 9;
   TLS_MD_CLIENT_FINISH_CONST = 'client finished';
   TLS_MD_CLIENT_FINISH_CONST_SIZE = 15;
   TLS_MD_SERVER_FINISH_CONST = 'server finished';
   TLS_MD_SERVER_FINISH_CONST_SIZE = 15;
   TLS_MD_KEY_EXPANSION_CONST = 'key expansion';
   TLS_MD_KEY_EXPANSION_CONST_SIZE = 13;
   TLS_MD_CLIENT_WRITE_KEY_CONST = 'client write key';
   TLS_MD_CLIENT_WRITE_KEY_CONST_SIZE = 16;
   TLS_MD_SERVER_WRITE_KEY_CONST = 'server write key';
   TLS_MD_SERVER_WRITE_KEY_CONST_SIZE = 16;
   TLS_MD_IV_BLOCK_CONST = 'IV block';
   TLS_MD_IV_BLOCK_CONST_SIZE = 8;
   TLS_MD_MASTER_SECRET_CONST = 'master secret';
   TLS_MD_MASTER_SECRET_CONST_SIZE = 13;
   TLS_MD_MAX_CONST_SIZE = 20;
   TMP_MAX = 26;
   V_ASN1_APPLICATION = $40;
   V_ASN1_APP_CHOOSE = -2;
   V_ASN1_BIT_STRING = 3;
   V_ASN1_BMPSTRING = 30;
   V_ASN1_BOOLEAN = 1;
   V_ASN1_CONSTRUCTED = $20;
   V_ASN1_CONTEXT_SPECIFIC = $80;
   V_ASN1_ENUMERATED = 10;
   V_ASN1_EOC = 0;
   V_ASN1_EXTERNAL = 8;
   V_ASN1_GENERALIZEDTIME = 24;
   V_ASN1_GENERALSTRING = 27;
   V_ASN1_GRAPHICSTRING = 25;
   V_ASN1_IA5STRING = 22;
   V_ASN1_INTEGER = 2;
   V_ASN1_ISO64STRING = 26;
   V_ASN1_NEG_ENUMERATED = 10 + $100;
   V_ASN1_NEG_INTEGER = 2 + $100;
   V_ASN1_NULL = 5;
   V_ASN1_NUMERICSTRING = 18;
   V_ASN1_OBJECT = 6;
   V_ASN1_OBJECT_DESCRIPTOR = 7;
   V_ASN1_OCTET_STRING = 4;
   V_ASN1_PRIMATIVE_TAG = $1F;
   V_ASN1_PRIMITIVE_TAG = $1F;
   V_ASN1_PRINTABLESTRING = 19;
   V_ASN1_PRIVATE = $C0;
   V_ASN1_REAL = 9;
   V_ASN1_SEQUENCE = 16;
   V_ASN1_SET = 17;
   V_ASN1_T61STRING = 20;
   V_ASN1_TELETEXSTRING = 20;
   V_ASN1_UNDEF = -1;
   V_ASN1_UNIVERSAL = $00;
   V_ASN1_UNIVERSALSTRING = 28;
   V_ASN1_UTCTIME = 23;
   V_ASN1_UTF8STRING = 12;
   V_ASN1_VIDEOTEXSTRING = 21;
   V_ASN1_VISIBLESTRING = 26;
   WINNT = 1;
   X509_TRUST_DEFAULT = -1;
   X509_TRUST_COMPAT = 1;
   X509_TRUST_SSL_CLIENT = 2;
   X509_TRUST_SSL_SERVER = 3;
   X509_TRUST_EMAIL = 4;
   X509_TRUST_OBJECT_SIGN = 5;
   X509_TRUST_OCSP_SIGN = 6;
   X509_TRUST_OCSP_REQUEST = 7;
   X509_TRUST_TSA = 8;
   X509_TRUST_MIN = 1;
   X509_TRUST_MAX = 8;
   X509_EXT_PACK_STRING = 2;
   X509_EXT_PACK_UNKNOWN = 1;
   X509_EX_V_INIT = $0001;
   X509_EX_V_NETSCAPE_HACK = $8000;
   X509_FILETYPE_DEFAULT = 3;
   X509_F_ADD_CERT_DIR = 100;
   X509_F_BY_FILE_CTRL = 101;
   X509_F_DIR_CTRL = 102;
   X509_F_GET_CERT_BY_SUBJECT = 103;
   X509_F_X509V3_ADD_EXT = 104;
   X509_F_X509_EXTENSION_CREATE_BY_NID = 108;
   X509_F_X509_EXTENSION_CREATE_BY_OBJ = 109;
   X509_F_X509_GET_PUBKEY_PARAMETERS = 110;
   X509_F_X509_LOAD_CERT_FILE = 111;
   X509_F_X509_LOAD_CRL_FILE = 112;
   X509_F_X509_NAME_ADD_ENTRY = 113;
   X509_F_X509_NAME_ENTRY_CREATE_BY_NID = 114;
   X509_F_X509_NAME_ENTRY_SET_OBJECT = 115;
   X509_F_X509_NAME_ONELINE = 116;
   X509_F_X509_NAME_PRINT = 117;
   X509_F_X509_PRINT_FP = 118;
   X509_F_X509_PUBKEY_GET = 119;
   X509_F_X509_PUBKEY_SET = 120;
   X509_F_X509_REQ_PRINT = 121;
   X509_F_X509_REQ_PRINT_FP = 122;
   X509_F_X509_REQ_TO_X509 = 123;
   X509_F_X509_STORE_ADD_CERT = 124;
   X509_F_X509_STORE_ADD_CRL = 125;
   X509_F_X509_TO_X509_REQ = 126;
   X509_F_X509_VERIFY_CERT = 127;
   X509_F_X509_CHECK_PRIVATE_KEY = 128;
   X509_F_NETSCAPE_SPKI_B64_DECODE = 129;
   X509_F_NETSCAPE_SPKI_B64_ENCODE = 130;
   X509_F_X509_NAME_ENTRY_CREATE_BY_TXT = 131;
   X509_F_X509_LOAD_CERT_CRL_FILE = 132;
   X509_F_X509_TRUST_ADD = 133;
   X509_F_X509_STORE_CTX_PURPOSE_INHERIT = 134;
   X509_F_X509AT_ADD1_ATTR = 135;
   X509_F_X509_ATTRIBUTE_CREATE_BY_NID = 136;
   X509_F_X509_ATTRIBUTE_CREATE_BY_OBJ = 137;
   X509_F_X509_ATTRIBUTE_SET1_DATA = 138;
   X509_F_X509_ATTRIBUTE_GET0_DATA = 139;
   X509_F_X509_ATTRIBUTE_CREATE_BY_TXT = 140;
   X509_F_X509_TRUST_SET = 141;
   X509_F_X509_STORE_CTX_NEW = 142;
   X509_F_X509_STORE_CTX_INIT = 143;
   X509_F_X509_REQ_CHECK_PRIVATE_KEY = 144;
   X509_F_CHECK_POLICY = 145;
   X509_F_X509_STORE_CTX_GET1_ISSUER = 146;
   X509_F_X509_CRL_PRINT_FP = 147;
   X509_LU_CRL = 2;
   X509_LU_FAIL = 0;
   X509_LU_PKEY = 3;
   X509_LU_RETRY = -1;
   X509_LU_X509 = 1;
   X509_L_ADD_DIR = 2;
   X509_L_FILE_LOAD = 1;
   X509_R_BAD_X509_FILETYPE = 100;
   X509_R_BASE64_DECODE_ERROR = 118;
   X509_R_CANT_CHECK_DH_KEY = 114;
   X509_R_CERT_ALREADY_IN_HASH_TABLE = 101;
   X509_R_ERR_ASN1_LIB = 102;
   X509_R_INVALID_DIRECTORY = 113;
   X509_R_INVALID_FIELD_NAME = 119;
   X509_R_INVALID_TRUST = 123;
   X509_R_KEY_TYPE_MISMATCH = 115;
   X509_R_KEY_VALUES_MISMATCH = 116;
   X509_R_LOADING_CERT_DIR = 103;
   X509_R_LOADING_DEFAULTS = 104;
   X509_R_METHOD_NOT_SUPPORTED = 124;
   X509_R_NO_CERT_SET_FOR_US_TO_VERIFY = 105;
   X509_R_PUBLIC_KEY_DECODE_ERROR = 125;
   X509_R_PUBLIC_KEY_ENCODE_ERROR = 126;
   X509_R_SHOULD_RETRY = 106;
   X509_R_UNABLE_TO_FIND_PARAMETERS_IN_CHAIN = 107;
   X509_R_UNABLE_TO_GET_CERTS_PUBLIC_KEY = 108;
   X509_R_UNKNOWN_KEY_TYPE = 117;
   X509_R_UNKNOWN_NID = 109;
   X509_R_UNKNOWN_PURPOSE_ID = 121;
   X509_R_UNSUPPORTED_ALGORITHM = 111;
   X509_R_WRONG_LOOKUP_TYPE = 112;
   X509_R_WRONG_TYPE = 122;
   X509_V_ERR_UNSPECIFIED = 1;
   X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT = 2;
   X509_V_ERR_UNABLE_TO_GET_CRL = 3;
   X509_V_ERR_UNABLE_TO_DECRYPT_CERT_SIGNATURE = 4;
   X509_V_ERR_UNABLE_TO_DECRYPT_CRL_SIGNATURE = 5;
   X509_V_ERR_UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY = 6;
   X509_V_ERR_CERT_SIGNATURE_FAILURE = 7;
   X509_V_ERR_CRL_SIGNATURE_FAILURE = 8;
   X509_V_ERR_CERT_NOT_YET_VALID = 9;
   X509_V_ERR_CERT_HAS_EXPIRED = 10;
   X509_V_ERR_CRL_NOT_YET_VALID = 11;
   X509_V_ERR_CRL_HAS_EXPIRED = 12;
   X509_V_ERR_ERROR_IN_CERT_NOT_BEFORE_FIELD = 13;
   X509_V_ERR_ERROR_IN_CERT_NOT_AFTER_FIELD = 14;
   X509_V_ERR_ERROR_IN_CRL_LAST_UPDATE_FIELD = 15;
   X509_V_ERR_ERROR_IN_CRL_NEXT_UPDATE_FIELD = 16;
   X509_V_ERR_OUT_OF_MEM = 17;
   X509_V_ERR_DEPTH_ZERO_SELF_SIGNED_CERT = 18;
   X509_V_ERR_SELF_SIGNED_CERT_IN_CHAIN = 19;
   X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT_LOCALLY = 20;
   X509_V_ERR_UNABLE_TO_VERIFY_LEAF_SIGNATURE = 21;
   X509_V_ERR_CERT_CHAIN_TOO_LONG = 22;
   X509_V_ERR_CERT_REVOKED = 23;
   X509_V_ERR_INVALID_CA = 24;
   X509_V_ERR_PATH_LENGTH_EXCEEDED = 25;
   X509_V_ERR_INVALID_PURPOSE = 26;
   X509_V_ERR_CERT_UNTRUSTED = 27;
   X509_V_ERR_CERT_REJECTED = 28;
   X509_V_ERR_SUBJECT_ISSUER_MISMATCH = 29;
   X509_V_ERR_AKID_SKID_MISMATCH = 30;
   X509_V_ERR_AKID_ISSUER_SERIAL_MISMATCH = 31;
   X509_V_ERR_KEYUSAGE_NO_CERTSIGN = 32;
   X509_V_ERR_UNABLE_TO_GET_CRL_ISSUER = 33;
   X509_V_ERR_UNHANDLED_CRITICAL_EXTENSION = 34;
   X509_V_ERR_KEYUSAGE_NO_CRL_SIGN = 35;
   X509_V_ERR_UNHANDLED_CRITICAL_CRL_EXTENSION = 36;
   X509_V_ERR_INVALID_NON_CA = 37;
   X509_V_ERR_PROXY_PATH_LENGTH_EXCEEDED = 38;
   X509_V_ERR_KEYUSAGE_NO_DIGITAL_SIGNATURE = 39;
   X509_V_ERR_PROXY_CERTIFICATES_NOT_ALLOWED = 40;
   X509_V_ERR_INVALID_EXTENSION = 41;
   X509_V_ERR_INVALID_POLICY_EXTENSION = 42;
   X509_V_ERR_NO_EXPLICIT_POLICY = 43;
   X509_V_ERR_DIFFERENT_CRL_SCOPE = 44;
   X509_V_ERR_UNSUPPORTED_EXTENSION_FEATURE = 45;
   X509_V_ERR_UNNESTED_RESOURCE = 46;
   X509_V_ERR_PERMITTED_VIOLATION = 47;
   X509_V_ERR_EXCLUDED_VIOLATION = 48;
   X509_V_ERR_SUBTREE_MINMAX = 49;
   X509_V_ERR_APPLICATION_VERIFICATION = 50;
   X509_V_ERR_UNSUPPORTED_CONSTRAINT_TYPE = 51;
   X509_V_ERR_UNSUPPORTED_CONSTRAINT_SYNTAX = 52;
   X509_V_ERR_UNSUPPORTED_NAME_SYNTAX = 53;
   X509_V_ERR_CRL_PATH_VALIDATION_ERROR = 54;
   X509_V_ERR_PATH_LOOP = 55;
   X509_V_ERR_SUITE_B_INVALID_VERSION = 56;
   X509_V_ERR_SUITE_B_INVALID_ALGORITHM = 57;
   X509_V_ERR_SUITE_B_INVALID_CURVE = 58;
   X509_V_ERR_SUITE_B_INVALID_SIGNATURE_ALGORITHM = 59;
   X509_V_ERR_SUITE_B_LOS_NOT_ALLOWED = 60;
   X509_V_ERR_SUITE_B_CANNOT_SIGN_P_384_WITH_P_256 = 61;
   X509_V_ERR_HOSTNAME_MISMATCH = 62;
   X509_V_ERR_EMAIL_MISMATCH = 63;
   X509_V_ERR_IP_ADDRESS_MISMATCH = 64;
   X509_V_ERR_DANE_NO_MATCH = 65;
   X509_V_ERR_EE_KEY_TOO_SMALL = 66;
   X509_V_ERR_CA_KEY_TOO_SMALL = 67;
   X509_V_ERR_CA_MD_TOO_WEAK = 68;
   X509_V_ERR_INVALID_CALL = 69;
   X509_V_ERR_STORE_LOOKUP = 70;
   X509_V_ERR_NO_VALID_SCTS = 71;
   X509_V_ERR_PROXY_SUBJECT_NAME_VIOLATION = 72;
   X509_V_ERR_OCSP_VERIFY_NEEDED = 73;
   X509_V_ERR_OCSP_VERIFY_FAILED = 74;
   X509_V_ERR_OCSP_CERT_UNKNOWN = 75;
   X509_V_FLAG_CB_ISSUER_CHECK = $1;
   X509_V_FLAG_USE_CHECK_TIME = $2;
   X509_V_FLAG_CRL_CHECK = $4;
   X509_V_FLAG_CRL_CHECK_ALL = $8;
   X509_V_FLAG_IGNORE_CRITICAL = $10;
   X509_V_FLAG_X509_STRICT = $20;
   X509_V_FLAG_ALLOW_PROXY_CERTS = $40;
   X509_V_FLAG_POLICY_CHECK = $80;
   X509_V_FLAG_EXPLICIT_POLICY = $100;
   X509_V_FLAG_INHIBIT_ANY = $200;
   X509_V_FLAG_INHIBIT_MAP = $400;
   X509_V_FLAG_NOTIFY_POLICY = $800;
   X509_V_FLAG_EXTENDED_CRL_SUPPORT = $1000;
   X509_V_FLAG_USE_DELTAS = $2000;
   X509_V_FLAG_CHECK_SS_SIGNATURE = $4000;
   X509_VP_FLAG_DEFAULT = $1;
   X509_VP_FLAG_OVERWRITE = $2;
   X509_VP_FLAG_RESET_FLAGS = $4;
   X509_VP_FLAG_LOCKED = $8;
   X509_VP_FLAG_ONCE = $10;
   X509_V_FLAG_POLICY_MASK = (X509_V_FLAG_POLICY_CHECK Or X509_V_FLAG_EXPLICIT_POLICY Or X509_V_FLAG_INHIBIT_ANY Or X509_V_FLAG_INHIBIT_MAP);
   X509_V_OK = 0;
   X509v3_KU_CRL_SIGN = $0002;
   X509v3_KU_DATA_ENCIPHERMENT = $0010;
   X509v3_KU_DECIPHER_ONLY = $8000;
   X509v3_KU_DIGITAL_SIGNATURE = $0080;
   X509v3_KU_ENCIPHER_ONLY = $0001;
   X509v3_KU_KEY_AGREEMENT = $0008;
   X509v3_KU_KEY_CERT_SIGN = $0004;
   X509v3_KU_KEY_ENCIPHERMENT = $0020;
   X509v3_KU_NON_REPUDIATION = $0040;
   X509v3_KU_UNDEF = $FFFF;
   X509V3_EXT_DYNAMIC = $1;
   X509V3_EXT_CTX_DEP = $2;
   X509V3_EXT_MULTILINE = $4;
   GEN_OTHERNAME = 0;
   GEN_EMAIL = 1;
   GEN_DNS = 2;
   GEN_X400 = 3;
   GEN_DIRNAME = 4;
   GEN_EDIPARTY = 5;
   GEN_URI = 6;
   GEN_IPADD = 7;
   GEN_RID = 8;
   CRLDP_ALL_REASONS = $807F;
   CRL_REASON_NONE = -1;
   CRL_REASON_UNSPECIFIED = 0;
   CRL_REASON_KEY_COMPROMISE = 1;
   CRL_REASON_CA_COMPROMISE = 2;
   CRL_REASON_AFFILIATION_CHANGED = 3;
   CRL_REASON_SUPERSEDED = 4;
   CRL_REASON_CESSATION_OF_OPERATION = 5;
   CRL_REASON_CERTIFICATE_HOLD = 6;
   CRL_REASON_REMOVE_FROM_CRL = 8;
   CRL_REASON_PRIVILEGE_WITHDRAWN = 9;
   CRL_REASON_AA_COMPROMISE = 10;
   IDP_PRESENT = $1;
   IDP_INVALID = $2;
   IDP_ONLYUSER = $4;
   IDP_ONLYCA = $8;
   IDP_ONLYATTR = $10;
   IDP_INDIRECT = $20;
   IDP_REASONS = $40;
   EXFLAG_BCONS = $1;
   EXFLAG_KUSAGE = $2;
   EXFLAG_XKUSAGE = $4;
   EXFLAG_NSCERT = $8;
   EXFLAG_CA = $10;
   EXFLAG_SI = $20;
   EXFLAG_SS = $20;
   EXFLAG_V1 = $40;
   EXFLAG_INVALID = $80;
   EXFLAG_SET = $100;
   EXFLAG_CRITICAL = $200;
   EXFLAG_PROXY = $400;
   EXFLAG_INVALID_POLICY = $800;
   KU_DIGITAL_SIGNATURE = $0080;
   KU_NON_REPUDIATION = $0040;
   KU_KEY_ENCIPHERMENT = $0020;
   KU_DATA_ENCIPHERMENT = $0010;
   KU_KEY_AGREEMENT = $0008;
   KU_KEY_CERT_SIGN = $0004;
   KU_CRL_SIGN = $0002;
   KU_ENCIPHER_ONLY = $0001;
   KU_DECIPHER_ONLY = $8000;
   NS_SSL_CLIENT = $80;
   NS_SSL_SERVER = $40;
   NS_SMIME = $20;
   NS_OBJSIGN = $10;
   NS_SSL_CA = $04;
   NS_SMIME_CA = $02;
   NS_OBJSIGN_CA = $01;
   NS_ANY_CA = (NS_SSL_CA Or NS_SMIME_CA Or NS_OBJSIGN_CA);
   XKU_SSL_SERVER = $1;
   XKU_SSL_CLIENT = $2;
   XKU_SMIME = $4;
   XKU_CODE_SIGN = $8;
   XKU_SGC = $10;
   XKU_OCSP_SIGN = $20;
   XKU_TIMESTAMP = $40;
   XKU_DVCS = $80;
   X509_PURPOSE_DYNAMIC = $1;
   X509_PURPOSE_DYNAMIC_NAME = $2;
   X509_PURPOSE_SSL_CLIENT = 1;
   X509_PURPOSE_SSL_SERVER = 2;
   X509_PURPOSE_NS_SSL_SERVER = 3;
   X509_PURPOSE_SMIME_SIGN = 4;
   X509_PURPOSE_SMIME_ENCRYPT = 5;
   X509_PURPOSE_CRL_SIGN = 6;
   X509_PURPOSE_ANY = 7;
   X509_PURPOSE_OCSP_HELPER = 8;
   X509_PURPOSE_TIMESTAMP_SIGN = 9;
   X509_PURPOSE_MIN = 1;
   X509_PURPOSE_MAX = 9;
   X509V3_EXT_UNKNOWN_MASK = cLong($F Shl 16);
   X509V3_EXT_DEFAULT = 0;
   X509V3_EXT_ERROR_UNKNOWN = (cLong(1) Shl 16);
   X509V3_EXT_PARSE_UNKNOWN = (cLong(2) Shl 16);
   X509V3_EXT_DUMP_UNKNOWN = (cLong(3) Shl 16);
   X509V3_ADD_OP_MASK = cLong($F);
   X509V3_ADD_DEFAULT = cLong(0);
   X509V3_ADD_APPEND = cLong(1);
   X509V3_ADD_REPLACE = cLong(2);
   X509V3_ADD_REPLACE_EXISTING = cLong(3);
   X509V3_ADD_KEEP_EXISTING = cLong(4);
   X509V3_ADD_DELETE = cLong(5);
   X509V3_ADD_SILENT = cLong($10);
   ASIdOrRange_id = 0;
   ASIdOrRange_range = 1;
   ASIdentifierChoice_inherit = 0;
   ASIdentifierChoice_asIdsOrRanges = 1;
   IPAddressOrRange_addressPrefix = 0;
   IPAddressOrRange_addressRange = 1;
   IPAddressChoice_inherit = 0;
   IPAddressChoice_addressesOrRanges = 1;
   V3_ASID_ASNUM = 0;
   V3_ASID_RDI = 1;
   IANA_AFI_IPV4 = 1;
   IANA_AFI_IPV6 = 2;
   X509V3_F_A2I_GENERAL_NAME = 164;
   X509V3_F_ASIDENTIFIERCHOICE_CANONIZE = 161;
   X509V3_F_ASIDENTIFIERCHOICE_IS_CANONICAL = 162;
   X509V3_F_COPY_EMAIL = 122;
   X509V3_F_COPY_ISSUER = 123;
   X509V3_F_DO_DIRNAME = 144;
   X509V3_F_DO_EXT_CONF = 124;
   X509V3_F_DO_EXT_I2D = 135;
   X509V3_F_DO_EXT_NCONF = 151;
   X509V3_F_DO_I2V_NAME_CONSTRAINTS = 148;
   X509V3_F_GNAMES_FROM_SECTNAME = 156;
   X509V3_F_HEX_TO_STRING = 111;
   X509V3_F_I2S_ASN1_ENUMERATED = 121;
   X509V3_F_I2S_ASN1_IA5STRING = 149;
   X509V3_F_I2S_ASN1_INTEGER = 120;
   X509V3_F_I2V_AUTHORITY_INFO_ACCESS = 138;
   X509V3_F_NOTICE_SECTION = 132;
   X509V3_F_NREF_NOS = 133;
   X509V3_F_POLICY_SECTION = 131;
   X509V3_F_PROCESS_PCI_VALUE = 150;
   X509V3_F_R2I_CERTPOL = 130;
   X509V3_F_R2I_PCI = 155;
   X509V3_F_S2I_ASN1_IA5STRING = 100;
   X509V3_F_S2I_ASN1_INTEGER = 108;
   X509V3_F_S2I_ASN1_OCTET_STRING = 112;
   X509V3_F_S2I_ASN1_SKEY_ID = 114;
   X509V3_F_S2I_SKEY_ID = 115;
   X509V3_F_SET_DIST_POINT_NAME = 158;
   X509V3_F_STRING_TO_HEX = 113;
   X509V3_F_SXNET_ADD_ID_ASC = 125;
   X509V3_F_SXNET_ADD_ID_INTEGER = 126;
   X509V3_F_SXNET_ADD_ID_ULONG = 127;
   X509V3_F_SXNET_GET_ID_ASC = 128;
   X509V3_F_SXNET_GET_ID_ULONG = 129;
   X509V3_F_V2I_ASIDENTIFIERS = 163;
   X509V3_F_V2I_ASN1_BIT_STRING = 101;
   X509V3_F_V2I_AUTHORITY_INFO_ACCESS = 139;
   X509V3_F_V2I_AUTHORITY_KEYID = 119;
   X509V3_F_V2I_BASIC_CONSTRAINTS = 102;
   X509V3_F_V2I_CRLD = 134;
   X509V3_F_V2I_EXTENDED_KEY_USAGE = 103;
   X509V3_F_V2I_GENERAL_NAMES = 118;
   X509V3_F_V2I_GENERAL_NAME_EX = 117;
   X509V3_F_V2I_IDP = 157;
   X509V3_F_V2I_IPADDRBLOCKS = 159;
   X509V3_F_V2I_ISSUER_ALT = 153;
   X509V3_F_V2I_NAME_CONSTRAINTS = 147;
   X509V3_F_V2I_POLICY_CONSTRAINTS = 146;
   X509V3_F_V2I_POLICY_MAPPINGS = 145;
   X509V3_F_V2I_SUBJECT_ALT = 154;
   X509V3_F_V3_ADDR_VALIDATE_PATH_INTERNAL = 160;
   X509V3_F_V3_GENERIC_EXTENSION = 116;
   X509V3_F_X509V3_ADD1_I2D = 140;
   X509V3_F_X509V3_ADD_VALUE = 105;
   X509V3_F_X509V3_EXT_ADD = 104;
   X509V3_F_X509V3_EXT_ADD_ALIAS = 106;
   X509V3_F_X509V3_EXT_CONF = 107;
   X509V3_F_X509V3_EXT_I2D = 136;
   X509V3_F_X509V3_EXT_NCONF = 152;
   X509V3_F_X509V3_GET_SECTION = 142;
   X509V3_F_X509V3_GET_STRING = 143;
   X509V3_F_X509V3_GET_VALUE_BOOL = 110;
   X509V3_F_X509V3_PARSE_LIST = 109;
   X509V3_F_X509_PURPOSE_ADD = 137;
   X509V3_F_X509_PURPOSE_SET = 141;
   X509V3_R_BAD_IP_ADDRESS = 118;
   X509V3_R_BAD_OBJECT = 119;
   X509V3_R_BN_DEC2BN_ERROR = 100;
   X509V3_R_BN_TO_ASN1_INTEGER_ERROR = 101;
   X509V3_R_DIRNAME_ERROR = 149;
   X509V3_R_DISTPOINT_ALREADY_SET = 160;
   X509V3_R_DUPLICATE_ZONE_ID = 133;
   X509V3_R_ERROR_CONVERTING_ZONE = 131;
   X509V3_R_ERROR_CREATING_EXTENSION = 144;
   X509V3_R_ERROR_IN_EXTENSION = 128;
   X509V3_R_EXPECTED_A_SECTION_NAME = 137;
   X509V3_R_EXTENSION_EXISTS = 145;
   X509V3_R_EXTENSION_NAME_ERROR = 115;
   X509V3_R_EXTENSION_NOT_FOUND = 102;
   X509V3_R_EXTENSION_SETTING_NOT_SUPPORTED = 103;
   X509V3_R_EXTENSION_VALUE_ERROR = 116;
   X509V3_R_ILLEGAL_EMPTY_EXTENSION = 151;
   X509V3_R_ILLEGAL_HEX_DIGIT = 113;
   X509V3_R_INCORRECT_POLICY_SYNTAX_TAG = 152;
   X509V3_R_INVALID_MULTIPLE_RDNS = 161;
   X509V3_R_INVALID_ASNUMBER = 162;
   X509V3_R_INVALID_ASRANGE = 163;
   X509V3_R_INVALID_BOOLEAN_STRING = 104;
   X509V3_R_INVALID_EXTENSION_STRING = 105;
   X509V3_R_INVALID_INHERITANCE = 165;
   X509V3_R_INVALID_IPADDRESS = 166;
   X509V3_R_INVALID_NAME = 106;
   X509V3_R_INVALID_NULL_ARGUMENT = 107;
   X509V3_R_INVALID_NULL_NAME = 108;
   X509V3_R_INVALID_NULL_VALUE = 109;
   X509V3_R_INVALID_NUMBER = 140;
   X509V3_R_INVALID_NUMBERS = 141;
   X509V3_R_INVALID_OBJECT_IDENTIFIER = 110;
   X509V3_R_INVALID_OPTION = 138;
   X509V3_R_INVALID_POLICY_IDENTIFIER = 134;
   X509V3_R_INVALID_PROXY_POLICY_SETTING = 153;
   X509V3_R_INVALID_PURPOSE = 146;
   X509V3_R_INVALID_SAFI = 164;
   X509V3_R_INVALID_SECTION = 135;
   X509V3_R_INVALID_SYNTAX = 143;
   X509V3_R_ISSUER_DECODE_ERROR = 126;
   X509V3_R_MISSING_VALUE = 124;
   X509V3_R_NEED_ORGANIZATION_AND_NUMBERS = 142;
   X509V3_R_NO_CONFIG_DATABASE = 136;
   X509V3_R_NO_ISSUER_CERTIFICATE = 121;
   X509V3_R_NO_ISSUER_DETAILS = 127;
   X509V3_R_NO_POLICY_IDENTIFIER = 139;
   X509V3_R_NO_PROXY_CERT_POLICY_LANGUAGE_DEFINED = 154;
   X509V3_R_NO_PUBLIC_KEY = 114;
   X509V3_R_NO_SUBJECT_DETAILS = 125;
   X509V3_R_ODD_NUMBER_OF_DIGITS = 112;
   X509V3_R_OPERATION_NOT_DEFINED = 148;
   X509V3_R_OTHERNAME_ERROR = 147;
   X509V3_R_POLICY_LANGUAGE_ALREADY_DEFINED = 155;
   X509V3_R_POLICY_PATH_LENGTH = 156;
   X509V3_R_POLICY_PATH_LENGTH_ALREADY_DEFINED = 157;
   X509V3_R_POLICY_SYNTAX_NOT_CURRENTLY_SUPPORTED = 158;
   X509V3_R_POLICY_WHEN_PROXY_LANGUAGE_REQUIRES_NO_POLICY = 159;
   X509V3_R_SECTION_NOT_FOUND = 150;
   X509V3_R_UNABLE_TO_GET_ISSUER_DETAILS = 122;
   X509V3_R_UNABLE_TO_GET_ISSUER_KEYID = 123;
   X509V3_R_UNKNOWN_BIT_STRING_ARGUMENT = 111;
   X509V3_R_UNKNOWN_EXTENSION = 129;
   X509V3_R_UNKNOWN_EXTENSION_NAME = 130;
   X509V3_R_UNKNOWN_OPTION = 120;
   X509V3_R_UNSUPPORTED_OPTION = 117;
   X509V3_R_UNSUPPORTED_TYPE = 167;
   X509V3_R_USER_TOO_LONG = 132;
   TS_STATUS_GRANTED = 0;
   TS_STATUS_GRANTED_WITH_MODS = 1;
   TS_STATUS_REJECTION = 2;
   TS_STATUS_WAITING = 3;
   TS_STATUS_REVOCATION_WARNING = 4;
   TS_STATUS_REVOCATION_NOTIFICATION = 5;
   TS_INFO_BAD_ALG = 0;
   TS_INFO_BAD_REQUEST = 2;
   TS_INFO_BAD_DATA_FORMAT = 5;
   TS_INFO_TIME_NOT_AVAILABLE = 14;
   TS_INFO_UNACCEPTED_POLICY = 15;
   TS_INFO_UNACCEPTED_EXTENSION = 16;
   TS_INFO_ADD_INFO_NOT_AVAILABLE = 17;
   TS_INFO_SYSTEM_FAILURE = 25;
   TS_TSA_NAME = $01;
   TS_ORDERING = $02;
   TS_ESS_CERT_ID_CHAIN = $04;
   TS_MAX_CLOCK_PRECISION_DIGITS = 6;
   TS_VFY_SIGNATURE = cuLong(1 Shl 0);
   TS_VFY_VERSION = cuLong(1 Shl 1);
   TS_VFY_POLICY = cuLong(1 Shl 2);
   TS_VFY_IMPRINT = cuLong(1 Shl 3);
   TS_VFY_DATA = cuLong(1 Shl 4);
   TS_VFY_NONCE = cuLong(1 Shl 5);
   TS_VFY_SIGNER = cuLong(1 Shl 6);
   TS_VFY_TSA_NAME = cuLong(1 Shl 7);
   TS_VFY_ALL_IMPRINT = (TS_VFY_SIGNATURE Or TS_VFY_VERSION Or TS_VFY_POLICY Or TS_VFY_IMPRINT Or TS_VFY_NONCE Or TS_VFY_SIGNER Or TS_VFY_TSA_NAME);
   TS_VFY_ALL_DATA = (TS_VFY_SIGNATURE Or TS_VFY_VERSION Or TS_VFY_POLICY Or TS_VFY_DATA Or TS_VFY_NONCE Or TS_VFY_SIGNER Or TS_VFY_TSA_NAME);
   TS_F_D2I_TS_RESP = 147;
   TS_F_DEF_SERIAL_CB = 110;
   TS_F_DEF_TIME_CB = 111;
   TS_F_ESS_ADD_SIGNING_CERT = 112;
   TS_F_ESS_CERT_ID_NEW_INIT = 113;
   TS_F_ESS_SIGNING_CERT_NEW_INIT = 114;
   TS_F_INT_TS_RESP_VERIFY_TOKEN = 149;
   TS_F_PKCS7_TO_TS_TST_INFO = 148;
   TS_F_TS_ACCURACY_SET_MICROS = 115;
   TS_F_TS_ACCURACY_SET_MILLIS = 116;
   TS_F_TS_ACCURACY_SET_SECONDS = 117;
   TS_F_TS_CHECK_IMPRINTS = 100;
   TS_F_TS_CHECK_NONCES = 101;
   TS_F_TS_CHECK_POLICY = 102;
   TS_F_TS_CHECK_SIGNING_CERTS = 103;
   TS_F_TS_CHECK_STATUS_INFO = 104;
   TS_F_TS_COMPUTE_IMPRINT = 145;
   TS_F_TS_CONF_SET_DEFAULT_ENGINE = 146;
   TS_F_TS_GET_STATUS_TEXT = 105;
   TS_F_TS_MSG_IMPRINT_SET_ALGO = 118;
   TS_F_TS_REQ_SET_MSG_IMPRINT = 119;
   TS_F_TS_REQ_SET_NONCE = 120;
   TS_F_TS_REQ_SET_POLICY_ID = 121;
   TS_F_TS_RESP_CREATE_RESPONSE = 122;
   TS_F_TS_RESP_CREATE_TST_INFO = 123;
   TS_F_TS_RESP_CTX_ADD_FAILURE_INFO = 124;
   TS_F_TS_RESP_CTX_ADD_MD = 125;
   TS_F_TS_RESP_CTX_ADD_POLICY = 126;
   TS_F_TS_RESP_CTX_NEW = 127;
   TS_F_TS_RESP_CTX_SET_ACCURACY = 128;
   TS_F_TS_RESP_CTX_SET_CERTS = 129;
   TS_F_TS_RESP_CTX_SET_DEF_POLICY = 130;
   TS_F_TS_RESP_CTX_SET_SIGNER_CERT = 131;
   TS_F_TS_RESP_CTX_SET_STATUS_INFO = 132;
   TS_F_TS_RESP_GET_POLICY = 133;
   TS_F_TS_RESP_SET_GENTIME_WITH_PRECISION = 134;
   TS_F_TS_RESP_SET_STATUS_INFO = 135;
   TS_F_TS_RESP_SET_TST_INFO = 150;
   TS_F_TS_RESP_SIGN = 136;
   TS_F_TS_RESP_VERIFY_SIGNATURE = 106;
   TS_F_TS_RESP_VERIFY_TOKEN = 107;
   TS_F_TS_TST_INFO_SET_ACCURACY = 137;
   TS_F_TS_TST_INFO_SET_MSG_IMPRINT = 138;
   TS_F_TS_TST_INFO_SET_NONCE = 139;
   TS_F_TS_TST_INFO_SET_POLICY_ID = 140;
   TS_F_TS_TST_INFO_SET_SERIAL = 141;
   TS_F_TS_TST_INFO_SET_TIME = 142;
   TS_F_TS_TST_INFO_SET_TSA = 143;
   TS_F_TS_VERIFY = 108;
   TS_F_TS_VERIFY_CERT = 109;
   TS_F_TS_VERIFY_CTX_NEW = 144;
   TS_R_BAD_PKCS7_TYPE = 132;
   TS_R_BAD_TYPE = 133;
   TS_R_CERTIFICATE_VERIFY_ERROR = 100;
   TS_R_COULD_NOT_SET_ENGINE = 127;
   TS_R_COULD_NOT_SET_TIME = 115;
   TS_R_D2I_TS_RESP_INT_FAILED = 128;
   TS_R_DETACHED_CONTENT = 134;
   TS_R_ESS_ADD_SIGNING_CERT_ERROR = 116;
   TS_R_ESS_SIGNING_CERTIFICATE_ERROR = 101;
   TS_R_INVALID_NULL_POINTER = 102;
   TS_R_INVALID_SIGNER_CERTIFICATE_PURPOSE = 117;
   TS_R_MESSAGE_IMPRINT_MISMATCH = 103;
   TS_R_NONCE_MISMATCH = 104;
   TS_R_NONCE_NOT_RETURNED = 105;
   TS_R_NO_CONTENT = 106;
   TS_R_NO_TIME_STAMP_TOKEN = 107;
   TS_R_PKCS7_ADD_SIGNATURE_ERROR = 118;
   TS_R_PKCS7_ADD_SIGNED_ATTR_ERROR = 119;
   TS_R_PKCS7_TO_TS_TST_INFO_FAILED = 129;
   TS_R_POLICY_MISMATCH = 108;
   TS_R_PRIVATE_KEY_DOES_NOT_MATCH_CERTIFICATE = 120;
   TS_R_RESPONSE_SETUP_ERROR = 121;
   TS_R_SIGNATURE_FAILURE = 109;
   TS_R_THERE_MUST_BE_ONE_SIGNER = 110;
   TS_R_TIME_SYSCALL_ERROR = 122;
   TS_R_TOKEN_NOT_PRESENT = 130;
   TS_R_TOKEN_PRESENT = 131;
   TS_R_TSA_NAME_MISMATCH = 111;
   TS_R_TSA_UNTRUSTED = 112;
   TS_R_TST_INFO_SETUP_ERROR = 123;
   TS_R_TS_DATASIGN = 124;
   TS_R_UNACCEPTABLE_POLICY = 125;
   TS_R_UNSUPPORTED_MD_ALGORITHM = 126;
   TS_R_UNSUPPORTED_VERSION = 113;
   TS_R_WRONG_CONTENT_TYPE = 114;
   CMS_SIGNERINFO_ISSUER_SERIAL = 0;
   CMS_SIGNERINFO_KEYIDENTIFIER = 1;
   CMS_RECIPINFO_TRANS = 0;
   CMS_RECIPINFO_AGREE = 1;
   CMS_RECIPINFO_KEK = 2;
   CMS_RECIPINFO_PASS = 3;
   CMS_RECIPINFO_OTHER = 4;
   CMS_TEXT = $1;
   CMS_NOCERTS = $2;
   CMS_NO_CONTENT_VERIFY = $4;
   CMS_NO_ATTR_VERIFY = $8;
   CMS_NOSIGS = (CMS_NO_CONTENT_VERIFY Or CMS_NO_ATTR_VERIFY);
   CMS_NOINTERN = $10;
   CMS_NO_SIGNER_CERT_VERIFY = $20;
   CMS_NOVERIFY = $20;
   CMS_DETACHED = $40;
   CMS_BINARY = $80;
   CMS_NOATTR = $100;
   CMS_NOSMIMECAP = $200;
   CMS_NOOLDMIMETYPE = $400;
   CMS_CRLFEOL = $800;
   CMS_STREAM = $1000;
   CMS_NOCRL = $2000;
   CMS_PARTIAL = $4000;
   CMS_REUSE_DIGEST = $8000;
   CMS_USE_KEYID = $10000;
   CMS_F_CHECK_CONTENT = 99;
   CMS_F_CMS_ADD0_CERT = 164;
   CMS_F_CMS_ADD0_RECIPIENT_KEY = 100;
   CMS_F_CMS_ADD1_RECEIPTREQUEST = 158;
   CMS_F_CMS_ADD1_RECIPIENT_CERT = 101;
   CMS_F_CMS_ADD1_SIGNER = 102;
   CMS_F_CMS_ADD1_SIGNINGTIME = 103;
   CMS_F_CMS_COMPRESS = 104;
   CMS_F_CMS_COMPRESSEDDATA_CREATE = 105;
   CMS_F_CMS_COMPRESSEDDATA_INIT_BIO = 106;
   CMS_F_CMS_COPY_CONTENT = 107;
   CMS_F_CMS_COPY_MESSAGEDIGEST = 108;
   CMS_F_CMS_DATA = 109;
   CMS_F_CMS_DATAFINAL = 110;
   CMS_F_CMS_DATAINIT = 111;
   CMS_F_CMS_DECRYPT = 112;
   CMS_F_CMS_DECRYPT_SET1_KEY = 113;
   CMS_F_CMS_DECRYPT_SET1_PKEY = 114;
   CMS_F_CMS_DIGESTALGORITHM_FIND_CTX = 115;
   CMS_F_CMS_DIGESTALGORITHM_INIT_BIO = 116;
   CMS_F_CMS_DIGESTEDDATA_DO_FINAL = 117;
   CMS_F_CMS_DIGEST_VERIFY = 118;
   CMS_F_CMS_ENCODE_RECEIPT = 161;
   CMS_F_CMS_ENCRYPT = 119;
   CMS_F_CMS_ENCRYPTEDCONTENT_INIT_BIO = 120;
   CMS_F_CMS_ENCRYPTEDDATA_DECRYPT = 121;
   CMS_F_CMS_ENCRYPTEDDATA_ENCRYPT = 122;
   CMS_F_CMS_ENCRYPTEDDATA_SET1_KEY = 123;
   CMS_F_CMS_ENVELOPEDDATA_CREATE = 124;
   CMS_F_CMS_ENVELOPEDDATA_INIT_BIO = 125;
   CMS_F_CMS_ENVELOPED_DATA_INIT = 126;
   CMS_F_CMS_FINAL = 127;
   CMS_F_CMS_GET0_CERTIFICATE_CHOICES = 128;
   CMS_F_CMS_GET0_CONTENT = 129;
   CMS_F_CMS_GET0_ECONTENT_TYPE = 130;
   CMS_F_CMS_GET0_ENVELOPED = 131;
   CMS_F_CMS_GET0_REVOCATION_CHOICES = 132;
   CMS_F_CMS_GET0_SIGNED = 133;
   CMS_F_CMS_MSGSIGDIGEST_ADD1 = 162;
   CMS_F_CMS_RECEIPTREQUEST_CREATE0 = 159;
   CMS_F_CMS_RECEIPT_VERIFY = 160;
   CMS_F_CMS_RECIPIENTINFO_DECRYPT = 134;
   CMS_F_CMS_RECIPIENTINFO_KEKRI_DECRYPT = 135;
   CMS_F_CMS_RECIPIENTINFO_KEKRI_ENCRYPT = 136;
   CMS_F_CMS_RECIPIENTINFO_KEKRI_GET0_ID = 137;
   CMS_F_CMS_RECIPIENTINFO_KEKRI_ID_CMP = 138;
   CMS_F_CMS_RECIPIENTINFO_KTRI_CERT_CMP = 139;
   CMS_F_CMS_RECIPIENTINFO_KTRI_DECRYPT = 140;
   CMS_F_CMS_RECIPIENTINFO_KTRI_ENCRYPT = 141;
   CMS_F_CMS_RECIPIENTINFO_KTRI_GET0_ALGS = 142;
   CMS_F_CMS_RECIPIENTINFO_KTRI_GET0_SIGNER_ID = 143;
   CMS_F_CMS_RECIPIENTINFO_SET0_KEY = 144;
   CMS_F_CMS_RECIPIENTINFO_SET0_PKEY = 145;
   CMS_F_CMS_SET1_SIGNERIDENTIFIER = 146;
   CMS_F_CMS_SET_DETACHED = 147;
   CMS_F_CMS_SIGN = 148;
   CMS_F_CMS_SIGNED_DATA_INIT = 149;
   CMS_F_CMS_SIGNERINFO_CONTENT_SIGN = 150;
   CMS_F_CMS_SIGNERINFO_SIGN = 151;
   CMS_F_CMS_SIGNERINFO_VERIFY = 152;
   CMS_F_CMS_SIGNERINFO_VERIFY_CERT = 153;
   CMS_F_CMS_SIGNERINFO_VERIFY_CONTENT = 154;
   CMS_F_CMS_SIGN_RECEIPT = 163;
   CMS_F_CMS_STREAM = 155;
   CMS_F_CMS_UNCOMPRESS = 156;
   CMS_F_CMS_VERIFY = 157;
   CMS_R_ADD_SIGNER_ERROR = 99;
   CMS_R_CERTIFICATE_ALREADY_PRESENT = 175;
   CMS_R_CERTIFICATE_HAS_NO_KEYID = 160;
   CMS_R_CERTIFICATE_VERIFY_ERROR = 100;
   CMS_R_CIPHER_INITIALISATION_ERROR = 101;
   CMS_R_CIPHER_PARAMETER_INITIALISATION_ERROR = 102;
   CMS_R_CMS_DATAFINAL_ERROR = 103;
   CMS_R_CMS_LIB = 104;
   CMS_R_CONTENTIDENTIFIER_MISMATCH = 170;
   CMS_R_CONTENT_NOT_FOUND = 105;
   CMS_R_CONTENT_TYPE_MISMATCH = 171;
   CMS_R_CONTENT_TYPE_NOT_COMPRESSED_DATA = 106;
   CMS_R_CONTENT_TYPE_NOT_ENVELOPED_DATA = 107;
   CMS_R_CONTENT_TYPE_NOT_SIGNED_DATA = 108;
   CMS_R_CONTENT_VERIFY_ERROR = 109;
   CMS_R_CTRL_ERROR = 110;
   CMS_R_CTRL_FAILURE = 111;
   CMS_R_DECRYPT_ERROR = 112;
   CMS_R_DIGEST_ERROR = 161;
   CMS_R_ERROR_GETTING_PUBLIC_KEY = 113;
   CMS_R_ERROR_READING_MESSAGEDIGEST_ATTRIBUTE = 114;
   CMS_R_ERROR_SETTING_KEY = 115;
   CMS_R_ERROR_SETTING_RECIPIENTINFO = 116;
   CMS_R_INVALID_ENCRYPTED_KEY_LENGTH = 117;
   CMS_R_INVALID_KEY_LENGTH = 118;
   CMS_R_MD_BIO_INIT_ERROR = 119;
   CMS_R_MESSAGEDIGEST_ATTRIBUTE_WRONG_LENGTH = 120;
   CMS_R_MESSAGEDIGEST_WRONG_LENGTH = 121;
   CMS_R_MSGSIGDIGEST_ERROR = 172;
   CMS_R_MSGSIGDIGEST_VERIFICATION_FAILURE = 162;
   CMS_R_MSGSIGDIGEST_WRONG_LENGTH = 163;
   CMS_R_NEED_ONE_SIGNER = 164;
   CMS_R_NOT_A_SIGNED_RECEIPT = 165;
   CMS_R_NOT_ENCRYPTED_DATA = 122;
   CMS_R_NOT_KEK = 123;
   CMS_R_NOT_KEY_TRANSPORT = 124;
   CMS_R_NOT_SUPPORTED_FOR_THIS_KEY_TYPE = 125;
   CMS_R_NO_CIPHER = 126;
   CMS_R_NO_CONTENT = 127;
   CMS_R_NO_CONTENT_TYPE = 173;
   CMS_R_NO_DEFAULT_DIGEST = 128;
   CMS_R_NO_DIGEST_SET = 129;
   CMS_R_NO_KEY = 130;
   CMS_R_NO_KEY_OR_CERT = 174;
   CMS_R_NO_MATCHING_DIGEST = 131;
   CMS_R_NO_MATCHING_RECIPIENT = 132;
   CMS_R_NO_MATCHING_SIGNATURE = 166;
   CMS_R_NO_MSGSIGDIGEST = 167;
   CMS_R_NO_PRIVATE_KEY = 133;
   CMS_R_NO_PUBLIC_KEY = 134;
   CMS_R_NO_RECEIPT_REQUEST = 168;
   CMS_R_NO_SIGNERS = 135;
   CMS_R_PRIVATE_KEY_DOES_NOT_MATCH_CERTIFICATE = 136;
   CMS_R_RECEIPT_DECODE_ERROR = 169;
   CMS_R_RECIPIENT_ERROR = 137;
   CMS_R_SIGNER_CERTIFICATE_NOT_FOUND = 138;
   CMS_R_SIGNFINAL_ERROR = 139;
   CMS_R_SMIME_TEXT_ERROR = 140;
   CMS_R_STORE_INIT_ERROR = 141;
   CMS_R_TYPE_NOT_COMPRESSED_DATA = 142;
   CMS_R_TYPE_NOT_DATA = 143;
   CMS_R_TYPE_NOT_DIGESTED_DATA = 144;
   CMS_R_TYPE_NOT_ENCRYPTED_DATA = 145;
   CMS_R_TYPE_NOT_ENVELOPED_DATA = 146;
   CMS_R_UNABLE_TO_FINALIZE_CONTEXT = 147;
   CMS_R_UNKNOWN_CIPHER = 148;
   CMS_R_UNKNOWN_DIGEST_ALGORIHM = 149;
   CMS_R_UNKNOWN_ID = 150;
   CMS_R_UNSUPPORTED_COMPRESSION_ALGORITHM = 151;
   CMS_R_UNSUPPORTED_CONTENT_TYPE = 152;
   CMS_R_UNSUPPORTED_KEK_ALGORITHM = 153;
   CMS_R_UNSUPPORTED_RECIPIENT_TYPE = 154;
   CMS_R_UNSUPPORTED_RECPIENTINFO_TYPE = 155;
   CMS_R_UNSUPPORTED_TYPE = 156;
   CMS_R_UNWRAP_ERROR = 157;
   CMS_R_VERIFICATION_FAILURE = 158;
   CMS_R_WRAP_ERROR = 159;
   DSO_F_BEOS_BIND_FUNC = 144;
   DSO_F_BEOS_BIND_VAR = 145;
   DSO_F_BEOS_LOAD = 146;
   DSO_F_BEOS_NAME_CONVERTER = 147;
   DSO_F_BEOS_UNLOAD = 148;
   DSO_F_DLFCN_BIND_FUNC = 100;
   DSO_F_DLFCN_BIND_VAR = 101;
   DSO_F_DLFCN_LOAD = 102;
   DSO_F_DLFCN_MERGER = 130;
   DSO_F_DLFCN_NAME_CONVERTER = 123;
   DSO_F_DLFCN_UNLOAD = 103;
   DSO_F_DL_BIND_FUNC = 104;
   DSO_F_DL_BIND_VAR = 105;
   DSO_F_DL_LOAD = 106;
   DSO_F_DL_MERGER = 131;
   DSO_F_DL_NAME_CONVERTER = 124;
   DSO_F_DL_UNLOAD = 107;
   DSO_F_DSO_BIND_FUNC = 108;
   DSO_F_DSO_BIND_VAR = 109;
   DSO_F_DSO_CONVERT_FILENAME = 126;
   DSO_F_DSO_CTRL = 110;
   DSO_F_DSO_FREE = 111;
   DSO_F_DSO_GET_FILENAME = 127;
   DSO_F_DSO_GET_LOADED_FILENAME = 128;
   DSO_F_DSO_GLOBAL_LOOKUP = 139;
   DSO_F_DSO_LOAD = 112;
   DSO_F_DSO_MERGE = 132;
   DSO_F_DSO_NEW_METHOD = 113;
   DSO_F_DSO_PATHBYADDR = 140;
   DSO_F_DSO_SET_FILENAME = 129;
   DSO_F_DSO_SET_NAME_CONVERTER = 122;
   DSO_F_DSO_UP_REF = 114;
   DSO_F_GLOBAL_LOOKUP_FUNC = 138;
   DSO_F_PATHBYADDR = 137;
   DSO_F_VMS_BIND_SYM = 115;
   DSO_F_VMS_LOAD = 116;
   DSO_F_VMS_MERGER = 133;
   DSO_F_VMS_UNLOAD = 117;
   DSO_F_WIN32_BIND_FUNC = 118;
   DSO_F_WIN32_BIND_VAR = 119;
   DSO_F_WIN32_GLOBALLOOKUP = 142;
   DSO_F_WIN32_GLOBALLOOKUP_FUNC = 143;
   DSO_F_WIN32_JOINER = 135;
   DSO_F_WIN32_LOAD = 120;
   DSO_F_WIN32_MERGER = 134;
   DSO_F_WIN32_NAME_CONVERTER = 125;
   DSO_F_WIN32_PATHBYADDR = 141;
   DSO_F_WIN32_SPLITTER = 136;
   DSO_F_WIN32_UNLOAD = 121;
   DSO_R_CTRL_FAILED = 100;
   DSO_R_DSO_ALREADY_LOADED = 110;
   DSO_R_EMPTY_FILE_STRUCTURE = 113;
   DSO_R_FAILURE = 114;
   DSO_R_FILENAME_TOO_BIG = 101;
   DSO_R_FINISH_FAILED = 102;
   DSO_R_INCORRECT_FILE_SYNTAX = 115;
   DSO_R_LOAD_FAILED = 103;
   DSO_R_NAME_TRANSLATION_FAILED = 109;
   DSO_R_NO_FILENAME = 111;
   DSO_R_NO_FILE_SPECIFICATION = 116;
   DSO_R_NULL_HANDLE = 104;
   DSO_R_SET_FILENAME_FAILED = 112;
   DSO_R_STACK_ERROR = 105;
   DSO_R_SYM_FAILURE = 106;
   DSO_R_UNLOAD_FAILED = 107;
   DSO_R_UNSUPPORTED = 108;
   SRP_NO_ERROR = 0;
   SRP_ERR_VBASE_INCOMPLETE_FILE = 1;
   SRP_ERR_VBASE_BN_LIB = 2;
   SRP_ERR_OPEN_FILE = 3;
   SRP_ERR_MEMORY = 4;
   DB_srptype = 0;
   DB_srpverifier = 1;
   DB_srpsalt = 2;
   DB_srpid = 3;
   DB_srpgN = 4;
   DB_srpinfo = 5;
   DB_NUMBER = 6;
   DB_SRP_INDEX = 'I';
   DB_SRP_VALID = 'V';
   DB_SRP_REVOKED = 'R';
   DB_SRP_MODIF = 'v';
   SRTP_AES128_CM_SHA1_80 = $0001;
   SRTP_AES128_CM_SHA1_32 = $0002;
   SRTP_AES128_F8_SHA1_80 = $0003;
   SRTP_AES128_F8_SHA1_32 = $0004;
   SRTP_NULL_SHA1_80 = $0005;
   SRTP_NULL_SHA1_32 = $0006;
   _ATEXIT_SIZE = 32;
   _IOFBF = 0;
   _IOLBF = 1;
   _IONBF = 2;
   _N_LISTS = 30;
   _MSS_WIN32 = 1;
   _MSS_X86_ = 1;
   __CYGWIN32__ = 1;
   __CYGWIN__ = 1;
   __GNUC_MINOR__ = 91;
   __GNUC__ = 2;
   __SAPP = $0100;
   __SEOF = $0020;
   __SERR = $0040;
   __SLBF = $0001;
   __SMBF = $0080;
   __SMOD = $2000;
   __SNBF = $0002;
   __SNPT = $0800;
   __SOFF = $1000;
   __SOPT = $0400;
   __SRD = $0004;
   __SRW = $0010;
   __SSTR = $0200;
   __STDC__ = 1;
   __SWR = $0008;
   __WINNT = 1;
   __WINNT__ = 1;
   __i386 = 1;
   __i386__ = 1;
   __i586 = 1;
   __i586__ = 1;
   __pentium = 1;
   __pentium__ = 1;
   i386 = 1;
   i586 = 1;
   pentium = 1;
   DTLS1_COOKIE_LENGTH = 256;
   DTLS1_RT_HEADER_LENGTH = 13;
   DTLS1_HM_HEADER_LENGTH = 12;
   DTLS1_HM_BAD_FRAGMENT = -2;
   DTLS1_HM_FRAGMENT_RETRY = -3;
   DTLS1_CCS_HEADER_LENGTH = 1;
   DTLS1_AL_HEADER_LENGTH = 2;

   BIO_PARSE_PRIO_HOST = 0;
   BIO_PARSE_PRIO_SERV = 1;

   BIO_LOOKUP_CLIENT = 0;
   BIO_LOOKUP_SERVER = 1;

//============================================================================
//============================================================================

Type
   size_t = PtrUInt;
   Psize_t = ^size_t;
   RC2_INT = cUINT;
   RC4_INT = cUINT;
   RC4_CHUNK = cULONGLONG;
   IDEA_INT = cUINT;
   timeval = Record
      tv_sec: Longint;
      tv_usec: Longint;
   End;
   PPByte = ^PByte;
   PQ_64BIT = cuint64;
   time_t = cLong;
   STACK = Record
      num: cInt;
      data: PAnsiChar;
      sorted: cInt;
      num_alloc: cInt;
      comp: Function(_para1: PPAnsiChar; _para2: PPAnsiChar): cInt; cdecl;
   End;
   PSTACK = ^STACK;
   PPSTACK = ^PSTACK;
   PSTACK_OF_POINTER = Pointer;
   PSSL = ^SSL;
   CRYPTO_THREADID = Record
      ptr: Pointer;
      val: cuLong;
   End;
   PCRYPTO_THREADID = ^CRYPTO_THREADID;
   OPENSSL_ITEM = Record
      code: cInt;
      value: Pointer;
      value_size: size_t;
      value_length: Psize_t;
   End;
   CRYPTO_EX_DATA = Record
      sk: PSTACK;
      dummy: cInt;
   End;
   PCRYPTO_EX_DATA = ^CRYPTO_EX_DATA;
   PCRYPTO_dynlock_value = Pointer;
   CRYPTO_dynlock = Record
      references: cInt;
      data: PCRYPTO_dynlock_value;
   End;
   PCRYPTO_dynlock = ^CRYPTO_dynlock;
   CRYPTO_EX_new = Function(parent: Pointer; ptr: Pointer; ad: CRYPTO_EX_DATA;
      idx: cInt; arg1: cLong; argp: Pointer): cInt; cdecl;
   CRYPTO_EX_free = Procedure(parent: Pointer; ptr: Pointer; ad: CRYPTO_EX_DATA;
      idx: cInt; arg1: cLong; argp: Pointer); cdecl;
   CRYPTO_EX_dup = Function(_to: PCRYPTO_EX_DATA; from: PCRYPTO_EX_DATA;
      from_d: Pointer; idx: cInt; arg1: cLong; argp: Pointer): cInt; cdecl;
   CRYPTO_EX_DATA_FUNCS = Record
      argl: cLong;
      argp: Pointer;
      new_func: CRYPTO_EX_new;
      free_func: CRYPTO_EX_free;
      dup_func: CRYPTO_EX_dup;
   End;
   PSTACK_OF_CRYPTO_EX_DATA_FUNCS = PSTACK;
   PCRYPTO_EX_DATA_IMPL = Pointer;
   ERR_string_data = Record
      error: cuLong;
      _string: PAnsiChar;
   End;
   PERR_string_data = ^ERR_string_data;
   ERR_STATE = Record
      tid: CRYPTO_THREADID;
      err_flags: Array[0..ERR_NUM_ERRORS - 1] Of cInt;
      err_buffer: Array[0..ERR_NUM_ERRORS - 1] Of cUInt;
      err_data: Array[0..ERR_NUM_ERRORS - 1] Of PAnsiChar;
      err_data_flags: Array[0..ERR_NUM_ERRORS - 1] Of cInt;
      err_file: Array[0..ERR_NUM_ERRORS - 1] Of PAnsiChar;
      err_line: Array[0..ERR_NUM_ERRORS - 1] Of cInt;
      top: cInt;
      bottom: cInt;
   End;
   TERR_STATE = ERR_STATE;
   PERR_FNS = Pointer;
   RAND_METHOD = Record
      seed: Procedure(Const buf: Pointer; num: cInt) Cdecl;
      bytes: Function(Const buf: PAnsiChar; num: cInt): cInt Cdecl;
      cleanup: Procedure cdecl;
      add: Procedure(Const buf: Pointer; num: cInt; entropy: cdouble) Cdecl;
      pseudorand: Function(buf: PAnsiChar; num: cInt): cInt Cdecl;
      status: Function: cInt Cdecl;
   End;
   BN_ULLONG = cuLongLONG;
   BN_LONG = cLongLONG;
   BN_ULONG = cuLongLONG;
   PBN_LONG = ^BN_LONG;
   PBN_ULONG = ^BN_ULONG;
   BIGNUM = Record
      d: PBN_ULONG;
      top: cInt;
      dmax: cInt;
      neg: cInt;
      flags: cInt;
   End;
   PBIGNUM = ^BIGNUM;
   PBN_CTX = Pointer;
   PPBN_CTX = ^PBN_CTX;
   BN_MONT_CTX = Record
      ri: cInt;
      RR: BIGNUM;
      N: BIGNUM;
      Ni: BIGNUM;
      n0: Array[0..1] Of BN_ULONG;
      flags: cInt;
   End;
   PBN_MONT_CTX = ^BN_MONT_CTX;
   PBN_BLINDING = pointer;
   BN_RECP_CTX = Record
      N: BIGNUM;
      Nr: BIGNUM;
      num_bits: cInt;
      shift: cInt;
      flags: cInt;
   End;
   PBN_RECP_CTX = ^BN_RECP_CTX;
   PBN_GENCB = ^BN_GENCB;
   PPBN_GENCB = ^PBN_GENCB;
   BN_cb_1 = Procedure(p1, p2: cInt; p3: Pointer); cdecl;
   BN_cb_2 = Function(p1, p2: cInt; p3: PBN_GENCB): cInt; cdecl;
   BN_GENCB_union = Record
      Case Integer Of
         0: (cb_1: BN_cb_1);
         1: (cb_2: BN_cb_2);
   End;
   BN_GENCB = Record
      ver: cUInt;
      arg: Pointer;
      cb: BN_GENCB_union;
   End;
   WHIRLPOOL_CTX_union = Record
      Case byte Of
         0: (c: Array[0..WHIRLPOOL_DIGEST_LENGTH - 1] Of byte);
         1: (q: Array[0..(WHIRLPOOL_DIGEST_LENGTH Div SizeOf(cdouble)) - 1] Of cdouble);
   End;
   WHIRLPOOL_CTX = Record
      H: WHIRLPOOL_CTX_union;
      data: Array[0..(WHIRLPOOL_BBLOCK Div 8) - 1] Of byte;
      bitoff: cInt;
      bitlen: Array[0..(WHIRLPOOL_COUNTER Div sizeof(size_t)) - 1] Of size_t;
   End;
   PWHIRLPOOL_CTX = ^WHIRLPOOL_CTX;
   MD4_LONG = cuLong;
   MD4_CTX = Record
      A, B, C, D: MD4_LONG;
      Nl, Nh: MD4_LONG;
      data: Array[0..(MD4_LBLOCK - 1)] Of MD4_LONG;
      num: cUInt;
   End;
   PMD4_CTX = ^MD4_CTX;
   MD5_LONG = cUInt;
   MD5_CTX = Record
      A, B, C, D: MD5_LONG;
      Nl, Nh: MD5_LONG;
      data: Array[0..(MD5_LBLOCK - 1)] Of MD5_LONG;
      num: cUInt;
   End;
   PMD5_CTX = ^MD5_CTX;
   SHA_LONG = cUInt;
   SHA_CTX = Record
      h0, h1, h2, h3, h4: SHA_LONG;
      Nl, Nh: SHA_LONG;
      data: Array[0..SHA_LBLOCK] Of SHA_LONG;
      num: cInt;
   End;
   SHA256_CTX = Record
      h: Array[0..(8 - 1)] Of SHA_LONG;
      Nl, Nh: SHA_LONG;
      data: Array[0..(SHA_LBLOCK - 1)] Of SHA_LONG;
      num, md_len: cUInt;
   End;
   SHA_LONG64 = cuint64;
   TSHA512_CTX_Union = Record
      Case integer Of
         0: (d: Array[0..(SHA_LBLOCK - 1)] Of SHA_LONG64);
         1: (p: Array[0..(SHA512_CBLOCK - 1)] Of byte);
   End;
   SHA512_CTX = Record
      h: Array[0..(8 - 1)] Of SHA_LONG64;
      Nl, Nh: SHA_LONG64;
      u: TSHA512_CTX_Union;
      num, md_len: cUInt;
   End;
   PSHA512_CTX = ^SHA512_CTX;
   PUI_METHOD = Pointer;
   PUI_STRING = Pointer;
   PSTACK_OF_UI_STRING = PSTACK;
   UI_string_types = (
      UIT_NONE,
      UIT_PROMPT,
      UIT_VERIFY,
      UIT_BOOLEAN,
      UIT_INFO,
      UIT_ERROR);
   PBIO = ^BIO;

   PBIO_METHOD = ^BIO_METHOD;
   Pbio_info_cb = Procedure(_para1: PBIO; _para2: cInt; _para3: PAnsiChar;_para4: cInt; _para5, _para6: cLong); cdecl;
   BIO_METHOD = Record
      _type: cInt;
      name: PAnsiChar;
      bwrite: Function(_para1: PBIO; _para2: PAnsiChar; _para3: cInt): cInt; cdecl;
      bread: Function(_para1: PBIO; _para2: PAnsiChar; _para3: cInt): cInt; cdecl;
      bputs: Function(_para1: PBIO; _para2: PAnsiChar): cInt; cdecl;
      bgets: Function(_para1: PBIO; _para2: PAnsiChar; _para3: cInt): cInt; cdecl;
      ctrl: Function(_para1: PBIO; _para2: cInt; _para3: cLong; _para4: Pointer): cLong; cdecl;
      create: Function(_para1: PBIO): cInt; cdecl;
      destroy: Function(_para1: PBIO): cInt; cdecl;
      callback_ctrl: Function(_para1: PBIO; _para2: cInt; _para3: pbio_info_cb): cLong; cdecl;
   End;

   BIO = Record
      method: PBIO_METHOD;
      callback: Function(_para1: PBIO; _para2: cInt; _para3: PAnsiChar;
         _para4: cInt; _para5, _para6: cLong): cLong Cdecl;
      cb_arg: PAnsiChar;
      init: cInt;
      shutdown: cInt;
      flags: cInt;
      retry_reason: cInt;
      num: cInt;
      ptr: Pointer;
      next_bio: PBIO;
      prev_bio: PBIO;
      references: cInt;
      num_read: cuLong;
      num_write: cuLong;
      ex_data: CRYPTO_EX_DATA;
   End;

   BIO_F_BUFFER_CTX = Record
      ibuf_size: cInt;
      obuf_size: cInt;
      ibuf: PAnsiChar;
      ibuf_len: cInt;
      ibuf_off: cInt;
      obuf: PAnsiChar;
      obuf_len: cInt;
      obuf_off: cInt;
   End;
   PBIO_F_BUFFER_CTX = ^BIO_F_BUFFER_CTX;

   asn1_ps_function = Function(b: PBIO; pbuf: PPAnsiChar; plen: pcInt; parg: Pointer): cInt Cdecl;
   PENGINE = Pointer;
   PPENGINE = ^PENGINE;
   I2D_OF_void = Function(_para1: Pointer; _para2: PPByte): cInt Cdecl;
   D2I_OF_void = Function(_para1: PPointer; _para2: PPByte; _para3: cLong): Pointer Cdecl;
   PASN1_VALUE = Pointer;
   PPASN1_VALUE = ^PASN1_VALUE;
   PSTACK_OF_ASN1_VALUE = PSTACK;

   ASN1_OBJECT = Record
      sn, ln: PAnsiChar;
      nid: cInt;
      length: cInt;
      data: PAnsiChar;
      flags: cInt;
   End;
   PASN1_OBJECT = ^ASN1_OBJECT;
   PPASN1_OBJECT = ^PASN1_OBJECT;

   PSTACK_OF_ASN1_OBJECT = PSTACK;
   PPSTACK_OF_ASN1_OBJECT = ^PSTACK_OF_ASN1_OBJECT;
   asn1_string_st = Record
      length: cInt;
      _type: cInt;
      data: PAnsiChar;
      flags: cLong;
   End;
   PASN1_ITEM = ^ASN1_ITEM;
   asn1_output_data_fn = Function(AOut: PBIO; data: PBIO; val: PASN1_VALUE;
      flags: cInt; it: PASN1_ITEM): cInt; stdcall;
   ASN1_STRING = asn1_string_st;
   PASN1_STRING = ^ASN1_STRING;
   PPASN1_STRING = ^PASN1_STRING;
   ASN1_INTEGER = ASN1_STRING;
   PASN1_INTEGER = ^ASN1_INTEGER;
   PPASN1_INTEGER = ^PASN1_INTEGER;
   PSTACK_OF_ASN1_INTEGER = PSTACK;
   ASN1_ENUMERATED = ASN1_STRING;
   PASN1_ENUMERATED = ^ASN1_ENUMERATED;
   PPASN1_ENUMERATED = ^PASN1_ENUMERATED;
   ASN1_BIT_STRING = ASN1_STRING;
   PASN1_BIT_STRING = ^ASN1_BIT_STRING;
   PPASN1_BIT_STRING = ^PASN1_BIT_STRING;
   ASN1_OCTET_STRING = ASN1_STRING;
   PASN1_OCTET_STRING = ^ASN1_OCTET_STRING;
   PPASN1_OCTET_STRING = ^PASN1_OCTET_STRING;
   ASN1_PRINTABLESTRING = ASN1_STRING;
   PASN1_PRINTABLESTRING = ^ASN1_PRINTABLESTRING;
   PPASN1_PRINTABLESTRING = ^PASN1_PRINTABLESTRING;
   ASN1_T61STRING = ASN1_STRING;
   PASN1_T61STRING = ^ASN1_T61STRING;
   PPASN1_T61STRING = ^PASN1_T61STRING;
   ASN1_IA5STRING = ASN1_STRING;
   PASN1_IA5STRING = ^ASN1_IA5STRING;
   PPASN1_IA5STRING = ^PASN1_IA5STRING;
   ASN1_UTCTIME = ASN1_STRING;
   PASN1_UTCTIME = ^ASN1_UTCTIME;
   PPASN1_UTCTIME = ^PASN1_UTCTIME;
   ASN1_GENERALIZEDTIME = ASN1_STRING;
   PASN1_GENERALIZEDTIME = ^ASN1_GENERALIZEDTIME;
   PPASN1_GENERALIZEDTIME = ^PASN1_GENERALIZEDTIME;
   ASN1_TIME = ASN1_STRING;
   PASN1_TIME = ^ASN1_TIME;
   PPASN1_TIME = ^PASN1_TIME;
   ASN1_GENERALSTRING = ASN1_STRING;
   PASN1_GENERALSTRING = ^ASN1_GENERALSTRING;
   PPASN1_GENERALSTRING = ^PASN1_GENERALSTRING;
   PSTACK_OF_ASN1_GENERALSTRING = PSTACK;
   ASN1_UNIVERSALSTRING = ASN1_STRING;
   PASN1_UNIVERSALSTRING = ^ASN1_UNIVERSALSTRING;
   PPASN1_UNIVERSALSTRING = ^PASN1_UNIVERSALSTRING;
   ASN1_BMPSTRING = ASN1_STRING;
   PASN1_BMPSTRING = ^ASN1_BMPSTRING;
   PPASN1_BMPSTRING = ^PASN1_BMPSTRING;
   ASN1_VISIBLESTRING = ASN1_STRING;
   PASN1_VISIBLESTRING = ^ASN1_VISIBLESTRING;
   PPASN1_VISIBLESTRING = ^PASN1_VISIBLESTRING;
   ASN1_UTF8STRING = ASN1_STRING;
   PASN1_UTF8STRING = ^ASN1_UTF8STRING;
   PPASN1_UTF8STRING = ^PASN1_UTF8STRING;
   ASN1_BOOLEAN = cInt;
   PASN1_BOOLEAN = ^ASN1_BOOLEAN;
   PPASN1_BOOLEAN = ^PASN1_BOOLEAN;
   ASN1_NULL = cInt;
   PASN1_NULL = ^ASN1_NULL;
   PPASN1_NULL = ^PASN1_NULL;
   ASN1_TYPE = Record
      Case Integer Of
         0: (ptr: PAnsiChar);
         1: (boolean: ASN1_BOOLEAN);
         2: (asn1_string: PASN1_STRING);
         3: (_object: PASN1_OBJECT);
         4: (integer: PASN1_INTEGER);
         5: (enumerated: PASN1_ENUMERATED);
         6: (bit_string: PASN1_BIT_STRING);
         7: (octet_string: PASN1_OCTET_STRING);
         8: (printablestring: PASN1_PRINTABLESTRING);
         9: (t61string: PASN1_T61STRING);
         10: (ia5string: PASN1_IA5STRING);
         11: (generalstring: PASN1_GENERALSTRING);
         12: (bmpstring: PASN1_BMPSTRING);
         13: (universalstring: PASN1_UNIVERSALSTRING);
         14: (utctime: PASN1_UTCTIME);
         15: (generalizedtime: PASN1_GENERALIZEDTIME);
         16: (visiblestring: PASN1_VISIBLESTRING);
         17: (utf8string: PASN1_UTF8STRING);
         18: (_set: PASN1_STRING);
         19: (sequence: PASN1_STRING);
   End;
   PASN1_TYPE = ^ASN1_TYPE;
   PPASN1_TYPE = ^PASN1_TYPE;
   PSTACK_OF_ASN1_TYPE = ^PSTACK;
   ASN1_CTX = Record
      p: PAnsiChar;
      eos: cInt;
      error: cInt;
      inf: cInt;
      tag: cInt;
      xclass: cInt;
      slen: cLong;
      max: PAnsiChar;
      q: PAnsiChar;
      pp: PPAnsiChar;
      line: cInt;
   End;
   PASN1_CTX = ^ASN1_CTX;
   PPASN1_CTX = ^PASN1_CTX;
   ASN1_METHOD = Record
      i2d: i2d_of_void;
      d2i: i2d_of_void;
      create: Function: Pointer; cdecl;
      destroy: Procedure(ptr: Pointer); cdecl;
   End;
   PASN1_METHOD = ^ASN1_METHOD;
   PPASN1_METHOD = ^PASN1_METHOD;
   ASN1_HEADER = Record
      header: PASN1_OCTET_STRING;
      data: Pointer;
      meth: PASN1_METHOD;
   End;
   PASN1_HEADER = ^ASN1_HEADER;
   PPASN1_HEADER = ^PASN1_HEADER;
   ASN1_ENCODING = Record
      enc: PAnsiChar;
      len: cLong;
      modified: cInt;
   End;
   PASN1_ENCODING = ^ASN1_ENCODING;
   PPASN1_ENCODING = ^PASN1_ENCODING;
   ASN1_STRING_TABLE = Record
      nid: cInt;
      minsize: cLong;
      maxsize: cLong;
      mask: cuLong;
      flags: cuLong;
   End;
   PASN1_STRING_TABLE = ^ASN1_STRING_TABLE;
   PPASN1_STRING_TABLE = ^ASN1_STRING_TABLE;
   PSTACK_OF_ASN1_STRING_TABLE = PSTACK;
   PASN1_ITEM_EXP = PASN1_ITEM;
   PRSA = ^RSA;
   PPRSA = ^PRSA;
   RSA_METHOD = Record
      name: PAnsiChar;
      rsa_pub_enc: Function(flen: cInt; Const from: PAnsiChar;
         _to: PAnsiChar; rsa: PRSA; padding: cInt): cInt; cdecl;
      rsa_pub_dec: Function(flen: cInt; Const from: PAnsiChar;
         _to: PAnsiChar; rsa: PRSA; padding: cInt): cInt; cdecl;
      rsa_priv_enc: Function(flen: cInt; Const from: PAnsiChar;
         _to: PAnsiChar; rsa: PRSA; padding: cInt): cInt; cdecl;
      rsa_priv_dec: Function(flen: cInt; Const from: PAnsiChar;
         _to: PAnsiChar; rsa: PRSA; padding: cInt): cInt; cdecl;
      rsa_mod_exp: Function(r0: PBIGNUM; Const I: PBIGNUM;
         rsa: PRSA; ctx: PBN_CTX): cInt Cdecl;
      bn_mod_exp: Function(r: PBIGNUM; Const a: PBIGNUM;
         Const p: PBIGNUM; Const m: PBIGNUM; ctx: PBN_CTX;
         m_ctx: PBN_MONT_CTX): cInt; cdecl;
      init: Function(rsa: PRSA): cInt; cdecl;
      finish: Function(rsa: PRSA): cInt; cdecl;
      flags: cInt;
      app_data: PAnsiChar;
      rsa_sign: Function(_type: cInt; Const m: PAnsiChar; m_length: cUInt;
         sigret: PAnsiChar; siglen: pcUInt; Const rsa: PRSA): cInt; cdecl;
      rsa_verify: Function(dtype: cInt; Const m: PAnsiChar; m_length: pcUInt;
         sigbuf: PAnsiChar; siglen: pcUInt; Const rsa: PRSA): cInt; cdecl;
      rsa_keygen: Function(rsa: PRSA; bits: cInt; e: PBIGNUM; cb: PBN_GENCB): cInt; cdecl;
   End;
   PRSA_METHOD = ^RSA_METHOD;
   rsa_st = Record
      pad: cInt;
      version: cLong;
      meth: PRSA_METHOD;
      engine: PENGINE;
      n: PBIGNUM;
      e: PBIGNUM;
      d: PBIGNUM;
      p: PBIGNUM;
      q: PBIGNUM;
      dmp1: PBIGNUM;
      dmq1: PBIGNUM;
      iqmp: PBIGNUM;
      ex_data: CRYPTO_EX_DATA;
      references: cInt;
      flags: cInt;
      _method_mod_n: PBN_MONT_CTX;
      _method_mod_p: PBN_MONT_CTX;
      _method_mod_q: PBN_MONT_CTX;
      bignum_data: PAnsiChar;
      blinding: PBN_BLINDING;
      mt_blinding: PBN_BLINDING;
   End;
   RSA = rsa_st;
   Prsa_st = PRSA;
   PDSO = ^DSO;
   DSO_NAME_CONVERTER_FUNC = Function(dso: PDSO; para1: PAnsiChar): PAnsiChar Cdecl;
   PDSO_METHOD = ^DSO_METHOD;
   DSO_FUNC_TYPE = Procedure cdecl;
   DSO_MERGER_FUNC = Function(DSO: PDSO; para1, para2: PAnsiChar): PAnsiChar Stdcall;
   DSO_METHOD = Record
      name: PAnsiChar;
      dso_load: Function(dso: PDSO): cInt Cdecl;
      dso_unload: Function(dso: PDSO): cInt Cdecl;
      dso_bind_var: Function(dso: PDSO; symname: PAnsiChar): Pointer Cdecl;
      dso_bind_func: Function(dso: PDSO; symname: PAnsiChar): DSO_FUNC_TYPE Stdcall;
      dso_ctrl: Function(dso: PDSO; cmd: cInt; larg: cLong; parg: Pointer): cLong Stdcall;
      dso_name_converter: DSO_NAME_CONVERTER_FUNC;
      dso_merger: DSO_MERGER_FUNC;
      init: Function(dso: PDSO): cInt Stdcall;
      finish: Function(dso: PDSO): cInt Stdcall;
      pathbyaddr: Function(addr: Pointer; path: PAnsiChar; sz: cInt): cInt Stdcall;
      globallookup: Function(symname: PAnsiChar): Pointer Stdcall;
   End;
   DSO = Record
      meth: PDSO_METHOD;
      meth_data: PSTACK_OF_POINTER;
      references: cInt;
      flags: cInt;
      ex_data: CRYPTO_EX_DATA;
      name_converter: DSO_NAME_CONVERTER_FUNC;
      merger: DSO_MERGER_FUNC;
      filename: PAnsiChar;
      loaded_filename: PAnsiChar;
   End;
   PDH = ^DH;
   DH_METHOD = Record
      name: PAnsiChar;
      generate_key: Function(dh: PDH): cInt; cdecl;
      compute_key: Function(key: PAnsiChar; Const pub_key: PBIGNUM; dh: PDH): cInt; cdecl;
      bn_mod_exp: Function(Const dh: PDH; r: PBIGNUM; Const e: PBIGNUM;
         Const p: PBIGNUM; Const m: PBIGNUM; ctx: PBN_CTX;
         m_ctx: PBN_MONT_CTX): cInt; cdecl;
      init: Function(dh: PDH): cInt; cdecl;
      finish: Function(dh: PDH): cInt; cdecl;
      flags: cInt;
      app_data: PAnsiChar;
      generate_params: Function(dh: PDH; prime_len, generator: cInt; cb: PBN_GENCB): cInt; cdecl;
   End;
   dh_st = Record
      pad: cInt;
      version: cLong;
      meth: PRSA_METHOD;
      engine: PENGINE;
      n: PBIGNUM;
      e: PBIGNUM;
      d: PBIGNUM;
      p: PBIGNUM;
      q: PBIGNUM;
      dmp1: PBIGNUM;
      dmq1: PBIGNUM;
      iqmp: PBIGNUM;
      ex_data: CRYPTO_EX_DATA;
      references: cInt;
      flags: cInt;
      _method_mod_n: BN_MONT_CTX;
      _method_mod_p: BN_MONT_CTX;
      _method_mod_q: BN_MONT_CTX;
      bignum_data: PAnsiChar;
      blinding: PBN_BLINDING;
      mt_blinding: PBN_BLINDING;
   End;
   DH = dh_st;
   Pdh_st = PDH;
   PPDH = ^PDH;
   DSA_SIG = Record
      r: PBIGNUM;
      s: PBIGNUM;
   End;
   PDSA_SIG = ^DSA_SIG;
   PDSA = ^DSA;
   DSA_METHOD = Record
      name: PAnsiChar;
      dsa_do_sign: Function(Const dgst: PAnsiChar; dlen: cInt; dsa: PDSA): PDSA_SIG; cdecl;
      dsa_sign_setup: Function(dsa: PDSA; ctx_in: PBN_CTX; kinvp, rp: PPBN_CTX): cInt; cdecl;
      dsa_do_verify: Function(dgst: PAnsiChar; dgst_len: cInt;
         sig: PDSA_SIG; dsa: PDSA): cInt; cdecl;
      dsa_mod_exp: Function(dsa: PDSA; rr, a1, p1,
         a2, p2, m: PBIGNUM; ctx: PBN_CTX;
         in_mont: PBN_MONT_CTX): cInt; cdecl;
      bn_mod_exp: Function(dsa: PDSA; r, a: PBIGNUM; Const p, m: PBIGNUM;
         ctx: PBN_CTX; m_ctx: PBN_CTX): cInt; cdecl;
      init: Function(dsa: PDSA): cInt; cdecl;
      finish: Function(dsa: PDSA): cInt; cdecl;
      flags: cInt;
      app_data: PAnsiChar;
      dsa_paramgen: Function(dsa: PDSA; bits: cInt; seed: PAnsiChar;
         seed_len: cInt; counter_ret: pcInt; h_ret: pculong;
         cb: PBN_GENCB): cInt; cdecl;
      dsa_keygen: Function(dsa: PDSA): cInt; cdecl;
   End;
   PDSA_METHOD = ^DSA_METHOD;
   dsa_st = Record
      pad: cInt;
      version: cLong;
      write_params: cInt;
      p: PBIGNUM;
      q: PBIGNUM;
      g: PBIGNUM;
      pub_key: PBIGNUM;
      priv_key: PBIGNUM;
      kinv: BIGNUM;
      r: PBIGNUM;
      flags: cInt;
      method_mont_p: PBN_MONT_CTX;
      references: cInt;
      ex_data: CRYPTO_EX_DATA;
      meth: PDSA_METHOD;
      engine: PENGINE;
   End;
   DSA = dsa_st;
   Pdsa_st = PDSA;
   PPDSA = ^PDSA;
   PEC_METHOD = Pointer;
   PPEC_METHOD = ^PEC_METHOD;
   PEC_GROUP = Pointer;
   PPEC_GROUP = ^PEC_GROUP;
   PEC_POINT = Pointer;
   PPEC_POINT = ^PEC_POINT;
   EC_builtin_curve = Record
      nid: cInt;
      comment: PAnsiChar;
   End;
   Pec_key_st = Pointer;
   PEC_KEY = Pec_key_st;
   PPEC_KEY = ^PEC_KEY;
   PEVP_PKEY_METHOD = pointer;
   PEVP_PKEY_CTX = pointer;
   PPEVP_PKEY_CTX = ^PEVP_PKEY_CTX;
   PEVP_PKEY_ASN1_METHOD = pointer;
   PEVP_PBE_KEYGEN = Pointer;
   PPEVP_PKEY = ^PEVP_PKEY;
   PEVP_PKEY = ^EVP_PKEY;
   EVP_PKEY_union = Record
      Case byte Of
         0: (ptr: PAnsiChar);
         1: (rsa: PRSA);
         2: (dsa: PDSA);
         3: (dh: PDH);
         4: (ec: PEC_KEY);
   End;
   Pevp_pkey_st = PEVP_PKEY;
   PSTACK_OF_X509_ATTRIBUTE = PSTACK;
   PPSTACK_OF_X509_ATTRIBUTE = ^PSTACK_OF_X509_ATTRIBUTE;
   EVP_PKEY = Record
      _type: cInt;
      save_type: cInt;
      references: cInt;
      ameth: PEVP_PKEY_ASN1_METHOD;
      pkey: EVP_PKEY_union;
      attributes: PSTACK_OF_X509_ATTRIBUTE;
   End;
   PEVP_MD = ^EVP_MD;
   PEVP_MD_CTX = ^EVP_MD_CTX;
   PPEVP_MD_CTX = ^PEVP_MD_CTX;
   EVP_MD_CTX = Record
      digest: PEVP_MD;
      engine: PENGINE;
      flags: cuLong;
      md_data: Pointer;
      pctx: PEVP_PKEY_CTX;
      update: Function(ctx: PEVP_MD_CTX; Const data: Pointer; count: size_t): cInt Cdecl;
   End;
   EVP_MD_SVCTX = Record
      mctx: PEVP_MD_CTX;
      key: Pointer;
   End;
   PEVP_MD_SVCTX = ^EVP_MD_SVCTX;
   EVP_MD = Record
      _type: cInt;
      pkey_type: cInt;
      md_size: cInt;
      flags: cuLong;
      init: Function(ctx: PEVP_MD_CTX): cInt; cdecl;
      update: Function(ctx: PEVP_MD_CTX; data: Pointer; count: size_t): cInt; cdecl;
      _final: Function(ctx: PEVP_MD_CTX; md: PAnsiChar): cInt; cdecl;
      copy: Function(_to: PEVP_MD_CTX; from: PEVP_MD_CTX): cInt; cdecl;
      cleanup: Function(ctx: PEVP_MD_CTX): cInt; cdecl;
      sign: Function(_type: cInt; m: PAnsiChar; m_length: cUInt;
         sigret: PAnsiChar; siglen: cUInt; key: Pointer): cInt; cdecl;
      verify: Function(_type: cInt; m: PAnsiChar; m_length: PAnsiChar;
         sigbuf: PAnsiChar; siglen: cUInt; key: Pointer): cInt; cdecl;
      required_pkey_type: Array[0..4] Of cInt;
      block_size: cInt;
      ctx_size: cInt;
   End;
   PPEVP_CIPHER_CTX = ^PEVP_CIPHER_CTX;
   PEVP_CIPHER_CTX = ^EVP_CIPHER_CTX;
   PEVP_CIPHER = ^EVP_CIPHER;
   EVP_CIPHER = Record
      nid: cInt;
      block_size: cInt;
      key_len: cInt;
      iv_len: cInt;
      flags: cUInt;
      init: Function(ctx: PEVP_CIPHER_CTX; key: PAnsiChar; iv: PAnsiChar; enc: cInt): cInt; cdecl;
      do_cipher: Function(ctx: PEVP_CIPHER_CTX; _out: PAnsiChar; _in: PAnsiChar; inl: size_t): cInt; cdecl;
      cleanup: Function(_para1: PEVP_CIPHER_CTX): cInt; cdecl;
      ctx_size: cInt;
      set_asn1_parameters: Function(_para1: PEVP_CIPHER_CTX;
         _para2: PASN1_TYPE): cInt; cdecl;
      get_asn1_parameters: Function(_para1: PEVP_CIPHER_CTX;
         _para2: PASN1_TYPE): cInt; cdecl;
      ctrl: Function(_para1: PEVP_CIPHER_CTX; _type: cInt; arg: cInt;
         ptr: Pointer): cInt; cdecl;
      app_data: Pointer;
   End;
   EVP_CIPHER_CTX = Record
      cipher: PEVP_CIPHER;
      engine: PENGINE;
      encrypt: cInt;
      buf_len: cInt;
      oiv: Array[0..EVP_MAX_IV_LENGTH - 1] Of AnsiChar;
      iv: Array[0..EVP_MAX_IV_LENGTH - 1] Of AnsiChar;
      buf: Array[0..EVP_MAX_BLOCK_LENGTH - 1] Of AnsiChar;
      num: cInt;
      app_data: Pointer;
      key_len: cInt;
      flags: cuLong;
      cipher_data: Pointer;
      final_used: cInt;
      block_mask: cInt;
      _final: Array[0..EVP_MAX_BLOCK_LENGTH - 1] Of AnsiChar;
   End;
   EVP_CIPHER_INFO = Record
      cipher: PEVP_CIPHER;
      iv: Array[0..EVP_MAX_IV_LENGTH - 1] Of AnsiChar;
   End;
   PEVP_CIPHER_INFO = ^EVP_CIPHER_INFO;
   EVP_ENCODE_CTX = Record
      num: cInt;
      length: cInt;
      enc_data: Array[0..79] Of AnsiChar;
      line_num: cInt;
      expect_nl: cInt;
   End;
   PEVP_ENCODE_CTX = ^EVP_ENCODE_CTX;
   PX509 = ^X509;
   PPX509 = ^PX509;
   PX509_CRL = ^X509_CRL;
   PX509_NAME = ^X509_NAME;
   PX509_NAME_ENTRY = ^X509_NAME_ENTRY;
   PX509_REQ = ^X509_REQ;
   PX509_REQ_INFO = ^X509_REQ_INFO;
   PPX509_REQ_INFO = ^PX509_REQ_INFO;
   PSTACK_OF_X509_NAME_ENTRY = PSTACK;
   PSTACK_OF_X509_REVOKED = PSTACK;
   PSTACK_OF_X509_NAME = PSTACK;
   PPSTACK_OF_X509_REVOKED = ^PSTACK_OF_X509_REVOKED;
   PPX509_NAME = ^PX509_NAME;
   PPSTACK_OF_X509_NAME = ^PSTACK_OF_X509_NAME;
   PSTACK_OF_X509_POLICY_DATA = PSTACK;
   PSTACK_OF_X509_POLICY_REF = PSTACK;
   PSTACK_OF_X509_POLICY_NODE = PSTACK;
   PSTACK_OF_POLICYQUALINFO = PSTACK;
   PSTACK_OF_X509V3_EXT_METHOD = PSTACK;
   PPSTACK_OF_X509V3_EXT_METHOD = ^PSTACK_OF_X509V3_EXT_METHOD;
   PSTACK_OF_X509 = PSTACK;
   PPSTACK_OF_X509 = ^PSTACK_OF_X509;
   ENGINE_GEN_FUNC_PTR = Function: cInt; cdecl;
   ENGINE_GEN_INT_FUNC_PTR = Function(Para1: PENGINE): cInt; cdecl;
   ENGINE_CTRL_FUNC_PTR_F = Procedure; cdecl;
   ENGINE_CTRL_FUNC_PTR = Function(Para1: PENGINE; Para2: cInt;
      Para3: cLong; Para4: Pointer; f: ENGINE_CTRL_FUNC_PTR_F): cInt; cdecl;
   ENGINE_LOAD_KEY_PTR = Function(Para1: PENGINE; Para2: PAnsiChar;
      ui_method: PUI_METHOD; callback_data: Pointer): PEVP_PKEY; cdecl;
   ENGINE_SSL_CLIENT_CERT_PTR = Function(Para1: PENGINE; ssl: PSSL;
      ca_dn: PSTACK_OF_X509_NAME; Var pcert: PX509; Var pkey: PEVP_PKEY;
      Var pother: PSTACK_OF_X509; ui_method: PUI_METHOD; callback_data: Pointer): cInt; cdecl;
   ENGINE_CIPHERS_PTR = Function(para1: PENGINE; Var para2: PEVP_CIPHER; Var para3: pcInt; para4: cInt): cInt; cdecl;
   ENGINE_DIGESTS_PTR = Function(para1: PENGINE; Var Para2: PEVP_MD; Var Para3: pcInt; para4: cInt): cInt Cdecl;
   ENGINE_PKEY_METHS_PTR = Function(para1: PENGINE; Var Para2: PEVP_PKEY_METHOD; Var Para3: pcInt; para4: cInt): cInt Cdecl;
   ENGINE_PKEY_ASN1_METHS_PTR = Function(para1: PENGINE; Var Para2: PEVP_PKEY_ASN1_METHOD; Var Para3: pcInt; para4: cInt): cInt Cdecl;
   dyn_MEM_malloc_cb = Function(para1: size_t): Pointer; cdecl;
   dyn_MEM_realloc_cb = Function(para1: Pointer; para2: size_t): Pointer; cdecl;
   dyn_MEM_free_cb = Procedure(para1: Pointer); cdecl;
   dynamic_MEM_fns = Record
      malloc_cb: dyn_MEM_malloc_cb;
      realloc_cb: dyn_MEM_realloc_cb;
      free_cb: dyn_MEM_free_cb;
   End;
   dyn_lock_locking_cb = Procedure(para1, para2: cInt; para3: PAnsiChar; para4: cInt); cdecl;
   dyn_lock_add_lock_cb = Function(Var para1: cInt; para2, para3: cInt; para4: PAnsiChar; para5: cInt): cInt; cdecl;
   dyn_dynlock_create_cb = Function(para1: PAnsiChar; para2: cInt): PCRYPTO_dynlock_value; cdecl;
   dyn_dynlock_lock_cb = Procedure(para1: cInt; para2: PCRYPTO_dynlock_value); cdecl;
   dyn_dynlock_destroy_cb = Procedure(para1: PCRYPTO_dynlock_value; para2: PAnsiChar; para3: cInt); cdecl;
   dynamic_LOCK_fns = Record
      lock_locking_cb: dyn_lock_locking_cb;
      lock_add_lock_cb: dyn_lock_add_lock_cb;
      dynlock_create_cb: dyn_dynlock_create_cb;
      dynlock_lock_cb: dyn_dynlock_lock_cb;
      dynlock_destroy_cb: dyn_dynlock_destroy_cb;
   End;
   dynamic_fns = Record
      static_state: Pointer;
      err_fns: PERR_FNS;
      ex_data_fns: PCRYPTO_EX_DATA_IMPL;
      mem_fns: dynamic_MEM_fns;
      lock_fns: dynamic_LOCK_fns;
   End;
   dynamic_v_check_fn = Function(ossl_version: cuLong): cuLong; cdecl;
   dynamic_bind_engine = Function(e: PENGINE; id: PAnsiChar; fns: dynamic_fns): cInt; cdecl;
   ECDSA_SIG = Record
      r: PBIGNUM;
      s: PBIGNUM;
   End;
   PECDSA_SIG = ^ECDSA_SIG;
   PPECDSA_SIG = ^PECDSA_SIG;
   PECDH_METHOD = Pointer;
   PPECDH_METHOD = ^PECDH_METHOD;
   AES_KEY = Record
      rd_key: Array[0..(4 * (AES_MAXNR + 1) - 1)] Of cUInt;
      rounds: cInt;
   End;
   PAES_KEY = ^AES_KEY;
   PPAES_KEY = ^PAES_KEY;
   SEED_KEY_SCHEDULE = Record
      data: Array[0..(32 - 1)] Of cUInt;
   End;
   PSEED_KEY_SCHEDULE = ^SEED_KEY_SCHEDULE;
   PLHASH_NODE = ^LHASH_NODE;
   PPLHASH_NODE = ^PLHASH_NODE;
   LHASH_NODE = Record
      data: Pointer;
      next: PLHASH_NODE;
      hash: cuLong;
   End;
   LHASH_COMP_FN_TYPE = Function(Const p1, p2: Pointer): cInt; cdecl;
   PLHASH_COMP_FN_TYPE = ^LHASH_COMP_FN_TYPE;
   LHASH_HASH_FN_TYPE = Function(Const p1: Pointer): cuLong; cdecl;
   LHASH_DOALL_FN_TYPE = Procedure(p1: Pointer); cdecl;
   LHASH_DOALL_ARG_FN_TYPE = Procedure(p1, p2: Pointer); cdecl;
   LHASH = Record
      b: PPLHASH_NODE;
      comp: LHASH_COMP_FN_TYPE;
      hash: LHASH_HASH_FN_TYPE;
      num_nodes: cUInt;
      num_alloc_nodes: cUInt;
      p: cUInt;
      pmax: cUInt;
      up_load: cuLong;
      down_load: cuLong;
      num_items: cuLong;
      num_expands: cuLong;
      num_expand_reallocs: cuLong;
      num_contracts: cuLong;
      num_contract_reallocs: cuLong;
      num_hash_calls: cuLong;
      num_comp_calls: cuLong;
      num_insert: cuLong;
      num_replace: cuLong;
      num_delete: cuLong;
      num_no_delete: cuLong;
      num_retrieve: cuLong;
      num_retrieve_miss: cuLong;
      num_hash_comps: cuLong;
      error: cInt;
   End;
   PLHASH = ^LHASH;
   CONF_VALUE = Record
      section: PAnsiChar;
      name: PAnsiChar;
      value: PAnsiChar;
   End;
   PCONF_VALUE = ^CONF_VALUE;
   PSTACK_OF_CONF_VALUE = PSTACK;
   BIT_STRING_BITNAME = Record
      bitnum: cInt;
      lname: PAnsiChar;
      sname: PAnsiChar;
   End;
   PBIT_STRING_BITNAME = ^BIT_STRING_BITNAME;
   PPBIT_STRING_BITNAME = ^PBIT_STRING_BITNAME;
   buf_mem_st = Record
      length: cInt;
      data: PAnsiChar;
      max: cInt;
   End;
   BUF_MEM = buf_mem_st;
   PBUF_MEM = ^BUF_MEM;
   PPBUF_MEM = ^PBUF_MEM;
   PFILE = Pointer;
   ASN1_TEMPLATE = Record
      flags: cuLong;
      tag: cLong;
      offset: cuLong;
      field_name: PAnsiChar;
      item: PASN1_ITEM_EXP;
   End;
   PASN1_TEMPLATE = ^ASN1_TEMPLATE;
   ASN1_ITEM = Record
      itype: Char;
      utype: cLong;
      templates: PASN1_TEMPLATE;
      tcount: cLong;
      funcs: Pointer;
      size: cLong;
      sname: PAnsiChar;
   End;
   PASN1_PCTX = Pointer;
   PSTACK_OF_ASN1_ADB_TABLE = PSTACK;
   PPSTACK_OF_ASN1_ADB_TABLE = ^PSTACK_OF_ASN1_ADB_TABLE;
   PASN1_ADB_TABLE = ^ASN1_ADB_TABLE;
   PASN1_ADB = ^ASN1_ADB;
   ASN1_ADB = Record
      flags: cuLong;
      offset: cuLong;
      app_items: PPSTACK_OF_ASN1_ADB_TABLE;
      tbl: PASN1_ADB_TABLE;
      tblcount: cLong;
      default_tt: PASN1_TEMPLATE;
      null_tt: PASN1_TEMPLATE;
   End;
   ASN1_ADB_TABLE = Record
      flags: cLong;
      offset: cLong;
      app_items: PPSTACK_OF_ASN1_ADB_TABLE;
      tbl: PASN1_ADB_TABLE;
      tblcount: cLong;
      default_tt: PASN1_TEMPLATE;
      null_tt: PASN1_TEMPLATE;
   End;
   PASN1_TLC = ^ASN1_TLC;
   ASN1_TLC = Record
      valid: Byte;
      ret: cInt;
      plen: cLong;
      ptag: cInt;
      pclass: cInt;
      hdrlen: cInt;
   End;
   ASN1_new_func = Function: PASN1_VALUE; cdecl;
   ASN1_free_func = Procedure(a: PASN1_VALUE); cdecl;
   ASN1_d2i_func = Function(a: PASN1_VALUE; _in: PPByte; length: cLong): PASN1_VALUE; cdecl;
   ASN1_i2d_func = Function(a: PASN1_VALUE; _in: PPByte): cInt; cdecl;
   ASN1_ex_d2i = Function(pval: PPASN1_VALUE; _in: PPByte; len: cLong;
      it: PASN1_ITEM; tag, aclass: cInt; opt: Byte;
      ctx: PASN1_TLC): cInt; cdecl;
   ASN1_ex_i2d = Function(pval: PPASN1_VALUE; _out: PPByte; it: PASN1_ITEM; tag, aclass: cInt): cInt; cdecl;
   ASN1_ex_new_func = Function(pval: PPASN1_VALUE; it: PASN1_ITEM): cInt; cdecl;
   ASN1_ex_free_func = Procedure(pval: PPASN1_VALUE; it: PASN1_ITEM); cdecl;
   ASN1_primitive_i2c = Function(pval: PPASN1_VALUE; cont: PByte; putype: pcInt; it: PASN1_ITEM): cInt; cdecl;
   ASN1_primitive_c2i = Function(pval: PPASN1_VALUE; cont: PByte; len, utype: cInt; free_cont: PByte; it: PASN1_ITEM): cInt; cdecl;
   ASN1_COMPAT_FUNCS = Record
      asn1_new: ASN1_new_func;
      asn1_free: ASN1_free_func;
      asn1_d2i: ASN1_d2i_func;
      asn1_i2d: ASN1_i2d_func;
   End;
   PASN1_COMPAT_FUNCS = ^ASN1_COMPAT_FUNCS;
   ASN1_EXTERN_FUNCS = Record
      app_data: Pointer;
      asn1_ex_new: ASN1_ex_new_func;
      asn1_ex_free: ASN1_ex_free_func;
      asn1_ex_clear: ASN1_ex_free_func;
      asn1_ex_d2i: ASN1_ex_d2i;
      asn1_ex_i2d: ASN1_ex_i2d;
   End;
   PASN1_EXTERN_FUNCS = ^ASN1_EXTERN_FUNCS;
   ASN1_PRIMITIVE_FUNCS = Record
      app_data: Pointer;
      flags: cuLong;
      prim_new: ASN1_ex_new_func;
      prim_free: ASN1_ex_free_func;
      prim_clear: ASN1_ex_free_func;
      prim_c2i: ASN1_primitive_c2i;
      prim_i2c: ASN1_primitive_i2c;
   End;
   PASN1_PRIMITIVE_FUNCS = ^ASN1_PRIMITIVE_FUNCS;
   ASN1_aux_cb = Function(operation: cInt; _in: PPASN1_VALUE; it: PASN1_ITEM): cInt; cdecl;
   ASN1_AUX = Record
      app_data: Pointer;
      flags: cInt;
      ref_offset: cInt;
      ref_lock: cInt;
      asn1_cb: ASN1_aux_cb;
      enc_offset: cInt;
   End;
   PASN1_AUX = ^ASN1_AUX;
   HMAC_CTX = Record
      md: PEVP_MD;
      md_ctx: EVP_MD_CTX;
      i_ctx: EVP_MD_CTX;
      o_ctx: EVP_MD_CTX;
      key_length: cUInt;
      key: Array[0..(HMAC_MAX_MD_CBLOCK - 1)] Of byte;
   End;
   PHMAC_CTX = ^HMAC_CTX;
   PPHMAC_CTX = ^PHMAC_CTX;
   PX509_POLICY_DATA = Pointer;
   PX509_POLICY_REF = Pointer;
   PX509_POLICY_CACHE = Pointer;
   PPX509_NAME_ENTRY = ^PX509_NAME_ENTRY;
   PV3_EXT_METHOD = ^V3_EXT_METHOD;
   PV3_EXT_CTX = ^V3_EXT_CTX;
   X509V3_EXT_NEW = Function: Pointer; cdecl;
   X509V3_EXT_FREE = Procedure(_para1: Pointer); cdecl;
   X509V3_EXT_D2I = Function(_para1: Pointer; Const _para2: PPAnsiChar; para3: cLong): Pointer; cdecl;
   X509V3_EXT_I2D = Function(_para1: Pointer; _para2: PPAnsiChar): cInt; cdecl;
   X509V3_EXT_I2V = Function(method: PV3_EXT_METHOD; ext: Pointer; extlist: PSTACK_OF_CONF_VALUE): PSTACK_OF_CONF_VALUE; cdecl;
   X509V3_EXT_V2I = Function(method: Pv3_ext_method; ctx: PV3_EXT_CTX; values: PSTACK_OF_CONF_VALUE): Pointer; cdecl;
   X509V3_EXT_I2S = Function(method: Pv3_ext_method; ext: Pointer): PAnsiChar; cdecl;
   X509V3_EXT_S2I = Function(method: Pv3_ext_method; ctx: Pv3_ext_ctx; Const str: PAnsiChar): Pointer; cdecl;
   X509V3_EXT_I2R = Function(method: Pv3_ext_method; ext: Pointer; _out: PBIO; indent: cInt): cInt; cdecl;
   X509V3_EXT_R2I = Function(method: Pv3_ext_method; ctx: Pv3_ext_ctx; Const str: PAnsiChar): Pointer; cdecl;
   V3_EXT_METHOD = Record
      ext_nid: cInt;
      ext_flags: cInt;
      it: PASN1_ITEM_EXP;
      ext_new: X509V3_EXT_NEW;
      ext_free: X509V3_EXT_FREE;
      d2i: X509V3_EXT_D2I;
      i2d: X509V3_EXT_I2D;
      i2s: X509V3_EXT_I2S;
      s2i: X509V3_EXT_S2I;
      i2v: X509V3_EXT_I2V;
      v2i: X509V3_EXT_V2I;
      i2r: X509V3_EXT_I2R;
      r2i: X509V3_EXT_R2I;
      usr_data: Pointer;
   End;
   X509V3_EXT_METHOD = V3_EXT_METHOD;
   X509V3_CONF_METHOD = Record
      get_string: Function(db: Pointer; section, value: PAnsiChar): PAnsiChar; cdecl;
      get_section: Function(db: Pointer; section: PAnsiChar): PSTACK_OF_CONF_VALUE; cdecl;
      free_string: Procedure(db: Pointer; _string: PAnsiChar); cdecl;
      free_section: Procedure(db: Pointer; section: PSTACK_OF_CONF_VALUE);
   End;
   V3_EXT_CTX = Record
      flags: cInt;
      issuer_cert: PX509;
      subject_cert: PX509;
      subject_req: PX509_REQ;
      crl: PX509_CRL;
      db_meth: X509V3_CONF_METHOD;
      db: Pointer;
   End;
   ENUMERATED_NAMES = BIT_STRING_BITNAME;
   BASIC_CONSTRAINTS = Record
      ca: cInt;
      pathlen: PASN1_INTEGER;
   End;
   PBASIC_CONSTRAINTS = ^BASIC_CONSTRAINTS;
   PKEY_USAGE_PERIOD = Record
      notBefore: ASN1_GENERALIZEDTIME;
      notAfter: PASN1_GENERALIZEDTIME;
   End;
   PPKEY_USAGE_PERIOD = ^PKEY_USAGE_PERIOD;
   OTHERNAME = Record
      type_id: PASN1_OBJECT;
      value: PASN1_TYPE;
   End;
   POTHERNAME = ^OTHERNAME;
   EDIPARTYNAME = Record
      nameAssigner: PASN1_STRING;
      partyName: PASN1_STRING;
   End;
   PEDIPARTYNAME = ^EDIPARTYNAME;
   GENERAL_NAME_union = Record
      Case byte Of
         0: (ptr: PAnsiChar);
         1: (otherName: POTHERNAME);
         2: (rfc822Name: PASN1_IA5STRING);
         3: (dNSName: PASN1_IA5STRING);
         4: (x400Address: PASN1_TYPE);
         5: (directoryName: PX509_NAME);
         6: (ediPartyName: PEDIPARTYNAME);
         7: (uniformResourceIdentifier: PASN1_IA5STRING);
         8: (iPAddress: PASN1_OCTET_STRING);
         9: (registeredID: PASN1_OBJECT);
         10: (ip: PASN1_OCTET_STRING);
         11: (dirn: PX509_NAME);
         12: (ia5: PASN1_IA5STRING);
         13: (rid: ASN1_OBJECT);
         14: (other: PASN1_TYPE);
   End;
   GENERAL_NAME = Record
      _type: cInt;
      d: GENERAL_NAME_union;
   End;
   PGENERAL_NAME = ^GENERAL_NAME;
   PSTACK_OF_GENERAL_NAME = PSTACK;
   PGENERAL_NAMES = PSTACK_OF_GENERAL_NAME;
   ACCESS_DESCRIPTION = Record
      method: PASN1_OBJECT;
      location: PGENERAL_NAME;
   End;
   PACCESS_DESCRIPTION = ^ACCESS_DESCRIPTION;
   PSTACK_OF_ACCESS_DESCRIPTION = PSTACK;
   PAUTHORITY_INFO_ACCESS = PSTACK_OF_ACCESS_DESCRIPTION;
   PEXTENDED_KEY_USAGE = PSTACK_OF_ASN1_OBJECT;
   DIST_POINT_NAME_union = Record
      Case byte Of
         0: (fullname: PGENERAL_NAMES);
         1: (relativename: PSTACK_OF_X509_NAME_ENTRY);
   End;
   DIST_POINT_NAME = Record
      _type: cInt;
      name: DIST_POINT_NAME_union;
   End;
   PDIST_POINT_NAME = ^DIST_POINT_NAME;
   DIST_POINT = Record
      distpoint: PDIST_POINT_NAME;
      reasons: PASN1_BIT_STRING;
      CRLissuer: PGENERAL_NAMES;
      dp_reasons: cInt;
   End;
   PSTACK_OF_DIST_POINT = PSTACK;
   AUTHORITY_KEYID = Record
      keyid: PASN1_OCTET_STRING;
      issuer: PGENERAL_NAMES;
      serial: PASN1_INTEGER;
   End;
   PAUTHORITY_KEYID = ^AUTHORITY_KEYID;
   SXNETID = Record
      zone: PASN1_INTEGER;
      user: PASN1_OCTET_STRING;
   End;
   PSXNETID = ^SXNETID;
   PSTACK_OF_SXNETID = PSTACK;
   SXNET = Record
      version: PASN1_INTEGER;
      ids: PSTACK_OF_SXNETID;
   End;
   PSXNET = ^SXNET;
   NOTICEREF = Record
      organization: PASN1_STRING;
      noticenos: PSTACK_OF_ASN1_INTEGER;
   End;
   PNOTICEREF = ^NOTICEREF;
   USERNOTICE = Record
      noticeref: PNOTICEREF;
      exptext: PASN1_STRING;
   End;
   PUSERNOTICE = ^USERNOTICE;
   POLICYQUALINFO_union = Record
      Case byte Of
         0: (cpsuri: PASN1_IA5STRING);
         1: (usernotice: PUSERNOTICE);
         2: (other: PASN1_TYPE);
   End;
   POLICYQUALINFO = Record
      pqualid: PASN1_OBJECT;
      d: POLICYQUALINFO_union;
   End;
   PPOLICYQUALINFO = ^POLICYQUALINFO;
   PSTACK_OF_POLICYINFO = PSTACK;
   POLICYINFO = Record
      policyid: PASN1_OBJECT;
      qualifiers: PSTACK_OF_POLICYQUALINFO;
   End;
   CERTIFICATEPOLICIES = PSTACK_OF_POLICYINFO;
   POLICY_MAPPING = Record
      issuerDomainPolicy: PASN1_OBJECT;
      subjectDomainPolicy: PASN1_OBJECT;
   End;
   PPOLICY_MAPPING = ^POLICY_MAPPING;
   PSTACK_OF_POLICY_MAPPING = PSTACK;
   PPSTACK_OF_POLICY_MAPPING = ^PSTACK_OF_POLICY_MAPPING;
   GENERAL_SUBTREE = Record
      base: PGENERAL_NAME;
      minimum: PASN1_INTEGER;
      maximum: PASN1_INTEGER;
   End;
   PGENERAL_SUBTREE = ^GENERAL_SUBTREE;
   PSTACK_OF_GENERAL_SUBTREE = PSTACK;
   NAME_CONSTRAINTS = Record
      permittedSubtrees: PSTACK_OF_GENERAL_SUBTREE;
      excludedSubtrees: PSTACK_OF_GENERAL_SUBTREE;
   End;
   PNAME_CONSTRAINTS = ^NAME_CONSTRAINTS;
   POLICY_CONSTRAINTS = Record
      requireExplicitPolicy: PASN1_INTEGER;
      inhibitPolicyMapping: ASN1_INTEGER;
   End;
   PPOLICY_CONSTRAINTS = ^POLICY_CONSTRAINTS;
   PROXY_POLICY = Record
      policyLanguage: PASN1_OBJECT;
      policy: ASN1_OCTET_STRING;
   End;
   PPROXY_POLICY = ^PROXY_POLICY;
   PROXY_CERT_INFO_EXTENSION = Record
      pcPathLengthConstraint: PASN1_INTEGER;
      proxyPolicy: PPROXY_POLICY;
   End;
   ISSUING_DIST_POINT = Record
      distpoint: PDIST_POINT_NAME;
      onlyuser: cInt;
      onlyCA: cInt;
      onlysomereasons: PASN1_BIT_STRING;
      indirectCRL: cInt;
      onlyattr: cInt;
   End;
   PSTACK_OF_CMS_SignerInfo = PSTACK;
   PSTACK_OF_GENERAL_NAMES = PSTACK;
   PISSUING_DIST_POINT = ^ISSUING_DIST_POINT;
   PPROXY_CERT_INFO_EXTENSION = ^PROXY_CERT_INFO_EXTENSION;
   PX509_PURPOSE = ^X509_PURPOSE;
   X509_PURPOSE_check_purpose = Function(Const _para1: Px509_purpose; Const _para2: PX509;
      para3: cInt): cInt; cdecl;
   X509_PURPOSE = Record
      purpose: cInt;
      trust: cInt;
      flags: cInt;
      check_purpose: X509_PURPOSE_check_purpose;
      name: PAnsiChar;
      sname: PAnsiChar;
      usr_data: Pointer;
   End;
   PSTACK_OF_X509_PURPOSE = PSTACK;
   ASRange = Record
      min, max: PASN1_INTEGER;
   End;
   PASRange = ^ASRange;
   ASIdOrRange_union = Record
      Case byte Of
         ASIdOrRange_id: (id: PASN1_INTEGER);
         ASIdOrRange_range: (range: PASRange);
   End;
   ASIdOrRange = Record
      _type: cInt;
      u: ASIdOrRange_union;
   End;
   PASIdOrRange = ^ASIdOrRange;
   PSTACK_OF_ASIdOrRange = PSTACK;
   PASIdOrRanges = PSTACK_OF_ASIdOrRange;
   ASIdentifierChoice_union = Record
      Case byte Of
         ASIdentifierChoice_inherit: (inherit: PASN1_NULL);
         ASIdentifierChoice_asIdsOrRanges: (asIdsOrRanges: PASIdOrRanges);
   End;
   ASIdentifierChoice = Record
      _type: cInt;
      u: ASIdentifierChoice_union;
   End;
   PASIdentifierChoice = ^ASIdentifierChoice;
   ASIdentifiers = Record
      asnum: PASIdentifierChoice;
      rdi: PASIdentifierChoice;
   End;
   PASIdentifiers = ^ASIdentifiers;
   IPAddressRange = Record
      min, max: PASN1_BIT_STRING;
   End;
   PIPAddressRange = ^IPAddressRange;
   IPAddressOrRange_union = Record
      Case byte Of
         IPAddressOrRange_addressPrefix: (addressPrefix: PASN1_BIT_STRING);
         IPAddressOrRange_addressRange: (addressRange: PIPAddressRange);
   End;
   IPAddressOrRange = Record
      _type: cInt;
      u: IPAddressOrRange_union;
   End;
   PIPAddressOrRange = ^IPAddressOrRange;
   PSTACK_OF_IPAddressOrRange = PSTACK;
   PIPAddressOrRanges = PSTACK_OF_IPAddressOrRange;
   IPAddressChoice_union = Record
      Case byte Of
         IPAddressChoice_inherit: (inherit: PASN1_NULL);
         IPAddressChoice_addressesOrRanges: (addressesOrRanges: PIPAddressOrRanges);
   End;
   IPAddressChoice = Record
      _type: cInt;
      u: IPAddressChoice_union;
   End;
   PIPAddressChoice = ^IPAddressChoice;
   IPAddressFamily = Record
      addressFamily: PASN1_OCTET_STRING;
      ipAddressChoice: PIPAddressChoice;
   End;
   PIPAddressFamily = ^IPAddressFamily;
   PSTACK_OF_IPAddressFamily = PSTACK;
   PIPAddrBlocks = PSTACK_OF_IPAddressFamily;
   X509_HASH_DIR_CTX = Record
      num_dirs: cInt;
      dirs: PPAnsiChar;
      dirs_type: pcInt;
      num_dirs_alloced: cInt;
   End;
   PX509_HASH_DIR_CTX = ^X509_HASH_DIR_CTX;
   X509_CERT_FILE_CTX = Record
      num_paths: cInt;
      num_alloced: cInt;
      paths: PPAnsiChar;
      path_type: cInt;
   End;
   PX509_CERT_FILE_CTX = ^X509_CERT_FILE_CTX;
   x509_object_union = Record
      Case byte Of
         0: (ptr: PAnsiChar);
         1: (_x509: Px509);
         2: (crl: PX509_CRL);
         3: (pkey: PEVP_PKEY);
   End;
   X509_OBJECT = Record
      _type: cInt;
      data: x509_object_union;
   End;
   PX509_OBJECT = ^X509_OBJECT;
   PPX509_OBJECT = ^PX509_OBJECT;
   PSTACK_OF_X509_OBJECT = PSTACK;
   X509_ALGOR = Record
      algorithm: PASN1_OBJECT;
      parameter: PASN1_TYPE;
   End;
   PX509_ALGOR = ^X509_ALGOR;
   PPX509_ALGOR = ^PX509_ALGOR;
   PSTACK_OF_X509_ALGOR = PSTACK;
   PPSTACK_OF_X509_ALGOR = ^PSTACK_OF_X509_ALGOR;
   X509_VAL = Record
      notBefore: PASN1_TIME;
      notAfter: PASN1_TIME;
   End;
   PX509_VAL = ^X509_VAL;
   PPX509_VAL = ^PX509_VAL;
   X509_PUBKEY = Record
      algor: PX509_ALGOR;
      public_key: PASN1_BIT_STRING;
      pkey: PEVP_PKEY;
   End;
   PX509_PUBKEY = ^X509_PUBKEY;
   PPX509_PUBKEY = ^PX509_PUBKEY;
   X509_SIG = Record
      algor: PX509_ALGOR;
      digest: PASN1_OCTET_STRING;
   End;
   PX509_SIG = X509_SIG;
   PPX509_SIG = ^PX509_SIG;
   X509_NAME_ENTRY = Record
      _object: PASN1_OBJECT;
      value: PASN1_STRING;
      _set: cInt;
      size: cInt;
   End;
   X509_NAME = Record
      entries: PSTACK_OF_X509_NAME_ENTRY;
      modified: cInt;
      bytes: PBUF_MEM;
      canon_enc: PAnsiChar;
      canon_enclen: cInt;
   End;
   X509_EXTENSION = Record
      _object: PASN1_OBJECT;
      critical: ASN1_BOOLEAN;
      value: PASN1_OCTET_STRING;
   End;
   PX509_EXTENSION = ^X509_EXTENSION;
   PPX509_EXTENSION = ^PX509_EXTENSION;
   PSTACK_OF_X509_EXTENSION = PSTACK;
   PPSTACK_OF_X509_EXTENSION = ^PSTACK_OF_X509_EXTENSION;
   PX509_EXTENSIONS = PPSTACK_OF_X509_EXTENSION;
   x509_attributes_union = Record
      Case Byte Of
         $FF: (Ptr: PAnsiChar);
         0: (_set: PSTACK_OF_ASN1_TYPE);
         1: (_single: PASN1_TYPE);
   End;
   X509_ATTRIBUTE = Record
      _object: PASN1_OBJECT;
      single: cInt;
      value: x509_attributes_union;
   End;
   PX509_ATTRIBUTE = ^X509_ATTRIBUTE;
   PPX509_ATTRIBUTE = ^PX509_ATTRIBUTE;
   X509_REQ_INFO = Record
      enc: ASN1_ENCODING;
      version: PASN1_INTEGER;
      subject: PX509_NAME;
      pubkey: PX509_PUBKEY;
      attributes: PSTACK_OF_X509_ATTRIBUTE;
   End;
   X509_REQ = Record
      req_info: PX509_REQ_INFO;
      sig_alg: PX509_ALGOR;
      signature: PASN1_BIT_STRING;
      references: cInt;
   End;
   PPX509_REQ = ^PX509_REQ;
   PX509_CINF = ^X509_CINF;
   X509_CINF = Record
      version: PASN1_INTEGER;
      serialNumber: PASN1_INTEGER;
      signature: PX509_ALGOR;
      issuer: PX509_NAME;
      validity: PX509_VAL;
      subject: PX509_NAME;
      key: PX509_PUBKEY;
      issuerUID: PASN1_BIT_STRING;
      subjectUID: PASN1_BIT_STRING;
      extensions: PSTACK_OF_X509_EXTENSION;
      enc: ASN1_ENCODING;
   End;
   X509_CERT_AUX = Record
      trust: PSTACK_OF_ASN1_OBJECT;
      reject: PSTACK_OF_ASN1_OBJECT;
      alias: PASN1_UTF8STRING;
      keyid: PASN1_OCTET_STRING;
      other: PSTACK_OF_X509_ALGOR;
   End;
   PX509_CERT_AUX = ^X509_CERT_AUX;
   X509 = Record
      cert_info: PX509_CINF;
      sig_alg: PX509_ALGOR;
      signature: PASN1_BIT_STRING;
      valid: cInt;
      references: cInt;
      name: PAnsiChar;
      ex_data: CRYPTO_EX_DATA;
      ex_pathlen: cLong;
      ex_pcpathlen: cLong;
      ex_flags: cuLong;
      ex_kusage: cuLong;
      ex_xkusage: cuLong;
      ex_nscert: cuLong;
      skid: PASN1_OCTET_STRING;
      akid: PAUTHORITY_KEYID;
      policy_cache: PX509_POLICY_CACHE;
      crldp: PSTACK_OF_DIST_POINT;
      altname: PSTACK_OF_GENERAL_NAME;
      nc: PNAME_CONSTRAINTS;
      rfc3779_addr: PSTACK_OF_IPAddressFamily;
      rfc3779_asid: PASIdentifiers;
      sha1_hash: Array[0..SHA_DIGEST_LENGTH - 1] Of AnsiChar;
      aux: PX509_CERT_AUX;
   End;
   X509_CRL_INFO = Record
      version: PASN1_INTEGER;
      sig_alg: PX509_ALGOR;
      issuer: PX509_NAME;
      lastUpdate: PASN1_TIME;
      nextUpdate: PASN1_TIME;
      revoked: PSTACK_OF_X509_REVOKED;
      extensions: PSTACK_OF_X509_EXTENSION;
      enc: ASN1_ENCODING;
   End;
   PX509_CRL_INFO = ^X509_CRL_INFO;
   PPX509_CRL_INFO = ^PX509_CRL_INFO;
   PSTACK_OF_X509_CRL_INFO = PSTACK;
   PX509_LOOKUP = ^X509_LOOKUP;
   PSTACK_OF_X509_LOOKUP = PSTACK;
   PSTACK_OF_X509_CRL = PSTACK;
   PX509_VERIFY_PARAM = ^X509_VERIFY_PARAM;
   PX509_STORE_CTX = ^X509_STORE_CTX;
   PPX509_CRL = ^PX509_CRL;
   X509_STORE = Record
      cache: cInt;
      objs: PSTACK_OF_X509_OBJECT;
      get_cert_methods: PSTACK_OF_X509_LOOKUP;
      param: PX509_VERIFY_PARAM;
      verify: Function(ctx: PX509_STORE_CTX): cInt; cdecl;
      verify_cb: Function(ok: cInt; ctx: PX509_STORE_CTX): cInt; cdecl;
      get_issuer: Function(issuer: PPX509; ctx: PX509_STORE_CTX; x: PX509): cInt; cdecl;
      check_issued: Function(ctx: PX509_STORE_CTX; x: PX509; issuer: PX509): cInt; cdecl;
      check_revocation: Function(ctx: PX509_STORE_CTX): cInt; cdecl;
      get_crl: Function(ctx: PX509_STORE_CTX; crl: PPX509_CRL; x: PX509): cInt; cdecl;
      check_crl: Function(ctx: PX509_STORE_CTX; crl: PX509_CRL): cInt; cdecl;
      cert_crl: Function(ctx: PX509_STORE_CTX; crl: PX509_CRL; x: PX509): cInt; cdecl;
      lookup_certs: Function(ctx: PX509_STORE_CTX; nm: PX509_NAME): PSTACK_OF_X509 Cdecl;
      lookup_crls: Function(ctx: PX509_STORE_CTX; nm: PX509_NAME): PSTACK_OF_X509_CRL Cdecl;
      cleanup: Function(ctx: PX509_STORE_CTX): cInt; cdecl;
      ex_data: CRYPTO_EX_DATA;
      references: cInt;
   End;
   PX509_STORE = ^X509_STORE;
   PX509_CRL_METHOD = Pointer;
   X509_CRL = Record
      crl: PX509_CRL_INFO;
      sig_alg: PX509_ALGOR;
      signature: PASN1_BIT_STRING;
      references: cInt;
      flags: cInt;
      akid: PAUTHORITY_KEYID;
      idp: PISSUING_DIST_POINT;
      idp_flags: cInt;
      idp_reasons: cInt;
      crl_number: PASN1_INTEGER;
      base_crl_number: PASN1_INTEGER;
      sha1_hash: Array[0..(SHA_DIGEST_LENGTH - 1)] Of byte;
      issuers: PSTACK_OF_GENERAL_NAMES;
      meth: PX509_CRL_METHOD;
      meth_data: Pointer;
   End;
   X509_LOOKUP_METHOD = Record
      name: PAnsiChar;
      new_item: Function(ctx: PX509_LOOKUP): cInt; cdecl;
      free: Procedure(ctx: PX509_LOOKUP); cdecl;
      init: Function(ctx: PX509_LOOKUP): cInt; cdecl;
      shutdown: Function(ctx: PX509_LOOKUP): cInt; cdecl;
      ctrl: Function(ctx: PX509_LOOKUP; cmd: cInt; Const argc: PAnsiChar; argl: cLong; Out ret: PAnsiChar): cInt; cdecl;
      get_by_subject: Function(ctx: PX509_LOOKUP; _type: cInt; name: PX509_NAME; ret: PX509_OBJECT): cInt; cdecl;
      get_by_issuer_serial: Function(ctx: PX509_LOOKUP; _type: cInt; name: PX509_NAME; serial: PASN1_INTEGER; ret: PX509_OBJECT): cInt; cdecl;
      get_by_fingerprint: Function(ctx: PX509_LOOKUP; _type: cInt; bytes: PAnsiChar; len: cInt; ret: PX509_OBJECT): cInt; cdecl;
      get_by_alias: Function(ctx: PX509_LOOKUP; _type: cInt; str: PAnsiChar; ret: PX509_OBJECT): cInt; cdecl;
   End;
   PX509_LOOKUP_METHOD = ^X509_LOOKUP_METHOD;
   PPX509_LOOKUP_METHOD = ^PX509_LOOKUP_METHOD;
   X509_VERIFY_PARAM = Record
      name: PAnsiChar;
      check_time: time_t;
      inh_flags: cuLong;
      flags: cuLong;
      purpose: cInt;
      trust: cInt;
      depth: cInt;
      policies: PSTACK_OF_ASN1_OBJECT;
   End;
   PSTACK_OF_X509_VERIFY_PARAM = PSTACK;
   X509_LOOKUP = Record
      init: cInt;
      skip: cInt;
      method: PX509_LOOKUP_METHOD;
      method_data: PAnsiChar;
      store_ctx: PX509_STORE;
   End;
   PX509_POLICY_TREE = Pointer;
   PPSTACK_OF_X509_LOOKUP = ^PSTACK_OF_X509_LOOKUP;
   X509_STORE_CTX = Record
      ctx: PX509_STORE;
      current_method: cInt;
      cert: PX509;
      untrusted: PSTACK_OF_X509;
      crls: PSTACK_OF_X509_CRL;
      param: PX509_VERIFY_PARAM;
      other_ctx: Pointer;
      verify: Function(ctx: PX509_STORE_CTX): cInt; cdecl;
      verify_cb: Function(ok: cInt; ctx: PX509_STORE_CTX): cInt; cdecl;
      get_issuer: Function(Var issuer: PX509; ctx: PX509_STORE_CTX; x: PX509): cInt; cdecl;
      check_issued: Function(ctx: PX509_STORE_CTX; x, issuer: PX509): cInt; cdecl;
      check_revocation: Function(ctx: PX509_STORE_CTX): cInt; cdecl;
      get_crl: Function(ctx: PX509_STORE_CTX; Var crl: X509_CRL; x: PX509): cInt; cdecl;
      check_crl: Function(ctx: PX509_STORE_CTX; Var crl: X509_CRL): cInt; cdecl;
      cert_crl: Function(ctx: PX509_STORE_CTX; crl: PX509_CRL; x: PX509): cInt; cdecl;
      check_policy: Function(ctx: PX509_STORE_CTX): cInt; cdecl;
      cleanup: Function(ctx: PX509_STORE_CTX): cInt; cdecl;
      valid: cInt;
      last_untrusted: cInt;
      chain: PSTACK_OF_X509;
      tree: PX509_POLICY_TREE;
      explicit_policy: cInt;
      error_depth: cInt;
      error: cInt;
      current_cert: PX509;
      current_issuer: PX509;
      current_crl: PX509_CRL;
      current_crl_score: cInt;
      current_reasons: cUInt;
      parent: PX509_STORE_CTX;
      ex_data: CRYPTO_EX_DATA;
   End;
   PX509_EXTENSION_METHOD = Pointer;
   PX509_TRUST = ^X509_TRUST;
   X509_TRUST_check_trust = Function(_para1: PX509_TRUST; para2: PX509; _para3: cInt): cInt; cdecl;
   X509_TRUST = Record
      trust: cInt;
      flags: cInt;
      check_trust: X509_TRUST_check_trust;
      name: PAnsiChar;
      arg1: cInt;
      arg2: Pointer;
   End;
   PPX509_TRUST = ^PX509_TRUST;
   PSTACK_OF_509_TRUST = PSTACK;
   X509_REVOKED = Record
      serialNumber: PASN1_INTEGER;
      revocationDate: PASN1_TIME;
      extensions: PSTACK_OF_X509_EXTENSION;
      issuer: PSTACK_OF_GENERAL_NAME;
      reason: cInt;
      sequence: cInt;
   End;
   PX509_REVOKED = ^X509_REVOKED;
   PPX509_REVOKED = ^PX509_REVOKED;
   PX509_PKEY = Pointer;
   PPX509_PKEY = ^PX509_PKEY;
   X509_INFO = Record
      x509: PX509;
      crl: PX509_CRL;
      x_pkey: PX509_PKEY;
      enc_cipher: EVP_CIPHER_INFO;
      enc_len: cInt;
      enc_data: PAnsiChar;
      references: cInt;
   End;
   PX509_INFO = ^X509_INFO;
   PPX509_INFO = ^PX509_INFO;
   PSTACK_OF_X509_INFO = PSTACK;
   NETSCAPE_SPKAC = Record
      pubkey: PX509_PUBKEY;
      challenge: PASN1_IA5STRING;
   End;
   PNETSCAPE_SPKAC = ^NETSCAPE_SPKAC;
   PPNETSCAPE_SPKAC = ^PNETSCAPE_SPKAC;
   NETSCAPE_SPKI = Record
      spkac: PNETSCAPE_SPKAC;
      sig_algor: PX509_ALGOR;
      signature: PASN1_BIT_STRING;
   End;
   PNETSCAPE_SPKI = ^NETSCAPE_SPKI;
   PPNETSCAPE_SPKI = ^PNETSCAPE_SPKI;
   NETSCAPE_CERT_SEQUENCE = Record
      _type: PASN1_OBJECT;
      certs: PSTACK_OF_X509;
   End;
   PNETSCAPE_CERT_SEQUENCE = ^NETSCAPE_CERT_SEQUENCE;
   PPNETSCAPE_CERT_SEQUENCE = ^PNETSCAPE_CERT_SEQUENCE;
   PBEPARAM = Record
      salt: PASN1_OCTET_STRING;
      iter: PASN1_INTEGER;
   End;
   PPBEPARAM = ^PBEPARAM;
   PPPBEPARAM = ^PPBEPARAM;
   PBE2PARAM = Record
      keyfunc: PX509_ALGOR;
      encryption: PX509_ALGOR;
   End;
   PPBE2PARAM = ^PBE2PARAM;
   PBKDF2PARAM = Record
      salt: PASN1_TYPE;
      iter: PASN1_INTEGER;
      keylength: PASN1_INTEGER;
      prf: PX509_ALGOR;
   End;
   PPBKDF2PARAM = ^PBKDF2PARAM;
   PPPBKDF2PARAM = ^PPBKDF2PARAM;
   PKCS8_PRIV_KEY_INFO = Record
      broken: cInt;
      version: PASN1_INTEGER;
      pkeyalg: PX509_ALGOR;
      pkey: PASN1_TYPE;
      attributes: PSTACK_OF_X509_ATTRIBUTE;
   End;
   PPKCS8_PRIV_KEY_INFO = ^PKCS8_PRIV_KEY_INFO;
   PPPKCS8_PRIV_KEY_INFO = ^PPKCS8_PRIV_KEY_INFO;
   PPKCS7_RECIP_INFO = ^PKCS7_RECIP_INFO;
   PSHA_CTX = ^SHA_CTX;
   RIPEMD160_LONG = cUInt;
   RIPEMD160_CTX = Record
      A, B, C, D, E: RIPEMD160_LONG;
      Nl, Nh: RIPEMD160_LONG;
      data: Array[0..RIPEMD160_LBLOCK - 1] Of RIPEMD160_LONG;
      num: cUInt;
   End;
   PRIPEMD160_CTX = ^RIPEMD160_CTX;
   RC4_KEY = Record
      x, y: RC4_INT;
      data: Array[0..(256 - 1)] Of RC4_INT;
   End;
   PRC4_KEY = ^RC4_KEY;
   RC2_KEY = Record
      data: Array[0..(64 - 1)] Of RC2_INT;
   End;
   PRC2_KEY = ^RC2_KEY;
   RC5_32_INT = cUInt;
   RC5_32_KEY = Record
      rounds: cInt;
      data: Array[0..(2 * (RC5_16_ROUNDS + 1) - 1)] Of RC5_32_INT;
   End;
   PRC5_32_KEY = ^RC5_32_KEY;
   BF_LONG = cUInt;
   BF_KEY = Record
      P: Array[0..(BF_ROUNDS + 2) - 1] Of BF_LONG;
      S: Array[0..(4 * 256) - 1] Of BF_LONG;
   End;
   PBF_KEY = ^BF_KEY;
   CAST_LONG = cuLong;
   CAST_KEY = Record
      data: Array[0..(32 - 1)] Of CAST_LONG;
      short_key: cInt;
   End;
   PCAST_KEY = ^CAST_KEY;
   IDEA_KEY_SCHEDULE = Record
      data: Array[0..(9 - 1), 0..(6 - 1)] Of IDEA_INT;
   End;
   PIDEA_KEY_SCHEDULE = ^IDEA_KEY_SCHEDULE;
   OCSP_CERTID = Record
      hashAlgorithm: PX509_ALGOR;
      issuerNameHash: PASN1_OCTET_STRING;
      issuerKeyHash: PASN1_OCTET_STRING;
      serialNumber: PASN1_INTEGER;
   End;
   POCSP_CERTID = ^OCSP_CERTID;
   PPOCSP_CERTID = ^POCSP_CERTID;
   PSTACK_OF_OCSP_CERTID = PSTACK;
   OCSP_ONEREQ = Record
      reqCert: POCSP_CERTID;
      singleRequestExtensions: PSTACK_OF_X509_EXTENSION;
   End;
   POCSP_ONEREQ = ^OCSP_ONEREQ;
   PPOCSP_ONEREQ = ^POCSP_ONEREQ;
   PSTACK_OF_OCSP_ONEREQ = PSTACK;
   OCSP_REQINFO = Record
      version: PASN1_INTEGER;
      requestorName: PGENERAL_NAME;
      requestList: PSTACK_OF_OCSP_ONEREQ;
      requestExtensions: PSTACK_OF_X509_EXTENSION;
   End;
   POCSP_REQINFO = ^OCSP_REQINFO;
   PPOCSP_REQINFO = ^POCSP_REQINFO;
   OCSP_SIGNATURE = Record
      signatureAlgorithm: PX509_ALGOR;
      signature: PASN1_BIT_STRING;
      certs: PSTACK_OF_X509;
   End;
   POCSP_SIGNATURE = ^OCSP_SIGNATURE;
   PPOCSP_SIGNATURE = ^POCSP_SIGNATURE;
   OCSP_REQUEST = Record
      tbsRequest: POCSP_REQINFO;
      optionalSignature: POCSP_SIGNATURE;
   End;
   POCSP_REQUEST = ^OCSP_REQUEST;
   PPOCSP_REQUEST = ^POCSP_REQUEST;
   OCSP_RESPBYTES = Record
      responseType: PASN1_OBJECT;
      response: PASN1_OCTET_STRING;
   End;
   POCSP_RESPBYTES = ^OCSP_RESPBYTES;
   PPOCSP_RESPBYTES = ^POCSP_RESPBYTES;
   OCSP_RESPONSE = Record
      responseStatus: PASN1_ENUMERATED;
      responseBytes: POCSP_RESPBYTES;
   End;
   POCSP_RESPONSE = ^OCSP_RESPONSE;
   PPOCSP_RESPONSE = ^POCSP_RESPONSE;
   OCSP_RESPID_union = Record
      Case Integer Of
         0: (byName: PX509_NAME);
         1: (byKey: PASN1_OCTET_STRING);
   End;
   OCSP_RESPID = Record
      _type: cInt;
      value: OCSP_RESPID_union;
   End;
   POCSP_RESPID = ^OCSP_RESPID;
   PPOCSP_RESPID = ^POCSP_RESPID;
   PSTACK_OF_OCSP_RESPID = PSTACK;
   OCSP_REVOKEDINFO = Record
      revocationTime: PASN1_GENERALIZEDTIME;
      revocationReason: PASN1_ENUMERATED;
   End;
   POCSP_REVOKEDINFO = ^OCSP_REVOKEDINFO;
   PPOCSP_REVOKEDINFO = ^POCSP_REVOKEDINFO;
   OCSP_CERTSTATUS_union = Record
      Case Integer Of
         0: (good: PASN1_NULL);
         1: (revoked: POCSP_REVOKEDINFO);
         2: (unknown: PASN1_NULL);
   End;
   OCSP_CERTSTATUS = Record
      _type: cInt;
      value: OCSP_CERTSTATUS_union;
   End;
   POCSP_CERTSTATUS = ^OCSP_CERTSTATUS;
   PPOCSP_CERTSTATUS = ^POCSP_CERTSTATUS;
   OCSP_SINGLERESP = Record
      certId: POCSP_CERTID;
      certStatus: POCSP_CERTSTATUS;
      thisUpdate: PASN1_GENERALIZEDTIME;
      nextUpdate: PASN1_GENERALIZEDTIME;
      singleExtensions: PSTACK_OF_X509_EXTENSION;
   End;
   POCSP_SINGLERESP = ^OCSP_SINGLERESP;
   PPOCSP_SINGLERESP = ^POCSP_SINGLERESP;
   PSTACK_OF_OCSP_SINGLERESP = PSTACK;
   OCSP_RESPDATA = Record
      version: PASN1_INTEGER;
      responderId: POCSP_RESPID;
      producedAt: PASN1_GENERALIZEDTIME;
      responses: PSTACK_OF_OCSP_SINGLERESP;
      responseExtensions: PSTACK_OF_X509_EXTENSION;
   End;
   POCSP_RESPDATA = ^OCSP_RESPDATA;
   PPOCSP_RESPDATA = ^POCSP_RESPDATA;
   OCSP_BASICRESP = Record
      tbsResponseData: POCSP_RESPDATA;
      signatureAlgorithm: PX509_ALGOR;
      signature: PASN1_BIT_STRING;
      certs: PSTACK_OF_X509;
   End;
   POCSP_BASICRESP = ^OCSP_BASICRESP;
   PPOCSP_BASICRESP = ^POCSP_BASICRESP;
   OCSP_CRLID = Record
      crlUrl: PASN1_IA5STRING;
      crlNum: PASN1_INTEGER;
      crlTime: PASN1_GENERALIZEDTIME;
   End;
   POCSP_CRLID = ^OCSP_CRLID;
   PPOCSP_CRLID = ^POCSP_CRLID;
   OCSP_SERVICELOC = Record
      issuer: PX509_NAME;
      locator: PSTACK_OF_ACCESS_DESCRIPTION;
   End;
   POCSP_SERVICELOC = ^OCSP_SERVICELOC;
   PPOCSP_SERVICELOC = ^POCSP_SERVICELOC;
   PMDC2_CTX = Pointer;
   PMS_TM = Pointer;
   PPMS_TM = ^PMS_TM;
   ppem_password_cb = Function(buf: PAnsiChar; size: cInt; rwflag: cInt; userdata: Pointer): cInt; cdecl;
   PEM_ENCODE_SEAL_CTX = Record
      encode: EVP_ENCODE_CTX;
      md: EVP_MD_CTX;
      cipher: EVP_CIPHER_CTX;
   End;
   PPEM_ENCODE_SEAL_CTX = ^PEM_ENCODE_SEAL_CTX;
   PSTACK_OF_SSL_COMP = PSTACK;
   PPSTACK_OF_SSL_COMP = ^PSTACK_OF_SSL_COMP;
   PSSL_COMP = ^SSL_COMP;
   lhash_of_SSL_SESSION = Record
      dummy: cInt;
   End;
   Plhash_of_SSL_SESSION = ^lhash_of_SSL_SESSION;
   Phostent2 = Pointer;
   DES_cblock = Array[0..7] Of Byte;
   PDES_cblock = ^DES_cblock;
   const_DES_cblock = DES_cblock;
   Pconst_DES_cblock = ^const_DES_cblock;
   DES_LONG = cuLong;
   des_cblock_union = Record
      Case integer Of
         0: (cblock: des_cblock);
         1: (deslong: Array[0..1] Of DES_LONG);
   End;
   des_ks_struct = Record
      ks: des_cblock_union;
      weak_key: cInt;
   End;
   des_key_schedule = Array[0..15] Of des_ks_struct;
   des_cblocks = Array[0..7] Of byte;
   _ossl_old_des_cblock = Array[0..7] Of byte;
   P_ossl_old_des_cblock = ^_ossl_old_des_cblock;
   _ossl_old_des_ks_union = Record
      Case Integer Of
         0: (_: _ossl_old_des_cblock);
         2: (pad: Array[0..1] Of DES_LONG);
   End;
   _ossl_old_des_ks_struct = Record
      ks: _ossl_old_des_ks_union;
   End;
   _ossl_old_des_key_schedule = Array[0..15] Of _ossl_old_des_ks_struct;
   P_ossl_old_des_key_schedule = ^_ossl_old_des_key_schedule;
   _des_cblock = DES_cblock;
   _const_des_cblock = const_DES_cblock;
   _des_key_schedule = DES_key_schedule;
   TIdSslLockingCallback = Procedure(mode, n: cInt; Afile: PAnsiChar; line: cInt); cdecl;
   TIdSslIdCallback = Function: cuLong; cdecl;
   PSSL3_ENC_METHOD = pointer;
   PCERT = pointer;
   PPCERT = ^PCERT;
   PSESS_CERT = pointer;
   PPKCS7 = ^PKCS7;
   PPPKCS7 = ^PPKCS7;
   PKCS7_ISSUER_AND_SERIAL = Record
      issuer: PX509_NAME;
      serial: PASN1_INTEGER;
   End;
   PPKCS7_ISSUER_AND_SERIAL = ^PKCS7_ISSUER_AND_SERIAL;
   PKCS7_SIGNER_INFO = Record
      version: PASN1_INTEGER;
      issuer_and_serial: PPKCS7_ISSUER_AND_SERIAL;
      digest_alg: PX509_ALGOR;
      auth_attr: PSTACK_OF_X509_ATTRIBUTE;
      digest_enc_alg: PX509_ALGOR;
      enc_digest: PASN1_OCTET_STRING;
      unauth_attr: PSTACK_OF_X509_ATTRIBUTE;
      pkey: PEVP_PKEY;
   End;
   PPKCS7_SIGNER_INFO = ^PKCS7_SIGNER_INFO;
   PSTACK_OF_PKCS7_SIGNER_INFO = PSTACK;
   PKCS7_RECIP_INFO = Record
      version: PASN1_INTEGER;
      issuer_and_serial: PPKCS7_ISSUER_AND_SERIAL;
      key_enc_algor: PX509_ALGOR;
      enc_key: PASN1_OCTET_STRING;
      cert: PX509;
   End;
   PSTACK_OF_PKCS7_RECIP_INFO = PSTACK;
   PPSTACK_OF_PKCS7_RECIP_INFO = ^PSTACK_OF_PKCS7_RECIP_INFO;
   PKCS7_SIGNED = Record
      version: PASN1_INTEGER;
      md_algs: PSTACK_OF_X509_ALGOR;
      cert: PSTACK_OF_X509;
      crl: PSTACK_OF_X509_CRL;
      signer_info: PSTACK_OF_PKCS7_SIGNER_INFO;
      contents: PPKCS7;
   End;
   PPKCS7_SIGNED = ^PKCS7_SIGNED;
   PPPKCS7_SIGNED = ^PPKCS7_SIGNED;
   PKCS7_ENC_CONTENT = Record
      content_type: PASN1_OBJECT;
      algorithm: PX509_ALGOR;
      enc_data: PASN1_OCTET_STRING;
      cipher: PEVP_CIPHER;
   End;
   PPKCS7_ENC_CONTENT = ^PKCS7_ENC_CONTENT;
   PKCS7_ENVELOPE = Record
      version: PASN1_INTEGER;
      recipientinfo: PSTACK_OF_PKCS7_RECIP_INFO;
      enc_data: PPKCS7_ENC_CONTENT;
   End;
   PPKCS7_ENVELOPE = ^PKCS7_ENVELOPE;
   PKCS7_SIGN_ENVELOPE = Record
      version: PASN1_INTEGER;
      md_algs: PSTACK_OF_X509_ALGOR;
      cert: PSTACK_OF_X509;
      crl: PSTACK_OF_X509_CRL;
      signer_info: PSTACK_OF_PKCS7_SIGNER_INFO;
      enc_data: PPKCS7_ENC_CONTENT;
      recipientinfo: PSTACK_OF_PKCS7_RECIP_INFO;
   End;
   PPKCS7_SIGN_ENVELOPE = ^PKCS7_SIGN_ENVELOPE;
   PKCS7_DIGEST = Record
      version: PASN1_INTEGER;
      md: PX509_ALGOR;
      contents: PPKCS7;
      digest: PASN1_OCTET_STRING;
   End;
   PPKCS7_DIGEST = ^PKCS7_DIGEST;
   PKCS7_ENCRYPT = Record
      version: PASN1_INTEGER;
      enc_data: PPKCS7_ENC_CONTENT;
   End;
   PPKCS7_ENCRYPT = ^PKCS7_ENCRYPT;
   PKCS7_union = Record
      Case Integer Of
         0: (ptr: PAnsiChar);
         1: (data: PASN1_OCTET_STRING);
         2: (sign: PPKCS7_SIGNED);
         3: (enveloped: PPKCS7_ENVELOPE);
         4: (signed_and_enveloped: PPKCS7_SIGN_ENVELOPE);
         5: (digest: PPKCS7_DIGEST);
         6: (encrypted: PPKCS7_ENCRYPT);
   End;
   PKCS7 = Record
      asn1: PAnsiChar;
      length: cLong;
      state: cInt;
      detached: cInt;
      _type: PASN1_OBJECT;
      d: PKCS7_union;
   End;
   PSTACK_OF_PKCS7 = PSTACK;
   PKCS12_MAC_DATA = Record
      dinfo: PX509_SIG;
      salt: PASN1_OCTET_STRING;
      iter: PASN1_INTEGER;
   End;
   PPKCS12_MAC_DATA = ^PKCS12_MAC_DATA;
   PPKCS12 = ^PKCS12;
   PPPKCS12 = ^PPKCS12;
   PKCS12 = Record
      version: PASN1_INTEGER;
      mac: PPKCS12_MAC_DATA;
      authsafes: PPKCS7;
   End;

   PSTACK_OF_EVP_MD = PSTACK;
   PSTACK_OF_ASN1_UTF8STRING = PSTACK;
   TS_MSG_IMPRINT = Record
      hash_algo: PX509_ALGOR;
      hashed_msg: PASN1_OCTET_STRING;
   End;

   PTS_MSG_IMPRINT = ^TS_MSG_IMPRINT;
   TS_REQ = Record
      version: PASN1_INTEGER;
      msg_imprint: PTS_MSG_IMPRINT;
      policy_id: PASN1_OBJECT;
      nonce: PASN1_INTEGER;
      cert_req: ASN1_BOOLEAN;
      extensions: PSTACK_OF_X509_EXTENSION;
   End;

   PTS_REQ = ^TS_REQ;
   TS_ACCURACY = Record
      seconds: PASN1_INTEGER;
      millis: PASN1_INTEGER;
      micros: PASN1_INTEGER;
   End;

   PTS_ACCURACY = ^TS_ACCURACY;
   TS_TST_INFO = Record
      version: PASN1_INTEGER;
      policy_id: PASN1_OBJECT;
      msg_imprint: PTS_MSG_IMPRINT;
      serial: PASN1_INTEGER;
      time: PASN1_GENERALIZEDTIME;
      accuracy: PTS_ACCURACY;
      ordering: PASN1_BOOLEAN;
      nonce: PASN1_INTEGER;
      tsa: PGENERAL_NAME;
      extensions: PSTACK_OF_X509_EXTENSION;
   End;

   PTS_TST_INFO = ^TS_TST_INFO;
   TS_STATUS_INFO = Record
      status: PASN1_INTEGER;
      text: PSTACK_OF_ASN1_UTF8STRING;
      failure_info: PASN1_BIT_STRING;
   End;

   PTS_STATUS_INFO = ^TS_STATUS_INFO;
   TS_RESP = Record
      status_info: PTS_STATUS_INFO;
      token: PPKCS7;
      tst_info: PTS_TST_INFO;
   End;

   PTS_RESP = ^TS_RESP;
   ESS_ISSUER_SERIAL = Record
      issuer: PSTACK_OF_GENERAL_NAME;
      serial: PASN1_INTEGER;
   End;

   PESS_ISSUER_SERIAL = ^ESS_ISSUER_SERIAL;
   ESS_CERT_ID = Record
      hash: PASN1_OCTET_STRING;
      issuer_serial: PESS_ISSUER_SERIAL;
   End;

   PESS_CERT_ID = ^ESS_CERT_ID;
   PSTACK_OF_ESS_CERT_ID = PSTACK;
   ESS_SIGNING_CERT = Record
      cert_ids: PSTACK_OF_ESS_CERT_ID;
      policy_info: PSTACK_OF_POLICYINFO;
   End;

   PESS_SIGNING_CERT = ^ESS_SIGNING_CERT;
   PTS_resp_ctx = ^TS_resp_ctx;
   TS_serial_cb = Function(p1: PTS_resp_ctx; p2: Pointer): PASN1_INTEGER Cdecl;
   TS_time_cb = Function(p1: PTS_resp_ctx; p2: Pointer; sec, usec: cLong): cInt Cdecl;
   TS_extension_cb = Function(p1: PTS_resp_ctx; p2: PX509_EXTENSION; p3: Pointer): cInt Cdecl;

   TS_RESP_CTX = Record
      signer_cert: PX509;
      signer_key: PEVP_PKEY;
      certs: PSTACK_OF_X509;
      policies: PSTACK_OF_ASN1_OBJECT;
      default_policy: PASN1_OBJECT;
      mds: PSTACK_OF_EVP_MD;
      seconds: PASN1_INTEGER;
      millis: PASN1_INTEGER;
      micros: PASN1_INTEGER;
      clock_precision_digits: cunsigned;
      flags: cunsigned;
      serial_cb: TS_serial_cb;
      serial_cb_data: Pointer;
      time_cb: TS_time_cb;
      time_cb_data: Pointer;
      extension_cb: TS_extension_cb;
      extension_cb_data: Pointer;
      request: PTS_REQ;
      response: PTS_RESP;
      tst_info: PTS_TST_INFO;
   End;

   TS_VERIFY_CTX = Record
      flags: cunsigned;
      store: PX509_STORE;
      certs: PSTACK_OF_X509;
      policy: PASN1_OBJECT;
      md_alg: PX509_ALGOR;
      imprint: PAnsiChar;
      imprint_len: cunsigned;
      data: PBIO;
      nonce: PASN1_INTEGER;
      tsa_name: PGENERAL_NAME;
   End;

   PTS_VERIFY_CTX = ^TS_VERIFY_CTX;
   PCOMP_CTX = ^COMP_CTX;

   COMP_METHOD = Record
      _type: cInt;
      name: PAnsiChar;
      init: Function(ctx: PCOMP_CTX): cInt; cdecl;
      finish: Procedure(ctx: PCOMP_CTX); cdecl;
      compress: Function(ctx: PCOMP_CTX;
         _out: PAnsiChar; olen: cUInt;
         _in: PAnsiChar; ilen: cUInt): cInt; cdecl;
      expand: Function(ctx: PCOMP_CTX;
         _out: PAnsiChar; olen: cUInt;
         _in: PAnsiChar; ilen: cUInt): cInt; cdecl;
      ctrl: Function: cInt; cdecl;
      callback_ctrl: Function: cInt; cdecl;
   End;

   PCOMP_METHOD = ^COMP_METHOD;
   COMP_CTX = Record
      meth: PCOMP_METHOD;
      compress_in: cuLong;
      compress_out: cuLong;
      expand_in: cuLong;
      expand_out: cuLong;
      ex_data: PCRYPTO_EX_DATA;
   End;

   SRP_gN_cache = Record
      b64_bn: PAnsiChar;
      bn: PBIGNUM;
   End;

   PSRP_gN_cache = ^SRP_gN_cache;
   PSTACK_OF_SRP_gN_cache = PSTACK;
   SRP_user_pwd = Record
      id: PAnsiChar;
      s: PBIGNUM;
      v: PBIGNUM;
      g: PBIGNUM;
      N: PBIGNUM;
      info: PAnsiChar;
   End;

   PSRP_user_pwd = ^SRP_user_pwd;
   PSTACK_OF_SRP_user_pwd = PSTACK;
   SRP_VBASE = Record
      users_pwd: PSTACK_OF_SRP_user_pwd;
      gN_cache: PSTACK_OF_SRP_gN_cache;
      seed_key: PAnsiChar;
      default_g: PBIGNUM;
      default_N: PBIGNUM;
   End;

   PSRP_VBASE = ^SRP_VBASE;
   SRP_gN = Record
      id: PAnsiChar;
      g: PBIGNUM;
      N: PBIGNUM;
   End;
   PSRP_gN = ^SRP_gN;
   PSTACK_OF_SRP_gN = PSTACK;

   PSSL_CIPHER = ^SSL_CIPHER;
   SSL_CIPHER = Record
      valid: cInt;
      name: PAnsiChar;
      id: cuLong;
      algorithm_mkey: cuLong;
      algorithm_auth: cuLong;
      algorithm_enc: cuLong;
      algorithm_mac: cuLong;
      algorithm_ssl: cuLong;
      algo_strength: cuLong;
      algorithm2: cuLong;
      strength_bits: cInt;
      alg_bits: cInt;
   End;

   PSTACK_OF_SSL_CIPHER = PSTACK;

   PSSL_SESSION = ^SSL_SESSION;
   SSL_SESSION = Record
      ssl_version: cInt;
      key_arg_length: cUInt;
      key_arg: Array[0..SSL_MAX_KEY_ARG_LENGTH - 1] Of Byte;
      master_key_length: cInt;
      master_key: Array[0..SSL_MAX_MASTER_KEY_LENGTH - 1] Of Byte;
      session_id_length: cUInt;
      session_id: Array[0..SSL_MAX_SSL_SESSION_ID_LENGTH - 1] Of Byte;
      sid_ctx_length: cUInt;
      sid_ctx: Array[0..SSL_MAX_SID_CTX_LENGTH - 1] Of Byte;
      krb5_client_princ_len: cUInt;
      krb5_client_princ: Array[0..SSL_MAX_KRB5_PRINCIPAL_LENGTH - 1] Of Byte;
      psk_identity_hint: PAnsiChar;
      psk_identity: PAnsiChar;
      not_resumable: cInt;
      sess_cert: PSESS_CERT;
      peer: PX509;
      verify_result: cLong;
      references: cInt;
      timeout: cLong;
      time: cLong;
      compress_meth: cUInt;
      cipher: PSSL_CIPHER;
      cipher_id: cuLong;
      ciphers: PSTACK_OF_SSL_CIPHER;
      ex_data: CRYPTO_EX_DATA;
      prev, next: PSSL_SESSION;
      tlsext_hostname: PAnsiChar;
      tlsext_tick: PAnsiChar;
      tlsext_ticklen: size_t;
      tlsext_tick_lifetime_hint: cLong;
      srp_username: PAnsiChar;
   End;

   SRP_CTX = Record
      SRP_cb_arg: Pointer;
      TLS_ext_srp_username_callback: Function(para1: PSSL; para2: cInt; para3: Pointer): cInt Cdecl;
      SRP_verify_param_callback: Function(para1: PSSL; para2: Pointer): cInt Cdecl;
      SRP_give_srp_client_pwd_callback: Function(para1: PSSL; para2: Pointer): PAnsiChar Cdecl;
      login: PAnsiChar;
      N, g, s, B, A: PBIGNUM;
      _a, _b, v: PBIGNUM;
      info: PAnsiChar;
      strength: cInt;
      srp_Mask: cuLong;
   End;

   PSRP_CTX = ^SRP_CTX;
   PSSL_CTX = ^SSL_CTX;
   SRTP_PROTECTION_PROFILE = Record
      name: PAnsiChar;
      id: cuLong;
   End;

   PTLS_SESSION_TICKET_EXT = ^TLS_SESSION_TICKET_EXT;
   TLS_SESSION_TICKET_EXT = Record
      length: cuShort;
      data: Pointer;
   End;

   PSRTP_PROTECTION_PROFILE = ^SRTP_PROTECTION_PROFILE;
   tls_session_ticket_ext_cb_fn = Function(S: PSSL; data: PAnsiChar; len: cInt; arg: Pointer): cInt Cdecl;
   tls_session_secret_cb_fn = Function(S: PSSL; secret: Pointer; Var secret_len: cInt; peer_ciphers: PSTACK_OF_SSL_CIPHER;
                                        Out cipher: PSSL_CIPHER): cInt Cdecl;
   SSL_METHOD_PROC = Procedure; cdecl;
   PSSL_METHOD = ^SSL_METHOD;

   SSL_METHOD = Record
      version: cInt;
      ssl_new: Function(s: PSSL): cInt; cdecl;
      ssl_clear: Procedure(s: PSSL); cdecl;
      ssl_free: Procedure(s: PSSL); cdecl;
      ssl_accept: Function(s: PSSL): cInt; cdecl;
      ssl_connect: Function(s: PSSL): cInt; cdecl;
      ssl_read: Function(s: PSSL; buf: Pointer; len: cInt): cInt; cdecl;
      ssl_peek: Function(s: PSSL; buf: Pointer; len: cInt): cInt; cdecl;
      ssl_write: Function(s: PSSL; Const buf: Pointer; len: cInt): cInt; cdecl;
      ssl_shutdown: Function(s: PSSL): cInt; cdecl;
      ssl_renegotiate: Function(s: PSSL): cInt; cdecl;
      ssl_renegotiate_check: Function(s: PSSL): cInt; cdecl;
      ssl_get_message: Function(s: PSSL; st1, stn, mt: cInt; max: cLong; ok: pcInt): cLong; cdecl;
      ssl_read_bytes: Function(s: PSSL; _type: cInt; buf: PByte; len, peek: cInt): cInt; cdecl;
      ssl_write_bytes: Function(s: PSSL; _type: cInt; Const buf: Pointer; len: cInt): cInt; cdecl;
      ssl_dispatch_alert: Function(s: PSSL): cInt; cdecl;
      ssl_ctrl: Function(s: PSSL; cmd: cInt; larg: cLong; parg: Pointer): cLong; cdecl;
      ssl_ctx_ctrl: Function(ctx: PSSL_CTX; cmd: cInt; larg: cLong; parg: Pointer): cLong; cdecl;
      get_cipher_by_char: Function(Const ptr: PByte): PSSL_CIPHER; cdecl;
      put_cipher_by_char: Function(Const cipher: PSSL_CIPHER; ptr: PByte): cInt; cdecl;
      ssl_pending: Function(Const s: PSSL): cInt; cdecl;
      num_ciphers: Function: cInt; cdecl;
      get_cipher: Function(ncipher: cunsigned): PSSL_CIPHER; cdecl;
      get_ssl_method: Function(version: cInt): PSSL_METHOD; cdecl;
      get_timeout: Function: cLong; cdecl;
      ssl3_enc: PSSL3_ENC_METHOD;
      ssl_version: Function: cInt; cdecl;
      ssl_callback_ctrl: Function(s: PSSL; cb_id: cInt; fp: SSL_METHOD_PROC): cLong; cdecl;
      ssl_ctx_callback_ctrl: Function(s: PSSL_CTX; cb_id: cInt; fp: SSL_METHOD_PROC): cLong; cdecl;
   End;

   PPSSL_METHOD = ^PSSL_METHOD;
   PGEN_SESSION_CB = Function(Const SSL: PSSL; id: PByte; id_len: cUInt): cInt; cdecl;
   SSL_COMP = Record
      id: cInt;
      name: PAnsiChar;
      method: PCOMP_METHOD;
   End;

   PSTACK_OF_COMP = PSTACK;
   PSSL_CTEX_tlsext_servername_callback = Function(ssl: PSSL; Para1: cInt; Para2: Pointer): cInt; cdecl;
   PSSL_CTX_info_callback = Procedure(Const ssl: PSSL; _type, val: cInt); cdecl;
   Ptlsext_ticket_key_cb = Function(ssl: PSSL; name, iv: PAnsiChar;
      ectx: PEVP_CIPHER_CTX;
      hctx: PHMAC_CTX; enc: cInt): cInt; cdecl;
   Ptlsext_status_cb = Function(ssl: PSSL; arg: Pointer): cInt; cdecl;

   SSL_CTX_stats = Record
      sess_connect: cInt;
      sess_connect_renegotiate: cInt;
      sess_connect_good: cInt;
      sess_accept: cInt;
      sess_accept_renegotiate: cInt;
      sess_accept_good: cInt;
      sess_miss: cInt;
      sess_timeout: cInt;
      sess_cache_full: cInt;
      sess_hit: cInt;
      sess_cb_hit: cInt;
   End;

   lash_of_SSL_SESSION = Record
      dummy: cInt;
   End;

   Plash_of_SSL_SESSION = ^lash_of_SSL_SESSION;
   Pssl3_buf_freelist_st = Pointer;
   PSTACK_OF_SRTP_PROTECTION_PROFILE = PSTACK;

   SSL_CTX = Record
      method: PSSL_METHOD;
      cipher_list: PSTACK_OF_SSL_CIPHER;
      cipher_list_by_id: PSTACK_OF_SSL_CIPHER;
      cert_store: PX509_STORE;
      sessions: Plash_of_SSL_SESSION;
      session_cache_size: cuLong;
      session_cache_head: PSSL_SESSION;
      session_cache_tail: PSSL_SESSION;
      session_cache_mode: cInt;
      session_timeout: cLong;
      new_session_cb: Function(ssl: PSSL; sess: PSSL_SESSION): cInt; cdecl;
      remove_session_cb: Procedure(ctx: PSSL_CTX; sess: PSSL_SESSION); cdecl;
      get_session_cb: Function(ssl: PSSL; data: PByte; len: cInt; copy: pcInt): PSSL_SESSION; cdecl;
      stats: SSL_CTX_stats;
      references: cInt;
      app_verify_callback: Function(_para1: PX509_STORE_CTX; _para2: Pointer): cInt; cdecl;
      app_verify_arg: Pointer;
      default_passwd_callback: ppem_password_cb;
      default_passwd_callback_userdata: Pointer;
      client_cert_cb: Function(SSL: PSSL; x509: PPX509; pkey: PPEVP_PKEY): cInt; cdecl;
      app_gen_cookie_cb: Function(ssl: PSSL; cookie: PByte; cookie_len: cUInt): cInt; cdecl;
      app_verify_cookie_cb: Pointer;
      ex_data: CRYPTO_EX_DATA;
      rsa_md5: PEVP_MD;
      md5: PEVP_MD;
      sha1: PEVP_MD;
      extra_certs: PSTACK_OF_X509;
      comp_methods: PSTACK_OF_COMP;
      info_callback: PSSL_CTX_info_callback;
      client_CA: PSTACK_OF_X509_NAME;
      options: cuLong;
      mode: cuLong;
      max_cert_list: cLong;
      cert: PCERT;
      read_ahead: cInt;
      msg_callback: Procedure(write_p, version, content_type: cInt; Const buf: Pointer; len: size_t; ssl: PSSL; arg: Pointer); cdecl;
      msg_callback_arg: Pointer;
      verify_mode: cInt;
      sid_ctx_length: cUInt;
      sid_ctx: Array[0..SSL_MAX_SID_CTX_LENGTH - 1] Of AnsiChar;
      default_verify_callback: Function(ok: cInt; ctx: PX509_STORE_CTX): cInt; cdecl;
      generate_session_id: PGEN_SESSION_CB;
      param: PX509_VERIFY_PARAM;
      quiet_shutdown: cInt;
      max_send_fragment: cUInt;
      client_cert_engine: PENGINE;
      tlsext_servername_callback: PSSL_CTEX_tlsext_servername_callback;
      tlsext_servername_arg: Pointer;
      tlsext_tick_key_name: Array[0..(16 - 1)] Of AnsiChar;
      tlsext_tick_hmac_key: Array[0..(16 - 1)] Of AnsiChar;
      tlsext_tick_aes_key: Array[0..(16 - 1)] Of AnsiChar;
      tlsext_ticket_key_cb: Ptlsext_ticket_key_cb;
      tlsext_status_cb: Ptlsext_status_cb;
      tlsext_status_arg: Pointer;
      tlsext_opaque_prf_input_callback: Function(para1: PSSL; peerinput: Pointer; len: size_t; arg: Pointer): cInt Cdecl;
      tlsext_opaque_prf_input_callback_arg: Pointer;
      psk_identity_hint: PAnsiChar;
      psk_client_callback: Function(ssl: PSSL; hint: PAnsiChar;
         identity: PAnsiChar; max_identity_len: cUInt;
         psk: PAnsiChar; max_psk_len: cUInt): cUInt Cdecl;
      psk_server_callback: Function(ssl: PSSL; identity, psk: PAnsiChar; max_psk_len: cUInt): cUInt Cdecl;
      freelist_max_len: cUInt;
      wbuf_freelist: Pssl3_buf_freelist_st;
      rbuf_freelist: Pssl3_buf_freelist_st;
      srp_ctx: SRP_CTX;
      next_protos_advertised_cb: Function(s: PSSL; Out but: PAnsiChar; Out len: cUInt; arg: Pointer): cInt Cdecl;
      next_protos_advertised_cb_arg: Pointer;
      next_proto_select_cb: Function(s: PSSL; Out _out: PAnsiChar; outlen: PAnsiChar; _in: PAnsiChar; inlen: cUInt; arg: Pointer): cInt Cdecl;
      next_proto_select_cb_arg: Pointer;
      srtp_profiles: PSTACK_OF_SRTP_PROTECTION_PROFILE;
   End;

   PSSL2_STATE = ^SSL2_STATE;
   PSSL3_STATE = ^SSL3_STATE;
   PDTLS1_STATE = ^DTLS1_STATE;
   PSSL_tlsext_debug_cb = Procedure(s: PSSL; client_server: cInt; _type: cInt; data: PAnsiChar; len: cInt; arg: Pointer); cdecl;

   SSL = Record
      version: cInt;
      _type: cInt;
      method: PSSL_METHOD;
      rbio: PBIO;
      wbio: PBIO;
      bbio: PBIO;
      rwstate: cInt;
      in_handshake: cInt;
      handshake_func: Function(_para1: PSSL): cInt; cdecl;
      server: cInt;
      new_session: cInt;
      quiet_shutdown: cInt;
      shutdown: cInt;
      state: cInt;
      rstate: cInt;
      init_buf: PBUF_MEM;
      init_msg: Pointer;
      init_num: cInt;
      init_off: cInt;
      packet: PAnsiChar;
      packet_length: cUInt;
      s2: Pssl2_state;
      s3: Pssl3_state;
      d1: Pdtls1_state;
      read_ahead: cInt;
      msg_callback: Procedure(write_p, version, content_type: cInt; Const buf: Pointer; len: size_t; ssl: PSSL; arg: Pointer); cdecl;
      msg_callback_arg: Pointer;
      hit: cInt;
      param: PX509_VERIFY_PARAM;
      cipher_list: PSTACK_OF_SSL_CIPHER;
      cipher_list_by_id: PSTACK_OF_SSL_CIPHER;
      mac_flags: cInt;
      enc_read_ctx: PEVP_CIPHER_CTX;
      read_hash: PEVP_MD_CTX;
      expand: PCOMP_CTX;
      enc_write_ctx: PEVP_CIPHER_CTX;
      write_hash: PEVP_MD_CTX;
      compress: PCOMP_CTX;
      cert: PCERT;
      sid_ctx_length: cUInt;
      sid_ctx: Array[0..SSL_MAX_SID_CTX_LENGTH - 1] Of AnsiChar;
      session: PSSL_SESSION;
      generate_session_id: PGEN_SESSION_CB;
      verify_mode: cInt;
      verify_callback: Function(ok: cInt; ctx: PX509_STORE_CTX): cInt; cdecl;
      info_callback: Procedure(Const ssl: PSSL; _type, val: cInt); cdecl;
      error: cInt;
      error_code: cInt;
      psk_client_callback: Function(ssl: PSSL; hint: PAnsiChar;
      identity: PAnsiChar;
      max_identity_len: cUInt;
      psk: PAnsiChar;
      max_psk_len: cUInt): cUInt Cdecl;
      psk_server_callback: Function(ssl: PSSL; identity: PAnsiChar;
      psk: PAnsiChar; max_psk_len: cUInt): cUInt Cdecl;
      ctx: PSSL_CTX;
      debug: cInt;
      verify_result: cLong;
      ex_data: CRYPTO_EX_DATA;
      client_CA: PSTACK_OF_X509_NAME;
      references: cInt;
      options: cuLong;
      mode: cuLong;
      max_cert_list: cLong;
      first_packet: cInt;
      client_version: cInt;
      max_send_fragment: cUInt;
      tlsext_debug_cb: PSSL_tlsext_debug_cb;
      tlsext_debug_arg: Pointer;
      tlsext_hostname: PAnsiChar;
      servername_done: cInt;
      tlsext_status_type: cInt;
      tlsext_status_expected: cInt;
      tlsext_ecpointformatlist_length: size_t;
      tlsext_ecpointformatlist: PAnsiChar;
      tlsext_ellipticcurvelist_length: size_t;
      tlsext_ellipticcurvelist: PAnsiChar;
      tlsext_opaque_prf_input: Pointer;
      tlsext_opaque_prf_input_len: size_t;
      tlsext_session_ticket: PTLS_SESSION_TICKET_EXT;
      tls_session_ticket_ext_cb: tls_session_ticket_ext_cb_fn;
      tls_session_ticket_ext_cb_arg: Pointer;
      tls_session_secret_cb: tls_session_secret_cb_fn;
      tls_session_secret_cb_arg: Pointer;
      initial_ctx: PSSL_CTX;
      next_proto_negotiated: PAnsiChar;
      next_proto_negotiated_len: Byte;
      tlsext_ocsp_ids: PSTACK_OF_OCSP_RESPID;
      tlsext_ocsp_exts: PX509_EXTENSIONS;
      tlsext_ocsp_resp: PAnsiChar;
      tlsext_ocsp_resplen: cInt;
      tlsext_ticket_expected: cInt;
      _initial_ctx: PSSL_CTX;
   End;

   SSL2_STATE = Record
      three_byte_header: cInt;
      clear_text: cInt;
      escape: cInt;
      ssl2_rollback: cInt;
      wnum: cUInt;
      wpend_tot: cInt;
      wpend_buf: PByte;
      wpend_off: cInt;
      wpend_len: cInt;
      wpend_ret: cInt;
      rbuf_left: cInt;
      rbuf_offs: cInt;
      rbuf: PAnsiChar;
      wbuf: PAnsiChar;
      write_ptr: PAnsiChar;
      padding: cUInt;
      rlength: cUInt;
      ract_data_length: cInt;
      wlength: cUInt;
      wact_data_length: cInt;
      ract_data: PAnsiChar;
      wact_data: PAnsiChar;
      mac_data: PAnsiChar;
      read_key: PAnsiChar;
      write_key: PAnsiChar;
      challenge_length: cUInt;
      challenge: Array[0..SSL2_MAX_CHALLENGE_LENGTH - 1] Of AnsiChar;
      conn_id_length: cUInt;
      conn_id: Array[0..SSL2_MAX_CONNECTION_ID_LENGTH - 1] Of AnsiChar;
      key_material_length: cUInt;
      key_material: Array[0..(SSL2_MAX_KEY_MATERIAL_LENGTH * 2) - 1] Of AnsiChar;
      read_sequence: cuLong;
      write_sequence: cuLong;
      tmp_conn_id_length: cUInt;
      tmp_cert_type: cUInt;
      tmp_cert_length: cUInt;
      tmp_csl: cUInt;
      tmp_clear: cUInt;
      tmp_enc: cUInt;
      tmp_ccl: Array[0..SSL2_MAX_CERT_CHALLENGE_LENGTH - 1] Of AnsiChar;
      tmp_cipher_spec_length: cUInt;
      tmp_session_id_length: cUInt;
      tmp_clen: cUInt;
      tmp_rlen: cUInt;
   End;

   PSSL3_RECORD = ^SSL3_RECORD;
   SSL3_RECORD = Record
      _type: cInt;
      length: cUInt;
      off: cUInt;
      data: PAnsiChar;
      input: PAnsiChar;
      comp: PAnsiChar;
      epoch: cuLong;
      seq_num: Array[0..7] Of Byte;
   End;

   PSSL3_BUFFER = ^SSL3_BUFFER;
   SSL3_BUFFER = Record
      buf: PAnsiChar;

      len: size_t;
      offset: cInt;
      left: cInt;
   End;

   SSL3_STATE = Record
      flags: cLong;
      delay_buf_pop_ret: cInt;
      read_sequence: Array[0..7] Of AnsiChar;
      read_mac_secret_size: cInt;
      read_mac_secret: Array[0..EVP_MAX_MD_SIZE - 1] Of AnsiChar;
      write_sequence: Array[0..7] Of AnsiChar;
      write_mac_secret_size: cInt;
      write_mac_secret: Array[0..EVP_MAX_MD_SIZE - 1] Of AnsiChar;
      server_random: Array[0..SSL3_RANDOM_SIZE - 1] Of AnsiChar;
      client_random: Array[0..SSL3_RANDOM_SIZE - 1] Of AnsiChar;
      need_empty_fragments: cInt;
      empty_fragment_done: cInt;
      init_extra: cInt;
      rbuf: PSSL3_BUFFER;
      wbuf: PSSL3_BUFFER;
      rrec: PSSL3_RECORD;
      wrec: PSSL3_RECORD;
      alert_fragment: Array[0..1] Of PAnsiChar;
      alert_fragment_len: cUInt;
      handshake_fragment: Array[0..3] Of PAnsiChar;
      handshake_fragment_len: cUInt;
      wnum: cUInt;
      wpend_tot: cInt;
      wpend_type: cInt;
      wpend_ret: cInt;
      wpend_buf: PByte;
      handshake_buffer: PBIO;
      handshake_dgst: PPEVP_MD_CTX;
      finish_dgst2: PEVP_MD_CTX;
      change_cipher_spec: cInt;
      warn_alert: cInt;
      fatal_alert: cInt;
      alert_dispatch: cInt;
      send_alert: Array[0..1] Of AnsiChar;
      renegotiate: cInt;
      total_renegotiations: cInt;
      num_renegotiations: cInt;
      in_read_app_data: cInt;
      client_opaque_prf_input: Pointer;
      client_opaque_prf_input_len: size_t;
      server_opaque_prf_input: Pointer;
      server_opaque_prf_input_len: size_t;
      tmp_cert_verify_md: Array[0..(EVP_MAX_MD_SIZE * 2) - 1] Of AnsiChar;
      tmp_finish_md: Array[0..(EVP_MAX_MD_SIZE * 2) - 1] Of AnsiChar;
      tmp_finish_md_len: cInt;
      tmp_peer_finish_md: Array[0..(EVP_MAX_MD_SIZE * 2) - 1] Of AnsiChar;
      tmp_peer_finish_md_len: cInt;
      tmp_message_size: cUInt;
      tmp_message_type: cInt;
      tmp_new_cipher: PSSL_CIPHER;
      tmp_dh: PDH;
      tmp_ecdh: PEC_KEY;
      tmp_next_state: cInt;
      tmp_reuse_message: cInt;
      tmp_cert_req: cInt;
      tmp_ctype_num: cInt;
      tmp_ctype: Array[0..SSL3_CT_NUMBER - 1] Of AnsiChar;
      tmp_ca_names: PSTACK_OF_X509_NAME;
      tmp_use_rsa_tmp: cInt;
      tmp_key_block_length: cInt;
      tmp_key_block: PAnsiChar;
      tmp_new_sym_enc: PEVP_CIPHER;
      tmp_new_hash: PEVP_MD;
      new_mac_pkey_type: cInt;
      new_mac_secret_size: cInt;
      tmp_new_compression: PSSL_COMP;
      tmp_cert_request: cInt;
      previous_client_finished: Array[0..EVP_MAX_MD_SIZE - 1] Of AnsiChar;
      previous_client_finished_len: Byte;
      previous_server_finished: Array[0..EVP_MAX_MD_SIZE - 1] Of AnsiChar;
      previous_server_finished_len: Byte;
      send_connection_binding: cInt;
      next_proto_neg_seen: cInt;
   End;

   ppitem = ^pitem;
   pitem = Record
      priority: PQ_64BIT;
      data: Pointer;
      next: ppitem;
   End;

   pqueue = Record
      items: ppitem;
      count: cInt;
   End;

   dtls1_retransmit_state = Record
      enc_write_ctx: PEVP_CIPHER_CTX;
      write_hash: PEVP_MD;
      compress: COMP_CTX;
      session: PSSL_SESSION;
      epoch: cuShort;
   End;

   Pdtls1_retransmit_state = ^dtls1_retransmit_state;
   DTLS1_BITMAP = Record
      map: PQ_64BIT;
      length: cuLong;
      max_seq_num: PQ_64BIT;
   End;

   PDTLS1_BITMAP = ^DTLS1_BITMAP;
   hm_header = Record
      _type: PAnsiChar;
      msg_len: cuLong;
      seq: cuShort;
      frag_off: cuLong;
      frag_len: cuLong;
      is_ccs: cUInt;
      saved_retransmit_state: dtls1_retransmit_state;
   End;
   ccs_header_st = Record
      _type: PAnsiChar;
      seq: cuShort;
   End;
   dtls1_timeout_st = Record
      read_timeouts: cUInt;
      write_timeouts: cUInt;
      num_alerts: cUInt;
   End;

   record_pqueue = Record
      epoch: cuShort;
      q: pqueue;
   End;

   hm_fragment = Record
      msg_header: hm_header;
      fragment: PAnsiChar;
      reassembly: PAnsiChar;
   End;

   DTLS1_STATE = Record
      send_cookie: cUInt;
      cookie: Array[0..DTLS1_COOKIE_LENGTH - 1] Of AnsiChar;
      rcvd_cookie: Array[0..DTLS1_COOKIE_LENGTH - 1] Of AnsiChar;
      cookie_len: cUInt;
      r_epoch: cuShort;
      w_epoch: cuShort;
      bitmap: DTLS1_BITMAP;
      next_bitmap: DTLS1_BITMAP;
      handshake_write_seq: cuShort;
      next_handshake_write_seq: cuShort;
      handshake_read_seq: cuShort;
      last_write_sequence: Array[0..8 - 1] Of byte;
      unprocessed_rcds: record_pqueue;
      processed_rcds: record_pqueue;
      buffered_messages: pqueue;
      sent_messages: pqueue;
      buffered_app_data: record_pqueue;
      listen: cUInt;
      mtu: cUInt;
      w_msg_hdr: hm_header;
      r_msg_hdr: hm_header;
      timeout: dtls1_timeout_st;
      next_timeout: timeval;
      timeout_duration: cuShort;
      alert_fragment: Array[0..DTLS1_AL_HEADER_LENGTH - 1] Of AnsiChar;
      alert_fragment_len: cUInt;
      handshake_fragment: Array[0..DTLS1_HM_HEADER_LENGTH - 1] Of AnsiChar;
      handshake_fragment_len: cUInt;
      retransmitting: cUInt;
      change_cipher_spec_ok: cUInt;
   End;

   X509V3_CTX = V3_EXT_CTX;
   PX509V3_CTX = ^X509V3_CTX;
   TSSL_CTX_set_verify_callback = Function(ok: cINT; ctx: PX509_STORE_CTX): cINT; cdecl;

   OSSL_LIB_CTX=Pointer;
   BN_CTX=PPBN_CTX;
   BN_BLINDING=^PBN_BLINDING;

   //... BIO .....
   uint64_t = uint64;
                         
   BIO_ADDR = Pointer;
   BIO_ADDRINFO = Pointer;  
   PBIO_ADDRINFO  = ^BIO_ADDRINFO;
   PBIO_ADDR = ^BIO_ADDR;
   bio_addrinfo_st = BIO_ADDRINFO;

   BIO_hostserv_priorities =  Longint;
   BIO_lookup_type =  Longint;

   BIO_sock_info_type =  Longint;


   PBIO_sock_info_u = ^BIO_sock_info_u;
   BIO_sock_info_u = record
     case longint of
       0 : ( addr : PBIO_ADDR );
     end;

   BIO_callback_fn_ex = function (var b:BIO; oper:longint; argp:Pchar; len:size_t; argi:longint;
                                   argl:longint; ret:longint; var processed:size_t):longint;cdecl;
   BIO_dgram_sctp_notification_handler_fn = procedure (var b:BIO; context:pointer; buf:pointer);cdecl;


//============================================================================
//============================================================================ 
//============================================================================

Type

   Tsk_new_cmp = Function(Const a, b: PAnsiChar; Const c: PAnsiChar): cINT Cdecl;
   TRSA_generate_key_callback = Procedure(p1, p2: cINT; p3: Pointer); cdecl;
   TCRYPTO_set_mem_functions_m = Function(size: size_t): Pointer; cdecl;
   TCRYPTO_set_mem_functions_r = Function(ptr: Pointer; size: size_t): Pointer; cdecl;
   TCRYPTO_set_mem_functions_f = Procedure(ptr: Pointer); cdecl;
   TCRYPTO_set_mem_ex_functions_m = Function(size: size_t; Const c: PAnsiChar; i: cINT): Pointer; cdecl;
   TCRYPTO_set_mem_ex_functions_r = Function(ptr: Pointer; size: size_t; Const c: PAnsiChar; i: cINT): Pointer; cdecl;
   TCRYPTO_set_mem_ex_functions_f = Procedure(ptr: Pointer); cdecl;
   Tset_mem_debug_functions_m = Procedure(addr: Pointer; num: cINT; Const _file: PAnsiChar; line, before_p: cINT); cdecl;
   Tset_mem_debug_functions_r = Procedure(addr1, addr2: Pointer; num: cINT; Const _file: PAnsiChar; line, before_p: cINT); cdecl;
   Tset_mem_debug_functions_f = Procedure(addr: Pointer; before_p: cINT); cdecl;
   Tset_mem_debug_functions_so = Procedure(bits: cLONG); cdecl;
   Tset_mem_debug_functions_go = Function: cLONG; cdecl;
   Tsk_pop_free_func = Procedure(p: Pointer); cdecl;
   SSL_callback_ctrl_fp = Procedure(para1: PBIO; para2: cINT;para3: PAnsiChar; para4: cINT; para5, para6: cLONG); cdecl;
   TCRYPTO_THREADID_set_callback_threadid_func = Procedure(id: PCRYPTO_THREADID) Cdecl;
   TSSL_CTX_set_tlsext_status_cb = Function(SSL: PSSL; Arg: Pointer): cINT Cdecl;
   TSSL_CTX_set_tlsext_opaque_prf_input_callback_cb = Function(ssl: PSSL; peerinput: Pointer; len: size_t; arg: Pointer): cINT Cdecl;
   TSSL_CTX_set_tlsext_ticket_key_cb_fp = Function(SSL: PSSL; keyname, iv: PAnsiChar; ctx: PEVP_CIPHER_CTX; hctx: PHMAC_CTX; enc: cINT): cINT Cdecl;
   EVP_CIPHER_do_all_fn = Procedure(ciph: PEVP_CIPHER;from: PAnsiChar; _to: PAnsiChar; x: Pointer) Cdecl;
   EVP_MD_do_all_fn = Procedure(ciph: PEVP_CIPHER; from: PAnsiChar; _to: PAnsiChar; x: Pointer) Cdecl;
   EVP_PKEY_asn1_set_public_pub_decode = Function(pk: PEVP_PKEY; pub: PX509_PUBKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_public_pub_encode = Function(pub: PX509_PUBKEY; pk: PX509_PUBKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_public_pub_cmp = Function(a: PEVP_PKEY; b: PEVP_PKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_public_pub_print = Function(_out: PBIO; pkey: PEVP_PKEY; indent: cINT;pctx: PASN1_PCTX): cINT Cdecl;
   EVP_PKEY_asn1_set_public_pub_pkey_size = Function(pk: PEVP_PKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_public_pkey_bits = Function(pk: PEVP_PKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_private_priv_decode = Function(pk: PEVP_PKEY; p8inf: PPKCS8_PRIV_KEY_INFO): cINT Cdecl;
   EVP_PKEY_asn1_set_private_priv_encode = Function(p8: PPKCS8_PRIV_KEY_INFO; pk: PEVP_PKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_private_priv_print = Function(_out: PBIO; pkey: PEVP_PKEY; indent: cINT; pctx: PASN1_PCTX): cINT Cdecl;
   EVP_PKEY_asn1_set_param_param_decode = Function(pkey: PEVP_PKEY; pder: PPAnsiChar; derlen: cINT): cINT Cdecl;
   EVP_PKEY_asn1_set_param_param_encode = Function(pkey: PEVP_PKEY; pder: PPAnsiChar): cINT Cdecl;
   EVP_PKEY_asn1_set_param_param_missing = Function(pk: EVP_PKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_param_param_copy = Function(_to: PEVP_PKEY; from: PEVP_PKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_param_param_cmp = Function(a: PEVP_PKEY; b: PEVP_PKEY): cINT Cdecl;
   EVP_PKEY_asn1_set_param_param_print = Function(_out: PBIO; pkey: PEVP_PKEY; indent: cINT; pctx: PASN1_PCTX): cINT Cdecl;
   EVP_PKEY_asn1_set_free_pkey_free = Procedure(pkey: PEVP_PKEY) Cdecl;
   EVP_PKEY_asn1_set_ctr_pkey_ctrl = Function(pkey: PEVP_PKEY; op: cINT; arg1: cLONG; arg2: Pointer): cINT Cdecl;
   EVP_PKEY_gen_cb = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_init_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_copy_copy = Function(dst: PEVP_PKEY_CTX; src: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_cleanup_cleanup = Procedure(ctx: PEVP_PKEY_CTX) Cdecl;
   EVP_PKEY_meth_set_paramgen_paramgen_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_paramgen_paramgen = Function(ctx: PEVP_PKEY_CTX; pkey: PEVP_PKEY): cINT Cdecl;
   EVP_PKEY_meth_set_keygen_keygen_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_keygen_keygen = Function(ctx: PEVP_PKEY_CTX; pkey: PEVP_PKEY): cINT Cdecl;
   EVP_PKEY_meth_set_sign_sign_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_sign_sign = Function(ctx: PEVP_PKEY_CTX; sig: PAnsiChar; siglen: Psize_t;tbs: PAnsiChar; tbslen: size_t): cINT Cdecl;
   EVP_PKEY_meth_set_verify_verify_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_verify_verify = Function(ctx: PEVP_PKEY_CTX; sig: PAnsiChar; siglen: size_t; tbs: PAnsiChar; tbslen: size_t): cINT Cdecl;
   EVP_PKEY_meth_set_verify_recover_verify_recover_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_verify_recover_verify_recover = Function(ctx: PEVP_PKEY_CTX; sig: PAnsiChar; siglen: Psize_t;tbs: PAnsiChar; tbslen: size_t): cINT Cdecl;
   EVP_PKEY_meth_set_signctx_signctx_init = Function(ctx: PEVP_PKEY_CTX; mctx: PEVP_MD_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_signctx_signctx = Function(ctx: PEVP_PKEY_CTX; sig: PAnsiChar; siglen: size_t; mctx: PEVP_MD_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_verifyctx_verifyctx_init = Function: cINT Cdecl;
   EVP_PKEY_meth_set_verifyctx_verifyctx = Function: cINT Cdecl;
   EVP_PKEY_meth_set_encrypt_encrypt_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_encrypt_encryptfn = Function(ctx: PEVP_PKEY_CTX; _out: PAnsiChar; outlen: psize_t; _in: PAnsiChar; inlen: size_t): cINT Cdecl;
   EVP_PKEY_meth_set_decrypt_decrypt_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_decrypt_decrypt = Function(ctx: PEVP_PKEY_CTX; _out: PAnsiChar; outlen: psize_t; _in: PAnsiChar; inlen: size_t): cINT Cdecl;
   EVP_PKEY_meth_set_derive_derive_init = Function(ctx: PEVP_PKEY_CTX): cINT Cdecl;
   EVP_PKEY_meth_set_derive_derive = Function(ctx: PEVP_PKEY_CTX; key: PAnsiChar; keylen: psize_t): cINT Cdecl;
   EVP_PKEY_meth_set_ctrl_ctrl = Function(ctx: PEVP_PKEY_CTX; _type: cINT; p1: cINT; p2: Pointer): cINT Cdecl;
   EVP_PKEY_meth_set_ctrlctrl_str = Function(ctx: PEVP_PKEY_CTX; _type: PAnsiChar; value: PAnsiChar): cINT Cdecl;

//-------------------------------------------------

 Type

   TSSL_CTX_set_cipher_list = Function(_para1: PSSL_CTX; Const str: PAnsiChar): cInt Cdecl;
   TSSL_CTX_new = Function(meth: PSSL_METHOD): PSSL_CTX Cdecl;
   TSSL_CTX_free = Procedure(_para1: PSSL_CTX) Cdecl;
   TSSL_set_fd = Function(s: PSSL; fd: cInt): cInt Cdecl;
   TSSL_CTX_use_PrivateKey_file = Function(ctx: PSSL_CTX; Const _file: PAnsiChar; _type: cInt): cInt Cdecl;
   TSSL_CTX_use_PrivateKey = Function(ctx: PSSL_CTX; pkey: PEVP_PKEY): cInt Cdecl;
   TSSL_CTX_use_certificate = Function(ctx: PSSL_CTX; x: PX509): cInt Cdecl;
   TSSL_CTX_use_certificate_file = Function(ctx: PSSL_CTX; Const _file: PAnsiChar; _type: cInt): cInt Cdecl;
   TSSL_state_string_long = Function(s: PSSL): PAnsiChar Cdecl;
   TSSL_alert_desc_string_long = Function(value: cInt): PAnsiChar Cdecl;
   TSSL_alert_type_string_long = Function(value: cInt): PAnsiChar Cdecl;
   TSSL_CTX_set_verify = Procedure(ctx: PSSL_CTX; mode: cInt; callback: TSSL_CTX_set_verify_callback) Cdecl;
   TSSL_CTX_set_verify_depth = Procedure(ctx: PSSL_CTX; depth: cInt) Cdecl;
   TSSL_CTX_get_verify_depth = Function(ctx: PSSL_CTX): cInt Cdecl;
   TSSL_CTX_set_default_passwd_cb = Procedure(ctx: PSSL_CTX; cb: ppem_password_cb) Cdecl;
   TSSL_CTX_set_default_passwd_cb_userdata = Procedure(ctx: PSSL_CTX; u: Pointer) Cdecl;
   TSSL_CTX_check_private_key = Function(ctx: PSSL_CTX): cInt Cdecl;
   TSSL_new = Function(ctx: PSSL_CTX): PSSL Cdecl;
   TSSL_free = Procedure(ssl: PSSL) Cdecl;
   TSSL_accept = Function(ssl: PSSL): cInt Cdecl;
   TSSL_connect = Function(ssl: PSSL): cInt Cdecl;
   TSSL_read = Function(ssl: PSSL; buf: Pointer; num: cInt): cInt Cdecl;
   TSSL_peek = Function(ssl: PSSL; buf: Pointer; num: cInt): cInt Cdecl;
   TSSL_pending = Function(ssl: PSSL): cInt Cdecl;
   TSSL_write = Function(ssl: PSSL; Const buf: Pointer; num: cInt): cInt Cdecl;
   TSSL_ctrl = Function(ssl: PSSL; cmd: cInt; larg: cLong; parg: Pointer): cLong Cdecl;
   TSSL_callback_ctrl = Function(ssl: PSSL; cmd: cInt; fp: SSL_callback_ctrl_fp): cLong Cdecl;
   TSSL_CTX_ctrl = Function(ssl: PSSL_CTX; cmd: cInt; larg: cLong; parg: Pointer): cLong Cdecl;
   TSSL_CTX_callback_ctrl = Function(ssl: PSSL_CTX; cmd: cInt; fp: SSL_callback_ctrl_fp): cLong Cdecl;
   TSSL_get_error = Function(s: PSSL; ret_code: cInt): cInt Cdecl;
   TSSL_shutdown = Function(s: PSSL): cInt Cdecl;
   TSSL_set_connect_state = Procedure(s: PSSL) Cdecl;
   TSSL_set_accept_state = Procedure(s: PSSL) Cdecl;
   TSSL_set_shutdown = Procedure(ssl: PSSL; mode: cInt) Cdecl;
   TSSL_CTX_load_verify_locations = Function(ctx: PSSL_CTX; Const CAfile: PAnsiChar; Const CApath: PAnsiChar): cInt Cdecl;
   TSSL_get_session = Function(Const ssl: PSSL): PSSL_SESSION Cdecl;
   TSSL_SESSION_get_id = Function(Const s: PSSL_SESSION; length: pcUInt): PAnsiChar Cdecl;
   TSSL_copy_session_id = Procedure(sslTo: PSSL; Const sslFrom: PSSL) Cdecl;
   TSSL_set_ex_data = Function(ssl: PSSL; idx: cInt; data: Pointer): cInt Cdecl;
   TSSL_get_ex_data = Function(ssl: PSSL; idx: cInt): Pointer Cdecl;
   TSSL_load_client_CA_file = Function(Const _file: PAnsiChar): PSTACK_OF_X509_NAME Cdecl;
   TSSL_CTX_set_client_CA_list = Procedure(ctx: PSSL_CTX; list: PSTACK_OF_X509_NAME) Cdecl;
   TSSL_CTX_set_default_verify_paths = Function(ctx: PSSL_CTX): cInt Cdecl;
   TSSL_CTX_set_session_id_context = Function(ctx: PSSL_CTX; Const sid_ctx: PByte; sid_ctx_len: cUInt): cInt Cdecl;
   TSSL_CIPHER_description = Function(_para1: PSSL_CIPHER; buf: PAnsiChar; size: cInt): PAnsiChar Cdecl;
   TSSL_get_current_cipher = Function(Const s: PSSL): PSSL_CIPHER Cdecl;
   TSSL_CIPHER_get_name = Function(Const c: PSSL_CIPHER): PAnsiChar Cdecl;
   TSSL_CIPHER_get_version = Function(Const c: PSSL_CIPHER): PAnsiChar Cdecl;
   TSSL_CIPHER_get_bits = Function(Const c: PSSL_CIPHER; Var alg_bits: cInt): cInt Cdecl;
   Td2i_X509_NAME = Function(pr: PPX509_NAME; _in: PPByte; length: cLong): PX509_NAME Cdecl;
   Ti2d_X509_NAME = Function(x: PX509_NAME; buf: PPByte): cInt Cdecl;
   TX509_NAME_oneline = Function(a: PX509_NAME; buf: PAnsiChar; size: cInt): PAnsiChar Cdecl;
   TX509_NAME_cmp = Function(Const a, b: PX509_NAME): cInt Cdecl;
   TX509_NAME_hash_old = Function(x: PX509_NAME): cuLong Cdecl;
   TX509_set_issuer_name = Function(x: PX509; name: PX509_NAME): cInt Cdecl;
   TX509_get_issuer_name = Function(a: PX509): PX509_NAME Cdecl;
   TX509_set_subject_name = Function(x: PX509; name: PX509_NAME): cInt Cdecl;
   TX509_get_subject_name = Function(a: PX509): PX509_NAME Cdecl;
   TX509_digest = Function(Const data: PX509; Const _type: PEVP_MD;md: PByte; Var len: cUInt): cInt Cdecl;
   TX509_LOOKUP_ctrl = Function(ctx: PX509_LOOKUP; cmd: cInt; argc: PAnsiChar; arg1: cLong; ret: PPAnsiChar): cInt Cdecl;
   TX509_STORE_add_cert = Function(ctx: PX509_STORE; x: PX509): cInt Cdecl;
   TX509_STORE_add_crl = Function(ctx: PX509_STORE; x: PX509_CRL): cInt Cdecl;
   TX509_STORE_CTX_get_ex_data = Function(ctx: PX509_STORE_CTX; idx: cInt): Pointer Cdecl;
   TX509_STORE_CTX_get_error = Function(ctx: PX509_STORE_CTX): cInt Cdecl;
   TX509_STORE_CTX_set_error = Procedure(ctx: PX509_STORE_CTX; s: cInt) Cdecl;
   TX509_STORE_CTX_get_error_depth = Function(ctx: PX509_STORE_CTX): cInt Cdecl;
   TX509_STORE_CTX_get_current_cert = Function(ctx: PX509_STORE_CTX): PX509 Cdecl;
   TX509_STORE_add_lookup = Function(v: PX509_STORE; m: PX509_LOOKUP_METHOD): PX509_LOOKUP Cdecl;
   TX509_STORE_load_locations = Function(ctx: PX509_STORE; Const _file, path: PAnsiChar): cInt Cdecl;
   Ti2d_DSAPrivateKey = Function(x: PDSA; buf: PPByte): cInt Cdecl;
   Td2i_DSAPrivateKey = Function(pr: PDSA; _in: PPByte; len: cInt): PDSA Cdecl;
   Td2i_PrivateKey = Function(pr: PEVP_PKEY; _in: PPByte; len: cInt): PEVP_PKEY Cdecl;
   Td2i_PrivateKey_bio = Function(bp: PBIO; a: PPEVP_PKEY): PEVP_PKEY Cdecl;
   TX509_sign = Function(x: PX509; pkey: PEVP_PKEY; Const md: PEVP_MD): cInt Cdecl;
   TX509_REQ_sign = Function(x: PX509_REQ; pkey: PEVP_PKEY; Const md: PEVP_MD): cInt Cdecl;
   TX509_REQ_add_extensions = Function(req: PX509_REQ; exts: PSTACK_OF_X509_EXTENSION): cInt Cdecl;
   TX509V3_EXT_conf_nid = Function(conf: PLHASH; ctx: PX509V3_CTX; ext_nid: cInt; value: PAnsiChar): PX509_EXTENSION Cdecl;
   TX509_EXTENSION_create_by_NID = Function(ex: PPX509_EXTENSION; nid: cInt;crit: cInt; data: PASN1_OCTET_STRING): PX509_EXTENSION Cdecl;
   TX509V3_set_ctx = Procedure(ctx: PX509V3_CTX; issuer, subject: PX509; req: PX509_REQ; crl: PX509_CRL; flags: cInt) Cdecl;
   TX509_EXTENSION_free = Procedure(ex: PX509_EXTENSION) Cdecl;
   TX509_add_ext = Function(cert: PX509; ext: PX509_EXTENSION; loc: cInt): cInt Cdecl;
   TX509_print = Function(bp: PBIO; x: PX509): cInt Cdecl;
   TRAND_bytes = Function(buf: PAnsiChar; num: integer): integer; cdecl;
   TRAND_pseudo_bytes = Function(buf: PAnsiChar; num: integer): integer; cdecl;
   TRAND_seed = Procedure(buf: PAnsiChar; num: integer); cdecl;
   TRAND_add = Procedure(buf: PAnsiChar; num: integer; entropy: integer); cdecl;
   TDES_set_odd_parity = Procedure(key: Pdes_cblock) Cdecl;
   TDES_set_key = Function(key: Pconst_DES_cblock; schedule: DES_key_schedule): cInt Cdecl;
   TDES_ecb_encrypt = Procedure(input, output: Pconst_DES_cblock; ks: DES_key_schedule; enc: cInt) Cdecl;
   TCRYPTO_lock = Procedure(mode, _type: cInt; Const _file: PAnsiChar; line: cInt) Cdecl;
   TERR_error_string = Function(e: cuLong; buf: PAnsiChar): PAnsiChar Cdecl;
   TERR_error_string_n = Procedure(e: cuLong; buf: PAnsiChar; len: size_t) Cdecl;
   TERR_lib_error_string = Function(e: cuLong): PAnsiChar Cdecl;
   TERR_func_error_string = Function(e: cuLong): PAnsiChar Cdecl;
   TERR_reason_error_string = Function(e: cuLong): PAnsiChar Cdecl;
   TERR_remove_thread_state = Procedure(Const tId: PCRYPTO_THREADID) Cdecl;
   TOPENSSL_sk_pop_free = Procedure(st: PSTACK; func: Tsk_pop_free_func) Cdecl;
   TRSA_new = Function():PRSA;
   TRSA_free = Procedure(rsa: PRSA) Cdecl;
   TRSA_generate_key = Function(bits: cInt; e: cuLong; callback: TRSA_generate_key_callback; cb_arg: Pointer): PRSA Cdecl;
   TRSA_check_key = Function(Const rsa: PRSA): cInt Cdecl;
   TRSA_generate_key_ex = Function(rsa: PRSA; bits: cInt; e: PBIGNUM; cb: PBN_GENCB): cInt Cdecl;
   TRSA_size = Function(key: PRSA): cInt Cdecl;
   TRSA_private_decrypt = Function(flen: cInt; from: PByte; _to: PByte; rsa: PRSA; padding: cInt): cInt Cdecl;
   TRSA_public_encrypt = Function(flen: cInt; from: PByte; _to: PByte; rsa: PRSA; padding: cInt): cInt Cdecl;
   TDH_free = Procedure(dh: PDH) Cdecl;
   Ti2d_X509_bio = Function(bp: PBIO; x: PX509): cInt Cdecl;
   Ti2d_PrivateKey_bio = Function(b: PBIO; pkey: PEVP_PKEY): cInt Cdecl;
   Td2i_X509_bio = Function(bp: PBIO; x: PPx509): PX509 Cdecl;
   Ti2d_X509_REQ_bio = Function(bp: PBIO; x: PX509_REQ): cInt Cdecl;
   Ti2d_PKCS7 = Function(x: PPKCS7; buf: PPByte): cInt Cdecl;
   Td2i_PKCS7 = Function(pr: PPKCS7; _in: PPByte; len: cInt): PPKCS7 Cdecl;
   Ti2d_X509 = Function(x: PX509; buf: PPByte): cInt Cdecl;
   Td2i_X509 = Function(pr: PX509; _in: PPByte; len: cInt): PX509 Cdecl;
   Ti2d_X509_REQ = Function(x: PX509_REQ; buf: PPByte): cInt Cdecl;
   Td2i_X509_REQ = Function(pr: PX509_REQ; _in: PPByte; len: cInt): PX509_REQ Cdecl;
   Ti2d_X509_CRL = Function(x: PX509_CRL; buf: PPByte): cInt Cdecl;
   Td2i_X509_CRL = Function(pr: PX509_CRL; _in: PPByte; len: cInt): PX509_REQ Cdecl;
   Ti2d_RSAPrivateKey = Function(x: PRSA; buf: PPByte): cInt Cdecl;
   Td2i_RSAPrivateKey = Function(pr: PRSA; _in: PPByte; len: cInt): PRSA Cdecl;
   Ti2d_RSAPublicKey = Function(x: PRSA; buf: PPByte): cInt Cdecl;
   Td2i_RSAPublicKey = Function(pr: PRSA; _in: PPByte; len: cInt): PRSA Cdecl;
   Ti2d_PrivateKey = Function(x: PEVP_PKEY; buf: PPByte): cInt Cdecl;
   Ti2d_DSAparams = Function(x: PDSA; buf: PPByte): cInt Cdecl;
   Td2i_DSAparams = Function(pr: PDSA; _in: PPByte; len: cInt): PDSA Cdecl;
   Ti2d_DHparams = Function(x: PDH; buf: PPByte): cInt Cdecl;
   Td2i_DHparams = Function(pr: PDH; _in: PPByte; len: cInt): PDH Cdecl;
   Ti2d_NETSCAPE_CERT_SEQUENCE = Function(x: PNETSCAPE_CERT_SEQUENCE; buf: PPByte): cInt Cdecl;
   Td2i_NETSCAPE_CERT_SEQUENCE = Function(pr: PNETSCAPE_CERT_SEQUENCE; _in: PPByte; len: cInt): PNETSCAPE_CERT_SEQUENCE Cdecl;
   Ti2d_PUBKEY = Function(x: PEVP_PKEY; buf: PPByte): cInt Cdecl;
   Td2i_PUBKEY = Function(pr: PEVP_PKEY; _in: PPByte; len: cInt): PEVP_PKEY Cdecl;
   TX509_free = Procedure(x: PX509) Cdecl;
   TX509_REQ_free = Procedure(x: PX509_REQ) Cdecl;
   TX509_to_X509_REQ = Function(x: PX509; pkey: PEVP_PKEY; Const md: PEVP_MD): PX509_REQ Cdecl;
   TX509_NAME_free = Procedure(x: PX509_NAME) Cdecl;
   TX509_NAME_add_entry_by_txt = Function(name: PX509_NAME; Const field: PAnsiChar; _type: cInt;Const bytes: PAnsiChar; len, loc, _set: cInt): cInt Cdecl;
   TX509_INFO_free = Procedure(a: PX509_INFO) Cdecl;
   TX509_set_version = Function(x: PX509; version: cLong): cInt Cdecl;
   TX509_get_serialNumber = Function(x: PX509): PASN1_INTEGER Cdecl;
   TX509_gmtime_adj = Function(s: PASN1_TIME; adj: cLong): PASN1_TIME Cdecl;
   TX509_set_pubkey = Function(x: PX509; pkey: PEVP_PKEY): cInt Cdecl;
   TX509_REQ_set_pubkey = Function(x: PX509_REQ; pkey: PEVP_PKEY): cInt Cdecl;
   TX509_PUBKEY_get = Function(key: PX509_PUBKEY): PEVP_PKEY Cdecl;
   TX509_verify = Function(x509: PX509; pkey: PEVP_PKEY): cInt Cdecl;
   TPEM_read_bio_X509 = Function(bp: PBIO; x: PPX509; cb: ppem_password_cb; u: Pointer): PX509 Cdecl;
   TPEM_read_bio_X509_REQ = Function(bp: PBIO; x: PPX509_REQ; cb: ppem_password_cb; u: PAnsiChar): PX509_REQ Cdecl;
   TPEM_read_bio_X509_CRL = Function(bp: PBIO; x: PPX509_CRL; cb: ppem_password_cb; u: Pointer): PX509_CRL Cdecl;
   TPEM_read_bio_RSAPrivateKey = Function(bp: PBIO; x: PPRSA; cb: ppem_password_cb; u: Pointer): PRSA Cdecl;
   TPEM_read_bio_RSAPublicKey = Function(bp: PBIO; x: PPRSA; cb: ppem_password_cb; u: Pointer): PRSA Cdecl;
   TPEM_read_bio_DSAPrivateKey = Function(bp: PBIO; x: PPDSA; cb: ppem_password_cb; u: Pointer): PDSA Cdecl;
   TPEM_read_bio_PrivateKey = Function(bp: PBIO; x: PPEVP_PKEY; cb: ppem_password_cb; u: Pointer): PEVP_PKEY Cdecl;
   TPEM_read_bio_PKCS7 = Function(bp: PBIO; x: PPPKCS7; cb: ppem_password_cb; u: Pointer): PPKCS7 Cdecl;
   TPEM_read_bio_DHparams = Function(bp: PBIO; x: PPDH; cb: ppem_password_cb; u: Pointer): PDH Cdecl;
   TPEM_read_bio_DSAparams = Function(bp: PBIO; x: PPDSA; cb: ppem_password_cb; u: Pointer): PDSA Cdecl;
   TPEM_read_bio_NETSCAPE_CERT_SEQUENCE = Function(bp: PBIO; x: PPNETSCAPE_CERT_SEQUENCE;cb: ppem_password_cb; u: Pointer): PNETSCAPE_CERT_SEQUENCE Cdecl;
   TPEM_read_bio_PUBKEY = Function(bp: PBIO; x: PPEVP_PKEY; cb: ppem_password_cb; u: Pointer): PEVP_PKEY Cdecl;
   TPEM_write_bio_X509 = Function(b: PBIO; x: PX509): cInt Cdecl;
   TPEM_write_bio_X509_REQ = Function(bp: PBIO; x: PX509_REQ): cInt Cdecl;
   TPEM_write_bio_X509_CRL = Function(bp: PBIO; x: PX509_CRL): cInt Cdecl;
   TPEM_write_bio_RSAPrivateKey = Function(bp: PBIO; x: PRSA; Const enc: PEVP_CIPHER;kstr: PAnsiChar; klen: cInt; cb: Ppem_password_cb; u: Pointer): cInt Cdecl;
   TPEM_write_bio_RSAPublicKey = Function(bp: PBIO; x: PRSA): cInt Cdecl;
   TPEM_write_bio_DSAPrivateKey = Function(bp: PBIO; x: PDSA; Const enc: PEVP_CIPHER;kstr: PAnsiChar; klen: cInt; cb: Ppem_password_cb; u: Pointer): cInt Cdecl;
   TPEM_write_bio_PrivateKey = Function(bp: PBIO; x: PEVP_PKEY; Const enc: PEVP_CIPHER;kstr: PAnsiChar; klen: cInt; cb: Ppem_password_cb; u: Pointer): cInt Cdecl;
   TPEM_write_bio_PKCS7 = Function(bp: PBIO; x: PPKCS7): cInt Cdecl;
   TPEM_write_bio_DHparams = Function(bp: PBIO; x: PDH): cInt Cdecl;
   TPEM_write_bio_DSAparams = Function(bp: PBIO; x: PDSA): cInt Cdecl;
   TPEM_write_bio_NETSCAPE_CERT_SEQUENCE = Function(bp: PBIO; x: PDSA): cInt Cdecl;
   TPEM_write_bio_PKCS8PrivateKey = Function(bp: PBIO; key: PEVP_PKEY; enc: PEVP_CIPHER;kstr: PAnsiChar; klen: cInt; cb: ppem_password_cb; u: Pointer): cInt Cdecl;
   TPEM_write_bio_PUBKEY = Function(bp: PBIO; x: PEVP_PKEY): cInt Cdecl;
   TPEM_X509_INFO_read_bio = Function(bp: PBIO; sk: PSTACK_OF_X509_INFO;cb: ppem_password_cb; u: Pointer): PSTACK_OF_X509_INFO Cdecl;
   TPEM_read_bio_X509_AUX = Function(bp: PBIO; x: PPX509;cb: ppem_password_cb; u: Pointer): PX509 Cdecl;
   TEVP_MD_CTX_copy = Function(_out: PEVP_MD_CTX; _in: PEVP_MD_CTX): cInt Cdecl;
   TEVP_MD_CTX_copy_ex = Function(_out: PEVP_MD_CTX; Const _in: PEVP_MD_CTX): cInt Cdecl;
   TEVP_DigestInit_ex = Function(ctx: PEVP_MD_CTX; Const AType: PEVP_MD; impl: PENGINE): cInt Cdecl;
   TEVP_DigestUpdate = Function(ctx: PEVP_MD_CTX; d: Pointer; cnt: size_t): cInt Cdecl;
   TEVP_DigestFinal_ex = Function(ctx: PEVP_MD_CTX; md: PAnsiChar; Var s: cUInt): cInt Cdecl;
   TEVP_PKEY_new = Function(): PEVP_PKEY Cdecl;
   TEVP_PKEY_type = Function(_type: cInt): cInt Cdecl;
   TEVP_PKEY_free = Procedure(pkey: PEVP_PKEY) Cdecl;
   TEVP_PKEY_assign = Function(pkey: PEVP_PKEY; _type: cInt; key: Pointer): cInt Cdecl;
   TEVP_get_digestbyname = Function(Const name: PAnsiChar): PEVP_MD Cdecl;
   THMAC_Init_ex = Function(ctx: PHMAC_CTX; key: Pointer; len: cInt;md: PEVP_MD; impl: PENGINE): cInt Cdecl;
   THMAC_Update = Function(ctx: PHMAC_CTX; data: PAnsiChar; len: size_t): cInt Cdecl;
   THMAC_Final = Function(ctx: PHMAC_CTX; md: PAnsiChar; len: pcUInt): cInt Cdecl;
   TOBJ_obj2nid = Function(Const o: PASN1_OBJECT): cInt Cdecl;
   TOBJ_nid2obj = Function(n: cInt): PASN1_OBJECT Cdecl;
   TOBJ_nid2ln = Function(n: cInt): PAnsiChar Cdecl;
   TOBJ_nid2sn = Function(n: cInt): PAnsiChar Cdecl;
   TASN1_INTEGER_set = Function(a: PASN1_INTEGER; v: cLong): cInt Cdecl;
   TASN1_INTEGER_get = Function(a: PASN1_INTEGER): cLong Cdecl;
   TASN1_STRING_type_new = Function(_type: cInt): PASN1_STRING Cdecl;
   TASN1_STRING_free = Procedure(a: PASN1_STRING) Cdecl;
   TASN1_dup = Function(i2d: i2d_of_void; d2i: d2i_of_void; x: PAnsiChar): Pointer Cdecl;
   TCRYPTO_set_mem_functions = Function(m: TCRYPTO_set_mem_functions_m; r: TCRYPTO_set_mem_functions_r; f: TCRYPTO_set_mem_functions_f): cInt Cdecl;
   TCRYPTO_malloc = Function(num: cInt; Const _file: PAnsiChar; line: cInt): Pointer Cdecl;
   TCRYPTO_free = Procedure(ptr: Pointer) Cdecl;
   TPKCS12_create = Function(pass, name: PAnsiChar; pkey: PEVP_PKEY; cert: PX509;ca: PSTACK_OF_X509; nid_key, nid_cert, iter, mac_iter, keytype: cInt): PPKCS12 Cdecl;
   Ti2d_PKCS12_bio = Function(b: PBIO; p12: PPKCS12): cInt Cdecl;
   TPKCS12_free = Procedure(p12: PPKCS12) Cdecl;
   TOPENSSL_sk_num = Function(Const x: PSTACK): cInt Cdecl;
   TOPENSSL_sk_new = Function(cmp: Tsk_new_cmp): PStack Cdecl;
   TOPENSSL_sk_free = Procedure(st: PSTACK) Cdecl;
   TOPENSSL_sk_push = Function(st: PSTACK; data: PAnsiChar): cInt Cdecl;
   TOPENSSL_sk_dup = Function(st: PSTACK): PSTACK Cdecl;
   TOPENSSL_sk_find = Function(st: PSTACK; Data: PAnsiChar): cInt Cdecl;
   TOPENSSL_sk_value = Function(x: PSTACK; i: cInt): PAnsiChar Cdecl;

   //...BN ...
   TBN_free = Procedure(a: PBIGNUM) Cdecl;
   TBN_hex2bn = Function(Var n: PBIGNUM; Const Str: PAnsiChar): cInt Cdecl;
   TBN_bn2hex = Function(Const n: PBIGNUM): PAnsiChar Cdecl;
   TBN_set_word = Function(a: PBIGNUM; w: cuLong): cInt Cdecl;
   TBN_set_flags = Procedure(Var b: BIGNUM; n: longint); Cdecl;
   TBN_get_flags = Function(Var b: BIGNUM; n: longint): longint; Cdecl;
   TBN_with_flags = Procedure(Var dest: BIGNUM; Var b: BIGNUM; flags: longint); Cdecl;
   TBN_GENCB_call = Function(Var cb: BN_GENCB; a: longint; b: longint): longint; Cdecl;
   TBN_GENCB_new = Function(): PBN_GENCB; Cdecl;
   TBN_GENCB_free = Procedure(Var cb: BN_GENCB); Cdecl;
   TBN_GENCB_get_arg = Function(Var cb: BN_GENCB): pointer; Cdecl;
   TBN_abs_is_word = Function(Var a: BIGNUM; w: BN_ULONG): longint; Cdecl;
   TBN_is_zero = Function(Var a: BIGNUM): longint; Cdecl;
   TBN_is_one = Function(Var a: BIGNUM): longint; Cdecl;
   TBN_is_word = Function(Var a: BIGNUM; w: BN_ULONG): longint; Cdecl;
   TBN_is_odd = Function(Var a: BIGNUM): longint; Cdecl;
   TBN_zero_ex = Procedure(Var a: BIGNUM); Cdecl;
   TBN_options = Function(): Pchar; Cdecl;
   TBN_CTX_new_ex = Function(Var ctx: OSSL_LIB_CTX): PBN_CTX; Cdecl;
   TBN_CTX_new = Function(): PBN_CTX; Cdecl;
   TBN_CTX_secure_new_ex = Function(Var ctx: OSSL_LIB_CTX): PBN_CTX; Cdecl;
   TBN_CTX_secure_new = Function(): PBN_CTX; Cdecl;
   TBN_CTX_free = Procedure(Var c: BN_CTX); Cdecl;
   TBN_CTX_start = Procedure(Var ctx: BN_CTX); Cdecl;
   TBN_CTX_get = Function(Var ctx: BN_CTX): PBIGNUM; Cdecl;
   TBN_CTX_end = Procedure(Var ctx: BN_CTX); Cdecl;
   TBN_rand_ex = Function(Var rnd: BIGNUM; bits: longint; top: longint; bottom: longint; strength: dword; Var ctx: BN_CTX): longint; Cdecl;
   TBN_rand = Function(Var rnd: BIGNUM; bits: longint; top: longint; bottom: longint): longint; Cdecl;
   TBN_priv_rand_ex = Function(Var rnd: BIGNUM; bits: longint; top: longint; bottom: longint; strength: dword;Var ctx: BN_CTX): longint; Cdecl;
   TBN_priv_rand = Function(Var rnd: BIGNUM; bits: longint; top: longint; bottom: longint): longint; Cdecl;
   TBN_rand_range_ex = Function(Var r: BIGNUM; Var range: BIGNUM; strength: dword; Var ctx: BN_CTX): longint; Cdecl;
   TBN_rand_range = Function(Var rnd: BIGNUM; Var range: BIGNUM): longint; Cdecl;
   TBN_priv_rand_range_ex = Function(Var r: BIGNUM; Var range: BIGNUM; strength: dword; Var ctx: BN_CTX): longint; Cdecl;
   TBN_priv_rand_range = Function(Var rnd: BIGNUM; Var range: BIGNUM): longint; Cdecl;
   TBN_num_bits = Function(Var a: BIGNUM): longint; Cdecl;
   TBN_num_bits_word = Function(l: BN_ULONG): longint; Cdecl;
   TBN_security_bits = Function(L: longint; N: longint): longint; Cdecl;
   TBN_new = Function(): PBIGNUM; Cdecl;
   TBN_secure_new = Function(): PBIGNUM; Cdecl;
   TBN_clear_free = Procedure(Var a: BIGNUM); Cdecl;
   TBN_copy = Function(Var a: BIGNUM; Var b: BIGNUM): PBIGNUM; Cdecl;
   TBN_swap = Procedure(Var a: BIGNUM; Var b: BIGNUM); Cdecl;
   TBN_bin2bn = Function(Var s: byte; len: longint; Var ret: BIGNUM): PBIGNUM; Cdecl;
   TBN_bn2bin = Function(Var a: BIGNUM; Var aTo : byte): longint; Cdecl;
   TBN_bn2binpad = Function(Var a: BIGNUM; Var aTo : byte; tolen: longint): longint; Cdecl;
   TBN_lebin2bn = Function(Var s: byte; len: longint; Var ret: BIGNUM): PBIGNUM; Cdecl;
   TBN_bn2lebinpad = Function(Var a: BIGNUM; Var aTo : byte; tolen: longint): longint; Cdecl;
   TBN_native2bn = Function(Var s: byte; len: longint; Var ret: BIGNUM): PBIGNUM; Cdecl;
   TBN_bn2nativepad = Function(Var a: BIGNUM; Var aTo : byte; tolen: longint): longint; Cdecl;
   TBN_mpi2bn = Function(Var s: byte; len: longint; Var ret: BIGNUM): PBIGNUM; Cdecl;
   TBN_bn2mpi = Function(Var a: BIGNUM; Var aTo : byte): longint; Cdecl;
   TBN_sub = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM): longint; Cdecl;
   TBN_usub = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM): longint; Cdecl;
   TBN_uadd = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM): longint; Cdecl;
   TBN_add = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM): longint; Cdecl;
   TBN_mul = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_sqr = Function(Var r: BIGNUM; Var a: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_set_negative = Procedure(Var b: BIGNUM; n: longint); Cdecl;
   TBN_is_negative = Function(Var b: BIGNUM): longint; Cdecl;
   TBN_div = Function(Var dv: BIGNUM; Var rem: BIGNUM; Var m: BIGNUM; Var d: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_nnmod = Function(Var r: BIGNUM; Var m: BIGNUM; Var d: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_add = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_add_quick = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var m: BIGNUM): longint; Cdecl;
   TBN_mod_sub = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_sub_quick = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var m: BIGNUM): longint; Cdecl;
   TBN_mod_mul = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_sqr = Function(Var r: BIGNUM; Var a: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_lshift1 = Function(Var r: BIGNUM; Var a: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_lshift1_quick = Function(Var r: BIGNUM; Var a: BIGNUM; Var m: BIGNUM): longint; Cdecl;
   TBN_mod_lshift = Function(Var r: BIGNUM; Var a: BIGNUM; n: longint; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_lshift_quick = Function(Var r: BIGNUM; Var a: BIGNUM; n: longint; Var m: BIGNUM): longint; Cdecl;
   TBN_mod_word = Function(Var a: BIGNUM; w: BN_ULONG): BN_ULONG; Cdecl;
   TBN_div_word = Function(Var a: BIGNUM; w: BN_ULONG): BN_ULONG; Cdecl;
   TBN_mul_word = Function(Var a: BIGNUM; w: BN_ULONG): longint; Cdecl;
   TBN_add_word = Function(Var a: BIGNUM; w: BN_ULONG): longint; Cdecl;
   TBN_sub_word = Function(Var a: BIGNUM; w: BN_ULONG): longint; Cdecl;
   TBN_get_word = Function(Var a: BIGNUM): BN_ULONG; Cdecl;
   TBN_cmp = Function(Var a: BIGNUM; Var b: BIGNUM): longint; Cdecl;
   TBN_is_bit_set = Function(Var a: BIGNUM; n: longint): longint; Cdecl;
   TBN_lshift = Function(Var r: BIGNUM; Var a: BIGNUM; n: longint): longint; Cdecl;
   TBN_lshift1 = Function(Var r: BIGNUM; Var a: BIGNUM): longint; Cdecl;
   TBN_exp = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_exp = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_exp_mont = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX;Var m_ctx: BN_MONT_CTX): longint; Cdecl;
   TBN_mod_exp_mont_consttime = Function(Var rr: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX;Var in_mont: BN_MONT_CTX): longint; Cdecl;
   TBN_mod_exp_mont_word = Function(Var r: BIGNUM; a: BN_ULONG; Var p: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX;Var m_ctx: BN_MONT_CTX): longint; Cdecl;
   TBN_mod_exp2_mont = Function(Var r: BIGNUM; Var a1: BIGNUM; Var p1: BIGNUM; Var a2: BIGNUM; Var p2: BIGNUM;Var m: BIGNUM; Var ctx: BN_CTX; Var m_ctx: BN_MONT_CTX): longint; Cdecl;
   TBN_mod_exp_simple = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_exp_mont_consttime_x2 = Function(Var rr1: BIGNUM; Var a1: BIGNUM; Var p1: BIGNUM; Var m1: BIGNUM; Var in_mont1: BN_MONT_CTX; Var rr2: BIGNUM;
                                            Var a2: BIGNUM; Var p2: BIGNUM; Var m2: BIGNUM; Var in_mont2: BN_MONT_CTX;Var ctx: BN_CTX): longint; Cdecl;
   TBN_mask_bits = Function(Var a: BIGNUM; n: longint): longint; Cdecl;
   TBN_print_fp = Function(Var fp: File; Var a: BIGNUM): longint; Cdecl;
   TBN_print = Function(Var bio: BIO; Var a: BIGNUM): longint; Cdecl;
   TBN_reciprocal = Function(Var r: BIGNUM; Var m: BIGNUM; len: longint; Var ctx: BN_CTX): longint; Cdecl;
   TBN_rshift = Function(Var r: BIGNUM; Var a: BIGNUM; n: longint): longint; Cdecl;
   TBN_rshift1 = Function(Var r: BIGNUM; Var a: BIGNUM): longint; Cdecl;
   TBN_clear = Procedure(Var a: BIGNUM); Cdecl;
   TBN_dup = Function(Var a: BIGNUM): PBIGNUM; Cdecl;
   TBN_ucmp = Function(Var a: BIGNUM; Var b: BIGNUM): longint; Cdecl;
   TBN_set_bit = Function(Var a: BIGNUM; n: longint): longint; Cdecl;
   TBN_clear_bit = Function(Var a: BIGNUM; n: longint): longint; Cdecl;
   TBN_bn2dec = Function(Var a: BIGNUM): Pchar; Cdecl;
   TBN_dec2bn = Function(Var a: PBIGNUM; str: Pchar): longint; Cdecl;
   TBN_asc2bn = Function(Var a: PBIGNUM; str: Pchar): longint; Cdecl;
   TBN_gcd = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_kronecker = Function(Var a: BIGNUM; Var b: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_inverse = Function(Var ret: BIGNUM; Var a: BIGNUM; Var n: BIGNUM; Var ctx: BN_CTX): PBIGNUM; Cdecl;
   TBN_mod_sqrt = Function(Var ret: BIGNUM; Var a: BIGNUM; Var n: BIGNUM; Var ctx: BN_CTX): PBIGNUM; Cdecl;
   TBN_consttime_swap = Procedure(swap: BN_ULONG; Var a: BIGNUM; Var b: BIGNUM; nwords: longint); Cdecl;
   TBN_generate_prime_ex2 = Function(Var ret: BIGNUM; bits: longint; safe: longint; Var add: BIGNUM; Var rem: BIGNUM;Var cb: BN_GENCB; Var ctx: BN_CTX): longint; Cdecl;
   TBN_generate_prime_ex = Function(Var ret: BIGNUM; bits: longint; safe: longint; Var add: BIGNUM; Var rem: BIGNUM;Var cb: BN_GENCB): longint; Cdecl;
   TBN_check_prime = Function(Var p: BIGNUM; Var ctx: BN_CTX; Var cb: BN_GENCB): longint; Cdecl;
   TBN_mod_mul_montgomery = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var mont: BN_MONT_CTX; Var ctx: BN_CTX): longint; Cdecl;
   TBN_to_montgomery = Function(Var r: BIGNUM; Var a: BIGNUM; Var mont: BN_MONT_CTX; Var ctx: BN_CTX): longint; Cdecl;
   TBN_from_montgomery = Function(Var r: BIGNUM; Var a: BIGNUM; Var mont: BN_MONT_CTX; Var ctx: BN_CTX): longint; Cdecl;
   TBN_MONT_CTX_free = Procedure(Var mont: BN_MONT_CTX); Cdecl;
   TBN_MONT_CTX_set = Function(Var mont: BN_MONT_CTX; Var aMod : BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_MONT_CTX_copy = Function(Var aTo : BN_MONT_CTX; Var from: BN_MONT_CTX): PBN_MONT_CTX; Cdecl;
   TBN_BLINDING_new = Function(Var A: BIGNUM; Var Ai: BIGNUM; Var aMod : BIGNUM): BN_BLINDING; Cdecl;
   TBN_BLINDING_free = Procedure(Var b: pBN_BLINDING); Cdecl;
   TBN_BLINDING_update = Function(Var b: pBN_BLINDING; Var ctx: BN_CTX): longint; Cdecl;
   TBN_BLINDING_convert = Function(Var n: BIGNUM; Var b: pBN_BLINDING; Var ctx: BN_CTX): longint; Cdecl;
   TBN_BLINDING_invert = Function(Var n: BIGNUM; Var b: pBN_BLINDING; Var ctx: BN_CTX): longint; Cdecl;
   TBN_BLINDING_convert_ex = Function(Var n: BIGNUM; Var r: BIGNUM; Var b: pBN_BLINDING; _para4: PBN_CTX): longint; Cdecl;
   TBN_BLINDING_invert_ex = Function(Var n: BIGNUM; Var r: BIGNUM; Var b: pBN_BLINDING; _para4: PBN_CTX): longint; Cdecl;
   TBN_BLINDING_is_current_thread = Function(Var b: pBN_BLINDING): longint; Cdecl;
   TBN_BLINDING_set_current_thread = Procedure(Var b: pBN_BLINDING); Cdecl;
   TBN_BLINDING_lock = Function(Var b: pBN_BLINDING): longint; Cdecl;
   TBN_BLINDING_unlock = Function(Var b: pBN_BLINDING): longint; Cdecl;
   TBN_BLINDING_get_flags = Function(_para1: BN_BLINDING): dword; Cdecl;
   TBN_BLINDING_set_flags = Procedure(_para1: BN_BLINDING; _para2: dword); Cdecl;
   TBN_RECP_CTX_new = Function(): PBN_RECP_CTX; Cdecl;
   TBN_RECP_CTX_free = Procedure(Var recp: BN_RECP_CTX); Cdecl;
   TBN_RECP_CTX_set = Function(Var recp: BN_RECP_CTX; Var rdiv: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_mul_reciprocal = Function(Var r: BIGNUM; Var x: BIGNUM; Var y: BIGNUM; Var recp: BN_RECP_CTX; Var ctx: BN_CTX): longint; Cdecl;
   TBN_mod_exp_recp = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var m: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_div_recp = Function(Var dv: BIGNUM; Var rem: BIGNUM; Var m: BIGNUM; Var recp: BN_RECP_CTX; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_add = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM): longint; Cdecl;
   TBN_GF2m_mod = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM): longint; Cdecl;
   TBN_GF2m_mod_mul = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_sqr = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_inv = Function(Var r: BIGNUM; Var b: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_div = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_exp = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_sqrt = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_solve_quad = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_arr = Function(Var r: BIGNUM; Var a: BIGNUM; p: Plongint): longint; Cdecl;
   TBN_GF2m_mod_mul_arr = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; p: Plongint; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_sqr_arr = Function(Var r: BIGNUM; Var a: BIGNUM; p: Plongint; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_inv_arr = Function(Var r: BIGNUM; Var b: BIGNUM; p: Plongint; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_div_arr = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; p: Plongint; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_exp_arr = Function(Var r: BIGNUM; Var a: BIGNUM; Var b: BIGNUM; p: Plongint; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_sqrt_arr = Function(Var r: BIGNUM; Var a: BIGNUM; p: Plongint; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_mod_solve_quad_arr = Function(Var r: BIGNUM; Var a: BIGNUM; p: Plongint; Var ctx: BN_CTX): longint; Cdecl;
   TBN_GF2m_poly2arr = Function(Var a: BIGNUM; p: Plongint; max: longint): longint; Cdecl;
   TBN_GF2m_arr2poly = Function(p: Plongint; Var a: BIGNUM): longint; Cdecl;
   TBN_nist_mod_192 = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_nist_mod_224 = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_nist_mod_256 = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_nist_mod_384 = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_nist_mod_521 = Function(Var r: BIGNUM; Var a: BIGNUM; Var p: BIGNUM; Var ctx: BN_CTX): longint; Cdecl;
   TBN_get0_nist_prime_192 = Function(): PBIGNUM; Cdecl;
   TBN_get0_nist_prime_224 = Function(): PBIGNUM; Cdecl;
   TBN_get0_nist_prime_256 = Function(): PBIGNUM; Cdecl;
   TBN_get0_nist_prime_384 = Function(): PBIGNUM; Cdecl;
   TBN_get0_nist_prime_521 = Function(): PBIGNUM; Cdecl;
   TBN_generate_dsa_nonce = Function(Var _out: BIGNUM; Var range: BIGNUM; Var priv: BIGNUM; Var message: byte; message_len: size_t;Var ctx: BN_CTX): longint; Cdecl;
   TBN_get_rfc2409_prime_768 = Function(Var bn: BIGNUM): PBIGNUM; Cdecl;
   TBN_get_rfc2409_prime_1024 = Function(Var bn: BIGNUM): PBIGNUM; Cdecl;
   TBN_get_rfc3526_prime_1536 = Function(Var bn: BIGNUM): PBIGNUM; Cdecl;
   TBN_get_rfc3526_prime_2048 = Function(Var bn: BIGNUM): PBIGNUM; Cdecl;
   TBN_get_rfc3526_prime_3072 = Function(Var bn: BIGNUM): PBIGNUM; Cdecl;
   TBN_get_rfc3526_prime_4096 = Function(Var bn: BIGNUM): PBIGNUM; Cdecl;
   TBN_get_rfc3526_prime_6144 = Function(Var bn: BIGNUM): PBIGNUM; Cdecl;
   TBN_get_rfc3526_prime_8192 = Function(Var bn: BIGNUM): PBIGNUM; Cdecl;
   TBN_bntest_rand = Function(Var rnd: BIGNUM; bits: longint; top: longint; bottom: longint): longint; Cdecl;


   //...BIO ....
              
   TBIO_new = Function(_type: PBIO_METHOD): PBIO Cdecl;
   TBIO_free = Function(bio: PBIO): cInt Cdecl;
   TBIO_new_mem_buf = Function(buf: Pointer; len: cInt): PBIO Cdecl;
   TBIO_ctrl = Function(bp: PBIO; cmd: cInt; larg: cLong; parg: Pointer): cLong Cdecl;
   TBIO_int_ctrl = Function(bp: PBIO; cmd: cInt; larg: cLong; iArg: cInt): cLong Cdecl;
   TBIO_ptr_ctrl = Function(bp: PBIO; cmd: cInt; larg: cLong): PAnsiChar Cdecl;
   TBIO_new_file = Function(Const filename: PAnsiChar; Const mode: PAnsiChar): PBIO Cdecl;
   TBIO_puts = Function(b: PBIO; Const txt: PAnsiChar): cInt Cdecl;
   TBIO_read = Function(b: PBIO; data: Pointer; len: cInt): cInt Cdecl;
   TBIO_write = Function(b: PBIO; Const buf: Pointer; len: cInt): cInt Cdecl;
   TBIO_get_callback_ex = Function(Var b: BIO): BIO_callback_fn_ex; Cdecl;
   TBIO_set_callback_ex = Procedure(Var b: BIO; callback: BIO_callback_fn_ex); Cdecl;
   TBIO_debug_callback_ex = Function(Var bio: BIO; oper: longint; argp: Pchar; len: size_t; argi: longint; argl: longint; ret: longint; Var processed: size_t): longint; Cdecl;
   TBIO_get_callback_arg = Function(Var b: BIO): Pchar; Cdecl;
   TBIO_set_callback_arg = Procedure(Var b: BIO; arg: Pchar); Cdecl;
   TBIO_method_name = Function(Var b: BIO): Pchar; Cdecl;
   TBIO_method_type = Function(Var b: BIO): longint; Cdecl;
   TBIO_ctrl_get_write_guarantee = Function(Var b: BIO): size_t; Cdecl;
   TBIO_ctrl_get_read_request = Function(Var b: BIO): size_t; Cdecl;
   TBIO_ctrl_reset_read_request = Function(Var b: BIO): longint; Cdecl;
   TBIO_set_ex_data = Function(Var bio: BIO; idx: longint; data: pointer): longint; Cdecl;
   TBIO_get_ex_data = Function(Var bio: BIO; idx: longint): pointer; Cdecl;
   TBIO_number_read = Function(Var bio: BIO): uint64_t; Cdecl;
   TBIO_number_written = Function(Var bio: BIO): uint64_t; Cdecl;
   TBIO_new_fp = Function(Var stream: File; close_flag: longint): PBIO; Cdecl;
   TBIO_new_ex = Function(Var libctx: OSSL_LIB_CTX; Var method: BIO_METHOD): PBIO; Cdecl;
   TBIO_set_data = Procedure(Var a: BIO; ptr: pointer); Cdecl;
   TBIO_get_data = Function(Var a: BIO): pointer; Cdecl;
   TBIO_set_init = Procedure(Var a: BIO; init: longint); Cdecl;
   TBIO_get_init = Function(Var a: BIO): longint; Cdecl;
   TBIO_set_shutdown = Procedure(Var a: BIO; shut: longint); Cdecl;
   TBIO_get_shutdown = Function(Var a: BIO): longint; Cdecl;
   TBIO_vfree = Procedure(Var a: BIO); Cdecl;
   TBIO_up_ref = Function(Var a: BIO): longint; Cdecl;
   TBIO_read_ex = Function(Var b: BIO; data: pointer; dlen: size_t; Var readbytes: size_t): longint; Cdecl;
   TBIO_gets = Function(Var bp: BIO; buf: Pchar; size: longint): longint; Cdecl;
   TBIO_get_line = Function(Var bio: BIO; buf: Pchar; size: longint): longint; Cdecl;
   TBIO_write_ex = Function(Var b: BIO; data: pointer; dlen: size_t; Var written: size_t): longint; Cdecl;
   TBIO_indent = Function(Var b: BIO; indent: longint; max: longint): longint; Cdecl;
   TBIO_push = Function(Var b: BIO; Var append: BIO): PBIO; Cdecl;
   TBIO_pop = Function(Var b: BIO): PBIO; Cdecl;
   TBIO_free_all = Procedure(Var a: BIO); Cdecl;
   TBIO_find_type = Function(Var b: BIO; bio_type: longint): PBIO; Cdecl;
   TBIO_next = Function(Var b: BIO): PBIO; Cdecl;
   TBIO_set_next = Procedure(Var b: BIO; Var next: BIO); Cdecl;
   TBIO_get_retry_BIO = Function(Var bio: BIO; Var reason: longint): PBIO; Cdecl;
   TBIO_get_retry_reason = Function(Var bio: BIO): longint; Cdecl;
   TBIO_set_retry_reason = Procedure(Var bio: BIO; reason: longint); Cdecl;
   TBIO_dup_chain = Function(Var aIn : BIO): PBIO; Cdecl;
   TBIO_nread0 = Function(Var bio: BIO; buf: PPchar): longint; Cdecl;
   TBIO_nread = Function(Var bio: BIO; buf: PPchar; num: longint): longint; Cdecl;
   TBIO_nwrite0 = Function(Var bio: BIO; buf: PPchar): longint; Cdecl;
   TBIO_nwrite = Function(Var bio: BIO; buf: PPchar; num: longint): longint; Cdecl;
   TBIO_s_mem = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_file = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_secmem = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_socket = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_connect = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_accept = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_fd = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_log = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_bio = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_null = Function(): PBIO_METHOD; Cdecl;
   TBIO_f_null = Function(): PBIO_METHOD; Cdecl;
   TBIO_f_buffer = Function(): PBIO_METHOD; Cdecl;
   TBIO_f_readbuffer = Function(): PBIO_METHOD; Cdecl;
   TBIO_f_linebuffer = Function(): PBIO_METHOD; Cdecl;
   TBIO_f_nbio_test = Function(): PBIO_METHOD; Cdecl;
   TBIO_f_prefix = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_core = Function(): PBIO_METHOD; Cdecl;
   TBIO_s_datagram = Function(): PBIO_METHOD; Cdecl;
   TBIO_dgram_non_fatal_error = Function(error: longint): longint; Cdecl;
   TBIO_new_dgram = Function(fd: longint; close_flag: longint): PBIO; Cdecl;
   TBIO_sock_should_retry = Function(i: longint): longint; Cdecl;
   TBIO_sock_non_fatal_error = Function(error: longint): longint; Cdecl;
   TBIO_socket_wait = Function(fd: longint; for_read: longint; max_time: time_t): longint; Cdecl;
   TBIO_wait = Function(Var bio: BIO; max_time: time_t; nap_milliseconds: dword): longint; Cdecl;
   TBIO_do_connect_retry = Function(Var bio: BIO; timeout: longint; nap_milliseconds: longint): longint; Cdecl;
   TBIO_fd_should_retry = Function(i: longint): longint; Cdecl;
   TBIO_fd_non_fatal_error = Function(error: longint): longint; Cdecl;
   TBIO_dump = Function(Var b: BIO; bytes: pointer; len: longint): longint; Cdecl;
   TBIO_dump_indent = Function(Var b: BIO; bytes: pointer; len: longint; indent: longint): longint; Cdecl;
   TBIO_dump_fp = Function(Var fp: File; s: pointer; len: longint): longint; Cdecl;
   TBIO_dump_indent_fp = Function(Var fp: File; s: pointer; len: longint; indent: longint): longint; Cdecl;
   TBIO_hex_string = Function(Var _out: BIO; indent: longint; width: longint; data: pointer; datalen: longint): longint; Cdecl;
   TBIO_ADDR_new = Function(): PBIO_ADDR; Cdecl;
   TBIO_ADDR_rawmake = Function(Var ap: BIO_ADDR; family: longint; where: pointer; wherelen: size_t; port: word): longint; Cdecl;
   TBIO_ADDR_free = Procedure(_para1: PBIO_ADDR); Cdecl;
   TBIO_ADDR_clear = Procedure(Var ap: BIO_ADDR); Cdecl;
   TBIO_ADDR_family = Function(Var ap: BIO_ADDR): longint; Cdecl;
   TBIO_ADDR_rawaddress = Function(Var ap: BIO_ADDR; p: pointer; Var l: size_t): longint; Cdecl;
   TBIO_ADDR_rawport = Function(Var ap: BIO_ADDR): word; Cdecl;
   TBIO_ADDR_hostname_string = Function(Var ap: BIO_ADDR; numeric: longint): Pchar; Cdecl;
   TBIO_ADDR_service_string = Function(Var ap: BIO_ADDR; numeric: longint): Pchar; Cdecl;
   TBIO_ADDR_path_string = Function(Var ap: BIO_ADDR): Pchar; Cdecl;
   TBIO_ADDRINFO_next = Function(Var bai: BIO_ADDRINFO): PBIO_ADDRINFO; Cdecl;
   TBIO_ADDRINFO_family = Function(Var bai: BIO_ADDRINFO): longint; Cdecl;
   TBIO_ADDRINFO_socktype = Function(Var bai: BIO_ADDRINFO): longint; Cdecl;
   TBIO_ADDRINFO_protocol = Function(Var bai: BIO_ADDRINFO): longint; Cdecl;
   TBIO_ADDRINFO_address = Function(Var bai: BIO_ADDRINFO): PBIO_ADDR; Cdecl;
   TBIO_ADDRINFO_free = Procedure(Var bai: BIO_ADDRINFO); Cdecl;
   TBIO_parse_hostserv = Function(hostserv: Pchar; host: PPchar; service: PPchar; hostserv_prio: BIO_hostserv_priorities): longint; Cdecl;
   TBIO_lookup = Function(host: Pchar; service: Pchar; lookup_type: BIO_lookup_type; family: longint; socktype: longint;Var res: PBIO_ADDRINFO): longint; Cdecl;
   TBIO_lookup_ex = Function(host: Pchar; service: Pchar; lookup_type: longint; family: longint; socktype: longint;protocol: longint; Var res: PBIO_ADDRINFO): longint; Cdecl;
   TBIO_sock_error = Function(sock: longint): longint; Cdecl;
   TBIO_socket_ioctl = Function(fd: longint; _type: longint; arg: pointer): longint; Cdecl;
   TBIO_socket_nbio = Function(fd: longint; mode: longint): longint; Cdecl;
   TBIO_sock_init = Function(): longint; Cdecl;
   TBIO_set_tcp_ndelay = Function(sock: longint; turn_on: longint): longint; Cdecl;
   TBIO_sock_info = Function(sock: longint; _type: BIO_sock_info_type; Var info: BIO_sock_info_u): longint; Cdecl;
   TBIO_socket = Function(domain: longint; socktype: longint; protocol: longint; options: longint): longint; Cdecl;
   TBIO_connect = Function(sock: longint; Var addr: BIO_ADDR; options: longint): longint; Cdecl;
   TBIO_bind = Function(sock: longint; Var addr: BIO_ADDR; options: longint): longint; Cdecl;
   TBIO_listen = Function(sock: longint; Var addr: BIO_ADDR; options: longint): longint; Cdecl;
   TBIO_accept_ex = Function(accept_sock: longint; Var addr: BIO_ADDR; options: longint): longint; Cdecl;
   TBIO_closesocket = Function(sock: longint): longint; Cdecl;
   TBIO_new_socket = Function(sock: longint; close_flag: longint): PBIO; Cdecl;
   TBIO_new_connect = Function(host_port: Pchar): PBIO; Cdecl;
   TBIO_new_accept = Function(host_port: Pchar): PBIO; Cdecl;
   TBIO_new_fd = Function(fd: longint; close_flag: longint): PBIO; Cdecl;
   TBIO_new_bio_pair = Function(Var bio1: PBIO; writebuf1: size_t; Var bio2: PBIO; writebuf2: size_t): longint; Cdecl;
   TBIO_copy_next_retry = Procedure(Var b: BIO); Cdecl;
   TBIO_meth_new = Function(_type: longint; name: Pchar): PBIO_METHOD; Cdecl;
   TBIO_meth_free = Procedure(Var biom: BIO_METHOD); Cdecl;

//-------------------------------------------------

 Var

   SSL_CTX_set_cipher_list : TSSL_CTX_set_cipher_list = Nil;
   SSL_CTX_new : TSSL_CTX_new = Nil;
   SSL_CTX_free : TSSL_CTX_free = Nil;
   SSL_set_fd : TSSL_set_fd = Nil;
   SSL_CTX_use_PrivateKey_file : TSSL_CTX_use_PrivateKey_file = Nil;
   SSL_CTX_use_PrivateKey : TSSL_CTX_use_PrivateKey = Nil;
   SSL_CTX_use_certificate : TSSL_CTX_use_certificate = Nil;
   SSL_CTX_use_certificate_file : TSSL_CTX_use_certificate_file = Nil;
   SSL_state_string_long : TSSL_state_string_long = Nil;
   SSL_alert_desc_string_long : TSSL_alert_desc_string_long = Nil;
   SSL_alert_type_string_long : TSSL_alert_type_string_long = Nil;
   SSL_CTX_set_verify : TSSL_CTX_set_verify = Nil;
   SSL_CTX_set_verify_depth : TSSL_CTX_set_verify_depth = Nil;
   SSL_CTX_get_verify_depth : TSSL_CTX_get_verify_depth = Nil;
   SSL_CTX_set_default_passwd_cb : TSSL_CTX_set_default_passwd_cb = Nil;
   SSL_CTX_set_default_passwd_cb_userdata : TSSL_CTX_set_default_passwd_cb_userdata = Nil;
   SSL_CTX_check_private_key : TSSL_CTX_check_private_key = Nil;
   SSL_new : TSSL_new = Nil;
   SSL_free : TSSL_free = Nil;
   SSL_accept : TSSL_accept = Nil;
   SSL_connect : TSSL_connect = Nil;
   SSL_read : TSSL_read = Nil;
   SSL_peek : TSSL_peek = Nil;
   SSL_pending : TSSL_pending = Nil;
   SSL_write : TSSL_write = Nil;
   SSL_ctrl : TSSL_ctrl = Nil;
   SSL_callback_ctrl : TSSL_callback_ctrl = Nil;
   SSL_CTX_ctrl : TSSL_CTX_ctrl = Nil;
   SSL_CTX_callback_ctrl : TSSL_CTX_callback_ctrl = Nil;
   SSL_get_error : TSSL_get_error = Nil;
   SSL_shutdown : TSSL_shutdown = Nil;
   SSL_set_connect_state : TSSL_set_connect_state = Nil;
   SSL_set_accept_state : TSSL_set_accept_state = Nil;
   SSL_set_shutdown : TSSL_set_shutdown = Nil;
   SSL_CTX_load_verify_locations : TSSL_CTX_load_verify_locations = Nil;
   SSL_get_session : TSSL_get_session = Nil;
   SSL_SESSION_get_id : TSSL_SESSION_get_id = Nil;
   SSL_copy_session_id : TSSL_copy_session_id = Nil;   
   SSL_set_ex_data : TSSL_set_ex_data = Nil;
   SSL_get_ex_data : TSSL_get_ex_data = Nil;
   SSL_load_client_CA_file : TSSL_load_client_CA_file = Nil;
   SSL_CTX_set_client_CA_list : TSSL_CTX_set_client_CA_list = Nil;
   SSL_CTX_set_default_verify_paths : TSSL_CTX_set_default_verify_paths = Nil;
   SSL_CTX_set_session_id_context : TSSL_CTX_set_session_id_context = Nil;
   SSL_CIPHER_description : TSSL_CIPHER_description = Nil;
   SSL_get_current_cipher : TSSL_get_current_cipher = Nil;
   SSL_CIPHER_get_name : TSSL_CIPHER_get_name = Nil;
   SSL_CIPHER_get_version : TSSL_CIPHER_get_version = Nil;
   SSL_CIPHER_get_bits : TSSL_CIPHER_get_bits = Nil;
   d2i_X509_NAME : Td2i_X509_NAME = Nil;
   i2d_X509_NAME : Ti2d_X509_NAME = Nil;
   X509_NAME_oneline : TX509_NAME_oneline = Nil;
   X509_NAME_cmp : TX509_NAME_cmp = Nil;
   X509_NAME_hash_old : TX509_NAME_hash_old = Nil;
   X509_set_issuer_name : TX509_set_issuer_name = Nil;
   X509_get_issuer_name : TX509_get_issuer_name = Nil;
   X509_set_subject_name : TX509_set_subject_name = Nil;
   X509_get_subject_name : TX509_get_subject_name = Nil;
   X509_digest : TX509_digest = Nil;
   X509_LOOKUP_ctrl : TX509_LOOKUP_ctrl = Nil;
   X509_STORE_add_cert : TX509_STORE_add_cert = Nil;
   X509_STORE_add_crl : TX509_STORE_add_crl = Nil;
   X509_STORE_CTX_get_ex_data : TX509_STORE_CTX_get_ex_data = Nil;
   X509_STORE_CTX_get_error : TX509_STORE_CTX_get_error = Nil;
   X509_STORE_CTX_set_error : TX509_STORE_CTX_set_error = Nil;
   X509_STORE_CTX_get_error_depth : TX509_STORE_CTX_get_error_depth = Nil;
   X509_STORE_CTX_get_current_cert : TX509_STORE_CTX_get_current_cert = Nil;
   X509_STORE_add_lookup : TX509_STORE_add_lookup = Nil;
   X509_STORE_load_locations : TX509_STORE_load_locations = Nil;
   i2d_DSAPrivateKey : Ti2d_DSAPrivateKey = Nil;
   d2i_DSAPrivateKey : Td2i_DSAPrivateKey = Nil;
   d2i_PrivateKey : Td2i_PrivateKey = Nil;
   d2i_PrivateKey_bio : Td2i_PrivateKey_bio = Nil;
   X509_sign : TX509_sign = Nil;
   X509_REQ_sign : TX509_REQ_sign = Nil;
   X509_REQ_add_extensions : TX509_REQ_add_extensions = Nil;
   X509V3_EXT_conf_nid : TX509V3_EXT_conf_nid = Nil;
   X509_EXTENSION_create_by_NID : TX509_EXTENSION_create_by_NID = Nil;
   X509V3_set_ctx : TX509V3_set_ctx = Nil;
   X509_EXTENSION_free : TX509_EXTENSION_free = Nil;
   X509_add_ext : TX509_add_ext = Nil;
   X509_print : TX509_print = Nil;
   RAND_bytes : TRAND_bytes = Nil;
   RAND_pseudo_bytes : TRAND_pseudo_bytes = Nil;
   RAND_seed : TRAND_seed = Nil;
   RAND_add : TRAND_add = Nil;
   DES_set_odd_parity : TDES_set_odd_parity = Nil;
   DES_set_key : TDES_set_key = Nil;
   DES_ecb_encrypt : TDES_ecb_encrypt = Nil;
   ERR_error_string : TERR_error_string = Nil;
   ERR_error_string_n : TERR_error_string_n = Nil;
   ERR_lib_error_string : TERR_lib_error_string = Nil;
   ERR_func_error_string : TERR_func_error_string = Nil;
   ERR_reason_error_string : TERR_reason_error_string = Nil;
   ERR_remove_thread_state : TERR_remove_thread_state = Nil;
   OPENSSL_sk_pop_free : TOPENSSL_sk_pop_free = Nil;
   RSA_new : TRSA_new = Nil;
   RSA_free : TRSA_free = Nil;
   RSA_generate_key : TRSA_generate_key = Nil;
   RSA_check_key : TRSA_check_key = Nil;
   RSA_generate_key_ex : TRSA_generate_key_ex = Nil;
   RSA_size : TRSA_size = Nil;
   RSA_private_decrypt : TRSA_private_decrypt = Nil;
   RSA_public_encrypt : TRSA_public_encrypt = Nil;
   DH_free : TDH_free = Nil;
   i2d_X509_bio : Ti2d_X509_bio = Nil;
   i2d_PrivateKey_bio : Ti2d_PrivateKey_bio = Nil;
   d2i_X509_bio : Td2i_X509_bio = Nil;
   i2d_X509_REQ_bio : Ti2d_X509_REQ_bio = Nil;
   i2d_PKCS7 : Ti2d_PKCS7 = Nil;
   d2i_PKCS7 : Td2i_PKCS7 = Nil;
   i2d_X509 : Ti2d_X509 = Nil;
   d2i_X509 : Td2i_X509 = Nil;
   i2d_X509_REQ : Ti2d_X509_REQ = Nil;
   d2i_X509_REQ : Td2i_X509_REQ = Nil;
   i2d_X509_CRL : Ti2d_X509_CRL = Nil;
   d2i_X509_CRL : Td2i_X509_CRL = Nil;
   i2d_RSAPrivateKey : Ti2d_RSAPrivateKey = Nil;
   d2i_RSAPrivateKey : Td2i_RSAPrivateKey = Nil;
   i2d_RSAPublicKey : Ti2d_RSAPublicKey = Nil;
   d2i_RSAPublicKey : Td2i_RSAPublicKey = Nil;
   i2d_PrivateKey : Ti2d_PrivateKey = Nil;
   i2d_DSAparams : Ti2d_DSAparams = Nil;
   d2i_DSAparams : Td2i_DSAparams = Nil;
   i2d_DHparams : Ti2d_DHparams = Nil;
   d2i_DHparams : Td2i_DHparams = Nil;
   i2d_NETSCAPE_CERT_SEQUENCE : Ti2d_NETSCAPE_CERT_SEQUENCE = Nil;
   d2i_NETSCAPE_CERT_SEQUENCE : Td2i_NETSCAPE_CERT_SEQUENCE = Nil;
   i2d_PUBKEY : Ti2d_PUBKEY = Nil;
   d2i_PUBKEY : Td2i_PUBKEY = Nil;
   X509_free : TX509_free = Nil;
   X509_REQ_free : TX509_REQ_free = Nil;
   X509_to_X509_REQ : TX509_to_X509_REQ = Nil;
   X509_NAME_free : TX509_NAME_free = Nil;
   X509_NAME_add_entry_by_txt : TX509_NAME_add_entry_by_txt = Nil;
   X509_INFO_free : TX509_INFO_free = Nil;
   X509_set_version : TX509_set_version = Nil;
   X509_get_serialNumber : TX509_get_serialNumber = Nil;
   X509_gmtime_adj : TX509_gmtime_adj = Nil;
   X509_set_pubkey : TX509_set_pubkey = Nil;
   X509_REQ_set_pubkey : TX509_REQ_set_pubkey = Nil;
   X509_PUBKEY_get : TX509_PUBKEY_get = Nil;
   X509_verify : TX509_verify = Nil;
   PEM_read_bio_X509 : TPEM_read_bio_X509 = Nil;
   PEM_read_bio_X509_REQ : TPEM_read_bio_X509_REQ = Nil;
   PEM_read_bio_X509_CRL : TPEM_read_bio_X509_CRL = Nil;
   PEM_read_bio_RSAPrivateKey : TPEM_read_bio_RSAPrivateKey = Nil;
   PEM_read_bio_RSAPublicKey : TPEM_read_bio_RSAPublicKey = Nil;
   PEM_read_bio_DSAPrivateKey : TPEM_read_bio_DSAPrivateKey = Nil;
   PEM_read_bio_PrivateKey : TPEM_read_bio_PrivateKey = Nil;
   PEM_read_bio_PKCS7 : TPEM_read_bio_PKCS7 = Nil;
   PEM_read_bio_DHparams : TPEM_read_bio_DHparams = Nil;
   PEM_read_bio_DSAparams : TPEM_read_bio_DSAparams = Nil;
   PEM_read_bio_NETSCAPE_CERT_SEQUENCE : TPEM_read_bio_NETSCAPE_CERT_SEQUENCE = Nil;
   PEM_read_bio_PUBKEY : TPEM_read_bio_PUBKEY = Nil;
   PEM_write_bio_X509 : TPEM_write_bio_X509 = Nil;
   PEM_write_bio_X509_REQ : TPEM_write_bio_X509_REQ = Nil;
   PEM_write_bio_X509_CRL : TPEM_write_bio_X509_CRL = Nil;
   PEM_write_bio_RSAPrivateKey : TPEM_write_bio_RSAPrivateKey = Nil;
   PEM_write_bio_RSAPublicKey : TPEM_write_bio_RSAPublicKey = Nil;
   PEM_write_bio_DSAPrivateKey : TPEM_write_bio_DSAPrivateKey = Nil;
   PEM_write_bio_PrivateKey : TPEM_write_bio_PrivateKey = Nil;
   PEM_write_bio_PKCS7 : TPEM_write_bio_PKCS7 = Nil;
   PEM_write_bio_DHparams : TPEM_write_bio_DHparams = Nil;
   PEM_write_bio_DSAparams : TPEM_write_bio_DSAparams = Nil;
   PEM_write_bio_NETSCAPE_CERT_SEQUENCE : TPEM_write_bio_NETSCAPE_CERT_SEQUENCE = Nil;
   PEM_write_bio_PKCS8PrivateKey : TPEM_write_bio_PKCS8PrivateKey = Nil;
   PEM_write_bio_PUBKEY : TPEM_write_bio_PUBKEY = Nil;
   PEM_X509_INFO_read_bio : TPEM_X509_INFO_read_bio = Nil;
   PEM_read_bio_X509_AUX : TPEM_read_bio_X509_AUX = Nil;
   EVP_MD_CTX_copy : TEVP_MD_CTX_copy = Nil;
   EVP_MD_CTX_copy_ex : TEVP_MD_CTX_copy_ex = Nil;
   EVP_DigestInit_ex : TEVP_DigestInit_ex = Nil;
   EVP_DigestUpdate : TEVP_DigestUpdate = Nil;
   EVP_DigestFinal_ex : TEVP_DigestFinal_ex = Nil;
   EVP_PKEY_new : TEVP_PKEY_new = Nil;
   EVP_PKEY_type : TEVP_PKEY_type = Nil;
   EVP_PKEY_free : TEVP_PKEY_free = Nil;
   EVP_PKEY_assign : TEVP_PKEY_assign = Nil;
   EVP_get_digestbyname : TEVP_get_digestbyname = Nil;
   HMAC_Init_ex : THMAC_Init_ex = Nil;
   HMAC_Update : THMAC_Update = Nil;
   HMAC_Final : THMAC_Final = Nil;
   OBJ_obj2nid : TOBJ_obj2nid = Nil;
   OBJ_nid2obj : TOBJ_nid2obj = Nil;
   OBJ_nid2ln : TOBJ_nid2ln = Nil;
   OBJ_nid2sn : TOBJ_nid2sn = Nil;
   ASN1_INTEGER_set : TASN1_INTEGER_set = Nil;
   ASN1_INTEGER_get : TASN1_INTEGER_get = Nil;
   ASN1_STRING_type_new : TASN1_STRING_type_new = Nil;
   ASN1_STRING_free : TASN1_STRING_free = Nil;
   ASN1_dup : TASN1_dup = Nil;
   CRYPTO_set_mem_functions : TCRYPTO_set_mem_functions = Nil;
   CRYPTO_malloc : TCRYPTO_malloc = Nil;
   CRYPTO_free : TCRYPTO_free = Nil;
   PKCS12_create : TPKCS12_create = Nil;
   i2d_PKCS12_bio : Ti2d_PKCS12_bio = Nil;
   PKCS12_free : TPKCS12_free = Nil;
   OPENSSL_sk_num : TOPENSSL_sk_num = Nil;
   OPENSSL_sk_new : TOPENSSL_sk_new = Nil;
   OPENSSL_sk_free : TOPENSSL_sk_free = Nil;
   OPENSSL_sk_push : TOPENSSL_sk_push = Nil;
   OPENSSL_sk_dup : TOPENSSL_sk_dup = Nil;
   OPENSSL_sk_find : TOPENSSL_sk_find = Nil;
   OPENSSL_sk_value : TOPENSSL_sk_value = Nil;

   //...BN ...
   BN_free : TBN_free = Nil;
   BN_hex2bn : TBN_hex2bn = Nil;
   BN_bn2hex : TBN_bn2hex = Nil;
   BN_set_word : TBN_set_word = Nil;
   BN_set_flags : TBN_set_flags = Nil;
   BN_get_flags : TBN_get_flags = Nil;
   BN_with_flags : TBN_with_flags = Nil;
   BN_GENCB_call : TBN_GENCB_call = Nil;
   BN_GENCB_new : TBN_GENCB_new = Nil;
   BN_GENCB_free : TBN_GENCB_free = Nil;
   BN_GENCB_get_arg : TBN_GENCB_get_arg = Nil;
   BN_abs_is_word : TBN_abs_is_word = Nil;
   BN_is_zero : TBN_is_zero = Nil;
   BN_is_one : TBN_is_one = Nil;
   BN_is_word : TBN_is_word = Nil;
   BN_is_odd : TBN_is_odd = Nil;
   BN_zero_ex : TBN_zero_ex = Nil;
   BN_options : TBN_options = Nil;
   BN_CTX_new_ex : TBN_CTX_new_ex = Nil;
   BN_CTX_new : TBN_CTX_new = Nil;
   BN_CTX_secure_new_ex : TBN_CTX_secure_new_ex = Nil;
   BN_CTX_secure_new : TBN_CTX_secure_new = Nil;
   BN_CTX_free : TBN_CTX_free = Nil;
   BN_CTX_start : TBN_CTX_start = Nil;
   BN_CTX_get : TBN_CTX_get = Nil;
   BN_CTX_end : TBN_CTX_end = Nil;
   BN_rand_ex : TBN_rand_ex = Nil;
   BN_rand : TBN_rand = Nil;
   BN_priv_rand_ex : TBN_priv_rand_ex = Nil;
   BN_priv_rand : TBN_priv_rand = Nil;
   BN_rand_range_ex : TBN_rand_range_ex = Nil;
   BN_rand_range : TBN_rand_range = Nil;
   BN_priv_rand_range_ex : TBN_priv_rand_range_ex = Nil;
   BN_priv_rand_range : TBN_priv_rand_range = Nil;
   BN_num_bits : TBN_num_bits = Nil;
   BN_num_bits_word : TBN_num_bits_word = Nil;
   BN_security_bits : TBN_security_bits = Nil;
   BN_new : TBN_new = Nil;
   BN_secure_new : TBN_secure_new = Nil;
   BN_clear_free : TBN_clear_free = Nil;
   BN_copy : TBN_copy = Nil;
   BN_swap : TBN_swap = Nil;
   BN_bin2bn : TBN_bin2bn = Nil;
   BN_bn2bin : TBN_bn2bin = Nil;
   BN_bn2binpad : TBN_bn2binpad = Nil;
   BN_lebin2bn : TBN_lebin2bn = Nil;
   BN_bn2lebinpad : TBN_bn2lebinpad = Nil;
   BN_native2bn : TBN_native2bn = Nil;
   BN_bn2nativepad : TBN_bn2nativepad = Nil;
   BN_mpi2bn : TBN_mpi2bn = Nil;
   BN_bn2mpi : TBN_bn2mpi = Nil;
   BN_sub : TBN_sub = Nil;
   BN_usub : TBN_usub = Nil;
   BN_uadd : TBN_uadd = Nil;
   BN_add : TBN_add = Nil;
   BN_mul : TBN_mul = Nil;
   BN_sqr : TBN_sqr = Nil;
   BN_set_negative : TBN_set_negative = Nil;
   BN_is_negative : TBN_is_negative = Nil;
   BN_div : TBN_div = Nil;
   BN_nnmod : TBN_nnmod = Nil;
   BN_mod_add : TBN_mod_add = Nil;
   BN_mod_add_quick : TBN_mod_add_quick = Nil;
   BN_mod_sub : TBN_mod_sub = Nil;
   BN_mod_sub_quick : TBN_mod_sub_quick = Nil;
   BN_mod_mul : TBN_mod_mul = Nil;
   BN_mod_sqr : TBN_mod_sqr = Nil;
   BN_mod_lshift1 : TBN_mod_lshift1 = Nil;
   BN_mod_lshift1_quick : TBN_mod_lshift1_quick = Nil;
   BN_mod_lshift : TBN_mod_lshift = Nil;
   BN_mod_lshift_quick : TBN_mod_lshift_quick = Nil;
   BN_mod_word : TBN_mod_word = Nil;
   BN_div_word : TBN_div_word = Nil;
   BN_mul_word : TBN_mul_word = Nil;
   BN_add_word : TBN_add_word = Nil;
   BN_sub_word : TBN_sub_word = Nil;
   BN_get_word : TBN_get_word = Nil;
   BN_cmp : TBN_cmp = Nil;
   BN_is_bit_set : TBN_is_bit_set = Nil;
   BN_lshift : TBN_lshift = Nil;
   BN_lshift1 : TBN_lshift1 = Nil;
   BN_exp : TBN_exp = Nil;
   BN_mod_exp : TBN_mod_exp = Nil;
   BN_mod_exp_mont : TBN_mod_exp_mont = Nil;
   BN_mod_exp_mont_consttime : TBN_mod_exp_mont_consttime = Nil;
   BN_mod_exp_mont_word : TBN_mod_exp_mont_word = Nil;
   BN_mod_exp2_mont : TBN_mod_exp2_mont = Nil;
   BN_mod_exp_simple : TBN_mod_exp_simple = Nil;
   BN_mod_exp_mont_consttime_x2 : TBN_mod_exp_mont_consttime_x2 = Nil;
   BN_mask_bits : TBN_mask_bits = Nil;
   BN_print_fp : TBN_print_fp = Nil;
   BN_print : TBN_print = Nil;
   BN_reciprocal : TBN_reciprocal = Nil;
   BN_rshift : TBN_rshift = Nil;
   BN_rshift1 : TBN_rshift1 = Nil;
   BN_clear : TBN_clear = Nil;
   BN_dup : TBN_dup = Nil;
   BN_ucmp : TBN_ucmp = Nil;
   BN_set_bit : TBN_set_bit = Nil;
   BN_clear_bit : TBN_clear_bit = Nil;
   BN_bn2dec : TBN_bn2dec = Nil;
   BN_dec2bn : TBN_dec2bn = Nil;
   BN_asc2bn : TBN_asc2bn = Nil;
   BN_gcd : TBN_gcd = Nil;
   BN_kronecker : TBN_kronecker = Nil;
   BN_mod_inverse : TBN_mod_inverse = Nil;
   BN_mod_sqrt : TBN_mod_sqrt = Nil;
   BN_consttime_swap : TBN_consttime_swap = Nil;
   BN_generate_prime_ex2 : TBN_generate_prime_ex2 = Nil;
   BN_generate_prime_ex : TBN_generate_prime_ex = Nil;
   BN_check_prime : TBN_check_prime = Nil;
   BN_mod_mul_montgomery : TBN_mod_mul_montgomery = Nil;
   BN_to_montgomery : TBN_to_montgomery = Nil;
   BN_from_montgomery : TBN_from_montgomery = Nil;
   BN_MONT_CTX_free : TBN_MONT_CTX_free = Nil;
   BN_MONT_CTX_set : TBN_MONT_CTX_set = Nil;
   BN_MONT_CTX_copy : TBN_MONT_CTX_copy = Nil;
   BN_BLINDING_new : TBN_BLINDING_new = Nil;
   BN_BLINDING_free : TBN_BLINDING_free = Nil;
   BN_BLINDING_update : TBN_BLINDING_update = Nil;
   BN_BLINDING_convert : TBN_BLINDING_convert = Nil;
   BN_BLINDING_invert : TBN_BLINDING_invert = Nil;
   BN_BLINDING_convert_ex : TBN_BLINDING_convert_ex = Nil;
   BN_BLINDING_invert_ex : TBN_BLINDING_invert_ex = Nil;
   BN_BLINDING_is_current_thread : TBN_BLINDING_is_current_thread = Nil;
   BN_BLINDING_set_current_thread : TBN_BLINDING_set_current_thread = Nil;
   BN_BLINDING_lock : TBN_BLINDING_lock = Nil;
   BN_BLINDING_unlock : TBN_BLINDING_unlock = Nil;
   BN_BLINDING_get_flags : TBN_BLINDING_get_flags = Nil;
   BN_BLINDING_set_flags : TBN_BLINDING_set_flags = Nil;
   BN_RECP_CTX_new : TBN_RECP_CTX_new = Nil;
   BN_RECP_CTX_free : TBN_RECP_CTX_free = Nil;
   BN_RECP_CTX_set : TBN_RECP_CTX_set = Nil;
   BN_mod_mul_reciprocal : TBN_mod_mul_reciprocal = Nil;
   BN_mod_exp_recp : TBN_mod_exp_recp = Nil;
   BN_div_recp : TBN_div_recp = Nil;
   BN_GF2m_add : TBN_GF2m_add = Nil;
   BN_GF2m_mod : TBN_GF2m_mod = Nil;
   BN_GF2m_mod_mul : TBN_GF2m_mod_mul = Nil;
   BN_GF2m_mod_sqr : TBN_GF2m_mod_sqr = Nil;
   BN_GF2m_mod_inv : TBN_GF2m_mod_inv = Nil;
   BN_GF2m_mod_div : TBN_GF2m_mod_div = Nil;
   BN_GF2m_mod_exp : TBN_GF2m_mod_exp = Nil;
   BN_GF2m_mod_sqrt : TBN_GF2m_mod_sqrt = Nil;
   BN_GF2m_mod_solve_quad : TBN_GF2m_mod_solve_quad = Nil;
   BN_GF2m_mod_arr : TBN_GF2m_mod_arr = Nil;
   BN_GF2m_mod_mul_arr : TBN_GF2m_mod_mul_arr = Nil;
   BN_GF2m_mod_sqr_arr : TBN_GF2m_mod_sqr_arr = Nil;
   BN_GF2m_mod_inv_arr : TBN_GF2m_mod_inv_arr = Nil;
   BN_GF2m_mod_div_arr : TBN_GF2m_mod_div_arr = Nil;
   BN_GF2m_mod_exp_arr : TBN_GF2m_mod_exp_arr = Nil;
   BN_GF2m_mod_sqrt_arr : TBN_GF2m_mod_sqrt_arr = Nil;
   BN_GF2m_mod_solve_quad_arr : TBN_GF2m_mod_solve_quad_arr = Nil;
   BN_GF2m_poly2arr : TBN_GF2m_poly2arr = Nil;
   BN_GF2m_arr2poly : TBN_GF2m_arr2poly = Nil;
   BN_nist_mod_192 : TBN_nist_mod_192 = Nil;
   BN_nist_mod_224 : TBN_nist_mod_224 = Nil;
   BN_nist_mod_256 : TBN_nist_mod_256 = Nil;
   BN_nist_mod_384 : TBN_nist_mod_384 = Nil;
   BN_nist_mod_521 : TBN_nist_mod_521 = Nil;
   BN_get0_nist_prime_192 : TBN_get0_nist_prime_192 = Nil;
   BN_get0_nist_prime_224 : TBN_get0_nist_prime_224 = Nil;
   BN_get0_nist_prime_256 : TBN_get0_nist_prime_256 = Nil;
   BN_get0_nist_prime_384 : TBN_get0_nist_prime_384 = Nil;
   BN_get0_nist_prime_521 : TBN_get0_nist_prime_521 = Nil;
   BN_generate_dsa_nonce : TBN_generate_dsa_nonce = Nil;
   BN_get_rfc2409_prime_768 : TBN_get_rfc2409_prime_768 = Nil;
   BN_get_rfc2409_prime_1024 : TBN_get_rfc2409_prime_1024 = Nil;
   BN_get_rfc3526_prime_1536 : TBN_get_rfc3526_prime_1536 = Nil;
   BN_get_rfc3526_prime_2048 : TBN_get_rfc3526_prime_2048 = Nil;
   BN_get_rfc3526_prime_3072 : TBN_get_rfc3526_prime_3072 = Nil;
   BN_get_rfc3526_prime_4096 : TBN_get_rfc3526_prime_4096 = Nil;
   BN_get_rfc3526_prime_6144 : TBN_get_rfc3526_prime_6144 = Nil;
   BN_get_rfc3526_prime_8192 : TBN_get_rfc3526_prime_8192 = Nil;
   BN_bntest_rand : TBN_bntest_rand = Nil;

   //...BIO
   BIO_new : TBIO_new = Nil;
   BIO_free : TBIO_free = Nil;
   BIO_new_mem_buf : TBIO_new_mem_buf = Nil;
   BIO_ctrl : TBIO_ctrl = Nil;
   BIO_int_ctrl : TBIO_int_ctrl = Nil;
   BIO_ptr_ctrl : TBIO_ptr_ctrl = Nil;
   BIO_new_file : TBIO_new_file = Nil;
   BIO_puts : TBIO_puts = Nil;
   BIO_read : TBIO_read = Nil;
   BIO_write : TBIO_write = Nil;
   BIO_get_callback_ex : TBIO_get_callback_ex = Nil;
   BIO_set_callback_ex : TBIO_set_callback_ex = Nil;
   BIO_debug_callback_ex : TBIO_debug_callback_ex = Nil;
   BIO_get_callback_arg : TBIO_get_callback_arg = Nil;
   BIO_set_callback_arg : TBIO_set_callback_arg = Nil;
   BIO_method_name : TBIO_method_name = Nil;
   BIO_method_type : TBIO_method_type = Nil;
   BIO_ctrl_get_write_guarantee : TBIO_ctrl_get_write_guarantee = Nil;
   BIO_ctrl_get_read_request : TBIO_ctrl_get_read_request = Nil;
   BIO_ctrl_reset_read_request : TBIO_ctrl_reset_read_request = Nil;
   BIO_set_ex_data : TBIO_set_ex_data = Nil;
   BIO_get_ex_data : TBIO_get_ex_data = Nil;
   BIO_number_read : TBIO_number_read = Nil;
   BIO_number_written : TBIO_number_written = Nil;
   BIO_new_fp : TBIO_new_fp = Nil;
   BIO_new_ex : TBIO_new_ex = Nil;
   BIO_set_data : TBIO_set_data = Nil;
   BIO_get_data : TBIO_get_data = Nil;
   BIO_set_init : TBIO_set_init = Nil;
   BIO_get_init : TBIO_get_init = Nil;
   BIO_set_shutdown : TBIO_set_shutdown = Nil;
   BIO_get_shutdown : TBIO_get_shutdown = Nil;
   BIO_vfree : TBIO_vfree = Nil;
   BIO_up_ref : TBIO_up_ref = Nil;
   BIO_read_ex : TBIO_read_ex = Nil;
   BIO_gets : TBIO_gets = Nil;
   BIO_get_line : TBIO_get_line = Nil;
   BIO_write_ex : TBIO_write_ex = Nil;
   BIO_indent : TBIO_indent = Nil;
   BIO_push : TBIO_push = Nil;
   BIO_pop : TBIO_pop = Nil;
   BIO_free_all : TBIO_free_all = Nil;
   BIO_find_type : TBIO_find_type = Nil;
   BIO_next : TBIO_next = Nil;
   BIO_set_next : TBIO_set_next = Nil;
   BIO_get_retry_BIO : TBIO_get_retry_BIO = Nil;
   BIO_get_retry_reason : TBIO_get_retry_reason = Nil;
   BIO_set_retry_reason : TBIO_set_retry_reason = Nil;
   BIO_dup_chain : TBIO_dup_chain = Nil;
   BIO_nread0 : TBIO_nread0 = Nil;
   BIO_nread : TBIO_nread = Nil;
   BIO_nwrite0 : TBIO_nwrite0 = Nil;
   BIO_nwrite : TBIO_nwrite = Nil;
   BIO_s_mem : TBIO_s_mem = Nil;
   BIO_s_file : TBIO_s_file = Nil;
   BIO_s_secmem : TBIO_s_secmem = Nil;
   BIO_s_socket : TBIO_s_socket = Nil;
   BIO_s_connect : TBIO_s_connect = Nil;
   BIO_s_accept : TBIO_s_accept = Nil;
   BIO_s_fd : TBIO_s_fd = Nil;
   BIO_s_log : TBIO_s_log = Nil;
   BIO_s_bio : TBIO_s_bio = Nil;
   BIO_s_null : TBIO_s_null = Nil;
   BIO_f_null : TBIO_f_null = Nil;
   BIO_f_buffer : TBIO_f_buffer = Nil;
   BIO_f_readbuffer : TBIO_f_readbuffer = Nil;
   BIO_f_linebuffer : TBIO_f_linebuffer = Nil;
   BIO_f_nbio_test : TBIO_f_nbio_test = Nil;
   BIO_f_prefix : TBIO_f_prefix = Nil;
   BIO_s_core : TBIO_s_core = Nil;
   BIO_s_datagram : TBIO_s_datagram = Nil;
   BIO_dgram_non_fatal_error : TBIO_dgram_non_fatal_error = Nil;
   BIO_new_dgram : TBIO_new_dgram = Nil;
   BIO_sock_should_retry : TBIO_sock_should_retry = Nil;
   BIO_sock_non_fatal_error : TBIO_sock_non_fatal_error = Nil;
   BIO_socket_wait : TBIO_socket_wait = Nil;
   BIO_wait : TBIO_wait = Nil;
   BIO_do_connect_retry : TBIO_do_connect_retry = Nil;
   BIO_fd_should_retry : TBIO_fd_should_retry = Nil;
   BIO_fd_non_fatal_error : TBIO_fd_non_fatal_error = Nil;
   BIO_dump : TBIO_dump = Nil;
   BIO_dump_indent : TBIO_dump_indent = Nil;
   BIO_dump_fp : TBIO_dump_fp = Nil;
   BIO_dump_indent_fp : TBIO_dump_indent_fp = Nil;
   BIO_hex_string : TBIO_hex_string = Nil;
   BIO_ADDR_new : TBIO_ADDR_new = Nil;
   BIO_ADDR_rawmake : TBIO_ADDR_rawmake = Nil;
   BIO_ADDR_free : TBIO_ADDR_free = Nil;
   BIO_ADDR_clear : TBIO_ADDR_clear = Nil;
   BIO_ADDR_family : TBIO_ADDR_family = Nil;
   BIO_ADDR_rawaddress : TBIO_ADDR_rawaddress = Nil;
   BIO_ADDR_rawport : TBIO_ADDR_rawport = Nil;
   BIO_ADDR_hostname_string : TBIO_ADDR_hostname_string = Nil;
   BIO_ADDR_service_string : TBIO_ADDR_service_string = Nil;
   BIO_ADDR_path_string : TBIO_ADDR_path_string = Nil;
   BIO_ADDRINFO_next : TBIO_ADDRINFO_next = Nil;
   BIO_ADDRINFO_family : TBIO_ADDRINFO_family = Nil;
   BIO_ADDRINFO_socktype : TBIO_ADDRINFO_socktype = Nil;
   BIO_ADDRINFO_protocol : TBIO_ADDRINFO_protocol = Nil;
   BIO_ADDRINFO_address : TBIO_ADDRINFO_address = Nil;
   BIO_ADDRINFO_free : TBIO_ADDRINFO_free = Nil;
   BIO_parse_hostserv : TBIO_parse_hostserv = Nil;
   BIO_lookup : TBIO_lookup = Nil;
   BIO_lookup_ex : TBIO_lookup_ex = Nil;
   BIO_sock_error : TBIO_sock_error = Nil;
   BIO_socket_ioctl : TBIO_socket_ioctl = Nil;
   BIO_socket_nbio : TBIO_socket_nbio = Nil;
   BIO_sock_init : TBIO_sock_init = Nil;
   BIO_set_tcp_ndelay : TBIO_set_tcp_ndelay = Nil;
   BIO_sock_info : TBIO_sock_info = Nil;
   BIO_socket : TBIO_socket = Nil;
   BIO_connect : TBIO_connect = Nil;
   BIO_bind : TBIO_bind = Nil;
   BIO_listen : TBIO_listen = Nil;
   BIO_accept_ex : TBIO_accept_ex = Nil;
   BIO_closesocket : TBIO_closesocket = Nil;
   BIO_new_socket : TBIO_new_socket = Nil;
   BIO_new_connect : TBIO_new_connect = Nil;
   BIO_new_accept : TBIO_new_accept = Nil;
   BIO_new_fd : TBIO_new_fd = Nil;
   BIO_new_bio_pair : TBIO_new_bio_pair = Nil;
   BIO_copy_next_retry : TBIO_copy_next_retry = Nil;
   BIO_meth_new : TBIO_meth_new = Nil;
   BIO_meth_free : TBIO_meth_free = Nil;


//-------------------------------------------------

Function  libSSL3_Load(Const aLibName: String = SSL3LibName): Boolean;
Procedure libSSL3_Free;
Function  libSSL3_IsLoaded: boolean;

Function  libCrypto3_Load(Const aLibName: String = Crypto3LibName): Boolean;
Procedure libCrypto3_Free;
Function  libCrypto3_IsLoaded: boolean;

//==============================================================
//==============================================================
implementation

Const
  InvalidLibHandle = 0;
var
  SSL3_Handle: TLibHandle = InvalidLibHandle;
  Crypto3_Handle: TLibHandle = InvalidLibHandle;

function libSSL3_IsLoaded: boolean;
begin
  Result:=(SSL3_Handle <> InvalidLibHandle);
end;

Procedure libSSL3_Free;
begin
 if libSSL3_IsLoaded then
 begin
       DynLibs.UnloadLibrary(SSL3_Handle);
       SSL3_Handle := InvalidLibHandle;
 end;
end;

function libSSL3_Load(Const aLibName: String = SSL3LibName): Boolean;
   //.............................
   Function _GetProcAddress(Const aProcName: String): {$IFDEF cpui8086}FarPointer{$ELSE}Pointer{$ENDIF};
   Begin
    Result := Nil;
    If aProcName = '' Then Exit;

    Result := dynlibs.GetProcedureAddress(SSL3_Handle, AnsiString(aProcName));
   End;
   //.....................................
var
  thelib: string;

   {$IF DEFINED(UNIX) and (NOT DEFINED(DARWIN))}
     ssl:Integer;
     ssp:Integer;
   {$ENDIF}
begin
  Result := False;

  if SSL3_Handle <> InvalidLibHandle then Exit(True);

  if aLibName = '' then
     thelib := SSL3LibName else
     thelib := aLibName;

  SSL3_Handle := dynlibs.LoadLibrary(thelib);

      //.....................................
      // On UNIX If Library NOT load, try to load .so file
     {$IF DEFINED(UNIX) and (NOT DEFINED(DARWIN))}
      If SSL3_Handle = 0 Then
      Begin
         ssl := length(thelib);
         ssp := Pos('.so.', thelib);
         If ssp > 0 Then
            delete(thelib, ssp, ssl - ssp + 1);

         SSL3_Handle := dynlibs.LoadLibrary(thelib + '.so');
      End;
     {$ENDIF}

  if SSL3_Handle = InvalidLibHandle then Exit(False);

   //.........................................

    Pointer(SSL_CTX_set_cipher_list) := _GetProcAddress('SSL_CTX_set_cipher_list');
    Pointer(SSL_CTX_new) := _GetProcAddress('SSL_CTX_new');
    Pointer(SSL_CTX_free) := _GetProcAddress('SSL_CTX_free');
    Pointer(SSL_set_fd) := _GetProcAddress('SSL_set_fd');
    Pointer(SSL_CTX_use_PrivateKey_file) := _GetProcAddress('SSL_CTX_use_PrivateKey_file');
    Pointer(SSL_CTX_use_PrivateKey) := _GetProcAddress('SSL_CTX_use_PrivateKey');
    Pointer(SSL_CTX_use_certificate) := _GetProcAddress('SSL_CTX_use_certificate');
    Pointer(SSL_CTX_use_certificate_file) := _GetProcAddress('SSL_CTX_use_certificate_file');
    Pointer(SSL_state_string_long) := _GetProcAddress('SSL_state_string_long');
    Pointer(SSL_alert_desc_string_long) := _GetProcAddress('SSL_alert_desc_string_long');
    Pointer(SSL_alert_type_string_long) := _GetProcAddress('SSL_alert_type_string_long');
    Pointer(SSL_CTX_set_verify) := _GetProcAddress('SSL_CTX_set_verify');
    Pointer(SSL_CTX_set_verify_depth) := _GetProcAddress('SSL_CTX_set_verify_depth');
    Pointer(SSL_CTX_get_verify_depth) := _GetProcAddress('SSL_CTX_get_verify_depth');
    Pointer(SSL_CTX_set_default_passwd_cb) := _GetProcAddress('SSL_CTX_set_default_passwd_cb');
    Pointer(SSL_CTX_set_default_passwd_cb_userdata) := _GetProcAddress('SSL_CTX_set_default_passwd_cb_userdata');
    Pointer(SSL_CTX_check_private_key) := _GetProcAddress('SSL_CTX_check_private_key');
    Pointer(SSL_new) := _GetProcAddress('SSL_new');
    Pointer(SSL_free) := _GetProcAddress('SSL_free');
    Pointer(SSL_accept) := _GetProcAddress('SSL_accept');
    Pointer(SSL_connect) := _GetProcAddress('SSL_connect');
    Pointer(SSL_read) := _GetProcAddress('SSL_read');
    Pointer(SSL_peek) := _GetProcAddress('SSL_peek');
    Pointer(SSL_pending) := _GetProcAddress('SSL_pending');
    Pointer(SSL_write) := _GetProcAddress('SSL_write');
    Pointer(SSL_ctrl) := _GetProcAddress('SSL_ctrl');
    Pointer(SSL_callback_ctrl) := _GetProcAddress('SSL_callback_ctrl');
    Pointer(SSL_CTX_ctrl) := _GetProcAddress('SSL_CTX_ctrl');
    Pointer(SSL_CTX_callback_ctrl) := _GetProcAddress('SSL_CTX_callback_ctrl');
    Pointer(SSL_get_error) := _GetProcAddress('SSL_get_error');
    Pointer(SSL_shutdown) := _GetProcAddress('SSL_shutdown');
    Pointer(SSL_set_connect_state) := _GetProcAddress('SSL_set_connect_state');
    Pointer(SSL_set_accept_state) := _GetProcAddress('SSL_set_accept_state');
    Pointer(SSL_set_shutdown) := _GetProcAddress('SSL_set_shutdown');
    Pointer(SSL_CTX_load_verify_locations) := _GetProcAddress('SSL_CTX_load_verify_locations');
    Pointer(SSL_get_session) := _GetProcAddress('SSL_get_session');
    Pointer(SSL_SESSION_get_id) := _GetProcAddress('SSL_SESSION_get_id');
    Pointer(SSL_copy_session_id) := _GetProcAddress('SSL_copy_session_id'); 
    Pointer(SSL_set_ex_data) := _GetProcAddress('SSL_set_ex_data');
    Pointer(SSL_get_ex_data) := _GetProcAddress('SSL_get_ex_data');
    Pointer(SSL_load_client_CA_file) := _GetProcAddress('SSL_load_client_CA_file');
    Pointer(SSL_CTX_set_client_CA_list) := _GetProcAddress('SSL_CTX_set_client_CA_list');
    Pointer(SSL_CTX_set_default_verify_paths) := _GetProcAddress('SSL_CTX_set_default_verify_paths');
    Pointer(SSL_CTX_set_session_id_context) := _GetProcAddress('SSL_CTX_set_session_id_context');
    Pointer(SSL_CIPHER_description) := _GetProcAddress('SSL_CIPHER_description');
    Pointer(SSL_get_current_cipher) := _GetProcAddress('SSL_get_current_cipher');
    Pointer(SSL_CIPHER_get_name) := _GetProcAddress('SSL_CIPHER_get_name');
    Pointer(SSL_CIPHER_get_version) := _GetProcAddress('SSL_CIPHER_get_version');
    Pointer(SSL_CIPHER_get_bits) := _GetProcAddress('SSL_CIPHER_get_bits');

    //.........................................

  Result := True;

end;

//================================================================================
//================================================================================

function libCrypto3_IsLoaded: boolean;
begin
  Result:=(Crypto3_Handle <> InvalidLibHandle);
end;

Procedure libCrypto3_Free;
begin
 if libCrypto3_IsLoaded then
 begin
       DynLibs.UnloadLibrary(Crypto3_Handle);
       Crypto3_Handle := InvalidLibHandle;
 end;
end;

function libCrypto3_Load(Const aLibName: String = Crypto3LibName): Boolean;
   //.............................
   Function _GetProcAddress(Const aProcName: String): {$IFDEF cpui8086}FarPointer{$ELSE}Pointer{$ENDIF};
   Begin
    Result := Nil;
    If aProcName = '' Then Exit;

    Result := dynlibs.GetProcedureAddress(Crypto3_Handle, AnsiString(aProcName));
   End;
   //.....................................
var
  thelib: string;

   {$IF DEFINED(UNIX) and (NOT DEFINED(DARWIN))}
     ssl:Integer;
     ssp:Integer;
   {$ENDIF}
begin
  Result := False;

  if Crypto3_Handle <> 0 then Exit(False);

  if aLibName = '' then
     thelib := Crypto3LibName else
     thelib := aLibName;

  Crypto3_Handle := dynlibs.LoadLibrary(thelib);

      //.....................................
      // On UNIX If Library NOT load, try to load .so file
     {$IF DEFINED(UNIX) and (NOT DEFINED(DARWIN))}
      If Crypto3_Handle = 0 Then
      Begin
         ssl := length(thelib);
         ssp := Pos('.so.', thelib);
         If ssp > 0 Then
            delete(thelib, ssp, ssl - ssp + 1);

         Crypto3_Handle := dynlibs.LoadLibrary(thelib + '.so');
      End;
     {$ENDIF}

  if Crypto3_Handle = InvalidLibHandle then Exit(False);

   //.........................................

    Pointer(d2i_X509_NAME) := _GetProcAddress('d2i_X509_NAME');
    Pointer(i2d_X509_NAME) := _GetProcAddress('i2d_X509_NAME');
    Pointer(X509_NAME_oneline) := _GetProcAddress('X509_NAME_oneline');
    Pointer(X509_NAME_cmp) := _GetProcAddress('X509_NAME_cmp');
    Pointer(X509_NAME_hash_old) := _GetProcAddress('X509_NAME_hash_old');
    Pointer(X509_set_issuer_name) := _GetProcAddress('X509_set_issuer_name');
    Pointer(X509_get_issuer_name) := _GetProcAddress('X509_get_issuer_name');
    Pointer(X509_set_subject_name) := _GetProcAddress('X509_set_subject_name');
    Pointer(X509_get_subject_name) := _GetProcAddress('X509_get_subject_name');
    Pointer(X509_digest) := _GetProcAddress('X509_digest');
    Pointer(X509_LOOKUP_ctrl) := _GetProcAddress('X509_LOOKUP_ctrl');
    Pointer(X509_STORE_add_cert) := _GetProcAddress('X509_STORE_add_cert');
    Pointer(X509_STORE_add_crl) := _GetProcAddress('X509_STORE_add_crl');
    Pointer(X509_STORE_CTX_get_ex_data) := _GetProcAddress('X509_STORE_CTX_get_ex_data');
    Pointer(X509_STORE_CTX_get_error) := _GetProcAddress('X509_STORE_CTX_get_error');
    Pointer(X509_STORE_CTX_set_error) := _GetProcAddress('X509_STORE_CTX_set_error');
    Pointer(X509_STORE_CTX_get_error_depth) := _GetProcAddress('X509_STORE_CTX_get_error_depth');
    Pointer(X509_STORE_CTX_get_current_cert) := _GetProcAddress('X509_STORE_CTX_get_current_cert');
    Pointer(X509_STORE_add_lookup) := _GetProcAddress('X509_STORE_add_lookup');
    Pointer(X509_STORE_load_locations) := _GetProcAddress('X509_STORE_load_locations');
    Pointer(i2d_DSAPrivateKey) := _GetProcAddress('i2d_DSAPrivateKey');
    Pointer(d2i_DSAPrivateKey) := _GetProcAddress('d2i_DSAPrivateKey');
    Pointer(d2i_PrivateKey) := _GetProcAddress('d2i_PrivateKey');
    Pointer(d2i_PrivateKey_bio) := _GetProcAddress('d2i_PrivateKey_bio');
    Pointer(X509_sign) := _GetProcAddress('X509_sign');
    Pointer(X509_REQ_sign) := _GetProcAddress('X509_REQ_sign');
    Pointer(X509_REQ_add_extensions) := _GetProcAddress('X509_REQ_add_extensions');
    Pointer(X509V3_EXT_conf_nid) := _GetProcAddress('X509V3_EXT_conf_nid');
    Pointer(X509_EXTENSION_create_by_NID) := _GetProcAddress('X509_EXTENSION_create_by_NID');
    Pointer(X509V3_set_ctx) := _GetProcAddress('X509V3_set_ctx');
    Pointer(X509_EXTENSION_free) := _GetProcAddress('X509_EXTENSION_free');
    Pointer(X509_add_ext) := _GetProcAddress('X509_add_ext');
    Pointer(X509_print) := _GetProcAddress('X509_print');
    Pointer(RAND_bytes) := _GetProcAddress('RAND_bytes');
    Pointer(RAND_pseudo_bytes) := _GetProcAddress('RAND_pseudo_bytes');
    Pointer(RAND_seed) := _GetProcAddress('RAND_seed');
    Pointer(RAND_add) := _GetProcAddress('RAND_add');
    Pointer(DES_set_odd_parity) := _GetProcAddress('DES_set_odd_parity');
    Pointer(DES_set_key) := _GetProcAddress('DES_set_key');
    Pointer(DES_ecb_encrypt) := _GetProcAddress('DES_ecb_encrypt');
    Pointer(ERR_error_string) := _GetProcAddress('ERR_error_string');
    Pointer(ERR_error_string_n) := _GetProcAddress('ERR_error_string_n');
    Pointer(ERR_lib_error_string) := _GetProcAddress('ERR_lib_error_string');
    Pointer(ERR_func_error_string) := _GetProcAddress('ERR_func_error_string');
    Pointer(ERR_reason_error_string) := _GetProcAddress('ERR_reason_error_string');
    Pointer(ERR_remove_thread_state) := _GetProcAddress('ERR_remove_thread_state');
    Pointer(OPENSSL_sk_pop_free) := _GetProcAddress('OPENSSL_sk_pop_free'); 
    Pointer(RSA_new) := _GetProcAddress('RSA_new');
    Pointer(RSA_free) := _GetProcAddress('RSA_free');
    Pointer(RSA_generate_key) := _GetProcAddress('RSA_generate_key');
    Pointer(RSA_check_key) := _GetProcAddress('RSA_check_key');
    Pointer(RSA_generate_key_ex) := _GetProcAddress('RSA_generate_key_ex');
    Pointer(RSA_size) := _GetProcAddress('RSA_size');
    Pointer(RSA_private_decrypt) := _GetProcAddress('RSA_private_decrypt');
    Pointer(RSA_public_encrypt) := _GetProcAddress('RSA_public_encrypt');
    Pointer(DH_free) := _GetProcAddress('DH_free');
    Pointer(i2d_X509_bio) := _GetProcAddress('i2d_X509_bio');
    Pointer(i2d_PrivateKey_bio) := _GetProcAddress('i2d_PrivateKey_bio');
    Pointer(d2i_X509_bio) := _GetProcAddress('d2i_X509_bio');
    Pointer(i2d_X509_REQ_bio) := _GetProcAddress('i2d_X509_REQ_bio');
    Pointer(i2d_PKCS7) := _GetProcAddress('i2d_PKCS7');
    Pointer(d2i_PKCS7) := _GetProcAddress('d2i_PKCS7');
    Pointer(i2d_X509) := _GetProcAddress('i2d_X509');
    Pointer(d2i_X509) := _GetProcAddress('d2i_X509');
    Pointer(i2d_X509_REQ) := _GetProcAddress('i2d_X509_REQ');
    Pointer(d2i_X509_REQ) := _GetProcAddress('d2i_X509_REQ');
    Pointer(i2d_X509_CRL) := _GetProcAddress('i2d_X509_CRL');
    Pointer(d2i_X509_CRL) := _GetProcAddress('d2i_X509_CRL');
    Pointer(i2d_RSAPrivateKey) := _GetProcAddress('i2d_RSAPrivateKey');
    Pointer(d2i_RSAPrivateKey) := _GetProcAddress('d2i_RSAPrivateKey');
    Pointer(i2d_RSAPublicKey) := _GetProcAddress('i2d_RSAPublicKey');
    Pointer(d2i_RSAPublicKey) := _GetProcAddress('d2i_RSAPublicKey');
    Pointer(i2d_PrivateKey) := _GetProcAddress('i2d_PrivateKey');
    Pointer(i2d_DSAparams) := _GetProcAddress('i2d_DSAparams');
    Pointer(d2i_DSAparams) := _GetProcAddress('d2i_DSAparams');
    Pointer(i2d_DHparams) := _GetProcAddress('i2d_DHparams');
    Pointer(d2i_DHparams) := _GetProcAddress('d2i_DHparams');
    Pointer(i2d_NETSCAPE_CERT_SEQUENCE) := _GetProcAddress('i2d_NETSCAPE_CERT_SEQUENCE');
    Pointer(d2i_NETSCAPE_CERT_SEQUENCE) := _GetProcAddress('d2i_NETSCAPE_CERT_SEQUENCE');
    Pointer(i2d_PUBKEY) := _GetProcAddress('i2d_PUBKEY');
    Pointer(d2i_PUBKEY) := _GetProcAddress('d2i_PUBKEY');
    Pointer(X509_free) := _GetProcAddress('X509_free');
    Pointer(X509_REQ_free) := _GetProcAddress('X509_REQ_free');
    Pointer(X509_to_X509_REQ) := _GetProcAddress('X509_to_X509_REQ');
    Pointer(X509_NAME_free) := _GetProcAddress('X509_NAME_free');
    Pointer(X509_NAME_add_entry_by_txt) := _GetProcAddress('X509_NAME_add_entry_by_txt');
    Pointer(X509_INFO_free) := _GetProcAddress('X509_INFO_free');
    Pointer(X509_set_version) := _GetProcAddress('X509_set_version');
    Pointer(X509_get_serialNumber) := _GetProcAddress('X509_get_serialNumber');
    Pointer(X509_gmtime_adj) := _GetProcAddress('X509_gmtime_adj');
    Pointer(X509_set_pubkey) := _GetProcAddress('X509_set_pubkey');
    Pointer(X509_REQ_set_pubkey) := _GetProcAddress('X509_REQ_set_pubkey');
    Pointer(X509_PUBKEY_get) := _GetProcAddress('X509_PUBKEY_get');
    Pointer(X509_verify) := _GetProcAddress('X509_verify');
    Pointer(PEM_read_bio_X509) := _GetProcAddress('PEM_read_bio_X509');
    Pointer(PEM_read_bio_X509_REQ) := _GetProcAddress('PEM_read_bio_X509_REQ');
    Pointer(PEM_read_bio_X509_CRL) := _GetProcAddress('PEM_read_bio_X509_CRL');
    Pointer(PEM_read_bio_RSAPrivateKey) := _GetProcAddress('PEM_read_bio_RSAPrivateKey');
    Pointer(PEM_read_bio_RSAPublicKey) := _GetProcAddress('PEM_read_bio_RSAPublicKey');
    Pointer(PEM_read_bio_DSAPrivateKey) := _GetProcAddress('PEM_read_bio_DSAPrivateKey');
    Pointer(PEM_read_bio_PrivateKey) := _GetProcAddress('PEM_read_bio_PrivateKey');
    Pointer(PEM_read_bio_PKCS7) := _GetProcAddress('PEM_read_bio_PKCS7');
    Pointer(PEM_read_bio_DHparams) := _GetProcAddress('PEM_read_bio_DHparams');
    Pointer(PEM_read_bio_DSAparams) := _GetProcAddress('PEM_read_bio_DSAparams');
    Pointer(PEM_read_bio_NETSCAPE_CERT_SEQUENCE) := _GetProcAddress('PEM_read_bio_NETSCAPE_CERT_SEQUENCE');
    Pointer(PEM_read_bio_PUBKEY) := _GetProcAddress('PEM_read_bio_PUBKEY');
    Pointer(PEM_write_bio_X509) := _GetProcAddress('PEM_write_bio_X509');
    Pointer(PEM_write_bio_X509_REQ) := _GetProcAddress('PEM_write_bio_X509_REQ');
    Pointer(PEM_write_bio_X509_CRL) := _GetProcAddress('PEM_write_bio_X509_CRL');
    Pointer(PEM_write_bio_RSAPrivateKey) := _GetProcAddress('PEM_write_bio_RSAPrivateKey');
    Pointer(PEM_write_bio_RSAPublicKey) := _GetProcAddress('PEM_write_bio_RSAPublicKey');
    Pointer(PEM_write_bio_DSAPrivateKey) := _GetProcAddress('PEM_write_bio_DSAPrivateKey');
    Pointer(PEM_write_bio_PrivateKey) := _GetProcAddress('PEM_write_bio_PrivateKey');
    Pointer(PEM_write_bio_PKCS7) := _GetProcAddress('PEM_write_bio_PKCS7');
    Pointer(PEM_write_bio_DHparams) := _GetProcAddress('PEM_write_bio_DHparams');
    Pointer(PEM_write_bio_DSAparams) := _GetProcAddress('PEM_write_bio_DSAparams');
    Pointer(PEM_write_bio_NETSCAPE_CERT_SEQUENCE) := _GetProcAddress('PEM_write_bio_NETSCAPE_CERT_SEQUENCE');
    Pointer(PEM_write_bio_PKCS8PrivateKey) := _GetProcAddress('PEM_write_bio_PKCS8PrivateKey');
    Pointer(PEM_write_bio_PUBKEY) := _GetProcAddress('PEM_write_bio_PUBKEY');
    Pointer(PEM_X509_INFO_read_bio) := _GetProcAddress('PEM_X509_INFO_read_bio');
    Pointer(PEM_read_bio_X509_AUX) := _GetProcAddress('PEM_read_bio_X509_AUX');
    Pointer(EVP_MD_CTX_copy) := _GetProcAddress('EVP_MD_CTX_copy');
    Pointer(EVP_MD_CTX_copy_ex) := _GetProcAddress('EVP_MD_CTX_copy_ex');
    Pointer(EVP_DigestInit_ex) := _GetProcAddress('EVP_DigestInit_ex');
    Pointer(EVP_DigestUpdate) := _GetProcAddress('EVP_DigestUpdate');
    Pointer(EVP_DigestFinal_ex) := _GetProcAddress('EVP_DigestFinal_ex'); 
    Pointer(EVP_PKEY_new) := _GetProcAddress('EVP_PKEY_new');
    Pointer(EVP_PKEY_type) := _GetProcAddress('EVP_PKEY_type');
    Pointer(EVP_PKEY_free) := _GetProcAddress('EVP_PKEY_free');
    Pointer(EVP_PKEY_assign) := _GetProcAddress('EVP_PKEY_assign');
    Pointer(EVP_get_digestbyname) := _GetProcAddress('EVP_get_digestbyname');
    Pointer(HMAC_Init_ex) := _GetProcAddress('HMAC_Init_ex');
    Pointer(HMAC_Update) := _GetProcAddress('HMAC_Update');
    Pointer(HMAC_Final) := _GetProcAddress('HMAC_Final');
    Pointer(OBJ_obj2nid) := _GetProcAddress('OBJ_obj2nid');
    Pointer(OBJ_nid2obj) := _GetProcAddress('OBJ_nid2obj');
    Pointer(OBJ_nid2ln) := _GetProcAddress('OBJ_nid2ln');
    Pointer(OBJ_nid2sn) := _GetProcAddress('OBJ_nid2sn');
    Pointer(ASN1_INTEGER_set) := _GetProcAddress('ASN1_INTEGER_set');
    Pointer(ASN1_INTEGER_get) := _GetProcAddress('ASN1_INTEGER_get');
    Pointer(ASN1_STRING_type_new) := _GetProcAddress('ASN1_STRING_type_new');
    Pointer(ASN1_STRING_free) := _GetProcAddress('ASN1_STRING_free');
    Pointer(ASN1_dup) := _GetProcAddress('ASN1_dup');
    Pointer(CRYPTO_set_mem_functions) := _GetProcAddress('CRYPTO_set_mem_functions');
    Pointer(CRYPTO_malloc) := _GetProcAddress('CRYPTO_malloc');
    Pointer(CRYPTO_free) := _GetProcAddress('CRYPTO_free');
    Pointer(PKCS12_create) := _GetProcAddress('PKCS12_create');
    Pointer(i2d_PKCS12_bio) := _GetProcAddress('i2d_PKCS12_bio');
    Pointer(PKCS12_free) := _GetProcAddress('PKCS12_free');
    Pointer(OPENSSL_sk_num) := _GetProcAddress('OPENSSL_sk_num');
    Pointer(OPENSSL_sk_new) := _GetProcAddress('OPENSSL_sk_new');
    Pointer(OPENSSL_sk_free) := _GetProcAddress('OPENSSL_sk_free');
    Pointer(OPENSSL_sk_push) := _GetProcAddress('OPENSSL_sk_push');
    Pointer(OPENSSL_sk_dup) := _GetProcAddress('OPENSSL_sk_dup');
    Pointer(OPENSSL_sk_find) := _GetProcAddress('OPENSSL_sk_find');
    Pointer(OPENSSL_sk_value) := _GetProcAddress('OPENSSL_sk_value');

    //...BN
              
    Pointer(BN_free) := _GetProcAddress('BN_free');
    Pointer(BN_hex2bn) := _GetProcAddress('BN_hex2bn');
    Pointer(BN_bn2hex) := _GetProcAddress('BN_bn2hex');
    Pointer(BN_set_word) := _GetProcAddress('BN_set_word');
    Pointer(BN_set_flags) := _GetProcAddress('BN_set_flags');
    Pointer(BN_get_flags) := _GetProcAddress('BN_get_flags');
    Pointer(BN_with_flags) := _GetProcAddress('BN_with_flags');
    Pointer(BN_GENCB_call) := _GetProcAddress('BN_GENCB_call');
    Pointer(BN_GENCB_new) := _GetProcAddress('BN_GENCB_new');
    Pointer(BN_GENCB_free) := _GetProcAddress('BN_GENCB_free');
    Pointer(BN_GENCB_get_arg) := _GetProcAddress('BN_GENCB_get_arg');
    Pointer(BN_abs_is_word) := _GetProcAddress('BN_abs_is_word');
    Pointer(BN_is_zero) := _GetProcAddress('BN_is_zero');
    Pointer(BN_is_one) := _GetProcAddress('BN_is_one');
    Pointer(BN_is_word) := _GetProcAddress('BN_is_word');
    Pointer(BN_is_odd) := _GetProcAddress('BN_is_odd');
    Pointer(BN_zero_ex) := _GetProcAddress('BN_zero_ex');
    Pointer(BN_options) := _GetProcAddress('BN_options');
    Pointer(BN_CTX_new_ex) := _GetProcAddress('BN_CTX_new_ex');
    Pointer(BN_CTX_new) := _GetProcAddress('BN_CTX_new');
    Pointer(BN_CTX_secure_new_ex) := _GetProcAddress('BN_CTX_secure_new_ex');
    Pointer(BN_CTX_secure_new) := _GetProcAddress('BN_CTX_secure_new');
    Pointer(BN_CTX_free) := _GetProcAddress('BN_CTX_free');
    Pointer(BN_CTX_start) := _GetProcAddress('BN_CTX_start');
    Pointer(BN_CTX_get) := _GetProcAddress('BN_CTX_get');
    Pointer(BN_CTX_end) := _GetProcAddress('BN_CTX_end');
    Pointer(BN_rand_ex) := _GetProcAddress('BN_rand_ex');
    Pointer(BN_rand) := _GetProcAddress('BN_rand');
    Pointer(BN_priv_rand_ex) := _GetProcAddress('BN_priv_rand_ex');
    Pointer(BN_priv_rand) := _GetProcAddress('BN_priv_rand');
    Pointer(BN_rand_range_ex) := _GetProcAddress('BN_rand_range_ex');
    Pointer(BN_rand_range) := _GetProcAddress('BN_rand_range');
    Pointer(BN_priv_rand_range_ex) := _GetProcAddress('BN_priv_rand_range_ex');
    Pointer(BN_priv_rand_range) := _GetProcAddress('BN_priv_rand_range');
    Pointer(BN_num_bits) := _GetProcAddress('BN_num_bits');
    Pointer(BN_num_bits_word) := _GetProcAddress('BN_num_bits_word');
    Pointer(BN_security_bits) := _GetProcAddress('BN_security_bits');
    Pointer(BN_new) := _GetProcAddress('BN_new');
    Pointer(BN_secure_new) := _GetProcAddress('BN_secure_new');
    Pointer(BN_clear_free) := _GetProcAddress('BN_clear_free');
    Pointer(BN_copy) := _GetProcAddress('BN_copy');
    Pointer(BN_swap) := _GetProcAddress('BN_swap');
    Pointer(BN_bin2bn) := _GetProcAddress('BN_bin2bn');
    Pointer(BN_bn2bin) := _GetProcAddress('BN_bn2bin');
    Pointer(BN_bn2binpad) := _GetProcAddress('BN_bn2binpad');
    Pointer(BN_lebin2bn) := _GetProcAddress('BN_lebin2bn');
    Pointer(BN_bn2lebinpad) := _GetProcAddress('BN_bn2lebinpad');
    Pointer(BN_native2bn) := _GetProcAddress('BN_native2bn');
    Pointer(BN_bn2nativepad) := _GetProcAddress('BN_bn2nativepad');
    Pointer(BN_mpi2bn) := _GetProcAddress('BN_mpi2bn');
    Pointer(BN_bn2mpi) := _GetProcAddress('BN_bn2mpi');
    Pointer(BN_sub) := _GetProcAddress('BN_sub');
    Pointer(BN_usub) := _GetProcAddress('BN_usub');
    Pointer(BN_uadd) := _GetProcAddress('BN_uadd');
    Pointer(BN_add) := _GetProcAddress('BN_add');
    Pointer(BN_mul) := _GetProcAddress('BN_mul');
    Pointer(BN_sqr) := _GetProcAddress('BN_sqr');
    Pointer(BN_set_negative) := _GetProcAddress('BN_set_negative');
    Pointer(BN_is_negative) := _GetProcAddress('BN_is_negative');
    Pointer(BN_div) := _GetProcAddress('BN_div');
    Pointer(BN_nnmod) := _GetProcAddress('BN_nnmod');
    Pointer(BN_mod_add) := _GetProcAddress('BN_mod_add');
    Pointer(BN_mod_add_quick) := _GetProcAddress('BN_mod_add_quick');
    Pointer(BN_mod_sub) := _GetProcAddress('BN_mod_sub');
    Pointer(BN_mod_sub_quick) := _GetProcAddress('BN_mod_sub_quick');
    Pointer(BN_mod_mul) := _GetProcAddress('BN_mod_mul');
    Pointer(BN_mod_sqr) := _GetProcAddress('BN_mod_sqr');
    Pointer(BN_mod_lshift1) := _GetProcAddress('BN_mod_lshift1');
    Pointer(BN_mod_lshift1_quick) := _GetProcAddress('BN_mod_lshift1_quick');
    Pointer(BN_mod_lshift) := _GetProcAddress('BN_mod_lshift');
    Pointer(BN_mod_lshift_quick) := _GetProcAddress('BN_mod_lshift_quick');
    Pointer(BN_mod_word) := _GetProcAddress('BN_mod_word');
    Pointer(BN_div_word) := _GetProcAddress('BN_div_word');
    Pointer(BN_mul_word) := _GetProcAddress('BN_mul_word');
    Pointer(BN_add_word) := _GetProcAddress('BN_add_word');
    Pointer(BN_sub_word) := _GetProcAddress('BN_sub_word');
    Pointer(BN_set_word) := _GetProcAddress('BN_set_word');
    Pointer(BN_get_word) := _GetProcAddress('BN_get_word');
    Pointer(BN_cmp) := _GetProcAddress('BN_cmp');
    Pointer(BN_free) := _GetProcAddress('BN_free');
    Pointer(BN_is_bit_set) := _GetProcAddress('BN_is_bit_set');
    Pointer(BN_lshift) := _GetProcAddress('BN_lshift');
    Pointer(BN_lshift1) := _GetProcAddress('BN_lshift1');
    Pointer(BN_exp) := _GetProcAddress('BN_exp');
    Pointer(BN_mod_exp) := _GetProcAddress('BN_mod_exp');
    Pointer(BN_mod_exp_mont) := _GetProcAddress('BN_mod_exp_mont');
    Pointer(BN_mod_exp_mont_consttime) := _GetProcAddress('BN_mod_exp_mont_consttime');
    Pointer(BN_mod_exp_mont_word) := _GetProcAddress('BN_mod_exp_mont_word');
    Pointer(BN_mod_exp2_mont) := _GetProcAddress('BN_mod_exp2_mont');
    Pointer(BN_mod_exp_simple) := _GetProcAddress('BN_mod_exp_simple');
    Pointer(BN_mod_exp_mont_consttime_x2) := _GetProcAddress('BN_mod_exp_mont_consttime_x2');
    Pointer(BN_mask_bits) := _GetProcAddress('BN_mask_bits');
    Pointer(BN_print_fp) := _GetProcAddress('BN_print_fp');
    Pointer(BN_print) := _GetProcAddress('BN_print');
    Pointer(BN_reciprocal) := _GetProcAddress('BN_reciprocal');
    Pointer(BN_rshift) := _GetProcAddress('BN_rshift');
    Pointer(BN_rshift1) := _GetProcAddress('BN_rshift1');
    Pointer(BN_clear) := _GetProcAddress('BN_clear');
    Pointer(BN_dup) := _GetProcAddress('BN_dup');
    Pointer(BN_ucmp) := _GetProcAddress('BN_ucmp');
    Pointer(BN_set_bit) := _GetProcAddress('BN_set_bit');
    Pointer(BN_clear_bit) := _GetProcAddress('BN_clear_bit');
    Pointer(BN_bn2hex) := _GetProcAddress('BN_bn2hex');
    Pointer(BN_bn2dec) := _GetProcAddress('BN_bn2dec');
    Pointer(BN_hex2bn) := _GetProcAddress('BN_hex2bn');
    Pointer(BN_dec2bn) := _GetProcAddress('BN_dec2bn');
    Pointer(BN_asc2bn) := _GetProcAddress('BN_asc2bn');
    Pointer(BN_gcd) := _GetProcAddress('BN_gcd');
    Pointer(BN_kronecker) := _GetProcAddress('BN_kronecker');
    Pointer(BN_mod_inverse) := _GetProcAddress('BN_mod_inverse');
    Pointer(BN_mod_sqrt) := _GetProcAddress('BN_mod_sqrt');
    Pointer(BN_consttime_swap) := _GetProcAddress('BN_consttime_swap');
    Pointer(BN_generate_prime_ex2) := _GetProcAddress('BN_generate_prime_ex2');
    Pointer(BN_generate_prime_ex) := _GetProcAddress('BN_generate_prime_ex');
    Pointer(BN_check_prime) := _GetProcAddress('BN_check_prime');
    Pointer(BN_mod_mul_montgomery) := _GetProcAddress('BN_mod_mul_montgomery');
    Pointer(BN_to_montgomery) := _GetProcAddress('BN_to_montgomery');
    Pointer(BN_from_montgomery) := _GetProcAddress('BN_from_montgomery');
    Pointer(BN_MONT_CTX_free) := _GetProcAddress('BN_MONT_CTX_free');
    Pointer(BN_MONT_CTX_set) := _GetProcAddress('BN_MONT_CTX_set');
    Pointer(BN_MONT_CTX_copy) := _GetProcAddress('BN_MONT_CTX_copy');
    Pointer(BN_BLINDING_new) := _GetProcAddress('BN_BLINDING_new');
    Pointer(BN_BLINDING_free) := _GetProcAddress('BN_BLINDING_free');
    Pointer(BN_BLINDING_update) := _GetProcAddress('BN_BLINDING_update');
    Pointer(BN_BLINDING_convert) := _GetProcAddress('BN_BLINDING_convert');
    Pointer(BN_BLINDING_invert) := _GetProcAddress('BN_BLINDING_invert');
    Pointer(BN_BLINDING_convert_ex) := _GetProcAddress('BN_BLINDING_convert_ex');
    Pointer(BN_BLINDING_invert_ex) := _GetProcAddress('BN_BLINDING_invert_ex');
    Pointer(BN_BLINDING_is_current_thread) := _GetProcAddress('BN_BLINDING_is_current_thread');
    Pointer(BN_BLINDING_set_current_thread) := _GetProcAddress('BN_BLINDING_set_current_thread');
    Pointer(BN_BLINDING_lock) := _GetProcAddress('BN_BLINDING_lock');
    Pointer(BN_BLINDING_unlock) := _GetProcAddress('BN_BLINDING_unlock');
    Pointer(BN_BLINDING_get_flags) := _GetProcAddress('BN_BLINDING_get_flags');
    Pointer(BN_BLINDING_set_flags) := _GetProcAddress('BN_BLINDING_set_flags');
    Pointer(BN_RECP_CTX_new) := _GetProcAddress('BN_RECP_CTX_new');
    Pointer(BN_RECP_CTX_free) := _GetProcAddress('BN_RECP_CTX_free');
    Pointer(BN_RECP_CTX_set) := _GetProcAddress('BN_RECP_CTX_set');
    Pointer(BN_mod_mul_reciprocal) := _GetProcAddress('BN_mod_mul_reciprocal');
    Pointer(BN_mod_exp_recp) := _GetProcAddress('BN_mod_exp_recp');
    Pointer(BN_div_recp) := _GetProcAddress('BN_div_recp');
    Pointer(BN_GF2m_add) := _GetProcAddress('BN_GF2m_add');
    Pointer(BN_GF2m_mod) := _GetProcAddress('BN_GF2m_mod');
    Pointer(BN_GF2m_mod_mul) := _GetProcAddress('BN_GF2m_mod_mul');
    Pointer(BN_GF2m_mod_sqr) := _GetProcAddress('BN_GF2m_mod_sqr');
    Pointer(BN_GF2m_mod_inv) := _GetProcAddress('BN_GF2m_mod_inv');
    Pointer(BN_GF2m_mod_div) := _GetProcAddress('BN_GF2m_mod_div');
    Pointer(BN_GF2m_mod_exp) := _GetProcAddress('BN_GF2m_mod_exp');
    Pointer(BN_GF2m_mod_sqrt) := _GetProcAddress('BN_GF2m_mod_sqrt');
    Pointer(BN_GF2m_mod_solve_quad) := _GetProcAddress('BN_GF2m_mod_solve_quad');
    Pointer(BN_GF2m_mod_arr) := _GetProcAddress('BN_GF2m_mod_arr');
    Pointer(BN_GF2m_mod_mul_arr) := _GetProcAddress('BN_GF2m_mod_mul_arr');
    Pointer(BN_GF2m_mod_sqr_arr) := _GetProcAddress('BN_GF2m_mod_sqr_arr');
    Pointer(BN_GF2m_mod_inv_arr) := _GetProcAddress('BN_GF2m_mod_inv_arr');
    Pointer(BN_GF2m_mod_div_arr) := _GetProcAddress('BN_GF2m_mod_div_arr');
    Pointer(BN_GF2m_mod_exp_arr) := _GetProcAddress('BN_GF2m_mod_exp_arr');
    Pointer(BN_GF2m_mod_sqrt_arr) := _GetProcAddress('BN_GF2m_mod_sqrt_arr');
    Pointer(BN_GF2m_mod_solve_quad_arr) := _GetProcAddress('BN_GF2m_mod_solve_quad_arr');
    Pointer(BN_GF2m_poly2arr) := _GetProcAddress('BN_GF2m_poly2arr');
    Pointer(BN_GF2m_arr2poly) := _GetProcAddress('BN_GF2m_arr2poly');
    Pointer(BN_nist_mod_192) := _GetProcAddress('BN_nist_mod_192');
    Pointer(BN_nist_mod_224) := _GetProcAddress('BN_nist_mod_224');
    Pointer(BN_nist_mod_256) := _GetProcAddress('BN_nist_mod_256');
    Pointer(BN_nist_mod_384) := _GetProcAddress('BN_nist_mod_384');
    Pointer(BN_nist_mod_521) := _GetProcAddress('BN_nist_mod_521');
    Pointer(BN_get0_nist_prime_192) := _GetProcAddress('BN_get0_nist_prime_192');
    Pointer(BN_get0_nist_prime_224) := _GetProcAddress('BN_get0_nist_prime_224');
    Pointer(BN_get0_nist_prime_256) := _GetProcAddress('BN_get0_nist_prime_256');
    Pointer(BN_get0_nist_prime_384) := _GetProcAddress('BN_get0_nist_prime_384');
    Pointer(BN_get0_nist_prime_521) := _GetProcAddress('BN_get0_nist_prime_521');
    Pointer(BN_generate_dsa_nonce) := _GetProcAddress('BN_generate_dsa_nonce');
    Pointer(BN_get_rfc2409_prime_768) := _GetProcAddress('BN_get_rfc2409_prime_768');
    Pointer(BN_get_rfc2409_prime_1024) := _GetProcAddress('BN_get_rfc2409_prime_1024');
    Pointer(BN_get_rfc3526_prime_1536) := _GetProcAddress('BN_get_rfc3526_prime_1536');
    Pointer(BN_get_rfc3526_prime_2048) := _GetProcAddress('BN_get_rfc3526_prime_2048');
    Pointer(BN_get_rfc3526_prime_3072) := _GetProcAddress('BN_get_rfc3526_prime_3072');
    Pointer(BN_get_rfc3526_prime_4096) := _GetProcAddress('BN_get_rfc3526_prime_4096');
    Pointer(BN_get_rfc3526_prime_6144) := _GetProcAddress('BN_get_rfc3526_prime_6144');
    Pointer(BN_get_rfc3526_prime_8192) := _GetProcAddress('BN_get_rfc3526_prime_8192');
    Pointer(BN_bntest_rand) := _GetProcAddress('BN_bntest_rand');

    //... BIO

    Pointer(BIO_new) := _GetProcAddress('BIO_new');
    Pointer(BIO_free) := _GetProcAddress('BIO_free');
    Pointer(BIO_new_mem_buf) := _GetProcAddress('BIO_new_mem_buf');
    Pointer(BIO_ctrl) := _GetProcAddress('BIO_ctrl');
    Pointer(BIO_int_ctrl) := _GetProcAddress('BIO_int_ctrl');
    Pointer(BIO_ptr_ctrl) := _GetProcAddress('BIO_ptr_ctrl');
    Pointer(BIO_new_file) := _GetProcAddress('BIO_new_file');
    Pointer(BIO_puts) := _GetProcAddress('BIO_puts');
    Pointer(BIO_read) := _GetProcAddress('BIO_read');
    Pointer(BIO_write) := _GetProcAddress('BIO_write');
    Pointer(BIO_get_callback_ex) := _GetProcAddress('BIO_get_callback_ex');
    Pointer(BIO_set_callback_ex) := _GetProcAddress('BIO_set_callback_ex');
    Pointer(BIO_debug_callback_ex) := _GetProcAddress('BIO_debug_callback_ex');
    Pointer(BIO_get_callback_arg) := _GetProcAddress('BIO_get_callback_arg');
    Pointer(BIO_set_callback_arg) := _GetProcAddress('BIO_set_callback_arg');
    Pointer(BIO_method_name) := _GetProcAddress('BIO_method_name');
    Pointer(BIO_method_type) := _GetProcAddress('BIO_method_type');
    Pointer(BIO_ctrl_get_write_guarantee) := _GetProcAddress('BIO_ctrl_get_write_guarantee');
    Pointer(BIO_ctrl_get_read_request) := _GetProcAddress('BIO_ctrl_get_read_request');
    Pointer(BIO_ctrl_reset_read_request) := _GetProcAddress('BIO_ctrl_reset_read_request');
    Pointer(BIO_set_ex_data) := _GetProcAddress('BIO_set_ex_data');
    Pointer(BIO_get_ex_data) := _GetProcAddress('BIO_get_ex_data');
    Pointer(BIO_number_read) := _GetProcAddress('BIO_number_read');
    Pointer(BIO_number_written) := _GetProcAddress('BIO_number_written');
    Pointer(BIO_new_fp) := _GetProcAddress('BIO_new_fp');
    Pointer(BIO_new_ex) := _GetProcAddress('BIO_new_ex');
    Pointer(BIO_set_data) := _GetProcAddress('BIO_set_data');
    Pointer(BIO_get_data) := _GetProcAddress('BIO_get_data');
    Pointer(BIO_set_init) := _GetProcAddress('BIO_set_init');
    Pointer(BIO_get_init) := _GetProcAddress('BIO_get_init');
    Pointer(BIO_set_shutdown) := _GetProcAddress('BIO_set_shutdown');
    Pointer(BIO_get_shutdown) := _GetProcAddress('BIO_get_shutdown');
    Pointer(BIO_vfree) := _GetProcAddress('BIO_vfree');
    Pointer(BIO_up_ref) := _GetProcAddress('BIO_up_ref');
    Pointer(BIO_read_ex) := _GetProcAddress('BIO_read_ex');
    Pointer(BIO_gets) := _GetProcAddress('BIO_gets');
    Pointer(BIO_get_line) := _GetProcAddress('BIO_get_line');
    Pointer(BIO_write_ex) := _GetProcAddress('BIO_write_ex');
    Pointer(BIO_indent) := _GetProcAddress('BIO_indent');
    Pointer(BIO_push) := _GetProcAddress('BIO_push');
    Pointer(BIO_pop) := _GetProcAddress('BIO_pop');
    Pointer(BIO_free_all) := _GetProcAddress('BIO_free_all');
    Pointer(BIO_find_type) := _GetProcAddress('BIO_find_type');
    Pointer(BIO_next) := _GetProcAddress('BIO_next');
    Pointer(BIO_set_next) := _GetProcAddress('BIO_set_next');
    Pointer(BIO_get_retry_BIO) := _GetProcAddress('BIO_get_retry_BIO');
    Pointer(BIO_get_retry_reason) := _GetProcAddress('BIO_get_retry_reason');
    Pointer(BIO_set_retry_reason) := _GetProcAddress('BIO_set_retry_reason');
    Pointer(BIO_dup_chain) := _GetProcAddress('BIO_dup_chain');
    Pointer(BIO_nread0) := _GetProcAddress('BIO_nread0');
    Pointer(BIO_nread) := _GetProcAddress('BIO_nread');
    Pointer(BIO_nwrite0) := _GetProcAddress('BIO_nwrite0');
    Pointer(BIO_nwrite) := _GetProcAddress('BIO_nwrite');
    Pointer(BIO_s_mem) := _GetProcAddress('BIO_s_mem');
    Pointer(BIO_s_file) := _GetProcAddress('BIO_s_file');
    Pointer(BIO_s_secmem) := _GetProcAddress('BIO_s_secmem');
    Pointer(BIO_s_socket) := _GetProcAddress('BIO_s_socket');
    Pointer(BIO_s_connect) := _GetProcAddress('BIO_s_connect');
    Pointer(BIO_s_accept) := _GetProcAddress('BIO_s_accept');
    Pointer(BIO_s_fd) := _GetProcAddress('BIO_s_fd');
    Pointer(BIO_s_log) := _GetProcAddress('BIO_s_log');
    Pointer(BIO_s_bio) := _GetProcAddress('BIO_s_bio');
    Pointer(BIO_s_null) := _GetProcAddress('BIO_s_null');
    Pointer(BIO_f_null) := _GetProcAddress('BIO_f_null');
    Pointer(BIO_f_buffer) := _GetProcAddress('BIO_f_buffer');
    Pointer(BIO_f_readbuffer) := _GetProcAddress('BIO_f_readbuffer');
    Pointer(BIO_f_linebuffer) := _GetProcAddress('BIO_f_linebuffer');
    Pointer(BIO_f_nbio_test) := _GetProcAddress('BIO_f_nbio_test');
    Pointer(BIO_f_prefix) := _GetProcAddress('BIO_f_prefix');
    Pointer(BIO_s_core) := _GetProcAddress('BIO_s_core');
    Pointer(BIO_s_datagram) := _GetProcAddress('BIO_s_datagram');
    Pointer(BIO_dgram_non_fatal_error) := _GetProcAddress('BIO_dgram_non_fatal_error');
    Pointer(BIO_new_dgram) := _GetProcAddress('BIO_new_dgram');
    Pointer(BIO_sock_should_retry) := _GetProcAddress('BIO_sock_should_retry');
    Pointer(BIO_sock_non_fatal_error) := _GetProcAddress('BIO_sock_non_fatal_error');
    Pointer(BIO_socket_wait) := _GetProcAddress('BIO_socket_wait');
    Pointer(BIO_wait) := _GetProcAddress('BIO_wait');
    Pointer(BIO_do_connect_retry) := _GetProcAddress('BIO_do_connect_retry');
    Pointer(BIO_fd_should_retry) := _GetProcAddress('BIO_fd_should_retry');
    Pointer(BIO_fd_non_fatal_error) := _GetProcAddress('BIO_fd_non_fatal_error');
    Pointer(BIO_dump) := _GetProcAddress('BIO_dump');
    Pointer(BIO_dump_indent) := _GetProcAddress('BIO_dump_indent');
    Pointer(BIO_dump_fp) := _GetProcAddress('BIO_dump_fp');
    Pointer(BIO_dump_indent_fp) := _GetProcAddress('BIO_dump_indent_fp');
    Pointer(BIO_hex_string) := _GetProcAddress('BIO_hex_string');
    Pointer(BIO_ADDR_new) := _GetProcAddress('BIO_ADDR_new');
    Pointer(BIO_ADDR_rawmake) := _GetProcAddress('BIO_ADDR_rawmake');
    Pointer(BIO_ADDR_free) := _GetProcAddress('BIO_ADDR_free');
    Pointer(BIO_ADDR_clear) := _GetProcAddress('BIO_ADDR_clear');
    Pointer(BIO_ADDR_family) := _GetProcAddress('BIO_ADDR_family');
    Pointer(BIO_ADDR_rawaddress) := _GetProcAddress('BIO_ADDR_rawaddress');
    Pointer(BIO_ADDR_rawport) := _GetProcAddress('BIO_ADDR_rawport');
    Pointer(BIO_ADDR_hostname_string) := _GetProcAddress('BIO_ADDR_hostname_string');
    Pointer(BIO_ADDR_service_string) := _GetProcAddress('BIO_ADDR_service_string');
    Pointer(BIO_ADDR_path_string) := _GetProcAddress('BIO_ADDR_path_string');
    Pointer(BIO_ADDRINFO_next) := _GetProcAddress('BIO_ADDRINFO_next');
    Pointer(BIO_ADDRINFO_family) := _GetProcAddress('BIO_ADDRINFO_family');
    Pointer(BIO_ADDRINFO_socktype) := _GetProcAddress('BIO_ADDRINFO_socktype');
    Pointer(BIO_ADDRINFO_protocol) := _GetProcAddress('BIO_ADDRINFO_protocol');
    Pointer(BIO_ADDRINFO_address) := _GetProcAddress('BIO_ADDRINFO_address');
    Pointer(BIO_ADDRINFO_free) := _GetProcAddress('BIO_ADDRINFO_free');
    Pointer(BIO_parse_hostserv) := _GetProcAddress('BIO_parse_hostserv');
    Pointer(BIO_lookup) := _GetProcAddress('BIO_lookup');
    Pointer(BIO_lookup_ex) := _GetProcAddress('BIO_lookup_ex');
    Pointer(BIO_sock_error) := _GetProcAddress('BIO_sock_error');
    Pointer(BIO_socket_ioctl) := _GetProcAddress('BIO_socket_ioctl');
    Pointer(BIO_socket_nbio) := _GetProcAddress('BIO_socket_nbio');
    Pointer(BIO_sock_init) := _GetProcAddress('BIO_sock_init');
    Pointer(BIO_set_tcp_ndelay) := _GetProcAddress('BIO_set_tcp_ndelay');
    Pointer(BIO_sock_info) := _GetProcAddress('BIO_sock_info');
    Pointer(BIO_socket) := _GetProcAddress('BIO_socket');
    Pointer(BIO_connect) := _GetProcAddress('BIO_connect');
    Pointer(BIO_bind) := _GetProcAddress('BIO_bind');
    Pointer(BIO_listen) := _GetProcAddress('BIO_listen');
    Pointer(BIO_accept_ex) := _GetProcAddress('BIO_accept_ex');
    Pointer(BIO_closesocket) := _GetProcAddress('BIO_closesocket');
    Pointer(BIO_new_socket) := _GetProcAddress('BIO_new_socket');
    Pointer(BIO_new_connect) := _GetProcAddress('BIO_new_connect');
    Pointer(BIO_new_accept) := _GetProcAddress('BIO_new_accept');
    Pointer(BIO_new_fd) := _GetProcAddress('BIO_new_fd');
    Pointer(BIO_new_bio_pair) := _GetProcAddress('BIO_new_bio_pair');
    Pointer(BIO_copy_next_retry) := _GetProcAddress('BIO_copy_next_retry');
    Pointer(BIO_meth_new) := _GetProcAddress('BIO_meth_new');
    Pointer(BIO_meth_free) := _GetProcAddress('BIO_meth_free');



    //.........................................

  Result := True;

end;

end.

